/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.iwidget.IWidgetAdapter");

dojo.require("dijit._Templated");

dojo.require("dojo.i18n");
dojo.require("dojo.string");

dojo.require("jazz.core.loader");
dojo.require("jazz.ensemble.Widget");
dojo.require("jazz.util.ResizeNotifier");
dojo.require("jazz.iwidget._IWidget");
dojo.require("jazz.ui.MessageBox");

dojo.require("com.ibm.team.dashboard.web.ui.internal.Constants");

dojo.requireLocalization("jazz.iwidget.internal", "Messages");

(function()
{
   var Widget = jazz.ensemble.Widget;
   
   /**
    * the following are sample iWidget URIs which can be used for testing
    * "/jazz/web/com.ibm.team.dashboard.viewlets.web.tests/widgets/PreferenceTest.xml"
    * "/jazz/web/com.ibm.team.dashboard.viewlets.web.tests/widgets/NoEditModeTest.xml"
    * "/jazz/web/com.ibm.team.dashboard.viewlets.web.tests/widgets/EditModeTest.xml"
    * "/iwidget.accuweather/accuWeather/AccuWeather.xml"
    * "/iwidget.charts/Charts.xml"
    * "/iwidget.slideshow/slideshowWidget/slideshow.xml"
    * "/iwidget.openstreetmap/openStreetMap/openStreetMap.xml"
    */

	/*
	 * Adapts Viewlets to function as Widgets, allowing them to be placed in a
	 * widget panel.
	 */
	dojo.declare("jazz.iwidget.IWidgetAdapter", [Widget, dijit._Templated, jazz.iwidget._IWidget], {
	
		templatePath: dojo.moduleUrl("jazz.iwidget", "templates/IWidgetAdapter.html"),

      _widgetNode:null,
		_spec: null,
		
		constructor: function(args)
		{
			this._spec = args.definition;
			this.messages = messages = dojo.i18n.getLocalization("jazz.iwidget.internal", "Messages");
		},
		
		postCreate : function ()
		{
      },
		
		_onShowSettings : function ()
		{
         this.setMode(jazz.iwidget.mode.EDIT);
      },
		
		onSaveAttributes : function ()
		{
			if (this.readOnly) {
				var saveError = {
					type : jazz.ui.MessageBox.STATUS_TYPES.ERROR,
					message : this.messages.readOnlyIWidgetSettings
				} 
				dojo.publish(com.ibm.team.dashboard.web.ui.internal.Constants.serverError, [saveError]);
			} else {
				this.context.setPreferences(this.getAttributes());
			}         
      },
		
		startup: function()
		{
         this._createIWidget(this._widgetNode, this._spec, this.context.getPreferences());
         this.context.setSettingsHandler(dojo.hitch(this, "_onShowSettings"));
		},
		
		/*
		 * Refreshes the viewlet. Called by the container when the user requests a
		 * refresh.
		 */
		refresh: function()
		{
		}
	});
	
})();
