/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function()
{
	dojo.provide("jazz.iwidget.IWidgetDijit");
	
	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");
	dojo.require("jazz.iwidget._IWidget");
	
	dojo.declare("jazz.iwidget.IWidgetDijit", [dijit._Widget, dijit._Templated, jazz.iwidget._IWidget], {
		templatePath: dojo.moduleUrl("jazz.iwidget", "templates/IWidgetDijit.html"),
		
		_url: null,
		_prefs: null,
		
		constructor: function(args)
		{
			this._url   = _arg(args, 'url');
			this._prefs = _arg(args, 'prefs');
		},
		
		/**
		 * you are asking why don't I create the iWidget in postCreate.
		 * Well..
		 * com.ibm.mm.iwidget.iContextImpl does a dojo.byId(this.widgetId) 
		 * this means that the entire dom structure must be in place before we can create an iWidget 
		 * or iContextImpl won't be able to find the the dom node.
		 * 
		 * so we have to put this in startup. 
		 * 
		 * but ... it looks like net.jazz.ajax.ajaxModules is not calling statup() !!!
		 * so we are stuck. 
		 * 
		 * Nice that we don't need this class right now. hopefully either 
		 * com.ibm.mm.iwidget.iContextImpl will get the dom node differently
		 * or 
		 * net.jazz.ajax.ajaxModules will call start calling startup().
		 */
		startup : function()
		{
			this._createIWidget(this._widgetNode, this._url, this._prefs);
		}
	})
	
	var _arg = function(/*Map*/args, /*String*/ id, /*Object*/ optDefault)
	{
		if (!(id in args)) 
		{
			return optDefault;
		}
		try 
		{
			return args[id];
		}
		finally 
		{
			delete args[id];
		}
	}
})();
