/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ui.Menu");

(function() {
dojo.require("dijit.Menu");

/**
 *	A thin wrapper around dijit.Menu that provides appropriate styling 
 *  for menus within jazz applications. 
 */
dojo.declare("jazz.ui.Menu", dijit.Menu, {
	templateString: "<table class=\"jazz-ui-Menu\"><tr><td><div class=\"jazz-ui-Menu-border\"><div class=\"wrapper\"><table class=\"dijit dijitMenu dijitMenuPassive dijitReset dijitMenuTable\" waiRole=\"menu\" tabIndex=\"${tabIndex}\" dojoAttachEvent=\"onkeypress:_onKeyPress\">\n\t<tbody class=\"dijitReset\" dojoAttachPoint=\"containerNode\"></tbody>\n</table></div></div></td></tr></table>\n",
	selectable: false,
	/**
	 * Adds the "selected" class to menu item(s).
	 * @param {index|dijit.MenuItem|array of indices or menuItems}
	 */
	setSelected: function(item) {
		if (!this._selected) this._selected = [];
		var sel;
		while(this._selected.length > 0) {
			sel = this._selected.pop();
			if (sel.domNode) dojo.removeClass(sel.domNode, "selected");
		} 
		if (!item) {
			return;
		}
		if (dojo.isArray(item)) {
			for (var k = 0; k < item.length; k++) {
				if (typeof item[k] == "number") {
					item[k] = this.getChildren()[item[k]];
				}
			}
			this._selected = item;
		} else if (typeof item == "number") {
			this._selected = [ this.getChildren()[item] ];
		} else if (item.domNode) {
			this._selected = [ item ];
		}
		for (var i = 0; i < this._selected.length; i++) {
			var x = this._selected[i];
			if (x.domNode) {
				dojo.addClass(x.domNode, "selected");
				dijit.setWaiState(x.domNode, "checked", true);
			}
		}
	},
	_setSelectableAttr: function(sel) {
		dojo.toggleClass(this.domNode, "selectable", sel);
		this.selectable = sel;
	}
});
})();
