/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009,2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.fronting.server.web.migration.rrm.MilestoneMigrationWizardApplication");

function workbenchRootNode(){
    return net.jazz.ajax.ui.PlatformUI.getWorkbench().rootNode();
}

dojo.require("net.jazz.ajax.ui._Application");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.ui.Wizard");
dojo.require("jazz.ui.wizard.WizardStep");
      
dojo.require("com.ibm.rdm.fronting.server.web.migration.rrm.RepositoryVersionCheckStep");
dojo.require("com.ibm.rdm.fronting.server.web.migration.rrm.MigrationStatusStep");
      
dojo.require("com.ibm.rdm.fronting.server.web.util.rrsutils");

dojo.declare("com.ibm.rdm.fronting.server.web.migration.rrm.MilestoneMigrationWizardApplication", net.jazz.ajax.ui._Application, {
    
    // an object holding global state nd exposed to each WizardStep
    migrationInfo: {},
    // an object holding information about the server
    serverInfo: {},
    
    constructor: function() {
       // this.messages = dojo.i18n.getLocalization("com.ibm.rdm.fronting.server.web.ui.internal.wizard", "WizardApplicationMessages");
        this.messages = messages = { setupName: "RRC Migration", setupHeading: "RRC Migration" };
        this._startApp();
    },  

    _startApp: function () {
        var rdmBaseUrl =  com.ibm.rdm.fronting.server.web.util.rrsutils.getUrlPrecedingSegment(document.location.href, "/migration/rrc");
        var rrmMigrationServiceUrl = rdmBaseUrl + "/rrm-migration";
        var rdmWebUIUrl = rdmBaseUrl + "/web";
        this.serverInfo = { 
                rdmBaseUrl: rdmBaseUrl, 
                rrmMigrationServiceUrl: rrmMigrationServiceUrl,
                rdmWebUIUrl: rdmWebUIUrl
        };
        this._createUI();
        this.setName(this.messages.setupName);
        this.start();
    },
    
    _createUI: function() {
        dojo.addClass(workbenchRootNode(), "com-ibm-team-repository-web-setup-RootNode");
        this.content = document.createElement("div");
        dojo.addClass(this.content, "com-ibm-team-repository-wizard");
        
        var textHeader = document.createElement("div");
        textHeader.innerHTML= this.messages.setupHeading;
        textHeader.className = "setup-header";
        this.content.appendChild(textHeader);
        
        var jazzIcon = document.createElement("img");
        jazzIcon.src = dojo.moduleUrl("com.ibm.rdm.fronting.server.web.migration.rrm", "images/jazz-identR.png");
        jazzIcon.className = "jazz-icon";
        this.content.appendChild(jazzIcon);
        
        var setupGraphic = document.createElement("img");
        setupGraphic.src = dojo.moduleUrl("com.ibm.rdm.fronting.server.web.migration.rrm", "images/JTS-wizard-graphic.png");
        setupGraphic.className = "wizard-graphic";
        this.content.appendChild(setupGraphic);

        this.wizardBox = document.createElement("div");
        this.content.appendChild(this.wizardBox);
                
        var self = this;        
                
        var wizardParams = {
            fullPageContainer: this.wizardBox,
            processFinish:  function(){
                // URL to switch to when wizard finishes & we are not running embedded: /{context root}/web
                if(!this.isEmbedded) {
                     document.location.href = self.serverInfo.rdmWebUIUrl;
                }
            }
        };
        try {
             wizardParams.steps = this.initServerSetupSteps();
             var wizard = new jazz.ui.Wizard(wizardParams);
        
            //var outerFooter = new com.ibm.rdm.fronting.server.web.migration.rrm.LogoFooter();
            //this.content.appendChild(outerFooter.domNode);
                
            workbenchRootNode().appendChild(this.content);
        } catch(err){
           console.log(err);
        } 
     },
     
     // The the WizardSteps for this wizard.  Expose this.migrationInfo to each step - this contains 
     //  all global state.
     initServerSetupSteps: function () {
        var repositoryVersionCheck = new com.ibm.rdm.fronting.server.web.migration.rrm.RepositoryVersionCheckStep();
        repositoryVersionCheck.migrationInfo = this.migrationInfo;
        repositoryVersionCheck.serverInfo = this.serverInfo;
        var migrationStepCheck = new com.ibm.rdm.fronting.server.web.migration.rrm.MigrationStatusStep();
        migrationStepCheck.migrationInfo = this.migrationInfo;   
        migrationStepCheck.serverInfo = this.serverInfo;                
        var steps = [ repositoryVersionCheck, migrationStepCheck ]; 
        return steps;
    },
  }); 
})();