/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ui.Toolbar");

dojo.require("dijit.Toolbar");

(function() {
/**
 * Constructs a new Toolbar. A thin wrapper around the dijit.Toolbar to provide jazz styling
 * overrides.
 * @name jazz.ui.Toolbar
 * @class <p>A toolbar widget for web UIs.</p>
 * @constructor
 * @extends dijit.Toolbar
 */ 
dojo.declare("jazz.ui.Toolbar", [dijit.Toolbar], /** @lends jazz.ui.Toolbar.prototype */ {
	buildRendering: function(){
		this.inherited(arguments);
		dojo.addClass(this.domNode, "jazz-ui-Toolbar");
		
		//remove text nodes from toolbar - causes problems with layout
		var cn = this.domNode.childNodes;
		for (var i = 0; i < cn.length; i++) {
			var node = cn[i];
			if (node && node.nodeType == 3) {
				this.domNode.removeChild(node);
			}
		}	
	}
});

})();