/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ensemble.WidgetFactory");

(function() {

/**
 * An interface for widget factories registered via the
 * net.jazz.web.ensemble.widgetSystems extension point. Factories must implement
 * the methods described in this interface, but do not need to subclass this dojo
 * class. This class is for API reference.
 * 
 * @since 3.0
 */
dojo.declare("jazz.ensemble.WidgetFactory", null, {
	
	/**
	 * Creates a new Widget instance of the type the factory was registered.
	 * 
	 * @param args an object containing the properties defined in the Widget
	 * 		interface to initialize the Widget.
	 * @return a new Widget instance
	 */
	createWidget: function(/** object */ args) {}
});

})();
