/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.util.array");
dojo.provide("jazz.util.Array"); 	//temporarily make the old code work.

/*
 * PROVISIONAL: This API is considered provisional and may be changed or removed in the
 * future with minimal or no warning.
 * 
 * @since 0.7
 */

(function() {
jazz.util.Array.insertByPriority = function(array, newEntry) {
	dojo.deprecated("jazz.util.Array.insertByPriority", "use jazz.util.array.insertByPriority instead", "3.0M8");
	jazz.util.array.insertByPriority(array, newEntry);
}
jazz.util.array.insertByPriority = function (array, newEntry) {
	/*	summary:
	 * 		Splice newEntry into array based on the value of the of newEntry's p parameter
	 *	array: Array to push newEntry into
	 * 	newEntry: Object with p param, ex. {p: priority (required), func: some function}
	 *	p: integer, high priority = earlier in the array
	 */
	for (var i=0; i<array.length; i++) {
		if (newEntry.p > array[i].p) {
			array.splice(i, 0, newEntry);
			return;
		}
	}
	// if we didn't insert the new handler, just append it to the list
	array.push(newEntry);

};
jazz.util.Array.removeByReference = function(array, entry) {
	dojo.deprecated("jazz.util.Array.removeByReference", "use jazz.util.array.removeByReference instead", "3.0M8");
	jazz.util.array.removeByReference(array, entry);
}
jazz.util.array.removeByReference = function (array, entry) {
	/*	summary:
	 * 		Remove entry from array by reference.
	 *	array: Array of objects
	 * 	entry: Object to remove from array
	 * 	return: Success boolean
	 */
	for (var i = 0; i < array.length;i++) {
		if (entry == array[i]) {
			array.splice(i,1);
			return true;	
		}
	}
	return false;
};
	
})();