/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.repository.web.client.internal.DBProviderClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

// aliases and constants
var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
var SERVICE_URI = "com.ibm.team.repository.service.internal.rdb.IDbProviderRestService";
var THIS_PACKAGE = com.ibm.team.repository.web.client.internal.DBProviderClient;
//
// exported functions
//

THIS_PACKAGE.getIds = function(srh, args) {
	TeamServerClient.invokeService(getServiceRequest("getIds", args), srh);
}

THIS_PACKAGE.getInfo = function(srh, args) {
	validateArgs("getInfo", args, ["id"]);
	TeamServerClient.invokeService(getServiceRequest("getInfo", args), srh);
}

//
// internal functions
//

function getServiceRequest(method, args) {
	if (args) {
		return new ServiceRequest(SERVICE_URI, method, args);
	} else {
		return new ServiceRequest(SERVICE_URI, method);
	}
}

function validateArgs(fName, args, props) {
	for(var i=0; i<props.length; i++) {
		if(!args[props[i]]) {
			throw new Error(fName + " missing required parameter args." + props[i]);
		}
	}
}
})();
