/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function() {

dojo.provide("com.ibm.team.repository.web.client.internal.HttpHeaders");
dojo.require("dojo.cookie");

/*
 * HTTP constants
 */
com.ibm.team.repository.web.client.internal.HttpConstants = {
	
	ACCEPT: "Accept",
	CONTENT_TYPE: "Content-Type",
	CT_TEXT_JSON: "text/json",
	CT_APPLICATION_JSON: "application/json",
	CT_APPLICATION_RDF_XML: "application/rdf+xml",
	CT_APPLICATION_FORM_URLENCODED: "application/x-www-form-urlencoded; charset=utf-8",
	ETAG: "ETag",
	IF_MATCH: "If-Match",
	IF_UNMODIFIED_SINCE: "If-Unmodified-Since",
	LAST_MODIFIED: "Last-Modified",
	LAST_MODIFIED_USER: "X-Last-Modified-User",
	LAST_MODIFIED_XSD: "X-Last-Modified-XSD",
	LOCATION: "Location",
	CONFIG_VERSION: "X-com-ibm-team-configuration-versions",
	LATEST: "LATEST",
	CSRF_PREVENT: "X-Jazz-CSRF-Prevent"
};

/*
 * Provide a default set of headers for raw XHR requests.
 */

function getHeaders() {
	var headers = [];
	var HttpConstants = com.ibm.team.repository.web.client.internal.HttpConstants;
	//Default set of headers to use
	headers[HttpConstants.ACCEPT] 			= HttpConstants.CT_APPLICATION_JSON;
	headers[HttpConstants.CONTENT_TYPE] 	= HttpConstants.CT_APPLICATION_FORM_URLENCODED;
	headers[HttpConstants.CONFIG_VERSION] 	= HttpConstants.LATEST;
	headers[HttpConstants.CSRF_PREVENT] 	= dojo.cookie("JSESSIONID");
	return headers;
}

com.ibm.team.repository.web.client.internal.HttpHeaders._getHeaders = getHeaders;

})();
