/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.repository.web.client.internal.LDAPConfigClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

// aliases and constants
var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
var THIS_PACKAGE = com.ibm.team.repository.web.client.internal.LDAPConfigClient;
var SERVICE_URI = "com.ibm.team.repository.service.jts.internal.userregistry.ldap.ILDAPConfigRestService";

//
// exported functions
//

/**
 * See ILDAPConfigRestService#getContainerType
 */
function getContainerType(srh, args) {
	TeamServerClient.invokeService(getServiceRequest("getContainerType", args), srh);
}
THIS_PACKAGE.getContainerType = getContainerType;

/**
 * See ILDAPConfigRestService#postProperties
 */
function postProperties(srh, args) {
	validateArgs("postProperties", args, ["basicProperties"]);
	TeamServerClient.invokeService(getServiceRequest("postProperties", args), srh);
}
THIS_PACKAGE.postProperties = postProperties;

/**
 * See ILDAPConfigRestService#validateUser
 */
function getUserInfo(srh, args) {
	validateArgs("getUserInfo", args, ["basicProperties"]);
	TeamServerClient.invokeService(getServiceRequest("getUserInfo", args), srh);
}
THIS_PACKAGE.getUserInfo = getUserInfo;

//
// internal functions
//

function getServiceRequest(method, args) {
	if (args) {
		return new ServiceRequest(SERVICE_URI, method, args);
	} else {
		return new ServiceRequest(SERVICE_URI, method);
	}
}

function validateArgs(fName, args, props) {
	for(var i=0; i<props.length; i++) {
		if(!args[props[i]]) {
			throw new Error(fName + " missing required parameter args." + props[i]);
		}
	}
}

})();
