/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("dojox.xml.DomParser"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceRequest"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.TeamServerClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	
	dojo.requireLocalization("com.ibm.team.process.web.client.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	
	// constants and aliases
	var SERVICE_URI = "com.ibm.team.process.internal.service.web.IProcessWebUIService"; //$NON-NLS-1$
	var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
    var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	
	function getMembersWithReadAccess(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getMembersWithReadAccess", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getMembersWithReadAccess = getMembersWithReadAccess;
	
	function getMembersPaged(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getMembersPaged", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
		return serviceRequest;
	}
	
	ProcessClient.getMembersPaged = getMembersPaged;
	
	function getProcessAreasForUser(kwArgs, responseHandler){
		if (!kwArgs.userId) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.client.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			alert(dojo.string.substitute(this.messages.ProcessClient_1, [kwArgs.userId]));
			return;
		}
		
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProcessAreasForUser", kwArgs); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProcessAreasForUser = getProcessAreasForUser;
	
	function getAllProjectAreas(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getAllProjectAreas", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getAllProjectAreas = getAllProjectAreas;
	
	function getProjectAreasPaged(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProjectAreasPaged", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProjectAreasPaged = getProjectAreasPaged;
	
	
	function getProjectAreaByUUID(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProjectAreaByUUID", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProjectAreaByUUID = getProjectAreaByUUID;
	
	function getProjectAreaByUUIDWithLimitedMembers(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProjectAreaByUUIDWithLimitedMembers", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProjectAreaByUUIDWithLimitedMembers = getProjectAreaByUUIDWithLimitedMembers;
	
	function getLPAContainingProjectAreaUrl(/*ParmsUUID*/args, responseHandler) {	
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getLPAContainingProjectAreaUrl", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	ProcessClient.getLPAContainingProjectAreaUrl = getLPAContainingProjectAreaUrl;
	
	
	function getPermissionExtensions(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getPermissionExtensions", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getPermissionExtensions = getPermissionExtensions;
		
	function getPermissions(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getPermissions", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getPermissions = getPermissions;
	
	
	function getProjectHierarchy(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProjectHierarchy", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProjectHierarchy = getProjectHierarchy;
	
	function getTeamAreaByUUID(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getTeamAreaByUUID", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getTeamAreaByUUID = getTeamAreaByUUID;
	
	function getTeamAreaByUUIDWithLimitedMembers(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getTeamAreaByUUIDWithLimitedMembers", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getTeamAreaByUUIDWithLimitedMembers = getTeamAreaByUUIDWithLimitedMembers;
	
	function getProcessAreaHierarchies(responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProcessAreaHierarchies"); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProcessAreaHierarchies = getProcessAreaHierarchies;
	
	function getHierarchyForTeamArea(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getHierarchyForTeamArea", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getHierarchyForTeamArea = getHierarchyForTeamArea;
	
	function getContributors(args, responseHandler){
		if (!args.isLicenseSearch) {
			if (!args.searchTerm) {
				args.searchTerm = "%"; //$NON-NLS-1$
			} else {
				args.searchTerm = "%" + args.searchTerm + "%"; //$NON-NLS-1$ //$NON-NLS-2$
			}
		}
		if (!args.pageSize) {
			args.pageSize = 50;
		}
		if (!args.pageNum) {
			args.pageNum = 0;
		}
		if (args.filterOutUsers && args.filterOutUsers.length > 0) {
			args.filterOutUsers = dojo.toJson(args.filterOutUsers);
		}
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getContributors", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getContributors = getContributors;
	
	function getAllProcessDefinitions(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getAllProcessDefinitions", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getAllProcessDefinitions = getAllProcessDefinitions;
	
	function getAllProcessProviders(args, responseHandler) {
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getAllProcessProviders", args);//$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getAllProcessProviders = getAllProcessProviders;
	
	function getProcessDefinitions(args, responseHandler) {
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProcessDefinitions", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProcessDefinitions = getProcessDefinitions;
	
	function getProjectDevelopmentLines(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProjectDevelopmentLines", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProjectDevelopmentLines = getProjectDevelopmentLines;
	
	function getIterationTypes(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getIterationTypes", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getIterationTypes = getIterationTypes;
	
	function getIterations(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getIterations", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getIterations = getIterations;
	
	function getTeamAreaIterations(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getTeamAreaIterations", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getTeamAreaIterations = getTeamAreaIterations;
	
	function postProcessDefinition(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postProcessDefinition", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.postProcessDefinition = postProcessDefinition;
	
	function postProjectArea(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postProjectArea", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.postProjectArea = postProjectArea;
	
	function postTeamArea(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postTeamArea", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.postTeamArea = postTeamArea;
	
	function deployPredefinedProcessDefinitions(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postDeployPredefinedProcessDefinitions", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.deployPredefinedProcessDefinitions = deployPredefinedProcessDefinitions;
	
	function postArchiveProcessItem(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postArchiveProcessItem", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.postArchiveProcessItem = postArchiveProcessItem;

	function postUnarchiveProcessArea(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postUnarchiveProcessArea", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.postUnarchiveProcessArea = postUnarchiveProcessArea;

	function postInitializeProjectArea(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postInitializeProjectArea", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.postInitializeProjectArea = postInitializeProjectArea;
	
	function getProcessDefinitionById(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProcessDefinitionById", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProcessDefinitionById = getProcessDefinitionById;
	
	function deleteProcessDefinition(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postDeleteProcessDefinition", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.deleteProcessDefinition = deleteProcessDefinition;
	
	function generateTeamInvitations(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postGenerateTeamInvitations", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.generateTeamInvitations = generateTeamInvitations;
	
	function generateTeamInvitation(args, responseHandler) {
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getEmailSubjectAndBody", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	ProcessClient.generateTeamInvitation = generateTeamInvitation;

	function stringCompare(string1, string2){
		return string1.toLocaleLowerCase().localeCompare(string2.toLocaleLowerCase());
	}
	
	ProcessClient.stringCompare = stringCompare;
	
	function getIsOslcCoreEnabled(responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getIsOslcCoreEnabled"); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
		
	ProcessClient.getIsOslcCoreEnabled = getIsOslcCoreEnabled;
		
	function getIsConfigurationDataEnabled(responseHandler) {
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getIsConfigurationDataEnabled"); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	ProcessClient.getIsConfigurationDataEnabled = getIsConfigurationDataEnabled;

	function getProcessRoles (/* String */rolesUrl, /* Function */callback, /* Function */errorCallback) {
		// Summary:
		// 		Gets the process roles from the provided resource and pass them to 
		// 		the provided callback function.
		// Description:
		//		It parses the XML response and converts it into an Object.
		//		Error callback is invoked in case of any error during XHR request. 

		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};

		// Converts the provided roles' xml response into an object.
		var getRolesHandler = function(/* String */rolesXMLResponse){
			var rolesDoc = dojox.xml.DomParser.parse(rolesXMLResponse);
			var rolesNode = rolesDoc.documentElement;
			var roleNodes = rolesNode.childrenByNameNS("role", ProcessConstants.NAMESPACE_JP06); //$NON-NLS-1$
			var roles = [];
			var i = 0;
			dojo.forEach(roleNodes, function(roleNode){
				var role = {};
				
				// Roles's url
				var urlNode = roleNode.childrenByNameNS("url", ProcessConstants.NAMESPACE_JP06); //$NON-NLS-1$
				if (urlNode.length > 0 && urlNode[0].childNodes.length > 0) {
					role.url = urlNode[0].childNodes[0].nodeValue;
				} else {
					role.url = null;
				}
				
				// Roles's id
				var idNode = roleNode.childrenByNameNS("id", ProcessConstants.NAMESPACE_JP06); //$NON-NLS-1$
				if (idNode.length > 0 && idNode[0].childNodes.length > 0) {
					role.id = idNode[0].childNodes[0].nodeValue;
				} else {
					role.id = null;
				}
				
				// Roles's url
				var labelNode = roleNode.childrenByNameNS("label", ProcessConstants.NAMESPACE_JP06); //$NON-NLS-1$
				if (labelNode.length > 0 && labelNode[0].childNodes.length > 0) {
					role.label = labelNode[0].childNodes[0].nodeValue;
				} else {
					role.label = null; 
				}
				
				// Roles's description
				var descNode = roleNode.childrenByNameNS("description", ProcessConstants.NAMESPACE_JP06); //$NON-NLS-1$
				if (descNode.length > 0 && descNode[0].childNodes.length > 0) {
					role.description = descNode[0].childNodes[0].nodeValue;
				} else {
					role.description = ""; //$NON-NLS-1$
				}
				
				roles[i++] = role;
			});
			if (callback) {
				callback(roles);
			}
		};
		_invokeXhrGetService(rolesUrl, getRolesHandler, errorHandler);
	}
	ProcessClient.getProcessRoles = getProcessRoles;

	function getMember (/* String */memberUrl, /* Function */callback, /* Function */errorCallback) {
		// Summary:
		//		Gets the member details from the provided resource and pass them to 
		//		the provided callback function.
		// Description:
		//		It parses the XML response and converts it into an Object.
		//		Error callback is invoked in case of any error during XHR request. 
		
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};

		// Converts provided member xml response into an object.
		var getMemberHandler = function(/* String */memberXMLResponse){			
			var memberDoc = dojox.xml.DomParser.parse(memberXMLResponse);
			var memberNode = memberDoc.documentElement;
			var member = {};

			// Member's Url
			var urlNode = memberNode.childrenByNameNS("url", ProcessConstants.NAMESPACE_JP06); //$NON-NLS-1$
			if (urlNode.length > 0 && urlNode[0].childNodes.length > 0) {
				member.url = urlNode[0].childNodes[0].nodeValue;
			} else {
				member.url = null;
			}

			// User's Url
			var userUrlNode = memberNode.childrenByNameNS("user-url", ProcessConstants.NAMESPACE_JP06); //$NON-NLS-1$
			if (userUrlNode.length > 0 && userUrlNode[0].childNodes.length > 0) {
				member.userUrl = userUrlNode[0].childNodes[0].nodeValue;
			} else {
				member.userUrl = null;
			}
						
			// Member's assigned roles.
			var processRoles = [];
			var roleAssignmentsNode = memberNode.childrenByNameNS("role-assignments", ProcessConstants.NAMESPACE_JP06); //$NON-NLS-1$
			if (roleAssignmentsNode.length > 0 && roleAssignmentsNode[0].childNodes.length > 0) {
				var roleAssignmentNodes = roleAssignmentsNode[0].childrenByNameNS("role-assignment", ProcessConstants.NAMESPACE_JP06); //$NON-NLS-1$
				var j = 0;
				dojo.forEach(roleAssignmentNodes, function(roleAssignmentNode){
					var processRole = {};
					var urlNodes = roleAssignmentNode.childrenByNameNS("url", ProcessConstants.NAMESPACE_JP06); //$NON-NLS-1$
					if (urlNodes.length > 0 && urlNodes[0].childNodes.length > 0) {
						processRole.url = urlNodes[0].childNodes[0].nodeValue;
					} else {
						processRole.url = null;
					}					
					var roleUrlNodes = roleAssignmentNode.childrenByNameNS("role-url", ProcessConstants.NAMESPACE_JP06); //$NON-NLS-1$
					if (roleUrlNodes.length > 0 && roleUrlNodes[0].childNodes.length > 0) {
						processRole.roleUrl = roleUrlNodes[0].childNodes[0].nodeValue;
					} else {
						processRole.roleUrl = null;
					}
					processRoles[j++] = processRole;
				});
			}
			member.processRoles = processRoles;			
			if (callback) {
				callback(member);
			}
		};
		_invokeXhrGetService(memberUrl, getMemberHandler, errorHandler);
	}
	ProcessClient.getMember = getMember;
	
	function getRootServices(/* String - URL */rootServicesUrl, /* Function*/callback, /* Function */errorCallback) {
		// Summary:
		// Gets the rootservices DOM node from the provided root services resource.
		
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		
		var getRootServicesHandler = function(rootServicesRes){
			var rootServicesDoc = dojox.xml.DomParser.parse(rootServicesRes);
			var rootServicesNode = rootServicesDoc.documentElement;
			if (callback) {
				callback(rootServicesNode);
			}			
		};
		_invokeXhrGetService(rootServicesUrl, getRootServicesHandler, errorHandler);
	}
	ProcessClient.getRootServices = getRootServices;	
	
	function getLPACreateProjectAreaUrl(responseHandler) {
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getLPACreateProjectAreaUrl"); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	ProcessClient.getLPACreateProjectAreaUrl = getLPACreateProjectAreaUrl;
	
	function getApplication(/* Object */ args, /* Object */responseHandler) {
		// Summary:
		//	Gets the application with matching application key
		//	args - Argument object having 'owningApplicationKey' 
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getApplication", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	ProcessClient.getApplication = getApplication;	
	
	function putProcessRoleAssignments(args, success, fail) {
		
		//Summary: PUT to RoleAssginmentsResource to update the roles of the specified member
		var chosenRoles = args.chosenRoles;
		var roleAssignmentsUrl = args.memberUrl + "/" + "role-assignments"; //$NON-NLS-1$ //$NON-NLS-2$
		var roleUrl = args.memberUrl + "/" + "role"; //$NON-NLS-1$ //$NON-NLS-2$
		
		var data = '<?xml version="1.0" encoding="UTF-8"?>';//$NON-NLS-1$
		data += '<jp06:role-assignments xmlns:jp06="http://jazz.net/xmlns/prod/jazz/process/0.6/">'; //$NON-NLS-1$
		for (var i = 0; i < chosenRoles.length; i++) {
			data += "<jp06:role-assignment>"; //$NON-NLS-1$
			data += "<jp06:url>"; //$NON-NLS-1$
			data += roleAssignmentsUrl + "/" + chosenRoles[i].id; //$NON-NLS-1$
			data += "</jp06:url>"; //$NON-NLS-1$
			data += "<jp06:role-url>"; //$NON-NLS-1$
			data += roleUrl + "/" + chosenRoles[i].id; //$NON-NLS-1$
			data += "</jp06:role-url>"; //$NON-NLS-1$
			data += "</jp06:role-assignment>"; //$NON-NLS-1$
		}
		data += "</jp06:role-assignments>"; //$NON-NLS-1$
		
		var deferred = jazz.client.xhrPut({
			url: roleAssignmentsUrl,
			header: {
				"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Content-Type": "application/xml;charset=UTF-8" //$NON-NLS-1$ //$NON-NLS-2$
			},
			putData: data
		});
		
		if (success) {
			deferred.addCallback(success);
		}
		if (fail) {
			deferred.addErrback(fail);
		}
	}
	ProcessClient.putProcessRoleAssignments = putProcessRoleAssignments;
	
	
	function _invokeXhrGetService (/* String */url, /* Function */ callback, /* Function */ errorCallback){
		// Summary: 
		// 		Invokes XHR Get on the provided resource and connects the
		// 		response to the provided callback and errorback methods. 
		var args = {
			url: url,
			headers: {
				"accept": "text/xml" //$NON-NLS-1$ //$NON-NLS-2$
			}
		};
		var deferred = jazz.client.xhrGet(args);		
		deferred.addCallback(callback);
		deferred.addErrback(errorCallback);
	};
	
})();
