/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.client.internal.ProjectMoveClient"); //$NON-NLS-1$
	dojo.require("dojo.i18n");  //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");  //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");  //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");  //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.client.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	// constants and aliases
	var SERVICE_URI = "com.ibm.team.projectmove.service.IProjectMoveRestService";  //$NON-NLS-1$
	var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;	
	var ProjectMoveClient = com.ibm.team.process.web.client.internal.ProjectMoveClient;
	
	function postAnalyzeProjectsToMove(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postAnalyzeProjectsToMove", args);  //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProjectMoveClient.postAnalyzeProjectsToMove = postAnalyzeProjectsToMove;
	
	function postMoveProjects(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postMoveProjects", args);  //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProjectMoveClient.postMoveProjects = postMoveProjects;
	
	function postSuspendProjectMove(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postSuspendProjectMove", args);  //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProjectMoveClient.postSuspendProjectMove = postSuspendProjectMove;
	
	function postResumeProjectMove(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postResumeProjectMove", args);  //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProjectMoveClient.postResumeProjectMove = postResumeProjectMove;
	
	function postCancelProjectMove(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postCancelProjectMove", args);  //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProjectMoveClient.postCancelProjectMove = postCancelProjectMove;


})();
