/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.client.internal.ProjectMoveProgressClient"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient"); //$NON-NLS-1$

(function() {

var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;

var SERVICE_URI = "com.ibm.team.projectmove.service.IProjectMoveProgressRestService"; //$NON-NLS-1$

com.ibm.team.process.web.client.internal.ProjectMoveProgressClient = {
	
	getProjectMoveStatus: function(responseHandler) {
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProjectMoveStatus");  //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);		
	},
	
	getIsProjectMoveInProgress: function(responseHandler) {
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getIsProjectMoveInProgress");  //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);		
	},
	
	getReportItems: function(responseHandler, params) {
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getReportItems", params);  //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);		
	}

};

})();
