/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.client.internal.ReportsClient");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

dojo.require("jazz.app.context");

(function() { // module container

	var session = com.ibm.team.repository.web.client.session;
	var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;

	/**
	 * A copy of ReportsClient from com.ibm.team.reports.web, so we can call Reports REST API
	 * from the server setup wizard without a direct dependency on reports web plug-ins.
	 */
	com.ibm.team.repository.web.client.internal.ReportsClient = {

		SERVICE_URI : "com.ibm.team.reports.common.internal.service.IReportRestService",

		postInitializeDataWarehouse : function(responseHandler) {
			this._invokeReportsService(responseHandler,
					"postInitializeDataWarehouse");
		},

		getDataWarehouseInitializationStatus : function(responseHandler) {
			this._invokeReportsService(responseHandler,
					"getDataWarehouseInitializationStatus");
		},
		
		/**
		 * Invokes the requested method on the Reports REST service.
		 */
		_invokeReportsService : function(responseHandler, method, args) {
			// args is optional, so test whether or not it was sent
			var serviceRequest;
			if (arguments.length == 2) {
				serviceRequest = new ServiceRequest(this.SERVICE_URI, method);
			} else {
				serviceRequest = new ServiceRequest(this.SERVICE_URI, method,
						args);
			}
			TeamServerClient.invokeService(serviceRequest, responseHandler);
		}
	};

})();