/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.repository.web.client.internal.TokenLicenseClient");
dojo.require("jazz.client.xhr");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

var JAZZ_TOKEN_SERVICE_URL = "/service/com.ibm.team.jfs.license.internal.token.IJazzLicenseTokenRestService";
var LICENSE_TOKEN_SERVICE_URL = "/service/com.ibm.team.repository.service.internal.license.token.ILicenseTokenRestService";
var PROVIDER_CONFIG_SEGMENT = "provider-configs";
var PROVIDER_STATUS_SEGMENT = "provider-status";
com.ibm.team.repository.web.client.internal.TokenLicenseClient = {
	
	deleteLicense: function(licenseId , responseHandler){
		this._invokeService(JAZZ_TOKEN_SERVICE_URL + "/tokenLicense/" + licenseId , responseHandler , arguments , HTTP_METHOD.DELETE);
	},
	
	getJazzTokenServiceInfo: function(responseHandler , usage , group){
		url = JAZZ_TOKEN_SERVICE_URL;
		if (!usage)
		  url += "?usage=false";
		else if (!group)
		  url += "?group=false"
		this._invokeService(JAZZ_TOKEN_SERVICE_URL , responseHandler , arguments , HTTP_METHOD.GET);
	},
	
	getProviderConfigs: function(responseHandler){
		return this._invokeService(LICENSE_TOKEN_SERVICE_URL + "/" + PROVIDER_CONFIG_SEGMENT , responseHandler , arguments , HTTP_METHOD.GET);
	},
	
	getProviderStatus: function(responseHandler , args){
		return this._invokeService(LICENSE_TOKEN_SERVICE_URL + "/" + PROVIDER_STATUS_SEGMENT , responseHandler , args , HTTP_METHOD.GET);
	},
	
	getTokenProviderServiceInfo: function(responseHandler){
		this._invokeService(LICENSE_TOKEN_SERVICE_URL , responseHandler , arguments , HTTP_METHOD.GET);
	},
	
	_invokeService: function(url, responseHandler, args , method) {
		var headers = {			
			"X-com-ibm-team-configuration-versions": "LATEST",
			"X-Jazz-CSRF-Prevent": dojo.cookie("JSESSIONID")
		};
		
		var reqUrl = net.jazz.ajax._contextRoot + url; 
		if (args)
			reqUrl += "?" + dojo.objectToQuery(args);
			 		
		var xhrArgs = {
			url: reqUrl,
			handleAs: "json",
			headers: headers,
			preventCache: dojo.isIE,
			handle: function(response, ioArgs) {
				if (!(response instanceof Error)) {
					// success response
					responseHandler.doCallback(response);
				} else {
					// error response
					var errorObj = {
						status: ioArgs.xhr.status,
						statusText: ioArgs.xhr.statusText
					};
					/*
					if (ioArgs.xhr.status == 401 && ioArgs.args.url.match(/^.*\/isRepositoryAvailable.*$/)) {
						// Capture the scenario where the user cancels out of a Basic auth prompt and display a helpful message
						// rather than a blank "Loading..." screen
						var errMsg = messages.authRefresh; 
						//alert(errMsg);
						errorObj.message = errMsg; 					
					}
					*/
					errorObj.message = dojo.trim(unescape(ioArgs.xhr.statusText).replace(/\+/g, " ").replace(/^(-*)/g, ""));					
					responseHandler.doErrorCallback(errorObj);
				}
			}
		};
		
		if(args) {
			for (var arg in args) {
				xhrArgs[arg] = args[arg];
			}
		}
		if (method === HTTP_METHOD.GET)
			return jazz.client.xhrGet(xhrArgs);
		else if (method === HTTP_METHOD.PUT)
			return jazz.client.xhrPut(xhrArgs);
		else if (method === HTTP_METHOD.POST)
			return jazz.client.xhrPost(xhrArgs);
		else if (method === HTTP_METHOD.DELETE)
			return jazz.client.xhrDelete(xhrArgs);
		else if (method === HTTP_METHOD.HEAD)
			return jazz.client.xhrHead(xhrArgs);
		
		
			//
	}
		
};
HTTP_METHOD = {HEAD:0 , GET:1 , PUT:2 , POST:3 , DELETE:4};
})();
