/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	
	ProcessConstants.ROOTSERVICESXML = net.jazz.ajax._contextRoot + "/rootservices"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_RDF = "http://www.w3.org/1999/02/22-rdf-syntax-ns#"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_DC = "http://purl.org/dc/terms/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC = "http://open-services.net/xmlns/discovery/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_CM = "http://open-services.net/xmlns/cm/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_QM = "http://open-services.net/xmlns/qm/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_RM = "http://open-services.net/xmlns/rm/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_SCM = "http://open-services.net/xmlns/scm/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_JP = "http://jazz.net/xmlns/prod/jazz/process/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_JP06 = "http://jazz.net/xmlns/prod/jazz/process/0.6/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_JD = "http://jazz.net/xmlns/prod/jazz/discovery/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_JFS = "http://jazz.net/xmlns/prod/jazz/jfs/1.0/"; //$NON-NLS-1$
	ProcessConstants.CONTENT_TYPE_APPLICATION_XML = "application/xml"; //$NON-NLS-1$
	// Must be kept in sync with the matching constants in
	// PermissionPath.java
	ProcessConstants.PERMISSION_PATH_SEPARATOR = "~#_~#"; //$NON-NLS-1$
	ProcessConstants.PERMISSION_PATH_DELIMITER = ":~_:~"; //$NON-NLS-1$
	ProcessConstants.NONE = "none"; //$NON-NLS-1$
	ProcessConstants.BLOCK = "block"; //$NON-NLS-1$
	ProcessConstants.DIV = "div"; //$NON-NLS-1$
	ProcessConstants.EMPTY = ""; //$NON-NLS-1$
	ProcessConstants.INLINE = "inline"; //$NON-NLS-1$
	ProcessConstants.BR = "br"; //$NON-NLS-1$
	ProcessConstants.STALE_DATA_EXCEPTION = "com.ibm.team.repository.common.StaleDataException"; //$NON-NLS-1$
	ProcessConstants.TEAM_OPERATION_CANCELED_EXCEPTION = "com.ibm.team.process.common.advice.TeamOperationCanceledException"; //$NON-NLS-1$
	ProcessConstants.PERMISSION_DENIED_EXCEPTION = "com.ibm.team.repository.common.PermissionDeniedException"; //$NON-NLS-1$ 
	ProcessConstants.PROCESS_DATA_VALIDATION_EXCEPTION = "com.ibm.team.process.common.service.ProcessDataValidationException"; //$NON-NLS-1$
	ProcessConstants.MAIL_SERVICE_NOT_CONFIGURED_EXCEPTION = "com.ibm.team.process.internal.service.exceptions.MailServiceNotConfiguredException";//$NON-NLS-1$
	ProcessConstants.LICENSE_NOT_GRANTED_EXCEPTION = "com.ibm.team.repository.common.LicenseNotGrantedException"; //$NON-NLS-1$
	ProcessConstants.SC_FORBIDDEN = 403;
	ProcessConstants.PREFIX = "com.ibm.team.process.";//$NON-NLS-1$
	ProcessConstants.ERROR_PRIORITY_HIGH = 100;
	ProcessConstants.ERROR_PRIORITY_LOW = -500;
	ProcessConstants.ERROR_PRIORITY_WARNING = -999;
	ProcessConstants.ERROR_PRIORITY_WARNING_LOW = -1999;
	
	ProcessConstants.DEFAULT_ROLE_ID = "default"; //$NON-NLS-1$
	ProcessConstants.SERVICE_PROVIDER_ERROR_TYPE = "error"; //$NON-NLS-1$
	ProcessConstants.SERVICE_PROVIDER_NOT_LOADED_TYPE = "notLoaded"; //$NON-NLS-1$
	ProcessConstants.SERVICE_PROVIDER_TYPE = "serviceProvider"; //$NON-NLS-1$
	ProcessConstants.SERVICE_PROVIDER_CATALOG_TYPE = "serviceProviderCatalog"; //$NON-NLS-1$
	ProcessConstants.ITERATION_TYPE_NONE = 'com.ibm.team.process.internal.iteration.type.none'; //$NON-NLS-1$
	ProcessConstants.PARAM_OWNING_APP_KEY = "owningApplicationKey"; //$NON-NLS-1$
	ProcessConstants.JTS_OWNING_APPLICATION_KEY = "JTS-Sentinel-Id"; //$NON-NLS-1$

	ProcessConstants.ITEM_TYPE = {
		PROJECT_AREA: 1, 
		TEAM_AREA: 2
	};
	
	ProcessConstants.IterationTypeDTO = {
		ID: "id", //$NON-NLS-1$
		ITEM_ID: "itemId", //$NON-NLS-1$
		LABEL: "label" //$NON-NLS-1$
	};
	
	ProcessConstants.PermissionDTO = {
		ID: "id", //$NON-NLS-1$
		NAME: "name", //$NON-NLS-1$
		ITEMS: "items", //$NON-NLS-1$
		DESCRIPTION: "description" //$NON-NLS-1$
	};
	
	ProcessConstants.PermissionConfigurationDTO = {
		SELECTED: "selected", //$NON-NLS-1$
		CONFIGURED: "configured", //$NON-NLS-1$
		FINAL_OP: "finalOp", //$NON-NLS-1$
		DENIAL_EXPLANATION: "denialExplanation" //$NON-NLS-1$
	};
	
	ProcessConstants.PermissionsScopeContext = {
		PROJECT: 'project', //$NON-NLS-1$
		TEAM: 'team', //$NON-NLS-1$
		DEV_LINES: 'devLines', //$NON-NLS-1$
		ITERATION_TYPES: 'iterationTypes', //$NON-NLS-1$
		ITERATIONS: 'iterations' //$NON-NLS-1$	
	};
	
	ProcessConstants.PermissionContext = {
		PROJECT: 1,
		TEAM: 2,
		DEV_LINE: 3,
		ITERATION_TYPE: 4,
		ITERATION: 5
	};
	
	ProcessConstants.EditorContext = {
		PROJECT: 1,
		TEAM: 2
	};
	
	ProcessConstants.TabEnum = {
		OVERVIEW: "com.ibm.team.process.web.Overview", //$NON-NLS-1$
		PERMISSIONS: "com.ibm.team.process.web.Permissions", //$NON-NLS-1$
		ROLES: "com.ibm.team.process.web.Roles", //$NON-NLS-1$
		ACCESS_CONTROL: "com.ibm.team.process.web.AccessControl", //$NON-NLS-1$
		TIMELINE: "com.ibm.team.process.web.Timelines", //$NON-NLS-1$
		CONFIGURATIONDATA: "com.ibm.team.process.web.ConfigurationData" //$NON-NLS-1$
	};
	
	ProcessConstants.EditorMode = {
		PREVIEW: "Preview", //$NON-NLS-1$
		EDIT: "Edit", //$NON-NLS-1$
		NEW: "new" //$NON-NLS-1$
	};
	
	ProcessConstants.RoleCardinality = {
		MANY: 0,
		SINGLE: 1
	};
	
	ProcessConstants.LinkTypes = {
		IMPLEMENTS: "implements", //$NON-NLS-1$
		IMPLEMENTED_BY: "implemented-by", //$NON-NLS-1$
		VALIDATES: "validates", //$NON-NLS-1$
		VALIDATED_BY: "validated-by", //$NON-NLS-1$
		TESTS: "tests", //$NON-NLS-1$
		TESTED_BY: "tested-by", //$NON-NLS-1$
		RELATED_TO: "related-to", //$NON-NLS-1$
		TRACKS: "tracks", //$NON-NLS-1$
		TRACKED_BY: "tracked-by", //$NON-NLS-1$
		TRACKS_CHANGES: "tracks-changes", //$NON-NLS-1$
		CHANGES_TRACKED_BY: "changes-tracked-by", //$NON-NLS-1$
		TRACKS_RM: "tracks-rm", //$NON-NLS-1$
		TRACKED_BY_CM: "tracked-by-cm", //$NON-NLS-1$
		ELABORATES: "elaborates", //$NON-NLS-1$
		ELABORATED_BY: "elaborated-by", //$NON-NLS-1$
		ARCHITECTS: "architects", //$NON-NLS-1$
		ARCHITECTED_BY: "architected-by", //$NON-NLS-1$
		VALIDATED_BY_AM: "validated-by-am", //$NON-NLS-1$
		VALIDATES_AM: "validates-am" //$NON-NLS-1$
	};
	
	ProcessConstants.AllLinkTypes = [ProcessConstants.LinkTypes.IMPLEMENTS, ProcessConstants.LinkTypes.IMPLEMENTED_BY, ProcessConstants.LinkTypes.VALIDATES, ProcessConstants.LinkTypes.VALIDATED_BY, ProcessConstants.LinkTypes.TESTS, ProcessConstants.LinkTypes.TESTED_BY, ProcessConstants.LinkTypes.RELATED_TO, ProcessConstants.LinkTypes.TRACKS, ProcessConstants.LinkTypes.TRACKED_BY, ProcessConstants.LinkTypes.TRACKS_CHANGES, ProcessConstants.LinkTypes.CHANGES_TRACKED_BY, ProcessConstants.LinkTypes.TRACKS_RM, ProcessConstants.LinkTypes.TRACKED_BY_CM, ProcessConstants.LinkTypes.ELABORATES, ProcessConstants.LinkTypes.ELABORATED_BY, ProcessConstants.LinkTypes.ARCHITECTS, ProcessConstants.LinkTypes.ARCHITECTED_BY, ProcessConstants.LinkTypes.VALIDATED_BY_AM, ProcessConstants.LinkTypes.VALIDATES_AM];
	
	ProcessConstants.UsesLinkTypes = [ProcessConstants.LinkTypes.IMPLEMENTED_BY, ProcessConstants.LinkTypes.VALIDATES, ProcessConstants.LinkTypes.TESTS, ProcessConstants.LinkTypes.TRACKED_BY, ProcessConstants.LinkTypes.TRACKED_BY_CM, ProcessConstants.LinkTypes.CHANGES_TRACKED_BY, ProcessConstants.LinkTypes.ELABORATES, ProcessConstants.LinkTypes.ARCHITECTS, ProcessConstants.LinkTypes.VALIDATED_BY_AM];
	
	ProcessConstants.ServiceProviderTypes = {
		CM: "cmServiceProviders", //$NON-NLS-1$
		RM: "rmServiceProviders", //$NON-NLS-1$
		QM: "qmServiceProviders", //$NON-NLS-1$
		SCM: "scmServiceProviders", //$NON-NLS-1$
		AM: "amServiceProviders" //$NON-NLS-1$
	};
	
	ProcessConstants.CSSClass = {
		ACTION_COLUMN: "action-column", //$NON-NLS-1$
		TOOLBAR_TABLE: "toolbar-table", //$NON-NLS-1$
		TABLE_ROW_SELECTED: "selected" //$NON-NLS-1$
	};
	
	ProcessConstants.ProjectSelectorContext = {
		ADD: "jazz.app.events.contextSwitcher.addContext", //$NON-NLS-1$
		DELETE: "jazz.app.events.contextSwitcher.deleteContext" //$NON-NLS-1$
	};
	
	ProcessConstants.ProjectAreaExtensionPage = {
		EXTENSION_POINT_PROFILE_PAGES: "com.ibm.team.process.web.projectAreaEditorPages", //$NON-NLS-1$
		ELEMENT_PAGE: "page", //$NON-NLS-1$
		ATTRIBUTE_ID: "id", //$NON-NLS-1$
		ATTRIBUTE_TITLE: "title", //$NON-NLS-1$
		ATTRIBUTE_WIDGET: "widget", //$NON-NLS-1$
		ATTRIBUTE_TEAM_AREA_EDITOR: "teamAreaEditor", //$NON-NLS-1$
		ATTRIBUTE_UA_KEY: "uaKey", //$NON-NLS-1$
		ATTRIBUTE_UA_KEY_TEAM_AREA: "uaKeyForTeamAreaEditor" //$NON-NLS-1$
	};
	
	ProcessConstants.UAKey = {
		OVERVIEW_TAB: "com.ibm.team.process.web.tab_overview", //$NON-NLS-1$
		TIMELINES_TAB: "com.ibm.team.process.web.tab_timelines", //$NON-NLS-1$
		ROLES_TAB: "com.ibm.team.process.web.tab_roles", //$NON-NLS-1$
		PERMISSIONS_TAB: "com.ibm.team.process.web.tab_permissions", //$NON-NLS-1$
		ACCESSCONTROL_TAB: "com.ibm.team.process.web.tab_accesscontrol", //$NON-NLS-1$
		CONFIGURATION_DATA_TAB: "com.ibm.team.process.web.tab_configuration_data", //$NON-NLS-1$
		PROCESS_DESCRIPTION_TAB: "com.ibm.team.process.web.tab_process_description", //$NON-NLS-1$
		OVERVIEW_TEAMAREA_TAB: "com.ibm.team.process.web.tab_overview_teamarea", //$NON-NLS-1$
		ROLES_TEAMAREA_TAB: "com.ibm.team.process.web.tab_roles_teamarea", //$NON-NLS-1$
		PERMISSIONS_TEAMAREA_TAB: "com.ibm.team.process.web.tab_permissions_teamarea", //$NON-NLS-1$		
		ARCHIVED_PROJECTAREAS_PAGE: "com.ibm.team.process.web.page_archived_project_areas", //$NON-NLS-1$
		CREATE_PROJECTAREA_PAGE: "com.ibm.team.process.web.page_create_project_area", //$NON-NLS-1$				
		CROSS_APPLICATION_EVENTS_PAGE: "com.ibm.team.process.web.page_cross_application_events" //$NON-NLS-1$	
	};	
	
	ProcessConstants.TYPE_EVENT_SOURCE_NOT_LOADED = "eventSourceNotLoaded"; //$NON-NLS-1$
	ProcessConstants.TYPE_EVENT_SOURCE = "eventSource"; //$NON-NLS-1$
	ProcessConstants.TYPE_EVENT_TYPE_CATEGORY = "eventTypeCategory"; //$NON-NLS-1$
	ProcessConstants.TYPE_EVENT_TYPE = "eventType"; //$NON-NLS-1$
	ProcessConstants.ConfigurationData = {
		ROOT: "configurationDataRoot", //$NON-NLS-1$
		CATEGORY: "configurationDataTypeCategory", //$NON-NLS-1$
		CONFIGURATION_DATA_TYPE: "configurationDataType" //$NON-NLS-1$
	};
	ProcessConstants.PREFS_EVENTSOURCES_URL = "eventSourcesURL"; //$NON-NLS-1$
	ProcessConstants.PREFS_EVENTTYPES_URL = "eventTypesURL"; //$NON-NLS-1$
	ProcessConstants.RPCSERVICE_EVENTSOURCE_SELECTION_CHANGED = "eventSourceSelectionChanged"; //$NON-NLS-1$
	ProcessConstants.RPCSERVICE_EVENTTYPE_SELECTION_CHANGED = "eventTypeSelectionChanged"; //$NON-NLS-1$
	ProcessConstants.EVENTTYPES_GADGET_SPECIFICATION_URL = net.jazz.ajax._contextRoot + "/process-events-gadget-specification/eventTypesGadgetSpecification"; //$NON-NLS-1$
	ProcessConstants.EVENTSOURCES_URL = net.jazz.ajax._contextRoot + "/process-events/eventSources"; //$NON-NLS-1$
	ProcessConstants.EVENT_MANAGEMENT_WIDGET_URL = net.jazz.ajax._contextRoot + "/_ajax-modules/com.ibm.team.process.ManageCrossAppEventsWidget"; //$NON-NLS-1$
	
	ProcessConstants.NodeType = {
		ELEMENT: 1,
		ATTRIBUTE: 2,
		TEXT: 3,
		COMMENT: 8,
		DOCUMENT: 9
	};
	ProcessConstants.XMLATTRIBUTE_RESOURCE = "resource"; //$NON-NLS-1$
	ProcessConstants.XMLATTRIBUTE_ABOUT = "about"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_JTP = "http://jazz.net/xmlns/prod/jazz/jtp/0.6/"; //$NON-NLS-1$
	ProcessConstants.XMLELEMENT_TITLE = "title"; //$NON-NLS-1$
	
	// OSLC Core (V2) Constants
	ProcessConstants.OSLC_VERSION_HEADER = "OSLC-Core-Version"; //$NON-NLS-1$
	ProcessConstants.OSLC_CORE_VERSION = "2.0"; //$NON-NLS-1$
	ProcessConstants.OSLC_PRE_CORE_VERSION = "1.0"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_CORE = "http://open-services.net/ns/core#"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_CORE_CM = "http://open-services.net/ns/cm#"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_CORE_RM = "http://open-services.net/ns/rm#"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_CORE_QM = "http://open-services.net/ns/qm#"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_CORE_SCM = "http://open-services.net/ns/scm#"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_AM = "http://open-services.net/ns/am#"; //$NON-NLS-1$
	ProcessConstants.ELEM_OSLC_CATALOGS = "oslcCatalogs"; //$NON-NLS-1$
	ProcessConstants.ELEM_SERVICE_PROVIDER_CATALOG = "ServiceProviderCatalog"; //$NON-NLS-1$
	ProcessConstants.ELEM_DOMAIN = "domain"; //$NON-NLS-1$
	
	//Links to online help
	ProcessConstants.PROJECT_AREA_HELP_URL="http://publib.boulder.ibm.com/infocenter/clmhelp/v3r0m1/topic/com.ibm.jazz.platform.doc/topics/c_project_area.html"; //$NON-NLS-1$
	ProcessConstants.LPA_HELP_URL="http://publib.boulder.ibm.com/infocenter/clmhelp/v3r0m1/topic/com.ibm.jazz.platform.doc/topics/c_creating_managing_cross_application_projects.html"; //$NON-NLS-1$
})();
