/***********************************************************************************/
/* IBM Rational Jazz                                                               */
/*                                                                                 */
/* (c) Copyright IBM Corporation 2005-2008.                                        */
/* All rights reserved.                                                            */
/* US Government Users Restricted Rights -                                         */
/* Use, duplication or disclosure restricted                                       */
/* by GSA ADP Schedule Contract with IBM Corp.                                     */
/*                                                                                 */
/* Licensed Materials-Property of IBM                                              */
/*                                                                                 */
/* Portions of this file are based on buildUtils.js from the Dojo toolkit 0.9.     */
/* Accordingly, the following notices are included from the "New" BSD License:     */
/*                                                                                 */
/* Copyright (c) 2005, The Dojo Foundation                                         */
/* All rights reserved.                                                            */
/*                                                                                 */
/* Redistribution and use in source and binary forms, with or without              */
/* modification, are permitted provided that the following conditions are met:     */
/*                                                                                 */
/*   * Redistributions of source code must retain the above copyright notice, this */
/* 	list of conditions and the following disclaimer.                               */
/*   * Redistributions in binary form must reproduce the above copyright notice,   */
/*	this list of conditions and the following disclaimer in the documentation      */
/*	and/or other materials provided with the distribution.                         */
/*   * Neither the name of the Dojo Foundation nor the names of its contributors   */
/*	may be used to endorse or promote products derived from this software          */
/*	without specific prior written permission.                                     */
/*                                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED   */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE          */
/* DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE    */
/* FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL      */
/* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR      */
/* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER      */
/* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,   */
/* OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   */
/* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.            */
/*                                                                                 */
/***********************************************************************************/

var jsanalyzer0_9 = {};

jsanalyzer0_9.includeLoaderFiles = function(/*String*/dojoLoader, /*String or Array*/hostenvType){
	//summary: adds the loader files to the file list for a build file.
	dojo._loadedUrls.push("jslib/dojoGuardStart.jsfrag");
	dojo._loadedUrls.push("dojo/_base/_loader/bootstrap.js");
	dojo._loadedUrls.push("dojo/_base/_loader/loader.js");

	if(hostenvType.constructor == Array){
		for(var x=0; x<hostenvType.length; x++){
			dojo._loadedUrls.push("dojo/_base/_loader/hostenv_"+hostenvType[x]+".js");
		}
		hostenvType = hostenvType.pop();
	}else{
		dojo._loadedUrls.push("dojo/_base/_loader/hostenv_"+hostenvType+".js");
	}

	dojo._loadedUrls.push("jslib/dojoGuardEnd.jsfrag");
}


jsanalyzer0_9.findDependencies = function(dependencies){
	if(!dependencies){
		dependencies = [
			"dojo._base"
		];
	}
	
	var dojoLoader = "default";

	//Now build the URI list, starting with the main dojo.js file
	if(!dependencies["layers"]){
		dependencies.layers = [];
	}

	//Set up the dojo.js layer. Add _base if the profile already
	//defines a dojo.js layer. If the profile defines a dojo.js
	//layer it MUST be the first layer.
	if(dependencies.layers[0] && dependencies.layers[0].name == "dojo.js"){
		dependencies.layers[0].dependencies.unshift("dojo._base");
	}else{
		dependencies.layers.unshift({
			name: "dojo.js",
			dependencies: [
				"dojo._base"
			]
		});
	}

	currentProvideList = [];
	var result = [];
	var layers = dependencies["layers"];
	var layerCount = layers.length;
	
	//Process dojo layer files 
	if(layerCount){
		//Set up a lookup table for the layer URIs based on layer file name.
		var namedLayerUris = {};
				
		var endCount = layerCount;
		
		for(var i = 0; i < endCount; i++){
			var j = i;
			var layer = layers[j];
			var layerName = layers[j].name;

			djConfig = {
				baseRelativePath: "/"
				// isDebug: true
			};

			load("dojo/_base/_loader/bootstrap.js");
			load("dojo/_base/_loader/loader.js");
			load("core/internal/analyzer/hostenv_jazz0_9.js");
			dojo.global = {};
			dojo._global_omit_module_check = true;
			
			hostenvType = "browser";
		
			if(dependencies["prefixes"]){
				var tmp = dependencies.prefixes;
				for(var x=0; x<tmp.length; x++){
					dojo.registerModulePath(tmp[x][0], tmp[x][1]);
				}
			}
		
			dojo._name = hostenvType;
			if(hostenvType == "browser"){
				//Make sure we setup the env so that dojo
				//thinks we are running in a browser.
				dojo.isBrowser = true;
			}
			
			//Override dojo.provide to get a list of resource providers.
			var currentProvideList = [];
			dojo._provide = dojo.provide;
			dojo.provide = function(resourceName){
				currentProvideList.push(resourceName);
				dojo._provide(resourceName);
			}
			
			function removeComments(contents){
				// if we get the contents of the file from Rhino, it might not be a JS
				// string, but rather a Java string, which will cause the replace() method
				// to bomb.
				contents = contents ? new String(contents) : "";
				// clobber all comments
				return contents.replace( /(\/\*([\s\S]*?)\*\/|\/\/(.*)$)/mg , "");
			}
			
			dojo.oldRequireLocalization = dojo.requireLocalization;
			dojo.requireLocalization = function(modulename, bundlename, locale, availableFlatLocales){
				//dojo.oldRequireLocalization.apply(dojo, arguments);
				var syms = this._getModuleSymbols(modulename);
				var modpath = syms.concat("nls").join("/");

				requireLocalization(modpath, bundlename, locale, modulename, availableFlatLocales);
			}	
			dojo.oldRequire = dojo.require;
			dojo.require = function(moduleName, exactOnly, omitModuleCheck){
				return dojo._loadModule.apply(dojo, arguments);	
			}
			
			dojo._oldloadModule = dojo._loadModule;
			dojo._loadModule = function(moduleName, exactOnly, omitModuleCheck){
				var syms = this._getModuleSymbols(moduleName);
				var relpath = syms.join("/") + '.js';
				//print("relpath ["+relpath+"] moduleName["+moduleName+"]");
				loadModule(relpath, moduleName);
				dojo._oldloadModule.apply(dojo, arguments);
			}

			// over-write dojo.eval to prevent actual loading of subsequent files
			dojo._oldEval = dojo["eval"];
			dojo["eval"] = function(){ return true; }
			var old_load = load;
			load = function(uri){
				//print("uri ["+uri+"]");
				start(uri);
				try{
					var text = removeComments(readText(uri));
					var requires = dojo._getRequiresAndProvides(text);
					loadFromString(requires.join(";"));
					dojo._loadedUrls.push(uri);
					dojo._loadedUrls[uri] = true;
					//var delayRequires = dojo._getDelayRequiresAndProvides(text);
					//eval(delayRequires.join(";"));
					var localizations = dojo._getRequireLocalizations(text);
					loadFromString(localizations.join(";"));
				}catch(e){
					jsError("Error loading uri: [" + uri + "] at line "+e.lineNumber, e, e.lineNumber);
				}
				stop(uri);
				return true;
			}
			
			dojo._getRequiresAndProvides = function(contents){
				// FIXME: should probably memoize this!
				if(!contents){ return []; }
			
				// check to see if we need to load anything else first. Ugg.
				var deps = [];
				var tmp;
				RegExp.lastIndex = 0;
				var testExp = /dojo.(require|platformRequire|provide)\([\w\W]*?\)/mg;
				while((tmp = testExp.exec(contents)) != null){
					deps.push(tmp[0]);
				}
				
				//If there is a dojo.requireLocalization() call, make sure to add dojo.i18n
				if(contents.match(/dojo\.requireLocalization\(.*?\)/)){
					deps.push('dojo.require("dojo.i18n")');
				}
		
				return deps;
			}
			
			dojo._getDelayRequiresAndProvides = function(contents){
				// FIXME: should probably memoize this!
				if(!contents){ return []; }
			
				// check to see if we need to load anything else first. Ugg.
				var deps = [];
				var tmp;
				RegExp.lastIndex = 0;
				var testExp = /dojo.(requireAfterIf|requireIf)\([\w\W]*?\)/mg;
				while((tmp = testExp.exec(contents)) != null){
					deps.push(tmp[0]);
				}
				return deps;
			}
		
			dojo._getRequireLocalizations = function(contents){
				if(!contents){ return []; }
				var deps = [];
				var tmp;
				RegExp.lastIndex = 0;
				var testExp = /dojo\.requireLocalization\(.*?\)/mg;
				while((tmp = testExp.exec(contents)) != null){
					deps.push(tmp[0]);
				}
				return deps;
			}
			
			if(dependencies["dojoLoaded"]){
				dependencies["dojoLoaded"]();
			}
		
		
			if(layerName == "dojo.js"){
				jsanalyzer0_9.includeLoaderFiles("default", hostenvType);
			}
		
			//Set up list of module URIs that are already defined for this layer's
			//layer dependencies. Always include the dojo.js layer uris. dojo.js could
			//have more than _base, and in xdomain, it has dojo.i18n.
			var layerUris = [];
			if(layer.name != "dojo.js"){
				layerUris = layerUris.concat(namedLayerUris["dojo.js"]);
			}
			
			if(layer["layerDependencies"]){
				for(var j = 0; j < layer.layerDependencies.length; j++){
					if(namedLayerUris[layer.layerDependencies[j]]){
						layerUris = layerUris.concat(namedLayerUris[layer.layerDependencies[j]]);
					}
				}
			}

			//Get the final list of dependencies in this layer
			var depList = jsanalyzer0_9.determineUriList(layer.dependencies, layerUris, dependencies["filters"]); 
			
			//Store the layer URIs that are in this file as well as all files it depends on.
			namedLayerUris[layer.name] = layerUris.concat(depList);
		
			//Add to the results object.
			if(!layer["discard"]){
				result.push({
					layerName: layerName,
					depList: depList,
					provideList: currentProvideList
				});
			}

			//Reset for another run through the loop.
			currentProvideList = []; 
		
			load = old_load; // restore the original load function
			dojo["eval"] = dojo._oldEval; // restore the original dojo.eval function
			dojo._loadModule = dojo._oldloadModule;
			dojo.require = dojo.oldRequire;
			dojo.requireLocalization = dojo.oldRequireLocalization;

			var djGlobal = dojo.global;
			djGlobal['djConfig'] = undefined;
	
			delete dojo;
		}
	}

	return result; //Object with properties: name (String), depList (Array) and provideList (Array)
}

//Function to do the actual collection of file names to join.
jsanalyzer0_9.determineUriList = function(/*Array*/dependencies, /*Array*/layerUris, /*Object*/filters){
	for(var x=0; x<dependencies.length; x++){
		var dep;
		try{
			dep = dependencies[x];
			dojo._loadModule(dep, null, true);
		}catch(e){
			jsError("Error loading module: [" + dep + "]", e);
		}
	}

	var depList = [];
	var seen = {};
	uris: for(var x=0; x<dojo._loadedUrls.length; x++){
		var curi = dojo._loadedUrls[x];
		if(!seen[curi]){
			seen[curi] = true;
			if(filters){
				for(var i in filters){
					if(curi.match(filters[i])){
						continue uris;
					}
				}
			}
			
			//If the uri is already accounted for in another
			//layer, skip it.
			if(layerUris){
				for(var i = 0; i < layerUris.length; i++){ 
					if(curi == layerUris[i]){ 
						continue uris; 
					} 
				} 
			} 

			//No filter or layerUri matches, so it is good to keep.
			depList.push(curi);
		}
	}
	
	//Clear out the loadedUris for the next run. 
	dojo._loadedUrls = []; 
	return depList; 
}

