/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function(){
	load("core/internal/module/env.js");
	
	var obj_nodes = new java.util.HashMap();
	
	function makeNode(node){
		if ( node ) {
			if ( !obj_nodes.containsKey( node ) )
				obj_nodes.put( node, node.getNodeType() == 
					Packages.org.w3c.dom.Node.ELEMENT_NODE ?
						new DOMElement( node ) : new DOMNode( node ) );
			
			return obj_nodes.get(node);
		} else
			return null;
	}
	
	window.navigator.mimeTypes = {};
	window.navigator.appVersion = "";

	window.__defineSetter__("location", function(url){
	 	window.document = new DOMDocument(
							new java.io.ByteArrayInputStream(
								(new java.lang.String("<html><head><title></title></head><body><div id='test'></div></body></html>")).getBytes("UTF8")));	
	});
	
	window.__defineGetter__("location", function(url){
		return {
			get protocol(){
				return "file:";
			},
			get href(){
				return "file:///";
			},
			toString: function(){
				return this.href;
			},
			get pathname() {
				return "/";
			},
			get hash() {
				return "#";
			},
			get host() {
				return "";
			},
			get port() {
				return 80;
			},
			get hostname() {
				return "";
			},
			get search() {
				return "?";
			}
		};
	});
	
	DOMElement.prototype.removeChild = function(node){
		return makeNode((this._dom.removeChild( node._dom )));
	};
	
	DOMElement.prototype.replaceChild = function(newChild, oldChild) {
		return makeNode((this._dom.replaceChild( newChild._dom, oldChild._dom )));
	};
	
	DOMElement.prototype.hasChildNodes =  function() {
		return this._dom.hasChildNodes();
	};

	DOMElement.prototype.hasAttribute =  function(attribute) {
		return this._dom.hasAttribute(attribute);
	};
	
	DOMElement.prototype.__defineSetter__("innerHTML", function(html) {
		html = html.replace(/<\/?([A-Z]+)/g, function(m){
			return m.toLowerCase();
		});
		
		var nodes = this.ownerDocument.importNode(
			new DOMDocument( new java.io.ByteArrayInputStream(
				(new java.lang.String("<!DOCTYPE doc [<!ENTITY nbsp \"&#160;\">]><wrap>" + html + "</wrap>"))
					.getBytes("UTF8"))).documentElement, true).childNodes;
			
		while (this.firstChild)
			this.removeChild( this.firstChild );
		
		for ( var i = 0; i < nodes.length; i++ )
			this.appendChild( nodes[i] );
	});
	
	DOMDocument.prototype.__defineGetter__("firstChild", function() {
		return makeNode( this._dom.getFirstChild() );;
	});
	
	/*
	window.DOMAttrList = function(list) {
		this._dom = list;
		this.length = list.getLength();
		
		for ( var i = 0; i < this.length; i++ ) {
			var node = list.item(i);
			this[i] = new DOMAttr(node);
		}
	};
	
	DOMAttrList.prototype = {
		getNamedItem: function(name) {
			for (var i = 0; i < this.length; i++) {
				if (this[i].name == name) {
					return this[i];
				}
			}
			return null;
		},
		
		getLength: function() {
			return this.length;
		}		
	};
		
	window.DOMAttr = function(node){
		this._dom = node;
	};
	
	DOMAttr.prototype = {
		get specified() {
			return this._dom.getSpecified();
		},
		
		get name() {
			return new String(this._dom.getName());
		},
		
		get value() {
			return new String(this._dom.getValue());
		}	
	};
	
	DOMElement.prototype.__defineGetter__("attributes", function() {
		return new DOMAttrList(this._dom.getAttributes());
	});
	
	DOMElement.prototype.__defineGetter__("outerHTML", function() {
		var ret = "<" + this.tagName, attrs = this.attributes;
		
		for ( var i = 0; i < attrs.getLength(); i++ )
			ret += " " + attrs[i].name + "='" + attrs[i].value + "'";
			
		if ( this.childNodes.length || this.nodeName == "SCRIPT" )
			ret += ">" + this.childNodes.outerHTML + 
				"</" + this.tagName + ">";
		else
			ret += "/>";
		
		return ret;
	});
	*/
	
	XMLHttpRequest.prototype = {
		open: function(method, url, async, user, password){ 
			this.readyState = 1;
			this.method = method || "GET";
			this.url = url;
			this.onreadystatechange();
		},
		setRequestHeader: function(header, value){
			this.headers[header] = value;
		},
		getResponseHeader: function(header){ },
		send: function(data){
			var self = this;
			
			function makeRequest(){
				function handleResponse(){
					self.readyState = 4;
					self.status = 200;
					self.statusText = "";
					self.responseText = "<ok/>";
						
					try {
						self.responseXML = new DOMDocument(
							new java.io.ByteArrayInputStream(
								(new java.lang.String(
									self.responseText)).getBytes("UTF8")));
					} catch(e) {}
				}
				handleResponse();
				
				self.onreadystatechange();
			}
			
			makeRequest();
		},
		abort: function(){},
		onreadystatechange: function(){},
		getResponseHeader: function(header){
			if (this.readyState < 3)
				throw new Error("INVALID_STATE_ERR");
			else {
				var returnedHeaders = [];
				for (var rHeader in this.responseHeaders) {
					if (rHeader.match(new Regexp(header, "i")))
						returnedHeaders.push(this.responseHeaders[rHeader]);
				}
			
				if (returnedHeaders.length)
					return returnedHeaders.join(", ");
			}
			
			return null;
		},
		getAllResponseHeaders: function(header){
			if (this.readyState < 3)
				throw new Error("INVALID_STATE_ERR");
			else {
				var returnedHeaders = [];
				
				for (var header in this.responseHeaders)
					returnedHeaders.push( header + ": " + this.responseHeaders[header] );
				
				return returnedHeaders.join("\r\n");
			}
		},
		async: false,
		readyState: 0,
		responseText: "",
		status: 0
	};
	
	window.Image = function(width, height){};
	
	Image.prototype.__defineGetter__("border", function() {	return 0; });
	Image.prototype.__defineSetter__("border", function(border) {});
	Image.prototype.__defineGetter__("complete", function() {	return true; });
	Image.prototype.__defineSetter__("complete", function(complete) {});
	Image.prototype.__defineGetter__("height", function() {	return 0; });
	Image.prototype.__defineSetter__("height", function(height) {});
	Image.prototype.__defineGetter__("hspace", function() {	return 0; });
	Image.prototype.__defineSetter__("hspace", function(hspace) {});
	Image.prototype.__defineGetter__("lowsrc", function() {	return ""; });
	Image.prototype.__defineSetter__("lowsrc", function(lowsrc) {});
	Image.prototype.__defineGetter__("name", function() {	return ""; });
	Image.prototype.__defineSetter__("name", function(name) {});
	Image.prototype.__defineGetter__("src", function() {	return ""; });
	Image.prototype.__defineSetter__("src", function(src) {});
	Image.prototype.__defineGetter__("vspace", function() {	return 0; });
	Image.prototype.__defineSetter__("vspace", function(vspace) {});
	Image.prototype.__defineGetter__("width", function() {	return 0; });
	Image.prototype.__defineSetter__("width", function(width) {});
})();
