/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.app.events");

/**
 * Defines standard event names for the Jazz Web UI application environment.
 * Clients may subscribe to these events using dojo.subscribe(EVENT_NAME);
 * Clients should subscribe to the variable identifier, not the string value.
 * 
 * *WARNING* The string value of event names is not API and may be changed at
 * any time!
 * 
 * @since 0.7
 */

/**
 * Indicates that the user has logged in to the local server.
 * 
 * @since 0.7
 */
jazz.app.events.LOGIN = "jazz.app.events.login";

/**
 * Indicates that the user has logged out of the local server.
 * 
 * @since 0.7
 */
jazz.app.events.LOGOUT = "jazz.app.events.logout";

/**
 * Indicates that the logged-in user has changed.
 * 
 * @since 3.0
 */
jazz.app.events.USER_CHANGE = "jazz.app.events.userChange";


/**
 * Forces the home menu to refresh
 * 
 * @since 3.0
 */
jazz.app.events.HOME_MENU_REFRESH = "jazz.app.events.homeMenuRefresh";