/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ui.examples.ListBoxExamples");

/*
 * Imports 
 */
dojo.require("jazz.ui.ListBox"); 


(function() {

/*
 * Aliases 
 */
var ListBox = jazz.ui.ListBox;

/*
 * Class 
 */
jazz.ui.examples.ListBoxExamples = {
	
	iconMap: [
		"http://www.mozilla.com/favicon.ico",
		"http://www.ibm.com/favicon.ico",
		"http://www.apache.org/favicon.ico"
	],

	entries: [
				{
					label: "Arts &amp; Humanities",
					value: "value_1",
					id: "id_1",
					type: 0
				},	
				{
					label: "Business &amp; Economy",
					value: "value_2",
					id: "id_2",
					type: 1
				},	
				{
					label: "Education",
					value: "value_3",
					id: "id_3",
					type: 2
				},	
				{
					label: "Entertainment",
					value: "value_4",
					id: "id_4",
					type: 0
				},	
				{
					label: "Government",
					value: "value_5",
					id: "id_5",
					type: 1
				},	
				{
					label: "Health",
					value: "value_6",
					id: "id_6",
					type: 2
				},	
				{
					label: "News &amp; Media",
					value: "value_7",
					id: "id_7",
					type: 0
				},	
				{
					label: "Recreation &amp; Sports",
					value: "value_8",
					id: "id_8",
					type: 1
				},	
				{
					label: "Reference",
					value: "value_9",
					id: "id_9",
					type: 2
				},	
				{
					label: "Regional",
					value: "value_10",
					id: "id_10",
					type: 0
				},	
				{
					label: "Science",
					value: "value_11",
					id: "id_11",
					type: 1
				},	
				{
					label: "Social Science",
					value: "value_12",
					id: "id_12",
					type: 2
				},	
				{
					label: "Society &amp; Culture",
					value: "value_13",
					id: "id_13",
					type: 0
				},	
				{
					label: "Computers &amp; Internet",
					value: "value_14",
					id: "id_14",
					type: 1
				}
			],

	/*
 	 * @param void
 	 * 
 	 * @return ListBox
 	 */		
	_createListBox1: function() {
		
		var widget = new jazz.ui.ListBox({
							height: "250px",
							width: "250px",
							margin: "10px",
							sortField: "label",
							sortOrder: 0,
							allowMultipleSelections: true,
							iconMap: this.iconMap,
							onClick: function(entry) {
								console.log("single");
								console.debug(entry);
							}
						});
		
		widget.addEntries(this.entries);

		
		return widget;
	},

	/*
 	 * @param void
 	 * 
 	 * @return ListBox
 	 */		
	_createListBox2: function() {
		
		var widget = new jazz.ui.ListBox({
							margin: "10px",
							sortField: "type",
							sortOrder: 0,
							allowMultipleSelections: true,
							iconMap: this.iconMap,
							ondblClick: function(entry) {
								console.log("double");
								console.debug(entry);
							}
						});
		
		widget.addEntries(this.entries);
		
		return widget;
	},

	/*
 	 * @param void
 	 * 
 	 * @return ListBox
 	 */		
	_createListBox3: function() {
		
		var widget = new jazz.ui.ListBox({
							sortField: "label",
							sortOrder: 1,
							iconMap: this.iconMap
						});
		
		widget.addEntries(this.entries);
		
		return widget;
	},

	/*
 	 * @param void
 	 * 
 	 * @return ListBox
 	 */		
	_createListBox4: function() {
		
		var widget = new jazz.ui.ListBox({
							height: "500px"
						});
		
		widget.addEntries(this.entries);
		
		return widget;
	},

	/*
 	 * @param void
 	 * 
 	 * @return Element
 	 */		
	_createContainer1: function() {
		var container = document.createElement("div");
		container.style.width = "400px";
		container.style.border = "1px solid #CCCCCC";
		container.style.margin = "3px";
		return container;
	},

	/*
 	 * @param void
 	 * 
 	 * @return Element
 	 */		
	_createContainer2: function() {
		var container = document.createElement("div");
		container.style.width = "400px";
		container.style.border = "1px solid #CCCCCC";
		container.style.margin = "3px";
		return container;
	},

	/*
 	 * @param Element parent
 	 * 
 	 * @return void
 	 */		
	create: function(parent) {
		
		var table = document.createElement("table");
		var tbody = document.createElement("tbody");
		var tr = document.createElement("tr");
		var td1 = document.createElement("td");
		var td2 = document.createElement("td");
		
		// Example 1
		var container1 = this._createContainer1();
		this._listBox1 = this._createListBox1();
		container1.appendChild(this._listBox1.domNode);

		// Example 2
		var container2 = this._createContainer2();
		this._listBox2 = this._createListBox2();
		container2.appendChild(this._listBox2.domNode);

		// Example 3
		var container3 = this._createContainer1();
		this._listBox3 = this._createListBox3();
		container3.appendChild(this._listBox3.domNode);

		// Example 4
		var container4 = this._createContainer2();
		this._listBox4 = this._createListBox4();
		container4.appendChild(this._listBox4.domNode);

		// Assemble contents

		td1.appendChild(container1);
		td1.appendChild(container3);

		td2.appendChild(container2);
		td2.appendChild(container4);
		
		tr.appendChild(td1);
		tr.appendChild(td2);
		tbody.appendChild(tr);
		table.appendChild(tbody);
		parent.appendChild(table);
	}

};


})();

