/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.foundation.Status"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.repository.web.ui.internal", "FoundationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var OK= 0x00;
var INFO= 0x01;
var WARNING= 0x02;
var ERROR= 0x04;
var CANCEL= 0x08;

var MSGS= dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal", "FoundationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.repository.web.foundation.Status", null, { //$NON-NLS-1$

	// ---- constructor ----------------------------------------------------------------------------------------------------	

	_severity: null,
	_message: null,
	_exception: null,
	_subStatus: null,

	constructor: function(severity, message, exception) {
		this._severity= severity;
		this._message= message;
		this._exception= exception;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	isOK: function() {
		return this._severity == OK;
	},

	getMessage: function() {
		return this._message;
	},

	getException: function() {
		return this._exception;
	},

	getSeverity: function() {
		return this._severity;
	},
	
	getChildren: function() {
		return this._subStatus;
	},

	log: function(message) {
		var logMethod= console.debug;
		
		switch (this._severity) {
			case INFO:
				logMethod= console.info;
				break;	
			case WARNING:
				logMethod= console.warn;	
				break;	
			case ERROR:
				logMethod= console.error;	
				break;	
		}
		
		var out= (dojo.isString(message) ? message : "") + this._message; //$NON-NLS-1$
		logMethod.call(console, out);
	},

	__sentinel: null // terminates this class definition
});

com.ibm.team.repository.web.foundation.Status.OK= OK;
com.ibm.team.repository.web.foundation.Status.INFO= INFO;
com.ibm.team.repository.web.foundation.Status.WARNING= WARNING;
com.ibm.team.repository.web.foundation.Status.ERROR= ERROR;
com.ibm.team.repository.web.foundation.Status.CANCEL= CANCEL;

com.ibm.team.repository.web.foundation.Status.OK_STATUS= new com.ibm.team.repository.web.foundation.Status(OK, MSGS.OK, null); //$NON-NLS-1$

})();
