/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.app.web.internal.AdminApplication"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.ui.internal.admin.AdminApplication"); //$NON-NLS-1$
dojo.require("com.ibm.team.dashboard.web.ui.DashboardMini"); //$NON-NLS-1$
dojo.require("com.ibm.team.app.web.internal.welcome.WelcomeUtil"); //$NON-NLS-1$
dojo.require("dojo.string");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.app.web.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

var messages = dojo.i18n.getLocalization("com.ibm.team.app.web.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.app.web.internal.AdminApplication", com.ibm.team.repository.web.ui.internal.admin.AdminApplication, { //$NON-NLS-1$
	start: function() {
		this.ui.attr("drawer", "com.ibm.team.dashboard.web.ui.DashboardMini");
		this.inherited(arguments);
	},
	contributeToHelpMenu: function(menu){
		var dfd = com.ibm.team.app.web.internal.welcome.WelcomeUtil.isWelcomeEnabled();
		dfd.addCallback(dojo.hitch(this, function (enabled) {
			if (enabled) {
				menu.addItemByArgs({label: messages.welcome, onClick: dojo.hitch(this, this._openWelcomePage)});
			}
		}));
	},
	_openWelcomePage: function(event) {
		location.href = "#action=com.ibm.team.app.viewWelcome";
	}
});
})();
