/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.app.internal.BannerButtons");

(function() {

dojo.require("jazz.ui.MenuPopup");

dojo.declare("jazz.app.internal.BannerButtons", [dijit._Widget, dijit._Templated], {
	
	buttons: null, //array of objects - args: label, iconSrc, align, href, pageId, suppressPage, menuProvider
	
	templateString: "<div class=\"jazz-app-BannerButtons\"></div>",
	
	postCreate: function() {
		var buttons = this.buttons || [];
		var a11y = dojo.hasClass(document.body, "dijit_a11y");
		for (var i = 0; i < buttons.length; i++) {
			var args = buttons[i];
			if (args.domNode) {
				this.domNode.appendChild(args.domNode);
			} else {
				var label = args.label;
				if (!label) {
					console.error("Error creating button: Must pass label param"); //$NON-NLS-1$
					return;
				}
				var button = document.createElement("a");
				button.href = args.href ? args.href : "#";
				if (!args.href && !args.pageId) {
					this.connect(button,"onclick",dojo.stopEvent);
				}
				button.title = label;
				if (a11y) dojo.place(document.createTextNode(label),button);
				if (args.iconSrc) {
					var icon = document.createElement("img");
					icon.alt = label;
					icon.src = args.iconSrc;
					button.appendChild(icon);			
				} 
				if (args.className) {
					var inner = document.createElement("span");
					dojo.addClass(inner, "sprite-image");
					dojo.addClass(inner, args.className);
					button.appendChild(inner);
				}
				this.domNode.appendChild(button);
				if (args.menuProvider) {
					new jazz.ui.MenuPopup({group: "jazz-app-BannerButtons", align: args.align, menuProvider: args.menuProvider, menuClass:"jazz-app-Navbar-menu", injectCaret: true, destroyOnClose: true}, button);
				} else {
					dojo.addClass(button,"menu-narrow");
				}
				
			}
			if (args.rightPipe || i < buttons.length - 1) {
				var pipe = document.createElement("span");
				pipe.className = "pipe";
				pipe.innerHTML = "|";
				this.domNode.appendChild(pipe);
			}		
		}
	}
});
})();