/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("jazz.app.internal.BannerSearch"); //$NON-NLS-1$

dojo.require("dijit._Widget");

dojo.require("jazz.ui.SearchBox");
dojo.require("jazz.core.loader");

var SearchBox = jazz.ui.SearchBox;

dojo.declare("jazz.app.internal.BannerSearch",[dijit._Widget],{
	
	buildRendering: function() {
		if (dojo.isIE === 7)
			this.domNode = dojo.create("div",{style: {overflow: "hidden"}});
		else
			this.inherited(arguments);
	},
	
	startup: function() {
		this.searchProviders = [];
		this.defaultNames = [];
		this.defaultProvider = null;
		dojo.forEach(net.jazz.ajax.ui.internal.PageRegistry.getPages(true), dojo.hitch(this,function(page) {
			if (page.searchProvider != null) {
				this.searchProviders.push(page.searchProvider);
				this.defaultNames.push(page.name);
				if (page.isDefaultSearch) {
					this.defaultProvider = page.searchProvider;
					this.defaultScope = page.defaultSearchScope;
				}
			}
		}));
		if (this.searchProviders && this.searchProviders.length) {
			jazz.core.loader.batch_load_async(dojo.clone(this.searchProviders), dojo.hitch(this,function() {
				this._createSearchBox();
			}));
		}
		this.inherited(arguments);
	},
	
	_createSearchBox: function() {
		var args = {_bannerSearch: true}, providers = [], provider;
		for (var i = 0; i < this.searchProviders.length; i++) {
			provider = dojo.getObject(this.searchProviders[i]);
			provider = new provider();
			if (!provider.name)
				provider.name = this.defaultNames[i];
			providers.push(provider);
			if (this.searchProviders[i] === this.defaultProvider) {
				args.defaultProvider = provider;
				args.defaultScope = this.defaultScope;
			}
		}
		args.providers = providers;
		this._searchBox = new SearchBox(args);
		this._searchBox.placeAt(this.domNode, "first");
	}
});

})();