/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ensemble.internal.Layout");

dojo.require("dijit._Widget");

(function() {

/*
 * An abstract dijit widget which contains and lays out content
 * according to a specific arrangement.
 * 
 * Layout items have these properties:
 * - {string} id: identifier
 * - {Node} domNode: the DOM node
 */
dojo.declare("jazz.ensemble.internal.Layout", [dijit._Widget], {
	
	data: null,
	items: null,
	onStateChange: function() {},
	onAddWidget: function(elem) {},
	onRemoveWidget: function(elem) {},
	readOnly: false,
	
	/*
	 * A static method on the Layout subclass that provides the default
	 * layout data for an empty layout of this type.
	 */
	/* static */ getDefaultData: function(/* Element */ parentElem) {},
	
	/*
	 * Adds the given item to the layout, optionally before another
	 * item.
	 */
	add: function(/* object */ item, /* string|node? */ ref, /*number? */ pos) {},
	
	/*
	 * Returns an XML DOM element describing the current state of the layout.
	 */
	getState: function() {},
	
	/*
	 * Sets the maximized state of the item with the given id. If true, the
	 * item will be maximized to take up the entire content area of the layout,
	 * else it will be restored to its original size.
	 */
	setMaximized: function(/* string */ id, /* boolean */ maximized) {},
	
	/*
	 * Removes the item with the given id from the layout.
	 */
	remove: function(/* string */ id) {},
	
	/*
	 * Initializes the layout. Must be called immediately after the layout
	 * is added to the live DOM.
	 */
	startup: function() {}
});
})();