/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ensemble.internal.LayoutFactory");

dojo.require("jazz.ensemble.internal.layout.ColumnLayout");

(function() {

var ColumnLayout = jazz.ensemble.internal.layout.ColumnLayout;

// for new tabs
var DEFAULT_LAYOUT = ColumnLayout.ID_3;

jazz.ensemble.internal.LayoutFactory = {
	
	createLayout: function(/* object */ state, /* object[] */ items, /* boolean */ readOnly) {
		var data = state.getData();
		var type = state.getType();
		var args = {
			data: data.getLayoutData(),
			items: items,
			readOnly: readOnly,
			type: type
		};
		switch (type) {
			case ColumnLayout.ID_1:
			case ColumnLayout.ID_2:
			case ColumnLayout.ID_3:
				return new ColumnLayout(args);
			default:
				throw new Error("Invalid layout type '" + type + "'");
		}
	},
	
	/*
	 * Creates a default empty layout for the given page binding.
	 */
	createDefaultLayoutState: function(/* object */ page) {
		var layoutProp = page.createLayout();
		page.setLayout(layoutProp);
		var layout = layoutProp.createLayout();
		layoutProp.setLayout(layout);
		layout.setType(DEFAULT_LAYOUT);
		var data = layout.createData();
		layout.setData(data);
		var layoutDataElem = ColumnLayout.getDefaultData(data.elem);
		data.setLayoutData(layoutDataElem);
		return layoutProp;
	}
};

})();