/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("jazz.app.internal.LoginApplication"); //$NON-NLS-1$

dojo.require("jazz.app.internal.LoginText"); //$NON-NLS-1$
dojo.require("jazz.util.internal.login"); //$NON-NLS-1$
dojo.require("jazz.app.internal.LoginWidget"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui._Application"); //$NON-NLS-1$

dojo.requireLocalization("jazz.app.internal", "LoginWidgetMessages"); //$NON-NLS-1$

/**
 * This class provides client-side functionality in support of the Jazz server's
 * form-based log in implementation. See <code>net.jazz.web.app/plugin.xml<code>
 * for full documentation.
 */
dojo.declare("jazz.app.internal.LoginApplication", net.jazz.ajax.ui._Application, { //$NON-NLS-1$
	constructor: function() {
		
		// initialize UI
		dojo.body().removeChild(dojo.byId("net-jazz-ajax-InitialLoadMessage")); //$NON-NLS-1$
		this.messages = dojo.i18n.getLocalization("jazz.app.internal", "LoginWidgetMessages");
		
		var mode = jazz.util.internal.login.getLoginMode();
		var state = "";
		if(window.location.href.indexOf("authfailed") !== -1 || //$NON-NLS-1$
				window.location.href.indexOf("j_security_check") !== -1) { //$NON-NLS-1$
			state = "login-failed"; //$NON-NLS-1$
		}
		if(mode === "page") {
			this.showLoginForm(mode, state);
		} else {
			this.showLoginText(state);
		}
		
	},
	
	showLoginForm: function(mode, state) {
		document.title = this.messages.login;
		
		// show log in widget
		var loginForm = new jazz.app.internal.LoginWidget({
			state: state
		});
		var styledBox = new jazz.ui.Dialog({
			focusNode: loginForm.focusNode,
			modal: true,
			closable: false,
			width: "580px", //$NON-NLS-1$
			trim: jazz.ui.StyledBox.TrimStyles.LOGIN,
			contentNode: loginForm.domNode
		});
		loginForm.startup();
	},
	
	showLoginText: function(state) {
		var loginText = new jazz.app.internal.LoginText({
			state: state
		});
		dojo.body().appendChild(loginText.domNode);
	}
});

})();