/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("jazz.app.internal.LoginText"); //$NON-NLS-1$

dojo.require("dojo.string");
dojo.require("dijit._Widget");
dojo.require("jazz.util.internal.login");

dojo.requireLocalization("jazz.app.internal", "LoginWidgetMessages");

dojo.declare("jazz.app.internal.LoginText", dijit._Widget, { //$NON-NLS-1$
	postCreate: function() {
		this.domNode.style.backgroundColor = "transparent";
		this.domNode.style.padding = "10px";
		this.messages = dojo.i18n.getLocalization("jazz.app.internal", "LoginWidgetMessages");
		this.inherited(arguments);
		var loginLink = jazz.util.internal.login.insertLoginLink(this.domNode);
		this.connect(loginLink, "onclick", this.openLoginWindow);
		if(this.state === "login-failed") {
			var errorDiv = document.createElement("div");
			errorDiv.style.color = "red";
			errorDiv.appendChild(document.createTextNode(this.messages.invalidCredentials));
			this.domNode.appendChild(errorDiv);
		}
	},
	
	openLoginWindow: function(e) {
		dojo.stopEvent(e);
		
		var onSubmitFnName = "jazz.auth.onSubmit";
		var postSubmitFnName = "jazz.auth.postSubmit";
		
		var uriParts = [];
		uriParts[0] = net.jazz.ajax._contextRoot + "/web/login";
		uriParts[1] = "?callback=" + (this.onSubmit ? onSubmitFnName : postSubmitFnName);
		//uriParts[2] = "&debug=true&debugDojo=true";
		var popupUrl = uriParts.join("");
		
		var win = window.open(popupUrl, "authPopup", "location=1,status=1,scrollbars=1,width=750,height=675");
		
		var self = this;
		if(this.onSubmit) {
			window[onSubmitFnName] = function(userId, password) {
				self.onSubmit(userId, password);
				win.close();
			};
		} else {
			window[postSubmitFnName] = function(loadUri) {
				//console.warn("going to ... " + loadUri);
				window.location.href = loadUri + jazz.util.internal.login.getLocationHash();
				win.close();
			};
		}
		
		//function pollPopup() {
		//	if(win.location.href.indexOf("loggedInUser") != -1) {
		//	if(!win) {
		//		alert("window closed");
		//		clearInterval(pollPopupInterval);
		//	}
		//}
		//var pollPopupInterval = setInterval(pollPopup, 100);
	}
});

})();