/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("jazz.ui.internal.NodeMenuItem");

dojo.require("dijit.MenuItem");

dojo.declare("jazz.ui.internal.NodeMenuItem", dijit.MenuItem, {
	templateString: "<tr class=\"jazz-ui-NodeMenuItem dijitMenuItem\" waiRole=\"menuitem\"><td colspan=\"4\"><div dojoAttachPoint=\"containerNode, focusNode\" tabIndex=\"-1\"></div></td></tr>",
	label: "",
	focusable: false,
	isTitle: false,
	attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
		label: { node: "containerNode", type: "innerHTML" },
		className: { node: "containerNode", type: "class"}
	}),
	postCreate: function(){
		this.inherited(arguments);
		if (!this.focusable) {
			dojo.setSelectable(this.domNode, false);
			this.focusNode.removeAttribute("tabIndex");
		}
	},
	isFocusable: function(){
		return !!this.focusable;
	},
	focus: function(){
		if (!this.domNode || !this.focusable) return;
		this.inherited(arguments);
	},
	_setIsTitleAttr: function(isTitle) {
		dojo.toggleClass(this.containerNode, "menu-title", isTitle);
		this.isTitle = isTitle;
	},
	_setSelected: function(){
		if (this.focusable) this.inherited(arguments);
	}
});
})();
