/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ensemble.internal.catalog.WidgetCatalogDialog");

dojo.require("jazz.ensemble.internal.catalog.WidgetCatalog");
dojo.require("jazz.ui.Dialog");

dojo.requireLocalization("jazz.ensemble.internal", "WidgetCatalogMessages");

(function() {

var WidgetCatalog = jazz.ensemble.internal.catalog.WidgetCatalog;

var _messages = dojo.i18n.getLocalization("jazz.ensemble.internal", "WidgetCatalogMessages");

dojo.declare("jazz.ensemble.internal.catalog.WidgetCatalogDialog", jazz.ui.Dialog, {
	
	iconPath: dojo.moduleUrl("jazz.ensemble", "internal/graphics/widget-catalog/images/dialog-icon.gif"),
	primaryTitle: _messages.dialogTitle,
	width: "900px",
	
	constructor: function(args) {
		this.contentNode = dojo.create("div", {"class": "jazz-ensemble-internal-catalog-WidgetCatalogDialog-content"});
		this._catalog = new WidgetCatalog({
			provider: args.provider,
			onAddWidget: args.onAddWidget
		});		
		dojo.place(this._catalog.domNode, this.contentNode);
		var buttonBarDiv = dojo.create("div", {"class": "button-bar"}, this.contentNode);
		dojo.create("input", {type: "submit", value: _messages.dialogClose, "class": "close", onclick: dojo.hitch(this, this.close)}, buttonBarDiv);
	},
	
	destroy: function() {
		this._catalog.destroy();
		this.inherited(arguments);
	}
});

})();
