/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.util.internal.login");

dojo.require("dojo.cookie");

dojo.require("dojo.i18n");
dojo.require("dojo.string");
dojo.requireLocalization("jazz.util.internal", "LoginMessages");

jazz.util.internal.login.getLoginMode = function() {
	var mode = "page";
	
	try {
		if (top.location.href !== window.location.href) {
			mode = "frame";
		}
	} catch (e) {
		// if you're in an iframe in a different domain, the top.location check
		// results in a security exception
		mode = "frame";
	}
	
	// mode override for testing
	var query = location.search;
	if (query && (query.indexOf("showLoginLink=true") !== -1 || query.indexOf("testTextualLogin=true") !== -1)) {
		mode = "frame";
	}
	
	//console.warn("mode: " + mode + ", top.location.href: " + top.location.href + ", window.location.href: " + window.location.href);
	return mode;
};

jazz.util.internal.login.getLocationHash = function() {
	var result = window.location.hash;
	if (result)
		return result;
	result = window.document.URL;
	var index = result.indexOf('#');
	if (index > 0)
		return result.substr(index);
	return "";
};

jazz.util.internal.login.insertLoginLink = function(parentNode, hostname) {
	if (!hostname && hostname !== false) hostname = window.location.hostname;
	var tmpSpan = document.createElement("span");
	var messages = dojo.i18n.getLocalization("jazz.util.internal", "LoginMessages");
	tmpSpan.innerHTML = hostname ? dojo.string.substitute(messages.loginLinkText, [hostname]) : messages.loginLinkTextShort;
	var loginLink = tmpSpan.getElementsByTagName("a")[0];
	while(tmpSpan.hasChildNodes()) {
		parentNode.appendChild(tmpSpan.removeChild(tmpSpan.firstChild))
	}
	return loginLink;
}

jazz.util.internal.login.getUserIdCookie = function() {
	return dojo.cookie("net-jazz-ajax-cookie-rememberUserId");
};

jazz.util.internal.login.setUserIdCookie = function(userId) {
	dojo.cookie("net-jazz-ajax-cookie-rememberUserId", userId, {path: net.jazz.ajax._contextRoot, expires: 14 /*days*/});
};
