/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.app.internal.lpa");
dojo.require("jazz.app.internal.util.XhrUtil");
dojo.require("jazz.app.internal.util.DiscoveredService");
dojo.require("jazz.app.internal.schema.UserProjects");


(function(){
var XhrUtil = jazz.app.internal.util.XhrUtil;
var namespace = jazz.ensemble.internal.util.Xml.namespace;
var schema = jazz.app.internal.schema.UserProjects;
var DiscoveredService = jazz.app.internal.util.DiscoveredService;

namespace.lpa="http://jazz.net/xmlns/foundation/lpa/1.0/"; 

jazz.app.internal.lpa.getRelatedProjects = function(project, passive){
	var deferred = new dojo.Deferred();
	
	var serviceDeferred = jazz.app.internal.lpa.getUserProjectService();
	
	serviceDeferred.addCallback(function(service){
		if (!service) {
			deferred.callback(null);
			return;
		}
		var userProjectDeferred = XhrUtil.getXml(service, {
			schema: schema.projectService,
			passive: passive
		});
		userProjectDeferred.addCallback(function(service){
			deferred.callback(getRelatedContainers(service, project));
		});
		userProjectDeferred.addErrback(function(error){
			deferred.errback(error);
		});
	});
	serviceDeferred.addErrback(function(error){
		deferred.errback(error);
	});
	return deferred;
}

function getRelatedContainers(userProjects, container){
	var project = findProject(userProjects, container);
	if (project==null) return [];
	return project.containers;
}

function findProject(userProjects, container){
	if (userProjects && userProjects.projects) {
		for (var i = 0; i < userProjects.projects.length; i++) {
			var project = userProjects.projects[i];
			
			for (var j = 0; j < project.containers.length; j++) {
				if (project.containers[j].indexOf(container) >= 0) {
					return project;
				}
			}
		}
	}
	return null;
}
/**
 * cache the service URI
 */
var userProjectService = null; 
jazz.app.internal.lpa.getUserProjectService = function(){
	if (userProjectService) return XhrUtil.immediateCallback(userProjectService);
	
	var deferred = DiscoveredService.loadDiscoveryServices(namespace.lpa + "UserProjects", schema.discovery);
	 
	deferred.addCallback(function(services){
		return services&&services.UserProjects&&services.UserProjects.length&&services.UserProjects[0].service; 
	});
	
	return deferred;
}
})();
