/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.app.internal.schema.AboutService");

dojo.require("jazz.ensemble.internal.util.XmlBindingFactory");
dojo.require("jazz.ensemble.internal.util.Xml");

(function() {
	
var XmlBindingFactory = jazz.ensemble.internal.util.XmlBindingFactory;
var namespace = jazz.ensemble.internal.util.Xml.namespace;
var JFS_NS 	= "http://jazz.net/xmlns/prod/jazz/jfs/1.0/";

jazz.app.internal.schema.AboutService = {
		
	application: [{
		property:       "Application",
		type:     		XmlBindingFactory.OBJECT,
		nodeType: 		XmlBindingFactory.CHILD_ELEMENT,
		elemName: 		"Application",
		elemNS:   		namespace.jd,
		multiValued: 	false,
		schema:   	
			[{	property:		"publisher",
				type:			XmlBindingFactory.STRING,
				nodeType:		XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
				elemNS:			namespace.oslc,
				elemName:		"publisher",
				attrNS:			namespace.rdf,
				attrName:		"resource"
			},{	
				property: 		"rootServices",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
				elemNS:			namespace.jd,
				elemName:		"rootServices",
				attrNS: 		namespace.rdf,
				attrName: 		"resource"
			},{	
				property: 		"contextRoot",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_TEXT,
				elemNS:			namespace.jd,
				elemName:		"contextRoot"
			},{	
				property: 		"systemApplication",
				type: 			XmlBindingFactory.BOOLEAN,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_TEXT,
				elemNS:			namespace.jd,
				elemName:		"systemApplication"
			}]
		}],
	
	//TODO: Include the oslc:publisher URL for the application-about in this object
		
	aboutService: [{
		property:		"About",
		type:			XmlBindingFactory.OBJECT,
		nodeType:		XmlBindingFactory.CHILD_ELEMENT,
		elemNS:			namespace.oslc,
		elemName:		"Publisher",
		attrNS:     	namespace.rdf,
		attrName:   	"resource",
		multiValued:	false,
		schema: [{
			property:  "title",
			type:      XmlBindingFactory.STRING,
			nodeType:  XmlBindingFactory.CHILD_ELEMENT_TEXT,
			elemNS:    namespace.dublin,
			elemName:  "title"
		},{	
			property:  "description",
			type:      XmlBindingFactory.STRING,
			nodeType:  XmlBindingFactory.CHILD_ELEMENT_TEXT,
			elemNS:    namespace.dublin,
			elemName:  "description"
		},{	
			property:  	"identifier",
			type:      	XmlBindingFactory.STRING,
			nodeType:   XmlBindingFactory.CHILD_ELEMENT_TEXT,
			elemNS:     namespace.dublin,
			elemName:   "identifier"
		},{	
			property:   "icon",
			type:       XmlBindingFactory.STRING,
			nodeType:   XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
			elemNS:     namespace.oslc,
			elemName:   "icon",
			attrNS:     namespace.rdf,
			attrName:   "resource"
		},{
			property:  	"version",
			type:      	XmlBindingFactory.STRING,
			nodeType:  	XmlBindingFactory.CHILD_ELEMENT_TEXT,
			elemNS:    	JFS_NS,
			elemName:  	"version"
		},{	
			property:  	"instanceName",
			type:      	XmlBindingFactory.STRING,
			nodeType:  	XmlBindingFactory.CHILD_ELEMENT_TEXT,
			elemNS:    	JFS_NS,
			elemName:  	"instanceName"
	    }]
    }]		
	
}

})();
