/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.app.internal.schema.HomeMenu");

dojo.require("jazz.ensemble.internal.util.XmlBindingFactory");
dojo.require("jazz.ensemble.internal.util.Xml");

(function() {
	
var XmlBindingFactory = jazz.ensemble.internal.util.XmlBindingFactory;
var namespace = jazz.ensemble.internal.util.Xml.namespace;

jazz.app.internal.schema.HomeMenu = {
	
	discovery: [{
		property:       "HomeMenu",
		type:     		XmlBindingFactory.OBJECT,
		nodeType: 		XmlBindingFactory.CHILD_ELEMENT,
		elemName: 		"HomeMenu",
		elemNS:   		namespace.ju,
		multiValued: 	true,
		schema:   	
			[{	property: 		"menuSection",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
				elemNS:			namespace.ju,
				elemName:		"menuSection",
				attrNS: 		namespace.rdf,
				attrName: 		"resource"
			},{	
			    property: 		"publisher",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_TEXT,
				elemNS:			namespace.dublin,
				elemName:		"publisher"
			},{
				property:		"applicationAbout",
				type:			XmlBindingFactory.STRING,
				nodeType:		XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
				elemNS:			namespace.oslc,
				elemName:		"publisher",
				attrNS:			namespace.rdf,
				attrName:		"resource"
			},{	
				property: 		"defaultIcon",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
				elemNS:			namespace.ju,
				elemName:		"defaultIcon",
				attrNS: 		namespace.rdf,
				attrName: 		"resource"
			},{	
				property: 		"service",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
				elemNS:			namespace.jd,
				elemName:		"service",
				attrNS: 		namespace.rdf,
				attrName: 		"resource"
			},{	
				property: 		"contextRoot",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_TEXT,
				elemNS:			namespace.jd,
				elemName:		"contextRoot"
			}]
		}],

	menuService: [{
		property:   "MenuItems",
		type:       XmlBindingFactory.OBJECT,
		nodeType:   XmlBindingFactory.CHILD_ELEMENT,
		multiValued:true,
		elemNS:     namespace.ju,
		elemName:   "MenuItem",
		schema: [{
			property:  "title",
			type:      XmlBindingFactory.STRING,
			nodeType:  XmlBindingFactory.CHILD_ELEMENT_TEXT,
			elemNS:    namespace.dublin,
			elemName:  "title"
			},{	
			property:   "link",
			type:       XmlBindingFactory.STRING,
			nodeType:   XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
			elemNS:     namespace.ju,
			elemName:   "link",
			attrNS:     namespace.rdf,
			attrName:   "resource"
		    },{	
			property:   "resource",
			type:       XmlBindingFactory.STRING,
			nodeType:   XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
			elemNS:     namespace.ju,
			elemName:   "resource",
			attrNS:     namespace.rdf,
			attrName:   "resource"
		    },{				
			property:   "icon",
			type:       XmlBindingFactory.STRING,
			nodeType:   XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
			elemNS:     namespace.ju,
			elemName:   "icon",
			attrNS:     namespace.rdf,
			attrName:   "resource"
		    },{	
			property:   "usage",
			type:       XmlBindingFactory.STRING,
			nodeType:   XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
			elemNS:     namespace.ju,
			elemName:   "usage",
			attrNS:     namespace.rdf,
			attrName:   "resource"
		    }]
	    }]
	
}

})();
