/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.app.internal.schema.UIEntryPoints");

dojo.require("jazz.ensemble.internal.util.XmlBindingFactory");
dojo.require("jazz.ensemble.internal.util.Xml");

(function() {
	
var XmlBindingFactory = jazz.ensemble.internal.util.XmlBindingFactory;
var namespace = jazz.ensemble.internal.util.Xml.namespace;
var JFS_NS 	= "http://jazz.net/xmlns/prod/jazz/jfs/1.0/";

jazz.app.internal.schema.UIEntryPoints.getSchema = function (arr) {
	if (dojo.isArray(arr)) {
		schema = [];
		for (var i = 0; i < arr.length; i++) {
			var thisSchema = dojo.clone(baseSchema);
			thisSchema.property = arr[i];
			thisSchema.elemName = arr[i];
			schema.push(thisSchema);
		}
	} else {
		return [];
	}
	return schema;
}

var baseSchema = {
	property:	"",
	elemName:	"",
	type:		XmlBindingFactory.OBJECT,
	nodeType:	XmlBindingFactory.CHILD_ELEMENT,
	elemNS: 	namespace.juentry,
	schema: [{
		property:	"url",
		type:		XmlBindingFactory.STRING,
		nodeType:	XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
		elemNS:		namespace.jd,
		elemName:	"service",
		attrNS:		namespace.rdf,
		attrName:	"resource"
	}]
};

})();
