/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.app.internal.schema.UserProjects");

dojo.require("jazz.ensemble.internal.util.XmlBindingFactory");
dojo.require("jazz.ensemble.internal.util.Xml");

(function() {
	
var XmlBindingFactory = jazz.ensemble.internal.util.XmlBindingFactory;
var namespace = jazz.ensemble.internal.util.Xml.namespace;

namespace.lpa="http://jazz.net/xmlns/foundation/lpa/1.0/"; 

jazz.app.internal.schema.UserProjects = {
	discovery: [{
		property:       "UserProjects",
		type:     		XmlBindingFactory.OBJECT,
		nodeType: 		XmlBindingFactory.CHILD_ELEMENT,
		elemName: 		"UserProjects",
		elemNS:   		namespace.lpa, 
		multiValued: 	true,
		schema:   	
			[{	property: 		"service",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
				elemNS:			namespace.jd,
				elemName:		"service",
				attrNS: 		namespace.rdf, 
				attrName: 		"resource"
			}]
		}],
	projectService: [{	
		property:       "projects",
		type:     		XmlBindingFactory.OBJECT,
		nodeType: 		XmlBindingFactory.CHILD_ELEMENT,
		elemName: 		"Project",
		elemNS:   		namespace.lpa,
		multiValued: 	true,
		schema:   		
			[{	property:		"containers",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
				elemName:		"container",
				elemNS:			namespace.lpa,
				attrName: 		"resource",
				attrNS: 		namespace.rdf,
				multiValued: 	true
			},{	
				property: 		"title",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_TEXT,
				elemName:		"title",
				elemNS:			namespace.dublin
			},{	
				property:		"about",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.ATTRIBUTE,
				attrName: 		"about",
				attrNS: 		namespace.rdf
			}]
	},{	
		property:       "containers",
		type:     		XmlBindingFactory.OBJECT,
		nodeType: 		XmlBindingFactory.CHILD_ELEMENT,
		elemName: 		"Container",
		elemNS:   		namespace.lpa,
		multiValued: 	true,
		schema:   		
			[{	property:		"about",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.ATTRIBUTE,
				attrName: 		"about",
				attrNS: 		namespace.rdf
			},{	
				property: 		"title",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_TEXT,
				elemName:		"title",
				elemNS:			namespace.dublin
			}]
	}]
}
})();
