/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ensemble.internal.util.ImgMenuItem");

dojo.require("dijit.Menu");

(function() {

/*
 * A menu item that uses an image tag instead of a background css image in order
 * to support images that come from other servers.
 * 
 * (Copied from jazz.ui.internal.ImgMenuItem - see #103103)
 */
dojo.declare("jazz.ensemble.internal.util.ImgMenuItem",
	dijit.MenuItem, {
	
	icon: null,
	
	postCreate: function() {
		this.inherited(arguments);
		if (this.icon) {
			// replace iconNode with new img
			var img = dojo.create("img", {src: this.icon, "class": "dijitMenuItemIcon"});
			this.iconNode.parentNode.replaceChild(img, this.iconNode);
		}
	}
});

})();
