/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.app.internal.util.XhrUtil");
dojo.require("jazz.ensemble.internal.util.XmlBindingFactory");

(function() {

var XmlBindingFactory = jazz.ensemble.internal.util.XmlBindingFactory;


/*
 * we should not cache the deferreds since somone else in the call chain
 * could have modified it the return value
 */
jazz.app.internal.util.XhrUtil.immediateErrback = function(result)
{
 	var deferred = new dojo.Deferred();
 	deferred.errback(result);
 	return deferred;
}

jazz.app.internal.util.XhrUtil.immediateCallback = function(error)
{
	var deferred = new dojo.Deferred();
 	deferred.callback(error);
 	return deferred;
}

function isOauthError(error)
{
	return error.status&&(error.status == 401);
}

jazz.app.internal.util.XhrUtil.getXml = function(url,args)
{
	var passive  = 	args.passive&&true;
	var schema   = 	args.schema||null;

	var deferred =  new dojo.Deferred();

	var xhrDeferred = jazz.client.xhrGet(	{
    	url				 : url,
		handleAs		 : "xml",
		failOk			 : passive,
		headers			 : { "accept": "application/rdf+xml" },
		skipInterceptors : passive? ["jazz.oauth"] : null
	});
	
	xhrDeferred.addCallback(function(doc){
		if (schema) deferred.callback(XmlBindingFactory.createBinding(doc.documentElement, schema));
		else	 	deferred.callback(doc);
	});
	
	xhrDeferred.addErrback(function (error){
		if (passive && isOauthError(error)) {
			deferred.callback(null);
		} else {
			error.ioArgs = xhrDeferred.ioArgs;
			deferred.errback(error);
		}
	 });
	
	return deferred;
}

})();
