/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function()
{
   dojo.provide("jazz.iwidget.test.TestContainer");
   
   dojo.require("jazz.iwidget.IWidgetDijit");
   dojo.require("dijit.form.TextBox");
   dojo.require("dijit._Container");
   dojo.require("dijit._Widget");
   dojo.require("dijit._Templated");
   
   
   // declare and implement the widget "class"
   dojo.declare("jazz.iwidget.test.TestContainer", [dijit._Widget, dijit._Container, dijit._Templated], {
      widgetsInTemplate: true,
      templatePath: dojo.moduleUrl("jazz.iwidget", "test/templates/TestContainer.html"),
      
      _initPrefs: {
         "attr1": "VALUE:attr1",
         "attr2": "VALUE:attr2",
         "attr3": "VALUE:attr3"
      },
      
      _newPrefs: {
         "attr1": "VALUE:attr1",
         "attr2": "changed value",
         "attr3": "VALUE:attr3"
      },
      
      _widget: null,
      
      postCreate: function()
      {
         this.containerNode = this._container;
         this._module.value = 'com.ibm.team.dashboard.viewlets.web.tests';
         this._spec.value   = 'widgets/PreferenceTest.xml';
         this._uri.value    = dojo.moduleUrl(this._module.value, this._spec.value);

         /**
          * for some reason net.jazz.ajax.ajaxModules don't get startup() called. 
          * so lets hack it for now. TODO Fix this.
          */
			this.startup();
      },
      
      _makeURI: function()
      {
         this._uri.value = dojo.moduleUrl(this._module.value, this._spec.value);
      },
		
      _makeWidget: function()
      {
         if (this._widget) 
         {
            this.removeChild(this._widget);
            this._widget.destroy();
         }
         
         this._widget = new jazz.iwidget.IWidgetDijit({
            url: this._uri.value,
            prefs: this._initPrefs
         });
         
         var self = this;
         dojo.connect(this._widget, "onLoad", function()
         {
            console.log("attributes:", self._widget.getAttributes());
            console.log("descriptor:", self._widget.getDescriptorItems());
            console.log("supportedModes:", self._widget.getSupportedModes());
            console.log("getMode:", self._widget.getCurrentMode());
         });
         
         this.addChild(this._widget);
      },
      _changePrefs: function()
      {
         console.log("_changePrefs");
         this._widget.setAttributes(this._newPrefs);
      },
		
     _changeMode: function()
      {
         console.log("_changePrefs");
         this._widget.setMode(jazz.iwidget.mode.EDIT);
      }
   });
   
})();
