/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2008, 2011,
 * 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("jazz.util.theming");

dojo.require("jazz.util.internal.theming");

/*
 * PROVISIONAL: This API is considered provisional and may be changed or removed
 * in the future with minimal or no warning.
 * 
 * @since 0.7
 */

(function() {
	jazz.util.theming = {
		initialize : function() {
			jazz.util.theming.jsDfd = new dojo.Deferred();
			if (jazz.util.theming.isThemingLocal()) {
				jazz.util.internal.theming._loadThemingCSS();
				var dfd = jazz.util.internal.theming._loadThemingJS();
				dfd.addCallback(function() {
					jazz.util.theming.jsDfd.callback();
				});
				dfd.addErrback(function() {
					jazz.util.theming.jsDfd.errback();
				});
				dojo.registerModulePath("jazz.theme",
						jazz.util.internal.theming._getThemingUrl()
								+ "/resource");
			}
		},

		themeFileUrl : function(path) {
			var result = this.getPreviewUrl(dojo.moduleUrl("jazz.theme", path).toString());
			return new dojo._Url(result);
		},
		getPreviewTheme : function() {
			if (window.location.search) {
				var queryObject = dojo.queryToObject(window.location.search
						.substring(1));
				if (queryObject.previewTheme) {
					return queryObject.previewTheme;
				}
			}
			return null;
		},
		getPreviewUrl : function(url) {
			var themeName = jazz.util.theming.getPreviewTheme();
			if (themeName) {
				return url + "?theme=" + encodeURIComponent(themeName);
			}
			return url;
		},
		isThemingLocal : function(url) {
			return net.jazz.ajax._hasLocalRepository;
		}
	};
})();
