/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.transport.RestRequest"); //$NON-NLS-1$

(function() {

dojo.declare("com.ibm.team.repository.web.transport.RestRequest", null, {  //$NON-NLS-1$
	
	_serviceInterface: null,
	_resource: null, 
	_method: null,
	_params: null,
	
	_xhr: null,

	constructor: function(serviceInterface, resource, method, requestParams) {
		_validateInput(serviceInterface, resource, method, requestParams);
		
		this._serviceInterface= serviceInterface;
		this._resource= resource; 
		this._method= method.toUpperCase();
		this._params= requestParams;
	},
	
	// ---- api ------------------------------------------------------------------------------------------------------------

	abort: function() {
		if (this._xhr) {
			this._xhr.abort();
		}
	},

	getParameterNames: function() {
		var paramNames= [];
		for (prop in this._params) {
			paramNames.push(prop);
		}
		return paramNames;
	},

	getMethodType: function() {
		return this._method;
	},

	getResource: function() {
		return this._resource;
	},
	
	getParameterValues: function(name) {
		return this._params[name] ? this._params[name].slice(0) : null; 
	},
	
	getServiceInterface: function() {
		return this._serviceInterface;
	},
	
	getQueryString: function() {
		return dojo.objectToQuery(this._params);
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_setXMLHttpRequest: function(/* XMLHttpRequest */ xhr) {
		this._xhr = xhr;
	}
});

com.ibm.team.repository.web.transport.RestRequest.create= function(serviceInterface, resource, method, requestParams) {
	return new com.ibm.team.repository.web.transport.RestRequest(serviceInterface, resource, method, requestParams);
}

function _validateInput(serviceInterface, resource, method, requestParams) {
	
    if (!_validateServiceInterface(serviceInterface)) {
    	throw new Error("[RestRequest] invalid serviceInterface parameter: " + serviceInterface); //$NON-NLS-1$
	}

    if (!_validateMethod(method)) {
    	throw new Error("[RestRequest] invalid method parameter: " + method); //$NON-NLS-1$
	}
	
	if (requestParams && !_validateRequestParams(requestParams)) {
		throw new Error("[RestRequest] invalid requestParameters parameter: " + requestParams); //$NON-NLS-1$
	}
};

// ---- input validation ---------------------------------------------------------------------------------------------------

var METHOD_REGEX= /^(get|post|put|delete)$/i;

function _validateServiceInterface(serviceInterface) {
	return dojo.isString(serviceInterface) && dojo.trim(serviceInterface).length > 0;
};

function _validateMethod(method) {
	return METHOD_REGEX.test(method);
};

function _validateRequestParams(paramObj) {
	// TODO implement something smart here
	return true;
};

//function _makeAllParamsArrays(paramObj) {
//	var modifiedParams= {};
//	for (var prop in paramObj) {
//		var propVal= paramObj[prop];
//		if (dojo.isArray(propVal)) {
//			modifiedParams[prop]= propVal;
//		} else {
//			modifiedParams[prop]= [propVal];
//		}
//	}
//	return modifiedParams;
//}

})();
