/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.transport.internal.ProvisionResponseHandler");

dojo.declare("com.ibm.team.repository.web.transport.internal.ProvisionResponseHandler", null, {

	constructor: function(contextObject, callbackName, errorCallbackName) {
		if (arguments.length != 3) {
			throw new Error("com.ibm.team.repository.web.transport.internal.ProvisioningResponseHandler(): invalid number of parameters: " + arguments.length);
		}
		
	    if (!dojo.isObject(contextObject) ||
				!dojo.isFunction(contextObject[callbackName]) ||
	        	!dojo.isFunction(contextObject[errorCallbackName])) {
	    	throw new Error("com.ibm.team.repository.web.transport.internal.ProvisioningResponseHandler(): invalid parameter types.  Expected (object contextObject, string successFunctionName, string errorFunctionName).");
		}
		
		this._contextObject= contextObject;
		this._callbackName= callbackName;
		this._errorCallbackName= errorCallbackName;
	},
	
	doCallback: function(returnVal, args) {
		var obj= this._contextObject;
		obj[this._callbackName].call(obj, returnVal, args);
	},
	
	doErrorCallback: function(errorObj, args) {
		var obj= this._contextObject;
		obj[this._errorCallbackName].call(obj, errorObj, args);
	}
});
 