/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ui.tree.IconItem");

dojo.require("dijit._Templated");
dojo.require("jazz.ui.tree.AbstractItem");

(function() {

dojo.declare("jazz.ui.tree.IconItem", [jazz.ui.tree.AbstractItem, dijit._Templated], {
	// summary:
	//		A subclass of jazz.ui.tree.AbstractItem that shows an icon and a label in the tree.
	//
	//      NOTE: This is provisional API. Clients using this API do so with the
	//		awareness that this class may be removed or substantially changed at
	//		future times without warning.
	// since:
	//		0.7
	
	label:"",		// The label for the node
	iconClass:"",	// The class that gives the background image to use for the icon
	
	templateString: "<div class='simpleItem'><div dojoAttachPoint='_icon' class='icon ${iconClass}'></div><div dojoAttachPoint='_label' class='label'>${label}</div></div>",
	
	update: function() {
		this._icon.className = "icon " + this.iconClass;
		this._label.innerHTML = this.label;
	}
	
});

})();