/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ui.tree.SimpleItem");

dojo.require("dijit._Templated");
dojo.require("jazz.ui.tree.AbstractItem");

(function() {

dojo.declare("jazz.ui.tree.SimpleItem", [jazz.ui.tree.AbstractItem, dijit._Templated], {
	// summary:
	//		A subclass of jazz.ui.tree.AbstractItem that shows only a label in the tree.
	//
	//      NOTE: This is provisional API. Clients using this API do so with the
	//		awareness that this class may be removed or substantially changed at
	//		future times without warning.
	// since:
	//		0.7
	
	label:"",	// The label to show on the node
	
	templateString: "<div class='simpleItem'><div dojoAttachPoint='_label' class='label'>${label}</div></div>",
	
	update: function() {
		this._label.innerHTML = this.label;
	}
	
});

})();