/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function () {
dojo.provide("jazz.app.ua.internal.HelpDOMNode");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.app.ua.internal.client");

dojo.require("dojo.i18n");
dojo.requireLocalization("jazz.app.ua.internal", "HelpMessages");

var messages = dojo.i18n.getLocalization("jazz.app.ua.internal", "HelpMessages");

dojo.declare("jazz.app.ua.internal.HelpDOMNode", [dijit._Widget,dijit._Templated], {
	templateString: "<div style='color:#999999'>${loadingStr}</div>",
	constructor: function (args) {
		this.loadingStr = messages.loading;
	},
	postCreate: function () {
		if (this.uaKey) {
			var dfd = jazz.app.ua.internal.client.getTopicPrefix(this.uaKey);
			var errback = dojo.hitch(this, function(error) {
				this.domNode.style.color = "";
				this.domNode.innerHTML = messages.noContent;
			});
			dfd.addCallback(dojo.hitch(this, function (prefix) {
				var dfd2 = jazz.app.ua.internal.client.getContent(this.uaKey);
				dfd2.addCallback(dojo.hitch(this, function (content) {
					this.domNode.style.color = "";
					this.domNode.innerHTML = "";
					var doc = dojox.xml.parser.parse(content);
					this.addContentSection(doc.getElementsByTagName("description"));
					this.addTopicsSection(doc.getElementsByTagName("topic"), prefix);
				}));
				dfd2.addErrback(errback);
			}));
			dfd.addErrback(errback);
		}
	},
	addContentSection: function(nodeArray) {
		if (nodeArray && nodeArray.length && nodeArray[0].childNodes.length) {
			this.domNode.innerHTML = nodeArray[0].childNodes[0].nodeValue;
		}
	},
	addTopicsSection: function(nodeArray, prefix) {
		var topicsDiv = document.createElement("div");
		topicsDiv.style.paddingTop = "5px";
		for (var i=0; i < nodeArray.length; i++) {
			var div = document.createElement("div");
			var link = document.createElement("a");
			link.target = "_blank";
			for (var j=0; j < nodeArray[i].attributes.length; j++) {
				if (nodeArray[i].attributes[j].name == "label") {
					link.appendChild(document.createTextNode(nodeArray[i].attributes[j].value));
				} else if (nodeArray[i].attributes[j].name == "href") {
					link.href = prefix + nodeArray[i].attributes[j].value;
				}
			}					
			div.appendChild(link);
			topicsDiv.appendChild(div);
		}
		this.domNode.appendChild(topicsDiv);
	}
});
})();
