/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.ContentViewlet");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.team.dashboard.web.util.internal.Util");

dojo.require("jazz.app.proxy");

(function() {

var Util = com.ibm.team.dashboard.web.util.internal.Util;
var Viewlet = com.ibm.team.dashboard.web.ui.Viewlet;

/*
 * The Content Viewlet class.
 * 
 * @since 0.7
 */
dojo.declare("com.ibm.team.dashboard.web.ui.ContentViewlet",
	Viewlet, {
	
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "ui/internal/templates/ContentViewlet.html"),

	init: function(){
		var resizeFrame = function () {
			try {
				if (this._frame.contentWindow) {
					this._frame.style.height = dojo.position(this._frame.contentWindow.document.body).h + "px";
				}
			}
			catch (/* Error */ error) {
				// 83136: dojo.position doesn't work if unable to get computed styles, e.g.
				// if an iframe is display:none on FF. Skip this resize.
			}
		};
		this._frame.height = "0";
		this._interval = setInterval(dojo.hitch(this, resizeFrame), 300);
	},

	destroy : function() {
		clearInterval(this._interval);
		this.inherited(arguments);
	},
	
	update: function() {
		var source = !this.isZoomed()?this.getPreference("src"):this.getPreference("zoom-src");
		if (source) {
			// locate bundle and path segments
			var bundle;
			var path;
			var segments = source.split(':');
			if (segments.length >= 2) {
				bundle = segments[0];
				path = segments[1];
			}
			else {
				path = segments[0];
			}
			
			// build the url
			var buf = [net.jazz.ajax._contextRoot, "/web/"];
			if (bundle) {
				buf.push(bundle);
				buf.push("/");
			}
			buf.push(path);
			var url = buf.join(""); 
			
			// proxy if different origin
			if (Util._isDifferentOrigin(new dojo._Url(url))) {
				url = jazz.app.proxy.encodeProxiedURI(url);
			}
			this._frame.src = url;
		}
	},

	refresh: function() {
		this.update();
	},

	// Only make it zoomable if we have zoom-src defined.
	hasZoomableContent: function () {
		return this.getPreference("zoom-src")?true:false;
	}
});

})();