/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.ViewletSite");

(function(){

/*
 * This is an interface for API documentation only. It is not used in code,
 * nor should it be required by anyone.
 * 
 * PROVISIONAL: This API is considered provisional and may be changed or removed in the
 * future with minimal or no warning.
 * 
 * @since 0.6
 */
dojo.declare("com.ibm.team.dashboard.web.ui.ViewletSite",
	null, {
	
	/*
	 * Adds a menu item to the viewlet menu.
	 * 
	 * @param label the text shown for the menu item.
	 * @param icon (optional) either an image URL or a css class name specifying
	 * 		a background-image property for the menu item's icon, or null for none.
	 * 		The use of css class is deprecated as it does not work with iframed
	 * 		viewlets (because the css is not available outside the iframe).
	 * @param callback the function to call when the user activates the menu item. The scope
	 * 		(i.e. 'this') will be the viewlet adding the menu item.
	 */
	addMenuItem: function(/* string */ label, /* string */ icon, /* function */ callback) {},
	
	/*
	 * Returns true or false based on if the current server license level allows viewing of the
	 * indicated dashboard type.
	 * 
	 * @param scope a number representing one of the constants for the scope of the dashboard
	 * @since 0.6.1
	 */
	/* boolean */ canViewDashboard: function(/* number */ scope) {},
	
	/*
	 * Signals to the viewlet container that the viewlet is done loading.
	 * Viewlets should call this.
	 */
	doneRefresh: function() {},
	
	/*
	 * Can be called by viewlets to programatically enter edit mode.
	 */
	editContents: function() {},
	
	/*
	 * Reports a serious error which may impact the normal operation of the
	 * dashboard or other viewlets (e.g. connection failure, server down).
	 * 
	 * @param error An Error object representing the problem.
	 * @since 0.7
	 */
	error: function(/* Error */ error) {},
	
	/*
	 * Returns the action area of the container, a DOM element that is part of
	 * the viewlet trim where specialized actions can be added while
	 * in edit mode.
	 */
	getActionArea: function() {},
	
	/*
	 * Returns the jazz.ui.FilterBox for the viewlet. Will return null if the
	 * viewlet is not flagged as "filterable" in its definition.
	 */
	getFilterBox: function() {},
	
	/*
 	 * Returns the height of the viewlet's content area
 	 */		
	getHeight: function() {},
	
	/*
	 * Sets the secondary viewlet title.
	 */
	getSecondaryTitle: function() {},
	
	/*
	 * Returns the viewlet's main title.
	 */
	getTitle: function() {},
	
	/*
 	 * Returns the width of the viewlet's content area
 	 */		
	getWidth: function() {},
	
	/*
	 * Returns whether or not the viewlet is currently active, i.e. not hidden
	 * in a background UI element.
	 */
	isActive: function() {},
	
	/*
	 * Returns whether or not the dashboard is currently editable.
	 */
	isDashboardEditing: function() {},
	
	/*
 	 * Indicates whether the viewlet is loading or not
 	 */	
	isLoading: function() {},	
	
	/*
	 * Signals that the user is navigating away from the current page. This is
	 * used to prompt the user about unsaved changes.
	 */
	navigateAwayEvent: function(eventObj, workbenchNavigation) {},
	
	/*
	 * Refreshes the viewlet.
	 */
	refresh: function() {},
	
	/*
	 * Enables or disables automatic periodic refreshing of viewlets. Viewlets
	 * may wish to temporarily disable automatic refresh if it disrupts the
	 * normal user flow when, for example, the user is reading a hover tooltip or
	 * editing content. Normal auto-refresh will resume as soon as it is re-enabled.
	 */
	setAutoRefresh: function(/* boolean */ value) {},
	
	/*
	 * Sets the viewlet icon to the image pointed to by the given URL.
	 * 
	 * @param url the URL of the image file.
	 */
	setIcon: function(/* string */ url) {},
	
	/*
	 * Called to set loading state of viewlet.  Displays progress icon when loading.
	 */
	setLoading: function(loadingStatus) {},
	
	/*
	 * Sets the viewlet's secondary title.
	 */
	setSecondaryTitle: function(/* string */ title) {},
	
	/*
	 * Called by viewlets to update the dynamic title. Some viewlets only know the title
	 * when the settings area is closed. These viewlets should indicate that the title
	 * needs to be persisted by setting the persist flag to true. Note that this results
	 * in a dashboard modification and will make the Dashboard dirty, thus it should
	 * only be done in tandem with another action that dirties the dashboard, such as
	 * changing the viewlet settings.
	 */
	setTitle: function(/* string */ title, /* boolean */ persist) {},
	
	/*
	 * Can be called by viewlets to programatically open or close the settings area.
	 */
	toggleSettings: function() {}
});
	
})();
