/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.viewlets.web.ui.internal.AjaxModuleExampleGadget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.dashboard.viewlets.web.client.internal.MembersClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

(function() {

var MembersClient = com.ibm.team.dashboard.viewlets.web.client.internal.MembersClient;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;

dojo.declare("com.ibm.team.dashboard.viewlets.web.ui.internal.AjaxModuleExampleGadget", [dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.viewlets.web", "ui/internal/templates/AjaxModuleExampleGadget.html"),
	
	postCreate: function() {
		var itemId = "_IlXdYMbREd2Q0-bGqFrsIQ";
		var serviceObject = {
			self: this,
			success: function(result) {
				for (var i = 0; i < result.members.length; i++) {
					var div = document.createElement("div");
					div.innerHTML = result.members[i].name;
					this.self._members.appendChild(div);
				}
			},
			failure: function(error) {
			}
		}
		var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
		MembersClient.getMembersForTeamArea(itemId, 0, 10, "", false, srh);
	}
	
});

})();
