/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
var root = document.getElementById('root-node');

var callback = function(result) {
	try {
		root.className = "";
		if (result.oauthApprovalUrl) {
			// Create the popup handler. The onOpen function is called when the user
			// opens the popup window. The onClose function is called when the popup
			// window is closed.
			var popup = shindig.oauth.popup({
				destination: result.oauthApprovalUrl,
				windowOptions: null,
				onOpen: function(){},
				onClose: function() {
					fetchData();
				}
			});
			// Use the popup handler to attach onclick handlers to UI elements.  The
			// createOpenerOnClick() function returns an onclick handler to open the
			// popup window.  The createApprovedOnClick function returns an onclick 
			// handler that will close the popup window and attempt to fetch the user's
			// data again.
			root.innerHTML = "";
			root.appendChild(document.createTextNode("You need to "));
			var link = document.createElement("a");
			link.href = "#";
			link.innerHTML = "log in";
			link.onclick = popup.createOpenerOnClick();
			root.appendChild(link);
			root.appendChild(document.createTextNode(" to view the gadget content."));
		} else {
			console.debug(result);
			render(result[0]);
		}
	} catch (e) {
		console.error(e);
	}
};

var fetchData = function() {
	jazz.gadget.callService(gadgets.io.MethodType.GET, "com.ibm.team.dashboard.viewlets.service.internal.members.IMemberInfoService", "memberInfo", {
		itemIds: "_KGRY4CFWEdq-WY5y7lROQw"
	}, callback);
};

var render = function(value) {
	var html = [];
	html.push("Name: " + value.name);
	html.push("User ID: " + value.userId);
	html.push("Email: " + value.email);
	root.innerHTML = html.join("<br/>");
};
fetchData();
