/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.DashboardUpdate");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");

dojo.require("jazz.app.auth");
dojo.require("jazz.client.xhr");
dojo.require("jazz.ui.MessageBox");

dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

(function() {

var DASHBOARD_MIGRATION_SERVICE = "../dashboard-migration";
var CMD_UPDATE_DASHBOARDS = "updateDashboards";

var messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

dojo.declare("com.ibm.team.dashboard.web.ui.internal.DashboardUpdate",
	[dijit._Widget, dijit._Templated], {
	
	messages: messages,
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "ui/internal/templates/DashboardUpdate.html"),
	widgetsInTemplate: true,
	
	handleUpdate: function() {
		this.setEnabled(false);
		this.messageBox.showMessage({
			summary: messages.dashboardUpdateProgress + "<img class=\"spinner\" src=\"" + dojo.moduleUrl("com.ibm.team.dashboard.web", "graphics/Dashboard/icons/spinner.gif") + "\">"
		});
		jazz.client.xhrPost({
		    url: DASHBOARD_MIGRATION_SERVICE + "/" + CMD_UPDATE_DASHBOARDS,
		    load: dojo.hitch(this, function(response) {
				this.messageBox.showMessage({
					type: jazz.ui.MessageBox.STATUS_TYPES.OK,
					summary: messages.dashboardUpdateSuccess
				});
		    }),
			error: dojo.hitch(this, function(/* Error */ error, args) {
				error.message = args.xhr.responseText;
				this.messageBox.showMessage({
					type: jazz.ui.MessageBox.STATUS_TYPES.ERROR,
					summary: messages.dashboardUpdateError,
					errorObject: error
				});
				this.setEnabled(true);
			})
		});
	},
	
	setEnabled: function(/* boolean */ value) {
		this.button.disabled = !value;
	}
});

})();
