/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
if (!window.jazz)
	window.jazz = {};
if (!jazz.gadget)
	jazz.gadget = {};
(function() {
jazz.gadget.callService = function(httpMethod, serviceId, serviceMethod, requestParams, callback) {
	var url = _buildURL(serviceId, serviceMethod, requestParams);
	var params = {};
	params[gadgets.io.RequestParameters.AUTHORIZATION] = gadgets.io.AuthorizationType.OAUTH;
	params[gadgets.io.RequestParameters.OAUTH_SERVICE_NAME] = "jazz";
	params[gadgets.io.RequestParameters.HEADERS] = { "accept": "text/json", "content-type": "application/x-www-form-urlencoded; charset=utf-8" }
	params[gadgets.io.RequestParameters.CONTENT_TYPE] = gadgets.io.ContentType.JSON;
	params[gadgets.io.RequestParameters.METHOD] = httpMethod;
	gadgets.io.makeRequest(url, function(response) {
		callback(_handleResponse(response));
	}, params);
};

function _buildURL(serviceId, method, params) {
	var url = _getServicePrefix() + serviceId + "/" + method;
	var delim = "?";
	for (var key in params) {
		url += delim + key + "=" + params[key];
		delim = "&";
	}
	return url;
}

function _getServicePrefix() {
	// assume gadget server is at the same host as data server
	// assume /jazz/service for now
	return location.protocol + "//" + location.host + "/jazz/service/";
}

function _handleResponse(response) {
	if (!response.data)
		return response;
	return _demarshallResponse(response.data);
}

//
// Internal demarshalling functions
//

function _demarshallResponse(evaldObj) {
	var returnValue= evaldObj["soapenv:Body"].response.returnValue;
	
	var obj= null;
	
	if (returnValue.values) {          // array of EMF objects 
		obj = returnValue.values;
	} else if (returnValue.value) {    // single EMF object
		obj = returnValue.value;
	} else if (returnValue.dataArgs) { // data query
		obj = _demarshallDataQuery(returnValue.dataArgs);
	}
	
	return obj;
}

function _demarshallDataQuery(srcRows) {
	var targetRows= [];
	for (var i=0; i<srcRows.length; i++) {
		var srcCols= srcRows[i].dataArgs;
		var targetCols= [];
		for (var j=0; j<srcCols.length; j++) {
			targetCols.push(srcCols[j].value);
		}
		targetRows.push(targetCols);
	}
	return targetRows;
}

})();
