/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("net.jazz.ajax.ui.internal.JAFStatus");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.ui.ModeledTree");
	
dojo.declare("net.jazz.ajax.ui.internal.JAFStatus", [dijit._Widget, dijit._Templated], {
    templateString: "<div class=\"net-jazz-ajax-ui-internal-JAFStatus\"><div class=\"header\">Jazz Ajax Framework Status</div><div dojoAttachPoint=\"statusArea\"></div></div>",
	
	postCreate: function() {
		var webBundleTableArgs = {
			heading: {label: "Web Bundles"},
			headers: ["Namespace", "Alias", "Base"]
		};
		var webBundleTable = new net.jazz.ajax.ui.internal.DataTableContainer(webBundleTableArgs);
		for (var i = 0; i < net.jazz.ajax._status.webBundles.length; i++) {
			var webBundle = net.jazz.ajax._status.webBundles[i];
			
			var rowData = {
				0: {content: webBundle.namespace, style: "tight"},
				1: {content: webBundle.alias, style: "tight"},
				2: {content: webBundle.base, style: "tight"}
			};
			webBundleTable.addRow(rowData, 3);
		}
		this.statusArea.appendChild(webBundleTable.domNode);
		
		var ajaxApplicationTableArgs = {
			heading: {
				label: "Ajax Applications"
			},
			headers: ["Namespace", "id", "Alias", "JS Class", "Icon Path"]
		};
		var ajaxApplicationTable = new net.jazz.ajax.ui.internal.DataTableContainer(ajaxApplicationTableArgs);
		
		for (var j = 0; j < net.jazz.ajax._status.ajaxApplications.length; j++) {
			var link = document.createElement("a");
			link.href = net.jazz.ajax._contextRoot + net.jazz.ajax._status.ajaxApplications[j].alias;
			link.appendChild(document.createTextNode(net.jazz.ajax._status.ajaxApplications[j].alias));
			rowData = {
				0: {content: net.jazz.ajax._status.ajaxApplications[j].namespace, style: "tight"},
				1: {content: net.jazz.ajax._status.ajaxApplications[j].id, style: "tight"},
				2: {content: link, style: "tight"},
				3: {content: net.jazz.ajax._status.ajaxApplications[j].jsclass, style: "tight"},
				4: {content: net.jazz.ajax._status.ajaxApplications[j].iconPath, style: "tight"}
			};
			ajaxApplicationTable.addRow(rowData, 5);
		}
		this.statusArea.appendChild(ajaxApplicationTable.domNode);
		
		var ajaxModuleTableArgs = {
			heading: {
				label: "Ajax Modules"
			},
			headers: ["Namespace", "id", "Internal Path Info", "Widget Class"]
		};
		
		var ajaxModuleTable = new net.jazz.ajax.ui.internal.DataTableContainer(ajaxModuleTableArgs);
				
		for (j = 0; j < net.jazz.ajax._status.ajaxModules.length; j++) {
			var link = document.createElement("a");
			link.href = net.jazz.ajax._contextRoot + "/_ajax-modules/" + net.jazz.ajax._status.ajaxModules[j].id;
			link.appendChild(document.createTextNode(net.jazz.ajax._status.ajaxModules[j].id));
			rowData = {
				0: {content: net.jazz.ajax._status.ajaxModules[j].namespace, style: "tight"},
				1: {content: link, style: "tight"},
				2: {content: net.jazz.ajax._status.ajaxModules[j].internalPathInfo, style: "tight"},
				3: {content: net.jazz.ajax._status.ajaxModules[j].widgetClass, style: "tight"}
			};
			ajaxModuleTable.addRow(rowData, 4);
		}
		this.statusArea.appendChild(ajaxModuleTable.domNode);
		
		var jsWithErrorsTableArgs = {
			heading: {
				label: "Javascript Modules with errors"
			},
			headers: ["Module Name", "URI", "Error"]
		};
		
		var jsWithErrorsTable = new net.jazz.ajax.ui.internal.DataTableContainer(jsWithErrorsTableArgs);
		for (j = 0; j < net.jazz.ajax._status.jsWithErrors.length; j++) {
			rowData = {
				0: {content: net.jazz.ajax._status.jsWithErrors[j].moduleName, style: "tight"},
				1: {content: net.jazz.ajax._status.jsWithErrors[j].uri, style: "tight"},
				2: {content: net.jazz.ajax._status.jsWithErrors[j].error, style: "tight"}
			};
			jsWithErrorsTable.addRow(rowData, 3);
		}
		this.statusArea.appendChild(jsWithErrorsTable.domNode);
		
		var headingDiv = document.createElement("div");
		dojo.addClass(headingDiv, "heading");
		var labelSpan = document.createElement("span");
		labelSpan.innerHTML = "CSS Binding Sets";
		headingDiv.appendChild(labelSpan);
		this.statusArea.appendChild(headingDiv);
		
		var cssBindingSetsTree = new jazz.ui.ModeledTree({model: net.jazz.ajax._status.cssBindingSets});
		this.statusArea.appendChild(cssBindingSetsTree.domNode);

		this.statusArea.appendChild(document.createElement("br"));
		
		headingDiv = document.createElement("div");
		dojo.addClass(headingDiv, "heading");
		labelSpan = document.createElement("span");
		labelSpan.innerHTML = "Application Pages";
		headingDiv.appendChild(labelSpan);
		this.statusArea.appendChild(headingDiv);
		
		var applicationPageModel = [];
		
		for (j = 0; j < net.jazz.ajax._status.ajaxApplications.length; j++) {
			if (net.jazz.ajax._status.ajaxApplications[j].pages.length > 0) {
				var applicationModel = {
											label : net.jazz.ajax._status.ajaxApplications[j].id, 
											children : net.jazz.ajax._status.ajaxApplications[j].pages
										};
				applicationPageModel.push(applicationModel);
			}
		}
		var applicationPagesTree = new jazz.ui.ModeledTree({model: applicationPageModel});
		this.statusArea.appendChild(applicationPagesTree.domNode);
		
	}
});

dojo.declare("net.jazz.ajax.ui.internal.DataTableContainer", [dijit._Widget, dijit._Templated], {
		
	templateString: "<div class='net-jazz-ajax-ui-internal-DataTableContainer'><div class='wrapper'><div dojoAttachPoint='dataTableHeading'></div><table><tbody dojoAttachPoint='dataTableContainer'></tbody></table></div></div>",
	
	rowCount: 0,
	
	headers: "",
	
	addRow: function(data, columns){
		if(!columns) {
			columns = data.length;
		}
		var row = document.createElement("tr");
		if((this.rowCount%2) === 0){
			dojo.addClass(row, "alternate");
		}
		this.rowCount++;
		
		for (var i = 0; i < columns; i++) {
			var cell = document.createElement("td");
			var colData = data[i];
			if (colData) {
				// backwards compatibility with text prop - use content instead
				if(colData.text){
					colData.content = document.createTextNode(colData.text);
					delete colData.text;
				}				
				if(isNode(colData.content)) {
					var node = colData.content;
				} else {
					node = document.createTextNode(colData.content);
				}
				cell.appendChild(node);
				if (colData.style){
					dojo.addClass(cell, colData.style);
				}
			}
			row.appendChild(cell);
		}
		this.dataTableContainer.appendChild(row);
	},

	clearTable: function(){
		//	summary:
		//		Function to clear all the current rows in the table, except for the header.

		//Always leave the first row, which is the table header.
		while(this.dataTableContainer.firstChild.nextSibling){
			this.dataTableContainer.removeChild(this.dataTableContainer.firstChild.nextSibling);
		}
		this.rowCount = 0;
	},
	
	//
	// Widget lifecycle methods
	//

	postCreate: function(){
		if (this.heading) {
			var headingDiv = document.createElement("div");
			dojo.addClass(headingDiv, "heading");
			
			var labelSpan = document.createElement("span");
			labelSpan.innerHTML = this.heading.label;
			headingDiv.appendChild(labelSpan);
			
			if (this.heading.value) {
				var valueSpan = document.createElement("span");
				dojo.addClass(valueSpan, "headingValue");
				valueSpan.innerHTML = this.heading.value;
				headingDiv.appendChild(valueSpan);
			}
			this.dataTableHeading.appendChild(headingDiv);
		}
		if (this.headers) {
			var headerRow = document.createElement("tr");
			dojo.forEach(this.headers, function(header){
				var headerCell = document.createElement("th");
				var text = document.createTextNode(header);
				headerCell.appendChild(text);
				headerRow.appendChild(headerCell);
			});
			this.dataTableContainer.appendChild(headerRow);
		}
	}
});

function isNode(o){
	return o && o.nodeType && o.cloneNode;
}
})();