/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.ProjectAreaListPage"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dojo.cookie"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("jazz.ui.ResourceLink");//$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("jazz.ui.Toolbar"); //$NON-NLS-1$	
	dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.client.init.InitializationData"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants");//$NON-NLS-1$ 
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper");//$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var InitializationData = com.ibm.team.repository.web.client.init.InitializationData;
	var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var ResourceLink = jazz.ui.ResourceLink;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var UIHelper = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;
	
	var MANAGE_PROJECT_AREAS_ACTION_URI = "#action=jazz.viewPage&id=com.ibm.team.process.ProjectAreaManagement"; //$NON-NLS-1$
	var SHOWARCHIVED_COOKIE = "JazzProjectsShowArchived"; //$NON-NLS-1$
	dojo.declare("com.ibm.team.process.web.ui.internal.ProjectAreaListPage", //$NON-NLS-1$
 [dijit._Widget, dijit._Templated], {
	
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/templates/ProjectAreaListPage.html"), //$NON-NLS-1$ //$NON-NLS-2$
		
		widgetsInTemplate: true,
		
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this._manageHref = net.jazz.ajax._contextRoot + "/admin" + MANAGE_PROJECT_AREAS_ACTION_URI; //$NON-NLS-1$
			this._adminIconSrc = "com.ibm.team.process.web/ui/internal/images/admin_co.gif"; //$NON-NLS-1$
			this._dashboardIconSrc = "com.ibm.team.process.web/ui/internal/images/project.gif"; //$NON-NLS-1$
			this._resourceLinks = [];
			this._toolbars = [];
		},
		
		postCreate: function(){
			var ActionRegistry = net.jazz.ajax.ui.PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction("com.ibm.team.process.web._listProjects", this, "_runDefaultAction"); //$NON-NLS-1$ //$NON-NLS-2$
			var link = document.createElement("a"); //$NON-NLS-1$
			link.href = this._manageHref;
			link.appendChild(document.createTextNode(this.messages.ProjectAreaListPage_2));
			
			this.manageLink.appendChild(document.createTextNode(this.messages.ProjectAreaListPage_1));
			this.manageLink.appendChild(link);
			this.manageLink.appendChild(document.createTextNode(this.messages.ProjectAreaListPage_3));
			
			this.serverUrl.appendChild(document.createTextNode(dojo.string.substitute(this.messages.ProjectAreaListPage_9, [window.location.hostname])));
			
			this._messageBox = new jazz.ui.MessageBox();
			this._messageBoxDiv.appendChild(this._messageBox.domNode);
		},
		
		_runDefaultAction: function(){
			dojo.addClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
			dojox.xml.parser.removeChildren(this.myProjects);
			dojox.xml.parser.removeChildren(this.otherProjects);
			dojox.xml.parser.removeChildren(this.archivedProjects);
			
			var authContrib = getAuthenticatedContributor();
			var authContribId;
			if (authContrib) {
				authContribId = authContrib.userId;
			}
			var srh = new ServiceResponseHandler(this, "populateProjectAreas", "handleError"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.getAllProjectAreas(srh, {
				userId: authContribId
			});
		},
		
		showNoProjectAreasMessage: function(showMessage){
			if (showMessage) {
				dojo.removeClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
				var permissionInitializer = InitializationData.get("com.ibm.team.repository.service.canGrantPermissionInitializer"); //$NON-NLS-1$
				if (permissionInitializer && permissionInitializer.canGrantPermission) {
					dojo.removeClass(this.adminLinkArea, "hidden"); //$NON-NLS-1$
					if (!dojo.hasClass(this.filterArea, "hidden")) { //$NON-NLS-1$
						dojo.removeClass(this.separator, "hidden"); //$NON-NLS-1$
					}
					dojo.removeClass(this.manageLink, "hidden"); //$NON-NLS-1$
					dojo.addClass(this.adminContact, "hidden"); //$NON-NLS-1$
				} else {
					dojo.addClass(this.adminLinkArea, "hidden"); //$NON-NLS-1$
					dojo.addClass(this.separator, "hidden"); //$NON-NLS-1$
					dojo.addClass(this.manageLink, "hidden"); //$NON-NLS-1$
					dojo.removeClass(this.adminContact, "hidden"); //$NON-NLS-1$
				}
			} else {
				dojo.addClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
			}
		},
		
		populateProjectAreas: function(projectAreas){
			if (projectAreas) {
				projectAreas = projectAreas.sort(function(a, b){
					return a.name > b.name ? 1 : a.name < b.name ? -1 : 0;
				});
				var myProjects = [];
				var archivedProjects = [];
				for (var i = 0; i < projectAreas.length; i++) {
					if (projectAreas[i].archived) {
						archivedProjects.push(projectAreas[i]);
						projectAreas.splice(i, 1);
						i--;
					} else if (projectAreas[i].myProjectArea) {
						myProjects.push(projectAreas[i]);
						projectAreas.splice(i, 1);
						i--;
					}
				}
			}
			
			var showNoProjectsMessage = true;
			if (projectAreas && (projectAreas.length !== 0 || archivedProjects.length !== 0 || myProjects.length !== 0)) {
				if (myProjects.length > 0) {
					dojo.addClass(this.emptyMyProjectsMessage, "hidden");//$NON-NLS-1$
					this.populateArea(this.myProjects, myProjects);
					showNoProjectsMessage = false;
				} else {
					dojo.removeClass(this.emptyMyProjectsMessage, "hidden"); //$NON-NLS-1$
				}
				
				if (projectAreas && projectAreas.length > 0) {
					this.populateArea(this.otherProjects, projectAreas);
					showNoProjectsMessage = false;
				} else {
					dojo.addClass(this.otherProjects.parentNode, "hidden"); //$NON-NLS-1$
				}
				
				if (archivedProjects.length > 0) {
					dojo.removeClass(this.filterArea, "hidden"); //$NON-NLS-1$
					if (!dojo.hasClass(this.adminLinkArea, "hidden")) { //$NON-NLS-1$
						dojo.removeClass(this.separator, "hidden"); //$NON-NLS-1$
					}					
					var storedPref = dojo.cookie(SHOWARCHIVED_COOKIE);
					if (storedPref) {
						showNoProjectsMessage = false;
						this.showArchivedCheckbox.checked = "checked"; //$NON-NLS-1$
						this.populateArea(this.archivedProjects, archivedProjects, false, true);
					} else {
						this.showArchivedCheckbox.checked = null;
						this.populateArea(this.archivedProjects, archivedProjects, true, true);
					}
				}
			}
			this.showNoProjectAreasMessage(showNoProjectsMessage);
			this._createTableOfContents();
		},
		
		_createTableOfContents : function() {
			var div = this.toc;
			dojox.xml.parser.removeChildren(div);
			var isExistingLink = false;
			if (!this._isHidden(this.myProjectsSection)) {
				div.appendChild(this._createTOCEntry(this.myProjectsSection,  dojo.query("h2", this.myProjectsSection)[0].innerHTML));//$NON-NLS-1$
				isExistingLink = true;
			}
			if (!this._isHidden(this.projectsSection)) {
				if (isExistingLink) {
					div.appendChild(document.createElement("br"));//$NON-NLS-1$
				}
				div.appendChild(this._createTOCEntry(this.projectsSection, this.otherProjectsLabel.innerHTML));
				isExistingLink = true;
			}
			if (!this._isHidden(this.archivedProjectsSection)) {
				if (isExistingLink) {
					div.appendChild(document.createElement("br"));//$NON-NLS-1$
				}
				div.appendChild(this._createTOCEntry(this.archivedProjectsSection, dojo.query("h2", this.archivedProjectsSection)[0].innerHTML));//$NON-NLS-1$
			}
		},
		
		_createTOCEntry : function(element, title) {
			var anchor = document.createElement("a");//$NON-NLS-1$
				anchor.setAttribute("href", "#");//$NON-NLS-1$ //$NON-NLS-2$
				anchor.appendChild(document.createTextNode(title));
				this.connect(anchor, "onclick", function(e) { //$NON-NLS-1$
					dojo.stopEvent(e);
					var pos = dojo.position(element, true);
					window.scrollTo(pos.x, pos.y);
				}); 
				return anchor;
		},
		
		_isHidden : function(element) {
			return dojo.hasClass(element, "hidden"); //$NON-NLS-1$
		},
		
		_onCheckboxChange: function(event){
			if (event.target.checked) {
				dojo.cookie(SHOWARCHIVED_COOKIE, "checked", { //$NON-NLS-1$
					expires: 365
				});
				dojo.removeClass(this.archivedProjectsSection, "hidden"); //$NON-NLS-1$
				if (dojo.hasClass(this.otherProjects.parentNode, "hidden") && dojo.hasClass(this.myProjects.parentNode, "hidden")) { //$NON-NLS-1$ //$NON-NLS-2$
					dojo.addClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
				}
			} else {
				dojo.cookie(SHOWARCHIVED_COOKIE, ""); //$NON-NLS-1$
				dojo.addClass(this.archivedProjectsSection, "hidden"); //$NON-NLS-1$
				if (dojo.hasClass(this.otherProjects.parentNode, "hidden") && dojo.hasClass(this.myProjects.parentNode, "hidden")) { //$NON-NLS-1$ //$NON-NLS-2$
					dojo.removeClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
				}
			}
			this._createTableOfContents();
		},
		
		populateArea: function(area, data, hide, isArchived){
			if (area && area.parentNode) {
				if (!hide && area.parentNode) {
					dojo.removeClass(area.parentNode, "hidden"); //$NON-NLS-1$
				} else {
					dojo.addClass(area.parentNode, "hidden"); //$NON-NLS-1$
				}
			}
			var curUrl = new dojo._Url(location.href);
			
			if (curUrl.query) { //check for debug mode
				var urlSuffix = "?" + curUrl.query; //$NON-NLS-1$
			} else {
				urlSuffix = ""; //$NON-NLS-1$
			}
			
			for (var i = 0; i < data.length; i++) {
				area.appendChild(this.createProjectAreaRow(data[i].name, data[i].summary, data[i].description, data[i].itemId, data[i].projectLinks, urlSuffix, isArchived));
			}
		},
		handleError: function(err){
			this._displayMessage(this.messages.ProjectAreaListPage_4, err);
		},
		
		_displayMessage: function(summary, errorObject){
            var messageBoxArgs = {
				type: jazz.ui.MessageBox.STATUS_TYPES.ERROR,
            	summary: summary,
            	errorObject: errorObject
            }; 			
			this._messageBox.showMessage(messageBoxArgs);
		},
		createProjectAreaRow: function(projectAreaName, projectAreaSummary, projectAreaDetails, projectAreaId, projectLinks, urlSuffix, isArchived){
			var encodedName = encodeURIComponent(projectAreaName);
			var dashboardUrl = net.jazz.ajax._contextRoot + "/web/projects/" + encodedName + urlSuffix //$NON-NLS-1$ 
			
			var row = document.createElement("div"); //$NON-NLS-1$
			row.className = "project"; //$NON-NLS-1$
			
			//add the links to dashboard and project area editor so they will show up on 
			//right at same level as project name.
			var actionDiv = document.createElement("div");//$NON-NLS-1$
			dojo.addClass(actionDiv, "actionArea");//$NON-NLS-1$
			var toolbar = new jazz.ui.Toolbar();
			this._toolbars.push(toolbar);
			var button = new jazz.ui.toolbar.Button({
				href : dashboardUrl,
				imgSrc :  this._dashboardIconSrc,
				label : this.messages.ProjectAreaListPage_12				
			});
			toolbar.addChild(button);

			button = new jazz.ui.toolbar.Button({
				href :  this.getProjectAreaUrl(projectAreaId),
				imgSrc :  this._adminIconSrc,
				label : this.messages.ProjectAreaListPage_13
			});
			toolbar.addChild(button);
			actionDiv.appendChild(toolbar.domNode);									
			row.appendChild(actionDiv);
			
			// create project area link
			var linkArea = document.createElement("h3"); //$NON-NLS-1$
			var link = document.createElement("a"); //$NON-NLS-1$
			if (isArchived) {
				dojo.addClass(link, "archived-project-name"); //$NON-NLS-1$
			}
			link.appendChild(document.createTextNode(projectAreaName));
			linkArea.appendChild(link);
			
			
			link.href = this.getProjectAreaUrl(projectAreaId);
			
			var rl = new ResourceLink({
				'presentationUri': dashboardUrl,//$NON-NLS-1$
				'lazyFetch': true //$NON-NLS-1$
			}, link);
			
			this._resourceLinks.push(rl);
			
			row.appendChild(linkArea);
			
			
			if (projectAreaSummary && projectAreaSummary !== "") { //$NON-NLS-1$
				row.appendChild(document.createTextNode(projectAreaSummary));
			}
			if (projectAreaDetails && projectAreaDetails !== "") { //$NON-NLS-1$
				if ((projectAreaSummary && projectAreaSummary !== "")) { //$NON-NLS-1$
					row.appendChild(document.createElement("br")); //$NON-NLS-1$
					row.appendChild(document.createElement("br")); //$NON-NLS-1$
				}
				var lines = projectAreaDetails.split(/\n/);
				for (var i = 0; i < lines.length; i++) {
					if (i > 0) {
						row.appendChild(document.createElement("br")); //$NON-NLS-1$
					}
					row.appendChild(document.createTextNode(lines[i]));
				}
			}
			
			if (projectLinks && projectLinks.length > 0) {
				if ((projectAreaSummary && projectAreaSummary !== "") || (projectAreaDetails && projectAreaDetails !== "")) { //$NON-NLS-1$ //$NON-NLS-2$
					row.appendChild(document.createElement("br")); //$NON-NLS-1$
					row.appendChild(document.createElement("br")); //$NON-NLS-1$
				}
				
				var node = document.createElement("SPAN"); //$NON-NLS-1$
				node.className = "secondaryHeading"; //$NON-NLS-1$
				var label = document.createTextNode(this.messages.ProjectAreaListPage_11);
				node.appendChild(label);
				row.appendChild(node);
				
				var usesLinks = [];
				var prividesLinks = [];
				for (i = 0; i < projectLinks.length; i++) {
					var projectLink = projectLinks[i];
					if (UIHelper.isUsesLinkType(projectLink.linkType)) {
						usesLinks.push(projectLink);
					} else {
						prividesLinks.push(projectLink);
					}
				}
				
				if (usesLinks.length > 0) {
					this._createLinksSection(row, usesLinks, this.messages.ProjectAreaListPage_14);
				}
				
				if (prividesLinks.length > 0) {
					this._createLinksSection(row, prividesLinks, this.messages.ProjectAreaListPage_15);
				}
			}
			
			return row;
		},
		
		_createLinksSection: function(row, projectLinks, textFormat) {
			for (i = 0; i < projectLinks.length; i++) {
				var projectLink = projectLinks[i];

				row.appendChild(document.createElement("br")); //$NON-NLS-1$
				row.appendChild(UIHelper.getProjectLinkImage(projectLink.linkType, "projectLinkImage")); //$NON-NLS-1$
				var linkTypeLabel = UIHelper.getLinkTypeLabel(projectLink.linkType, this.messages);
				var link = "<a href=\"" + projectLink.targetURL + "\">" + projectLink.label + "</a>"; //$NON-NLS-1$  //$NON-NLS-2$  //$NON-NLS-3$
				var linkNode = document.createElement("SPAN"); //$NON-NLS-1$
				linkNode.innerHTML = dojo.string.substitute(textFormat, [linkTypeLabel, link]);
				row.appendChild(linkNode);
			}
		},
		
		getProjectAreaUrl: function(projectAreaItemId){
			var location = document.location.href;
			var path = location.split("/");//$NON-NLS-1$
			var serverAddress;
			if (path.length > 0) {
				serverAddress = path.shift() + "//";//$NON-NLS-1$
				path.shift(); //empty from the double //
				serverAddress = serverAddress + path.shift();
			}
			return serverAddress + net.jazz.ajax._contextRoot + "/process/project-areas/" + projectAreaItemId; //$NON-NLS-1$ 
		},
		
		_destroyResourceLinks: function(){
			for (var i = 0; i < this._resourceLinks.length; i++) {
				this._resourceLinks[i].destroyRecursive();
			}
			this._resourceLinks = [];
		},

		_destroyToolbars: function(){
			for (var i = 0; i < this._toolbars.length; i++) {
				this._toolbars[i].destroyRecursive();
			}
			this._toolbars = [];
		},

		uninitialize: function(){
			this._destroyResourceLinks();
			this._destroyToolbars();
			this.inherited(arguments);
		}
		
	});
})();
