/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.fronting.server.web.ui.internal.admin.AdminApplication");

dojo.require("jazz.app._AjaxApplication");
dojo.require("com.ibm.team.repository.web.ui.internal.admin.NotAuthorizedView");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.rdm.web.pages.WebUIinitializer");
dojo.require("com.ibm.rdm.fronting.server.web.ui.internal.admin.ServiceClient");
dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.rdm.fronting.server.web.ui.internal.admin", "AdminApplicationMessages");

var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var ServiceClient = com.ibm.rdm.fronting.server.web.ui.internal.admin.ServiceClient;
var messages = dojo.i18n.getLocalization("com.ibm.rdm.fronting.server.web.ui.internal.admin", "AdminApplicationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.rdm.fronting.server.web.ui.internal.admin.AdminApplication", jazz.app._AjaxApplication, {
	
	iconLarge: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/admin/images/admin.png"),
	
	constructor: function() {
		this.loadWebUIinitializer();
		jazz.app.auth.setLogoutUrl(net.jazz.ajax._contextRoot + "/service/com.ibm.team.repository.service.internal.ILogoutRestService");
		this._checkAuth();
	},	

	/**
	 * only JazzAdmins should see the UI 
	 */
	_checkAuth: function () {
		var srh= new ServiceResponseHandler(this, "authRequestPassed", "authRequestFailed");
		ServiceClient.getCheckAuth(srh);
	},
	
	authRequestPassed: function(response) {
		this._createUI();
	},
	
	authRequestFailed: function(errorObject) {
		this._showNotAuthorizedError();
	},
	
	_showNotAuthorizedError: function() {
		var notAuth = new com.ibm.team.repository.web.ui.internal.admin.NotAuthorizedView();
		this.onFailure(null, notAuth.domNode);
	},
	
	_createUI: function() {
		this.ui.attr("bannerTitle", messages.frameworkName);
		this.workbench._setDefaultTitle(messages.frameworkName + " - Rational Jazz Team Server"); //$NON-NLS-1$
			
		//can add or remove UI elements here			
	},
	
	loadWebUIinitializer: function() {
		com.ibm.rdm.web.pages.WebUIinitializer.init(this);
	},
	
	_showNotAuthorizedError: function() {
		var notAuth = new com.ibm.team.repository.web.ui.internal.admin.NotAuthorizedView();
		this.onFailure(null, notAuth.domNode);
	}

});

})();