/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    
dojo.provide("com.ibm.rdm.fronting.server.web.ui.internal.admin.Counters");
    
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");
dojo.require("jazz.ui.MessageBox");
dojo.require("com.ibm.team.repository.web.ui.internal.admin.DataTableContainer");

dojo.requireLocalization("com.ibm.rdm.fronting.server.web.ui.internal.admin", "AdminApplicationMessages");

var MessageBox = jazz.ui.MessageBox;

dojo.declare("com.ibm.rdm.fronting.server.web.ui.internal.admin.Counters", [dijit._Widget, dijit._Templated], {
    
    templatePath: dojo.moduleUrl("com.ibm.rdm.fronting.server.web", "ui/internal/admin/templates/Counters.html"),

    constructor: function(){
        this.messages = dojo.i18n.getLocalization("com.ibm.rdm.fronting.server.web.ui.internal.admin", "AdminApplicationMessages");
    },
    
    postCreate: function(){
        this.header = new MessageBox(); //error box
        this.headerArea.appendChild(this.header.domNode);
        this._pendingResponseCount = 0;

		this.reload();
    },
    
    reload: function(){
        this.header.hideMessage();           
		this._fetchAndDisplayInfo();
    },
    
    _fetchAndDisplayInfo: function(){
		this._emptyIfDomExists(this.infoArea);
        this.handleLoadingData();
        this._displayInfo();
    },

    /**
     * Show the counters
     */
    _displayInfo: function(data){ 	
    	
    	dojo.create("iframe", { 
			src: net.jazz.ajax._contextRoot + "/counters?private",    
			marginWidth: 0,    
			marginHeight: 0,    
			frameBorder: 0,    
			style: {        
				width: "100%",        
				height: "1000px",        
				border: "none"   
			}
		}, this.infoArea);
    	
        this.handleDataLoaded();
    },
    
	_emptyIfDomExists: function(node) {
		if(node) {
			node.innerHTML = "";
			return true;
		} else {
			return false;
		}
	},
	
	handleLoadingData: function(){
        this._pendingResponseCount++;
        getWorkbench().showMessage(this.messages.loadingData);
    },
    
    handleDataLoaded: function(){
        this._pendingResponseCount--;
        if (this._pendingResponseCount === 0) {
            getWorkbench().hideMessageArea();
        }
    }
    
});
    
function getWorkbench(){
    return net.jazz.ajax.ui.PlatformUI.getWorkbench();
}

})();
