/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    
dojo.provide("com.ibm.rdm.fronting.server.web.ui.internal.admin.ServiceClient");
    
dojo.require("dijit._Widget");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.client.internal.ServerStatusClient");
dojo.require("com.ibm.rdm.fronting.server.web.util.rrsutils");

var ServerStatusClient = com.ibm.team.repository.web.client.internal.ServerStatusClient;
var rrsutils = com.ibm.rdm.fronting.server.web.util.rrsutils;
var PUBLIC_URL_NAME = "server.webapp.url";
var PUBLIC_URL_SERVICE_NAME = "com.ibm.team.repository.service.internal.BaseServerDescriptionService";

com.ibm.rdm.fronting.server.web.ui.internal.admin.ServiceClient = {
	
    /**
     * Retrieves the rootservices document from the fronting server.
     */		
    getRootServices: function(responseHandler) {
		var result = jazz.client.xhrGet({
			url: net.jazz.ajax._contextRoot + "/rootservices",
			sync: false,
			handleAs: "xml",
			headers: {
		    	"Accept": "application/rdf+xml",
		    	"DoorsRP-Request-Type": "private" 
		    },
			load: function(data, ioargs) {
		        net.jazz.ajax.core.internal.util.callContributedCode(function() {
					responseHandler.doCallback(data);
				});
			},
			error: function(error) {
		        net.jazz.ajax.core.internal.util.callContributedCode(function() {
					responseHandler.doErrorCallback(error);
				});
			}	        
		});
    },
    
    getServerHealth: function(responseHandler) {
		var result = jazz.client.xhrGet({
			url: net.jazz.ajax._contextRoot + "/status",
			sync: false,
			handleAs: "json",
			load: function(data, ioargs) {
		        net.jazz.ajax.core.internal.util.callContributedCode(function() {
					responseHandler.doCallback(data);
				});
			},
			error: function(error) {
		        net.jazz.ajax.core.internal.util.callContributedCode(function() {
					responseHandler.doErrorCallback(error);
				});
			}	        
		});
    },
    
    getCheckAuth: function(responseHandler) {
		var result = jazz.client.xhrGet({
			url: net.jazz.ajax._contextRoot + "/status/auth",
			sync: true,
			load: function(data, ioargs) {
		        net.jazz.ajax.core.internal.util.callContributedCode(function() {
					responseHandler.doCallback(data);
				});
			},
			error: function(error) {
		        net.jazz.ajax.core.internal.util.callContributedCode(function() {
					responseHandler.doErrorCallback(error);
				});
			}	        
		});
    },
    
    getPublicURI: function(serviceInfo) {
		for (var i=0; i<serviceInfo.properties.length; i++) {
			if (serviceInfo.properties[i].name === PUBLIC_URL_NAME) {
				var prop = serviceInfo.properties[i]
				return prop.overrideValue != null ? prop.overrideValue : prop.defaultValue;
			}	
		};
	},
    
    getServiceConfiguration: function (responseHandler) {	
		ServerStatusClient.getServiceConfiguration(responseHandler, PUBLIC_URL_SERVICE_NAME);
	},
	
	getAllProductInfo: function (responseHandler) {	
		ServerStatusClient.getAllProductInfo(responseHandler);
	}    
    
};

})();
