/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){

	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.ConfigParams"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$	
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.ConfigParams", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_events/templates/ConfigParams.html"), //$NON-NLS-1$, //$NON-NLS-2$
		widgetsInTemplate: true,
		_isKeyDirty: false,
		_isValueDirty: false,
		
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$			
		},
		
		postCreate: function(){
			this._key.value = this.messages.ConfigParams_1;
			this._value.value = this.messages.ConfigParams_2;
			
			dojo.addClass(this._key, "fieldDefaultLabel"); //$NON-NLS-1$
			dojo.addClass(this._value, "fieldDefaultLabel"); //$NON-NLS-1$
			this._keyConnect = this.connect(this._key, "onfocus", function(){ //$NON-NLS-1$
				this._key.value = ""; //$NON-NLS-1$
				this._isKeyDirty = true;
				dojo.removeClass(this._key, "fieldDefaultLabel"); //$NON-NLS-1$
				this.disconnect(this._keyConnect);
			});
			this._valueConnect = this.connect(this._value, "onfocus", function(){ //$NON-NLS-1$
				this._value.value = ""; //$NON-NLS-1$
				this._isValueDirty = true;
				dojo.removeClass(this._value, "fieldDefaultLabel"); //$NON-NLS-1$
				this.disconnect(this._valueConnect);
			});
			this.connect(this._delete, "onclick", "onDelete"); //$NON-NLS-1$ //$NON-NLS-2$ 			
		},
		
		onDelete: function(){
			
		},		
		
		getCustomConfigData: function(){
			var keyValue = null;
			if (this._key.value && this._isKeyDirty && this._value.value && this._isValueDirty) {
				keyValue = {
					name: this._key.value,
					value: this._value.value
				}
			}
			return keyValue;
		},
		
		uninitialize: function(){
			delete this.messages;
			this.inherited(arguments);
		}
		
	});
})();
