/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){

	// TODO: remove all console.log statements once the feature is stabilized
	
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient");//$NON-NLS-1$
	dojo.require("dojo.cookie"); //$NON-NLS-1$
	dojo.require("dojo.i18n");//$NON-NLS-1$
	dojo.require("dojox.xml.DomParser"); //$NON-NLS-1$
	dojo.require("jazz.app.auth"); //$NON-NLS-1$
	dojo.require("jazz.app.proxy"); //$NON-NLS-1$
	dojo.require("jazz.client.xhr"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$	
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var Messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$;
	var FRIENDS = "friends"; //$NON-NLS-1$
	var RESOURCE = "resource"; //$NON-NLS-1$
	var FRIEND = "Friend"; //$NON-NLS-1$
	var ROOTSERVICES = "rootServices"; //$NON-NLS-1$
	var TITLE = "title"; //$NON-NLS-1$
	var INTERNAL = "internal"; //$NON-NLS-1$
	var EVENTSOURCES = "eventSources"; //$NON-NLS-1$
	var EVENTSOURCE = "eventSource"; //$NON-NLS-1$
	var NAME = "name"; //$NON-NLS-1$
	var URI = "uri"; //$NON-NLS-1$
	var SUMMARY = "summary"; //$NON-NLS-1$
	var DETAILS = "details"; //$NON-NLS-1$
	var TYPEID = "typeId"; //$NON-NLS-1$
	var URL = "url"; //$NON-NLS-1$
	var EVENTHANDLER = "eventHandler"; //$NON-NLS-1$
	var EVENTTYPES = "eventTypes"; //$NON-NLS-1$
	var CHILDREN = "children"; //$NON-NLS-1$
	var REFERENCE = "reference"; //$NON-NLS-1$
	var EVENTTYPE = "eventType"; //$NON-NLS-1$
	var CATEGORY = "category"; //$NON-NLS-1$
	var EVENT_LISTENER_REGISTRATIONS = "eventListenerRegistrations"; //$NON-NLS-1$
	var EVENT_SELECTOR = "eventSelector"; //$NON-NLS-1$
	var EVENT_SOURCES_GADGET_SPEC_URL = "eventSourcesGadgetSpecificationUrl"; //$NON-NLS-1$
	var EVENTHANDLERS = "eventHandlers"; //$NON-NLS-1$
	var CrossAppEventClient = com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient; //$NON-NLS-1$
	CrossAppEventClient.COOKIE_LISTENER_REGISTRATION_LAST_MODIFIED = "com.ibm.team.process.events.listenerRegistration#LastModified"; //$NON-NLS-1$
	
	
	com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient.getRegisteredApplications = function(/* String */rootservicesURL,/* function */ callback, /* function */ errorCallback){
		//Summary: Returns the registered applications of JTS.
		//			Registered applications are published as 'internal' firends of JTS.
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		
		var fetchFriendsResourceURL = function(/* String */rootservicesXMLResponse){
			var rootservicesDocument = dojox.xml.DomParser.parse(rootservicesXMLResponse);
			var friendsNode = rootservicesDocument.getElementsByTagNameNS(FRIENDS, ProcessConstants.NAMESPACE_JD);
			var friendsResourceURL = friendsNode[0].getAttributeNS(RESOURCE, ProcessConstants.NAMESPACE_RDF);
			
			var fetchFriendServers = function(/* String */friendsListXMLResponse){
				var friendsListDocument = dojox.xml.DomParser.parse(friendsListXMLResponse);
				var friendNodes = friendsListDocument.getElementsByTagNameNS(FRIEND, ProcessConstants.NAMESPACE_JD);
				var friends = [];
				var i = 0;
				dojo.forEach(friendNodes, function(friendNode){
					var internalNodes = friendNode.childrenByNameNS(INTERNAL, ProcessConstants.NAMESPACE_JFS);
					var internalFriend = false;
					if (internalNodes.length > 0 && internalNodes[0].childNodes.length > 0 && internalNodes[0].childNodes[0].nodeValue === 'true') {  //$NON-NLS-1$
						var friend = {};
						var friendTitleNode = friendNode.childrenByNameNS(TITLE, ProcessConstants.NAMESPACE_DC)[0];
						var friendRootservicesNode = friendNode.childrenByNameNS(ROOTSERVICES, ProcessConstants.NAMESPACE_JD)[0];
						var rootservicesResource = friendRootservicesNode.getAttributeNS(RESOURCE, ProcessConstants.NAMESPACE_RDF);
						friend.title = decodeURIComponent(friendTitleNode.childNodes[0].nodeValue);
						friend.rootservices = rootservicesResource;
						friend.isInternalFriend = internalFriend;
						friends[i++] = friend;
					}
				});
				if (callback) {
					callback(friends);
				}
			};
			_invokeService(friendsResourceURL, fetchFriendServers, errorHandler);
		};
		_invokeService(rootservicesURL, fetchFriendsResourceURL, errorHandler);
	};
	
	com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient.getEventSources = function(/* String */eventSourcesResourceURL, /* function */ callback, /* function */ errorCallback){
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		
		var fetchEventSources = function(/* String */eventSourcesListXMLResponse){
			// Error Handling when invoked from OpenSocial gadgets.
			if (eventSourcesListXMLResponse.errors && eventSourcesListXMLResponse.errors.length > 0) {
				var err = new Error(dojo.string.substitute(Messages.CrossAppEventClient_2, [eventSourcesResourceURL, eventSourcesListXMLResponse.errors]));
				if (errorCallback) {
					errorCallback(err);
				}
				return;
			}
			if (eventSourcesListXMLResponse.oauthErrorText && eventSourcesListXMLResponse.oauthErrorText.length > 0) {
				var err = new Error(dojo.string.substitute(Messages.CrossAppEventClient_2, [eventSourcesResourceURL, eventSourcesListXMLResponse.oauthErrorText]));
				if (errorCallback) {
					errorCallback(err);
				}
				return;
			}
			var eventSourcesListDocument = dojox.xml.DomParser.parse(eventSourcesListXMLResponse);
			var eventSourceNodes = eventSourcesListDocument.getElementsByTagNameNS(EVENTSOURCE, ProcessConstants.NAMESPACE_JP);
			var eventSources = [];
			var i = 0;
			dojo.forEach(eventSourceNodes, function(eventSourceNode){
				var eventSource = {};
				var nameNodes = eventSourceNode.childrenByNameNS(NAME, ProcessConstants.NAMESPACE_JP);
				if (nameNodes.length > 0 && nameNodes[0].childNodes.length > 0) {
					eventSource.name = nameNodes[0].childNodes[0].nodeValue;
				}
				var summaryNodes = eventSourceNode.childrenByNameNS(SUMMARY, ProcessConstants.NAMESPACE_JP);
				if (summaryNodes.length > 0 && summaryNodes[0].childNodes.length > 0) {
					eventSource.summary = summaryNodes[0].childNodes[0].nodeValue;
				}
				var detailsNodes = eventSourceNode.childrenByNameNS(DETAILS, ProcessConstants.NAMESPACE_JP);
				if (detailsNodes.length > 0 && detailsNodes[0].childNodes.length > 0) {
					eventSource.details = detailsNodes[0].childNodes[0].nodeValue;
				}
				var typeIdNodes = eventSourceNode.childrenByNameNS(TYPEID, ProcessConstants.NAMESPACE_JP);
				if (typeIdNodes.length > 0 && typeIdNodes[0].childNodes.length > 0) {
					eventSource.typeId = typeIdNodes[0].childNodes[0].nodeValue;
				}
				var urlNodes = eventSourceNode.childrenByNameNS(URL, ProcessConstants.NAMESPACE_JP);
				if (urlNodes.length > 0 && urlNodes[0].childNodes.length > 0) {
					eventSource.url = urlNodes[0].childNodes[0].nodeValue;
				}
				var eventTypesNodes = eventSourceNode.childrenByNameNS(EVENTTYPES, ProcessConstants.NAMESPACE_JP);
				if (eventTypesNodes.length > 0 && eventTypesNodes[0].childNodes.length > 0) {
					eventSource.eventTypes = eventTypesNodes[0].childNodes[0].nodeValue;
				}
				var childrenNodes = eventSourceNode.childrenByNameNS(CHILDREN, ProcessConstants.NAMESPACE_JP);
				if (childrenNodes.length > 0) {
					eventSource.children = [];
					var j = 0;
					var referenceNodes = childrenNodes[0].childrenByNameNS(REFERENCE, ProcessConstants.NAMESPACE_JP);
					dojo.forEach(referenceNodes, function(referenceNode){
						var reference = {};
						reference.reference = referenceNode.childNodes[0].nodeValue;
						eventSource.children[j++] = reference;
					});
				}
				eventSources[i++] = eventSource;
			});
			if (callback) {
				callback(eventSources);
			}
		};
		_invokeService(eventSourcesResourceURL, fetchEventSources, errorHandler);
	};
	
	/**
	 * Interface to fetch the registered listeners.
	 *
	 * @param {function} callback
	 * @param {function} errorCallback
	 */
	com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient.getRegisteredListeners = function(/* String */rootservicesURL,/* function */ callback, /* function */ errorCallback){
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		var fecthEventListenerData = function(/* String */rootservicesXMLResponse){
			var rootservicesDocument = dojox.xml.DomParser.parse(rootservicesXMLResponse);
			var eventListenerRegistrationsNode = rootservicesDocument.getElementsByTagNameNS(EVENT_LISTENER_REGISTRATIONS, ProcessConstants.NAMESPACE_JP);
			if (eventListenerRegistrationsNode.length !== 0) {
				var eventListenerRegistrationsResourceURL = eventListenerRegistrationsNode[0].getAttributeNS(RESOURCE, ProcessConstants.NAMESPACE_RDF);
				_getListeners(eventListenerRegistrationsResourceURL, callback, errorCallback);
			} else {
				var err = new Error(Messages.CrossAppEventClient_1);
				if (errorCallback) {
					errorCallback(err);
				}
			}
		};
		// request to fetch the root servicexml
		_invokeService(rootservicesURL, fecthEventListenerData, errorHandler);
	};
	
	/**
	 * Fetches the registered listeners
	 *
	 * @param {Object}fetchListenersurl
	 * @param {Object}callback
	 * @param {Object} errorCallback
	 */
	_getListeners = function(/* string */fetchListenersurl, /* callback */ callback, /* errorCallback */ errorCallback){
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		var fetchListeners = function(/* String */listenerXMLResponse){
			var eventRegListenersDocument = dojox.xml.DomParser.parse(listenerXMLResponse);
			var eventRegListenersNodes = eventRegListenersDocument.getElementsByTagNameNS("eventListenerRegistration", ProcessConstants.NAMESPACE_JP); //$NON-NLS-1$
			var eventRegListeners = [];
			var i = 0;
			dojo.forEach(eventRegListenersNodes, function(eventRegListenersNode){
				var eventRegListener = {};
				//sets name
				var nameNodes = eventRegListenersNode.childrenByNameNS(NAME, ProcessConstants.NAMESPACE_JP);
				if (nameNodes.length > 0 && nameNodes[0].childNodes.length > 0) {
					eventRegListener.name = nameNodes[0].childNodes[0].nodeValue;
				}
				//sets uri
				var uriNodes = eventRegListenersNode.childrenByNameNS(URI, ProcessConstants.NAMESPACE_JP);
				if (uriNodes.length > 0 && uriNodes[0].childNodes.length > 0) {
					if (uriNodes[0].childNodes[0].nodeValue) {
						eventRegListener.uri = uriNodes[0].childNodes[0].nodeValue;
					}
				}
				
				//sets summary
				var summaryNodes = eventRegListenersNode.childrenByNameNS(SUMMARY, ProcessConstants.NAMESPACE_JP);
				if (summaryNodes.length > 0 && summaryNodes[0].childNodes.length > 0) {
					eventRegListener.summary = summaryNodes[0].childNodes[0].nodeValue;
				}
				//sets eventHandler
				var eventHandlerNodes = eventRegListenersNode.childrenByNameNS(EVENTHANDLER, ProcessConstants.NAMESPACE_JP);
				if (eventHandlerNodes.length > 0 && eventHandlerNodes[0].childNodes.length > 0) {
					eventRegListener.eventHandler = eventHandlerNodes[0].childNodes[0].nodeValue;
				}
				//sets eventType
				var eventTypeNodes = eventRegListenersNode.childrenByNameNS(EVENTTYPE, ProcessConstants.NAMESPACE_JP);
				if (eventTypeNodes.length > 0 && eventTypeNodes[0].childNodes.length > 0) {
					eventRegListener.eventType = eventTypeNodes[0].childNodes[0].nodeValue;
				}
				//sets eventSource
				var eventSourceNodes = eventRegListenersNode.childrenByNameNS(EVENTSOURCE, ProcessConstants.NAMESPACE_JP);
				if (eventSourceNodes.length > 0 && eventSourceNodes[0].childNodes.length > 0) {
					eventRegListener.eventSource = eventSourceNodes[0].childNodes[0].nodeValue;
				}
				eventRegListeners[i++] = eventRegListener;
			});
			if (callback) {
				callback(eventRegListeners);
			}
		};
		// request to fetch the registered listeners. 
		// Get the latest timestamp when a listener was last registered and pass it in If-Modified-Since header.
		// By setting the If-Modified-Since header we try to ensure that the indexer had a chance 
		// to process the recently registered listeners.
		_invokeService(fetchListenersurl, fetchListeners, errorHandler, dojo.cookie(CrossAppEventClient.COOKIE_LISTENER_REGISTRATION_LAST_MODIFIED));
	};
	
	com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient.getEventTypes = function(/* String */eventTypeURL, /* function */ callback, /* function */ errorCallback){
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		var fetchEventTypes = function(/* String */eventTypesListXMLResponse){
			// Error Handling when invoked from OpenSocial gadgets.
			if (eventTypesListXMLResponse.errors && eventTypesListXMLResponse.errors.length > 0) {
				var err = new Error(dojo.string.substitute(Messages.CrossAppEventClient_2, [eventTypeURL, eventTypesListXMLResponse.errors]));
				if (errorCallback) {
					errorCallback(err);
				}
				return;
			}
			if (eventTypesListXMLResponse.oauthErrorText && eventTypesListXMLResponse.oauthErrorText.length > 0) {
				var err = new Error(dojo.string.substitute(Messages.CrossAppEventClient_2, [eventTypeURL, eventTypesListXMLResponse.oauthErrorText]));
				if (errorCallback) {
					errorCallback(err);
				}
				return;
			}
			var eventTypesListDocument = dojox.xml.DomParser.parse(eventTypesListXMLResponse);
			var eventTypeNodes = eventTypesListDocument.getElementsByTagNameNS(EVENTTYPE, ProcessConstants.NAMESPACE_JP);
			var eventTypes = [];
			var i = 0;
			dojo.forEach(eventTypeNodes, function(eventTypeNode){
				var eventType = {};
				var nameNodes = eventTypeNode.childrenByNameNS(NAME, ProcessConstants.NAMESPACE_JP);
				if (nameNodes.length > 0 && nameNodes[0].childNodes.length > 0) {
					eventType.name = nameNodes[0].childNodes[0].nodeValue;
				}
				var typeIdNode = eventTypeNode.childrenByNameNS(TYPEID, ProcessConstants.NAMESPACE_JP);
				if (typeIdNode.length > 0 && typeIdNode[0].childNodes.length > 0) {
					eventType.typeId = typeIdNode[0].childNodes[0].nodeValue;
				}
				var categoryNodes = eventTypeNode.childrenByNameNS(CATEGORY, ProcessConstants.NAMESPACE_JP);
				if (categoryNodes.length > 0 && categoryNodes[0].childNodes.length > 0) {
					eventType.category = categoryNodes[0].childNodes[0].nodeValue;
				}
				var summaryNodes = eventTypeNode.childrenByNameNS(SUMMARY, ProcessConstants.NAMESPACE_JP);
				if (summaryNodes.length > 0 && summaryNodes[0].childNodes.length > 0) {
					eventType.summary = summaryNodes[0].childNodes[0].nodeValue;
				}
				var urlNodes = eventTypeNode.childrenByNameNS(URL, ProcessConstants.NAMESPACE_JP);
				if (urlNodes.length > 0 && urlNodes[0].childNodes.length > 0) {
					eventType.url = urlNodes[0].childNodes[0].nodeValue;
				}
				eventTypes[i++] = eventType;
			});
			if (callback) {
				callback(eventTypes);
			}
		};
		_invokeService(eventTypeURL, fetchEventTypes, errorHandler);
	};
	
	com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient.getEventType = function(/* String */eventTypeURL, /* function */ callback, /* function */ errorCallback){
		// summary:
		//		Gets the representation of provided event type resource url.
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		
		var fetchEventType = function(/* String */eventTypeXMLResponse){
			var eventTypeDocument = dojox.xml.DomParser.parse(eventTypeXMLResponse);
			var eventTypeNode = eventTypeDocument.documentElement;
			var eventType = {};
			
			var nameNode = eventTypeNode.childrenByNameNS(NAME, ProcessConstants.NAMESPACE_JP);
			if (nameNode.length > 0 && nameNode[0].childNodes.length > 0) {
				eventType.name = nameNode[0].childNodes[0].nodeValue;
			}
			var typeIdNode = eventTypeNode.childrenByNameNS(TYPEID, ProcessConstants.NAMESPACE_JP);
			if (typeIdNode.length > 0 && typeIdNode[0].childNodes.length > 0) {
				eventType.typeId = typeIdNode[0].childNodes[0].nodeValue;
			}
			var categoryNode = eventTypeNode.childrenByNameNS(CATEGORY, ProcessConstants.NAMESPACE_JP);
			if (categoryNode.length > 0 && categoryNode[0].childNodes.length > 0) {
				eventType.category = categoryNode[0].childNodes[0].nodeValue;
			}
			var summaryNode = eventTypeNode.childrenByNameNS(SUMMARY, ProcessConstants.NAMESPACE_JP);
			if (summaryNode.length > 0 && summaryNode[0].childNodes.length > 0) {
				eventType.summary = summaryNode[0].childNodes[0].nodeValue;
			}
			var urlNode = eventTypeNode.childrenByNameNS(URL, ProcessConstants.NAMESPACE_JP);
			if (urlNode.length > 0 && urlNode[0].childNodes.length > 0) {
				eventType.url = urlNode[0].childNodes[0].nodeValue;
			}
			if (callback) {
				callback(eventType);
			}
		};
		
		_invokeService(eventTypeURL, fetchEventType, errorHandler);
	};
	
	
	com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient.getEventSource = function(/* String */eventSourceURL, /* function */ callback, /* function */ errorCallback){
		// summary:
		//		Gets the representation of provided event source resource url.
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		
		var fetchEventSource = function(/* String */eventSourceXMLResponse){
			var eventSourceDocument = dojox.xml.DomParser.parse(eventSourceXMLResponse);
			var eventSourceNode = eventSourceDocument.documentElement;
			var eventSource = {};
			var nameNodes = eventSourceNode.childrenByNameNS(NAME, ProcessConstants.NAMESPACE_JP);
			if (nameNodes.length > 0 && nameNodes[0].childNodes.length > 0) {
				eventSource.name = nameNodes[0].childNodes[0].nodeValue;
			}
			var summaryNodes = eventSourceNode.childrenByNameNS(SUMMARY, ProcessConstants.NAMESPACE_JP);
			if (summaryNodes.length > 0 && summaryNodes[0].childNodes.length > 0) {
				eventSource.summary = summaryNodes[0].childNodes[0].nodeValue;
			}
			var detailsNodes = eventSourceNode.childrenByNameNS(DETAILS, ProcessConstants.NAMESPACE_JP);
			if (detailsNodes.length > 0 && detailsNodes[0].childNodes.length > 0) {
				eventSource.details = detailsNodes[0].childNodes[0].nodeValue;
			}
			var typeIdNodes = eventSourceNode.childrenByNameNS(TYPEID, ProcessConstants.NAMESPACE_JP);
			if (typeIdNodes.length > 0 && typeIdNodes[0].childNodes.length > 0) {
				eventSource.typeId = typeIdNodes[0].childNodes[0].nodeValue;
			}
			var urlNodes = eventSourceNode.childrenByNameNS(URL, ProcessConstants.NAMESPACE_JP);
			if (urlNodes.length > 0 && urlNodes[0].childNodes.length > 0) {
				eventSource.url = urlNodes[0].childNodes[0].nodeValue;
			}
			var eventTypesNodes = eventSourceNode.childrenByNameNS(EVENTTYPES, ProcessConstants.NAMESPACE_JP);
			if (eventTypesNodes.length > 0 && eventTypesNodes[0].childNodes.length > 0) {
				eventSource.eventTypes = eventTypesNodes[0].childNodes[0].nodeValue;
			}
			var childrenNodes = eventSourceNode.childrenByNameNS(CHILDREN, ProcessConstants.NAMESPACE_JP);
			if (childrenNodes.length > 0) {
				eventSource.children = [];
				var j = 0;
				var referenceNodes = childrenNodes[0].childrenByNameNS(REFERENCE, ProcessConstants.NAMESPACE_JP);
				dojo.forEach(referenceNodes, function(referenceNode){
					var reference = {};
					reference.reference = referenceNode.childNodes[0].nodeValue;
					eventSource.children[j++] = reference;
				});
			}
			if (callback) {
				callback(eventSource);
			}
		};
		
		_invokeService(eventSourceURL, fetchEventSource, errorHandler);
	};
	
	com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient.getEventSourcesGadgetSpecUrl = function(/* String */rootservicesURL, /* function */ callback, /*function */ errorCallback){
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		var fetchEventSourcesGadgetSpecURL = function(/* String */rootservicesXMLResponse){
			var rootservicesDocument = dojox.xml.DomParser.parse(rootservicesXMLResponse);
			var eventSourcesGadgetSpecUrlNode = rootservicesDocument.getElementsByTagNameNS(EVENT_SOURCES_GADGET_SPEC_URL, ProcessConstants.NAMESPACE_JP);
			if (eventSourcesGadgetSpecUrlNode.length !== 0) {
				var eventSourcesGadgetSpecURL = eventSourcesGadgetSpecUrlNode[0].getAttributeNS(RESOURCE, ProcessConstants.NAMESPACE_RDF);
				if (callback) {
					callback(eventSourcesGadgetSpecURL);
				}
			} else {
				if (callback) {
					callback(null);
				}
			}
		};
		_invokeService(rootservicesURL, fetchEventSourcesGadgetSpecURL, errorHandler);
	};
		
	com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient.registerListener = function(/* String */rootServicesURL, /* Object */ newItem, /* function */ callback, /* function */ errorCallback){
		var regPostData = _getRegisterPostData(newItem);
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		var postEventListenerData = function(/* String */rootservicesXMLResponse){
			var rootservicesDocument = dojox.xml.DomParser.parse(rootservicesXMLResponse);
			var eventListenerRegistrationsNode = rootservicesDocument.getElementsByTagNameNS(EVENT_LISTENER_REGISTRATIONS, ProcessConstants.NAMESPACE_JP);
			if (eventListenerRegistrationsNode.length !== 0) {
				var eventListenerRegistrationsResourceURL = eventListenerRegistrationsNode[0].getAttributeNS(RESOURCE, ProcessConstants.NAMESPACE_RDF);
				var deferred = jazz.client.rawXhrPost({
					url: eventListenerRegistrationsResourceURL,
					contentType: "application/xml; charset=utf-8", //$NON-NLS-1$
					handleAs: "xml", //$NON-NLS-1$
					postData: regPostData,
					load: callback,
					error: errorCallback
				});
			} else {
				var err = new Error(Messages.CrossAppEventClient_1);
				if (errorCallback) {
					errorCallback(err);
				}
			}
		};
		_invokeService(rootServicesURL, postEventListenerData, errorHandler);
	};
	
	com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient.getEventHandlersServiceUrl = function(/* String */rootServicesURL, /* function */ callback, /* function */ errorCallback){
		// summary:
		//		Gets Event Handlers' service URL from the provided rootservices 
		//		document and passes it to provided callback method. Returns null 
		//		if not present.
		// description:
		//		Provided errback function is invoked in case any error occurs
		
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		
		// Gets the event handler service url from provided rootservices 
		// document.
		var getEventHandlersServiceUrl = function(/* String */rootservicesXMLResponse){
			var eventHandlersResourceURL;
			var rootservicesDocument = dojox.xml.DomParser.parse(rootservicesXMLResponse);
			var eventHandlersNode = rootservicesDocument.getElementsByTagNameNS(EVENTHANDLERS, ProcessConstants.NAMESPACE_JP);
			if (eventHandlersNode.length !== 0) {
				eventHandlersResourceURL = eventHandlersNode[0].getAttributeNS(RESOURCE, ProcessConstants.NAMESPACE_RDF);
			}
			if (callback) {
				callback(eventHandlersResourceURL);
			}
		};
		_invokeService(rootServicesURL, getEventHandlersServiceUrl, errorHandler);
	};
	
	com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient.getEventHandlers = function(/* String */eventHandlersServiceURL, /* function */ callback, /* function */ errorCallback){
		// summary:
		//		Gets the list of event handlers from the provided event handlers 
		//		service URL and passes it to provided callback method. 
		//		Returns an empty array in case there are no event handlers.
		// description:
		//		Provided errback function is invoked in case any error occurs
		
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		
		//Converts provided event handlers' xml response into json.
		var getEventHandlers = function(/* String */eventHandlersListXMLResponse){
			var eventHandlersListDocument = dojox.xml.DomParser.parse(eventHandlersListXMLResponse);
			var eventHandlerNodes = eventHandlersListDocument.getElementsByTagNameNS(EVENTHANDLER, ProcessConstants.NAMESPACE_JP);
			var eventHandlers = [];
			var i = 0;
			dojo.forEach(eventHandlerNodes, function(eventHandlerNode){
				var eventHandler = {};
				var nameNodes = eventHandlerNode.childrenByNameNS(NAME, ProcessConstants.NAMESPACE_JP);
				if (nameNodes.length > 0 && nameNodes[0].childNodes.length > 0) {
					eventHandler.name = nameNodes[0].childNodes[0].nodeValue;
				}
				var urlNodes = eventHandlerNode.childrenByNameNS(URL, ProcessConstants.NAMESPACE_JP);
				if (urlNodes.length > 0 && urlNodes[0].childNodes.length > 0) {
					eventHandler.url = urlNodes[0].childNodes[0].nodeValue;
				}
				eventHandlers[i++] = eventHandler;
			});
			if (callback) {
				callback(eventHandlers);
			}
		};
		_invokeService(eventHandlersServiceURL, getEventHandlers, errorHandler);
	};
	
	com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient.deleteListener = function(/* Object */deleteItem,/* function */ callback, /* function */ errorCallback){
		var deferred = jazz.client.xhrDelete({
			url: deleteItem.uri,
			handleAs: "xml", //$NON-NLS-1$
			load: callback,
			error: errorCallback
		});
	};
	
	_invokeService = function(/* string */url, /* callback */ callback, /* errorCallback */ errorCallback, /* string */ ifModifiedSince){
	
		var args = {
			url: url,
			headers: {
				"accept": "text/xml" //$NON-NLS-1$ //$NON-NLS-2$
			}
		};
		if (ifModifiedSince && ifModifiedSince !== null) {
			args.headers['If-Modified-Since'] = ifModifiedSince; //$NON-NLS-1$
		}
		var deferred = jazz.client.xhrGet(args);
		
		deferred.addCallback(callback);
		deferred.addErrback(errorCallback);
	};
	
	_getRegisterPostData = function(newItem){
		var postData = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" + //$NON-NLS-1$
		"<jp:eventListenerRegistration  " + //$NON-NLS-1$
		'xmlns:jp=\"' + //$NON-NLS-1$
		ProcessConstants.NAMESPACE_JP +
		'\">'; //$NON-NLS-1$
		postData += "<jp:name>" + encodeURIComponent(dojo.trim(newItem["name"])) + "</jp:name>\n"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		postData += "<jp:summary>" + encodeURIComponent(dojo.trim(newItem["summary"])) + "</jp:summary>\n"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		postData += "<jp:eventType>" + encodeURI(newItem["eventType"]) + "</jp:eventType>\n"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		postData += "<jp:eventSource>" + encodeURI(newItem["eventSource"]) + "</jp:eventSource>\n"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		postData += "<jp:eventHandler>" + encodeURI(newItem["eventHandler"]) + "</jp:eventHandler>\n"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		if (newItem.customConfigData && newItem.customConfigData.length > 0) {
			postData += "<jp:custom>\n"; //$NON-NLS-1$ 
			dojo.forEach(newItem.customConfigData, function(configData){
				if (configData.name && configData.value) {
					postData += "<jp:property jp:name='" + encodeURIComponent(dojo.trim(configData.name)) + "' jp:value='" + encodeURIComponent(dojo.trim(configData.value)) + "' /> \n"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				}
			});
			postData += "</jp:custom>\n"; //$NON-NLS-1$ 		
		}
		postData += "</jp:eventListenerRegistration>"; //$NON-NLS-1$
		return postData;
	};
	
})();
