/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventManagementPage"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("jazz.ui.SideNavigationLayout"); //$NON-NLS-1$
	dojo.require("jazz.ui.RemoteChooserContainer"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient"); //$NON-NLS-1$	
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$       
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ActionRegistry;
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var SideNavigationLayout = jazz.ui.SideNavigationLayout;
	var ManageCrossAppEventsClass = "manageCrossAppEventsUI"; //$NON-NLS-1$
	var ManageCrossAppEventsAction = "com.ibm.team.process.manageCrossAppEvents"; //$NON-NLS-1$
	var CrossAppEventClient = com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient;
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventManagementPage", dijit._Widget, { //$NON-NLS-1$
		//  summary:
		//     CrossAppEventManagementPage is used for all cross application event handling actions.
		
		_manageCrossAppEventsDiv: null,
		_remoteChooserContainer: null,
		_cached: false,
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function(){
			this.inherited(arguments);
			dojo.addClass(this.domNode, "com-ibm-team-process-events"); //$NON-NLS-1$
			this._appView = new SideNavigationLayout();
			this.domNode.appendChild(this._appView.domNode);
			this._manageCrossAppEventsDiv = document.createElement("div"); //$NON-NLS-1$
			dojo.addClass(this._manageCrossAppEventsDiv, ManageCrossAppEventsClass);
			var navSection = this._appView.addNavigationSection(document.createElement("div"), this.messages.CrossAppEventManagementPage_1, true); //$NON-NLS-1$
			this.link = navSection.addSectionRow(this.messages.CrossAppEventManagementPage_2, "#action=" + ManageCrossAppEventsAction); //$NON-NLS-1$
			navSection.addArtifactCommand(this.link, this.messages.CrossAppEventManagementPage_3, dojo.hitch(this, this._onNavSectionClick), "process-management-refresh-command", true); //$NON-NLS-1$
			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction(ManageCrossAppEventsAction, this, "manageEvents"); //$NON-NLS-1$
		},
		
		//  Description:
		//      On calling ManageCrossAppEventsAction this method is called. It instantes ManageCrossAppEvents widget.  		
		manageEvents: function(){
			dojo.toggleClass(this.link, "selected", true); //$NON-NLS-1$
			PlatformUI.getWorkbench().setTitle(this.messages.CrossAppEventManagementPage_2);
			if (!this._remoteChooserContainer || !this._cached) {
				this._displayManageCrossAppEventsWidget();
			}
		},
		
		// Description:
		//    It embeds the manageCrossAppEvents UI Widget.
		_displayManageCrossAppEventsWidget: function(){
			this._destroyManageCrossAppUI();
			var manageCrossAppEventsWidgetUrl = ProcessConstants.EVENT_MANAGEMENT_WIDGET_URL; 
			var remoteUrl = manageCrossAppEventsWidgetUrl + "?rootservices=" + ProcessConstants.ROOTSERVICESXML; //$NON-NLS-1$
			var placeholder = document.createElement("div"); //$NON-NLS-1$					
			this._cached = true;
			this._manageCrossAppEventsDiv.appendChild(placeholder);
			this._remoteChooserContainer = new jazz.ui.RemoteChooserContainer({
				remoteLocation: remoteUrl,
				onData: function(data){
					// Currently there is no data exchange
				}
			}, placeholder);
			this._appView.setMainContent(this._manageCrossAppEventsDiv);
		},
		
		_onNavSectionClick: function(e){
			dojo.stopEvent(e);
			this._cached = false;
			this.manageEvents();
		},
		
		_destroyManageCrossAppUI: function(){
			dojox.xml.parser.removeChildren(this._manageCrossAppEventsDiv);
			if (this._remoteChooserContainer) {
				this._remoteChooserContainer.destroyRecursive();
				delete this._remoteChooserContainer;
			}
		},
		
		uninitialize: function(){
			this._destroyManageCrossAppUI();
			this._appView.destroyRecursive();
			delete this._appView;
			delete this._manageCrossAppEventsDiv;
			delete this._cached;
			delete this.link;
			this.inherited(arguments);
		}
		
	});
})();
