/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){

	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.CustomConfigContainer"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$	
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.ConfigParams"); //$NON-NLS-1$  
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ConfigParams = com.ibm.team.process.web.ui.internal.admin.process_events.ConfigParams;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.CustomConfigContainer", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_events/templates/CustomConfigContainer.html"), //$NON-NLS-1$, //$NON-NLS-2$
		widgetsInTemplate: true,
		
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$			
		},
		
		postCreate: function(){
			this._configParams = [];
			this.connect(this._addConfigParams, "onclick", "_addConfig"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		_addConfig: function(){
			var configParams = new ConfigParams();
			this.connect(configParams, "onDelete", dojo.hitch(this, function(){ //$NON-NLS-1$ 
				this._configContainer.removeChild(configParams.domNode);
				for (var i = 0; i < this._configParams.length; i++) {
					if (this._configParams[i] === configParams) {
						this._configParams.splice(i, 1);
						configParams.destroyRecursive();
					}
				}
			}));
			this._configContainer.appendChild(configParams.domNode);
			this._configParams.push(configParams);
		},
		
		getCustomConfigData: function(){
			var customConfigData = [];
			dojo.forEach(this._configParams, function(configParams){
				var params = configParams.getCustomConfigData();
				if (params) {
					customConfigData.push(params);
				}
			});
			return customConfigData;
		},
		
		
		uninitialize: function(){
			delete this.messages;
			this.inherited(arguments);
		}
		
	});
})();
