/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.DisplayRegListeners"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$    
	dojo.require("com.ibm.team.process.web.ui.internal.TRToolbar"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.StyledTableItemList"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.RegListenerToolTip"); //$NON-NLS-1$  
	dojo.require("jazz.app.ua.PageHoverHelp"); //$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$	
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$    
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var CrossAppEventClient = com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient;
	var DisplayRegListenerControls = com.ibm.team.process.web.ui.internal.admin.process_events.DisplayRegListenerControls;
	var RegListenerToolTip = com.ibm.team.process.web.ui.internal.admin.process_events.RegListenerToolTip;
	var MessageBox = jazz.ui.MessageBox;
	var STATUS_TYPES = MessageBox.STATUS_TYPES;
	var ProcessWebPath = "com.ibm.team.process.web"; //$NON-NLS-1$
	var Delete_GIF = "ui/internal/images/delete_hov.gif"; //$NON-NLS-1$
	var Edit_GIF = "ui/internal/images/edit.gif"; //$NON-NLS-1$
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.DisplayRegListeners", com.ibm.team.process.web.ui.internal.StyledTableItemList, { //$NON-NLS-1$
		//  summary:
		//      This embedable ui widget used for managing cross application event listeners. The widget extends ItemList. It gets the registered event 
		//      listeners from the given rootsersvice .
		_actionToolbars: [],
		rootservices: null,
		_messageBox: null,
		onAdd: null,
		onQuickAdd: null,
		
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function(){
			this._messageBox = new MessageBox();
			this.messageArea.appendChild(this._messageBox.domNode);
			this._setText(this.heading, this.messages.DisplayRegListeners_1);
			this._setText(this.description, this.messages.DisplayRegListeners_2);
			this.setHelpHooks(ProcessConstants.UAKey.CROSS_APPLICATION_EVENTS_PAGE);
			this._initGrid();
			var callback = dojo.hitch(this, function(regEventListeners){
				this._displayGrid(regEventListeners);
			});
			var errback = dojo.hitch(this, function(error){
				this._messageBox.showMessage({
					type: STATUS_TYPES.ERROR,
					summary: this.messages.DisplayRegListeners_17,
					errorObject: error
				});
			});
			CrossAppEventClient.getRegisteredListeners(this.rootservices, callback, errback);
		},
		
		//  Description:
		//      Function used for initialisation of the display grid .   
		
		_initGrid: function(){
			dojo.addClass(this.tableContents, ProcessConstants.CSSClass.TOOLBAR_TABLE);
			dojo.addClass(this.tableContents, "displayRegListeners"); //$NON-NLS-1$            
			var columns = [];
			columns.push({
				label: this.messages.DisplayRegListeners_3,
				sortable: false
			});
            columns.push({
            	label: this.messages.DisplayRegListeners_4,
            	sortable: false
            });
            columns.push({
            	label: this.messages.DisplayRegListeners_5,
            	sortable: false
            });
            columns.push({
            	label: this.messages.DisplayRegListeners_6,
            	sortable: false
            });
        	columns.push({
            	label: this.messages.DisplayRegListeners_8,
           		className: ProcessConstants.CSSClass.ACTION_COLUMN,
            	sortable: false
            });

			this.createTable( {
				columns: columns
			});
			this._addLink = this.addLink("#", this.messages.DisplayRegListeners_23, "com.ibm.team.process.web/ui/internal/admin/process_events/images/register-event-handler_co.gif", dojo.hitch(this, this.onAdd));//$NON-NLS-1$ //$NON-NLS-2$
			this._quickAddLink = this.addLink("#", this.messages.DisplayRegListeners_24, "com.ibm.team.process.web/ui/internal/admin/process_events/images/quick-registration_co.gif", dojo.hitch(this, this.onQuickAdd));//$NON-NLS-1$ //$NON-NLS-2$
			
		},
		
		//  Description:
		//      Loop through the registered listeners and add it to the display grid                
		_displayGrid: function(regEventListeners){
			if (regEventListeners && regEventListeners.length > 0) {
				dojo.forEach(regEventListeners, function(eventListener){
					if (this._validateEventListener(eventListener)) {
						this._addListenerRow(eventListener);
					}
				}, this);
			} else {
				this._messageBox.showMessage({
					type: MessageBox.STATUS_TYPES.INFO,
					summary: this.messages.DisplayRegListeners_14
				});
			}
		},
		
		clearState: function(){
			dojox.xml.parser.removeChildren(this.tbody);
			this._messageBox.hideMessage();
			this._destroyActionToolbars();
		},
		
		//  Description:
		//      To add a row in event listeners display grid        
		_addListenerRow: function(rowItem){
			var nameDomNode = this._createNameNode(decodeURIComponent(rowItem.name));
			var regListenerToolTip = new RegListenerToolTip();
			regListenerToolTip.setToolTip(rowItem);
			var tooltip = new jazz.ui.HoverPopup({
				around: nameDomNode,
				html: regListenerToolTip.domNode.innerHTML,
				openDelay: 300,
				orientation: "R" //$NON-NLS-1$
			}, nameDomNode);
			if (!rowItem.summary) {
				rowItem.summary = ""; //$NON-NLS-1$
			}
			var summaryDomNode = document.createTextNode(decodeURIComponent(rowItem.summary));
			var eventSourceDomNode = this._createDomNode(this.messages.DisplayRegListeners_20 + "..."); //$NON-NLS-1$
			var eventTypeDomNode = this._createDomNode(this.messages.DisplayRegListeners_20 + "..."); //$NON-NLS-1$
			var toolBar = this._createToolBar(rowItem);
			var deleteButton = toolBar.getItem(0);
			var row = this.addRow(null, [nameDomNode, summaryDomNode, eventSourceDomNode, eventTypeDomNode, toolBar.domNode]);
			deleteButton.domNode.row = row;
			deleteButton.domNode.toolBar = toolBar;
			this._updateEventSource(eventSourceDomNode, rowItem.eventSource, regListenerToolTip, tooltip);
			this._updateEventType(eventTypeDomNode, rowItem.eventType, regListenerToolTip, tooltip);
		},
		
		//  Description:
		//      To create  dom element         
		_createDomNode: function(item){
			var node = document.createElement("div"); //$NON-NLS-1$
			node.innerHTML = item;
			return node;
		},
		
		//  Description:
		//      To create  dom element         
		_createNameNode: function(item){
			var name = document.createElement('a'); //$NON-NLS-1$
			name.innerHTML = item;
			return name;
		},
		
		_updateEventSource: function(eventSourceDomNode, eventSourceURL, regListenerToolTip, tooltip){
			var callback = dojo.hitch(this, function(eventSource){
				eventSourceDomNode.innerHTML = eventSource.name;
				regListenerToolTip.setEventSrcName(eventSource.name);
				tooltip.html = regListenerToolTip.domNode.innerHTML;
			});
			var errback = function(e){
				console.log(this.messages.DisplayRegListeners_17, e);
			};
			CrossAppEventClient.getEventSource(eventSourceURL, callback, errback);
		},
		
		_updateEventType: function(eventTypeDomNode, eventTypeURL, regListenerToolTip, tooltip){
			var callback = dojo.hitch(this, function(eventType){
				eventTypeDomNode.innerHTML = eventType.name;
				regListenerToolTip.setEventTypeName(eventType.name);
				tooltip.html = regListenerToolTip.domNode.innerHTML;
			});
			var errback = function(e){
				console.log(this.messages.DisplayRegListeners_18, e);
			};
			CrossAppEventClient.getEventType(eventTypeURL, callback, errback);
		},
		
		handleAddListenerSuccess: function(newItem){
			this._messageBox.showMessage({
				type: MessageBox.STATUS_TYPES.OK,
				summary: dojo.string.substitute(this.messages.DisplayRegListeners_22, [newItem.name])
			});
			this._addListenerRow(newItem);
		},
		
		_setText: function(e, text){
			e.appendChild(document.createTextNode(text));
		},
		
		//  Description:
		//      validate the event Listener      
		_validateEventListener: function(eventListener){
			if (eventListener.name && eventListener.eventSource && eventListener.eventType && eventListener.eventHandler) {
				return true;
			} else {
				return false;
			}
		},
		
		//  Description:
		//      create action tool bar.         
		_createToolBar: function(rowData){
			var trToolbar = new com.ibm.team.process.web.ui.internal.TRToolbar();
			this._actionToolbars.push(trToolbar);
			var deleteAction = {};
			var self = this;
			deleteAction.imgSrc = dojo.moduleUrl(ProcessWebPath, Delete_GIF);
			deleteAction.label = this.messages.DisplayRegListeners_12;
			deleteAction.callbackData = rowData;
			var deleteCallback = function(e){
				dojo.stopEvent(e);
				var param = e.currentTarget.callbackData;
				var confirmationMsg = dojo.string.substitute(this.messages.DisplayRegListeners_16,[decodeURIComponent(param.name)] );
				var isOk = confirm(confirmationMsg);
				if (!isOk) {
					return;
				}
				var row = e.currentTarget.row;
				var toolBar = e.currentTarget.toolBar;
				dojo.addClass(row, "hideRow"); //$NON-NLS-1$
				dojo.removeClass(row, "hideRow"); //$NON-NLS-1$
				toolBar.disableToolbar(true);
				var successCallback = function(response, ioArgs){
					// Save the Last-Modified timestamp which will be used later when fetching registered listeners.
					dojo.cookie(CrossAppEventClient.COOKIE_LISTENER_REGISTRATION_LAST_MODIFIED, ioArgs.xhr.getResponseHeader("Last-Modified")); //$NON-NLS-1$
					dojo.removeClass(row, "hideRow"); //$NON-NLS-1$
					var parentNode = row.parentNode;
					parentNode.removeChild(row);
					self._messageBox.showMessage({
						type: MessageBox.STATUS_TYPES.OK,
						summary: dojo.string.substitute(self.messages.DisplayRegListeners_21, [decodeURIComponent(param.name)])
					});
				};
				
				var errorCallback = function(error){
					dojo.removeClass(row, "hideRow"); //$NON-NLS-1$
					toolBar.disableToolbar(false);
					var msg = document.createElement("div");//$NON-NLS-1$
					msg.appendChild(document.createTextNode(self.messages.DisplayRegListeners_15));
					if (error.message) {
						msg.appendChild(document.createElement("br"));//$NON-NLS-1$
						msg.appendChild(document.createElement("br")); //$NON-NLS-1$
						msg.appendChild(document.createTextNode(decodeURIComponent(error.message)));
					}
					self._messageBox.showMessage({
						type: STATUS_TYPES.ERROR,
						summary: msg
					});
				};
				CrossAppEventClient.deleteListener(param, successCallback, errorCallback);
				
			};
			trToolbar.addButton(this, deleteCallback, deleteAction);
			return trToolbar;
		},
		
		_destroyActionToolbars: function(){
			for (var i = 0; i < this._actionToolbars.length; i++) {
				this._actionToolbars[i].destroyRecursive();
			}
			delete this._actionToolbars;
		},
		
		uninitialize: function(){
			this._destroyActionToolbars();
			delete this.rootservices;
			this._messageBox.destroyRecursive();
			delete this._messageBox;
			delete this.onAdd;
			delete this.onQuickAdd;
			this.inherited(arguments);
		}
		
	});
	
})();
