/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.QuickRegistrationForm"); //$NON-NLS-1$
	dojo.require("dojo.cookie"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dijit.layout.TabContainer"); //$NON-NLS-1$
	dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
	dojo.require("dijit.form.Button"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient"); //$NON-NLS-1$ 
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.CustomConfigContainer"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var CrossAppEventClient = com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.QuickRegistrationForm", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		//  summary:
		//     The widget is the listener registration form used to fill in the listener to registered.   
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_events/templates/QuickRegistrationForm.html"),//$NON-NLS-1$ //$NON-NLS-2$
		widgetsInTemplate: true,
		_nameConnect: null,
		_summaryConnect: null,
		_evntSrcConnect: null,
		_evntTypeConnect: null,
		rootservices: null,
		_addListenerConnect: null,
		_cancelConnect: null,
		
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function(){
			this._server.value = this.rootservices; //$NON-NLS-1$
			this._addListenerConnect = this.connect(this._addListener, "onclick", "_regListener"); //$NON-NLS-1$  //$NON-NLS-2$
			this._cancelConnect = this.connect(this._cancel, "onclick", "onCancel"); //$NON-NLS-1$  //$NON-NLS-2$
			this._nameConnect = this.connect(this._name, "onfocus", function(){ //$NON-NLS-1$
				this._name.value = ""; //$NON-NLS-1$
				dojo.removeClass(this._name, "formFieldLabel"); //$NON-NLS-1$
				this.disconnect(this._nameConnect);
			});
			this._summaryConnect = this.connect(this._summary, "onfocus", function(){ //$NON-NLS-1$
				this._summary.value = ""; //$NON-NLS-1$
				dojo.removeClass(this._summary, "formFieldLabel"); //$NON-NLS-1$
				this.disconnect(this._summaryConnect);
			});
			this._evntSrcConnect = this.connect(this._eventSource, "onfocus", function(){ //$NON-NLS-1$
				this._eventSource.value = ""; //$NON-NLS-1$
				dojo.removeClass(this._eventSource, "formFieldLabel"); //$NON-NLS-1$
				this.disconnect(this._evntSrcConnect);
			});
			this._evntTypeConnect = this.connect(this._eventType, "onfocus", function(){ //$NON-NLS-1$
				this._eventType.value = ""; //$NON-NLS-1$
				dojo.removeClass(this._eventType, "formFieldLabel"); //$NON-NLS-1$
				this.disconnect(this._evntTypeConnect);
			});
			this.setDefaultMessages();
		},
		
		reSize: function(){
			this._tabCont.doLayout = true;
			this._tabCont.startup();
		},
		
		setDefaultMessages: function(){
			this._eventSource.value = this.messages.QuickRegistrationForm_3; //$NON-NLS-1$
			this._eventType.value = this.messages.QuickRegistrationForm_4; //$NON-NLS-1$
			this._name.value = this.messages.QuickRegistrationForm_1; //$NON-NLS-1$
			this._summary.value = this.messages.QuickRegistrationForm_2; //$NON-NLS-1$
			this.setDefaultHandler();
			dojo.removeClass(this._warnMsg, "errorMsg"); //$NON-NLS-1$
			this._warnMsg.innerHTML = ""; //$NON-NLS-1$
		},
		
		setDefaultHandler: function(){
			// summary:
			// 		Temp code adding mock listener URL
			var listUrl = document.location.protocol + "//" + document.location.host + net.jazz.ajax._contextRoot + "/mock-process-event-listener-service"; //$NON-NLS-1$ //$NON-NLS-2$ 
			this._listener.value = listUrl; //$NON-NLS-1$			
		},
		
		
		//  Description:
		//      The method is used to add Listener. On register button click the method is called. It checks whether all forms are filled
		//  if not it will through error message.   		
		_regListener: function(e){
			var selRootservices = this._server.value
			if (!selRootservices) {
				this._warnMsg.innerHTML = this.messages.QuickRegistrationForm_7;
				dojo.addClass(this._warnMsg, "errorMsg"); //$NON-NLS-1$
				return;
			}
			var error = false;
			var newItem = {};
			this.isValid(this._name.value, this.messages.QuickRegistrationForm_1) ? newItem["name"] = this._name.value : error = true; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
			this.isValid(this._summary.value, this.messages.QuickRegistrationForm_2) ? newItem["summary"] = this._summary.value : newItem["summary"] = ""; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
			this.isValid(this._eventSource.value, this.messages.QuickRegistrationForm_3) ? newItem["eventSource"] = this._eventSource.value : error = true; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			this.isValid(this._eventType.value, this.messages.QuickRegistrationForm_4) ? newItem["eventType"] = this._eventType.value : error = true; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			this.isValid(this._listener.value, null) ? newItem["eventHandler"] = this._listener.value : error = true; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			var customConfigData = this._configContainer.getCustomConfigData();
			if (customConfigData) {
				newItem.customConfigData = customConfigData;
			}
			if (error) {
				this._warnMsg.innerHTML = this.messages.QuickRegistrationForm_5;
				dojo.addClass(this._warnMsg, "errorMsg"); //$NON-NLS-1$
				return;
			} else {
				dojo.removeClass(this._warnMsg, "errorMsg"); //$NON-NLS-1$
				this._warnMsg.innerHTML = ""; //$NON-NLS-1$
			}
			var callback = dojo.hitch(this, function(response, ioArgs){
				// Save the Last-Modified timestamp which will be used later when fetching registered listeners.
				dojo.cookie(CrossAppEventClient.COOKIE_LISTENER_REGISTRATION_LAST_MODIFIED, ioArgs.xhr.getResponseHeader("Last-Modified")); //$NON-NLS-1$
				var resourceUrl = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
				if (selRootservices === this.rootservices) {
					if (resourceUrl) {
						newItem.uri = resourceUrl;
					}
					this.onSuccess(newItem);
				} else {
					this.onSuccess();
				}
			});
			var errback = dojo.hitch(this, function(e){
				this._warnMsg.innerHTML = this.messages.QuickRegistrationForm_6;
				dojo.addClass(this._warnMsg, "errorMsg"); //$NON-NLS-1$
			});
			CrossAppEventClient.registerListener(selRootservices, newItem, callback, errback);
		},
		
		//  Description:
		//      On successful registration of the event listener this method is invoked.Overide method 		
		onSuccess: function(newItem){
		
		},
		//  Description:
		//      On click of cancel button this method is invoked.Overide method 
		onCancel: function(){
		
		},
		
		//  Description:
		//      To check whether the value is valid or not     
		isValid: function(value, defaultText){
			if (value !== null && dojo.string.trim(value) !== "") { //$NON-NLS-1$ 
				if (defaultText !== null && value == defaultText) {
					return false;
				}
				return true;
			}
			return false;
		},
		
		_destroyFieldConnects: function(){
			delete this._nameConnect;
			delete this._summaryConnect;
			delete this._evntSrcConnect;
			delete this._evntTypeConnect;
			delete this.rootservices;
			delete this._addListenerConnect;
			delete this._cancelConnect;
		},
		
		uninitialize: function(){
			this._destroyFieldConnects();
			this.inherited(arguments);
		}
		
	});
	
})();
