/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){

	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.RegListenerToolTip"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$	
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.wizard", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.RegListenerToolTip", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_events/templates/RegListenerToolTip.html"), //$NON-NLS-1$, //$NON-NLS-2$
		widgetsInTemplate: true,
		item: null,
		
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$			
		},
		
		
		setToolTip: function(item){
			if (item) {
				this._eventSrcURL.setAttribute("href", item.eventSource); //$NON-NLS-1$
				this._eventTypeURL.setAttribute("href", item.eventType); //$NON-NLS-1$
				this._eventHandler.setAttribute("href", item.eventHandler); //$NON-NLS-1$
				if (item.eventSource.length > 50) {
					var eventSrcLength = item.eventSource.length;
					this._eventSrcURL.innerHTML = "...." + item.eventSource.substring(eventSrcLength-50, eventSrcLength); //$NON-NLS-1$
				} else {
					this._eventSrcURL.innerHTML = item.eventSource;
				}
				if (item.eventType.length > 50) {
					var eventTypeLength = item.eventType.length;
					this._eventTypeURL.innerHTML =  "...." + item.eventType.substring(eventTypeLength-50, eventTypeLength); //$NON-NLS-1$
				} else {
					this._eventTypeURL.innerHTML = item.eventType;
				}
				if (item.eventHandler.length > 50) {
					var eventHandlerLength = item.eventHandler.length;
					this._eventHandler.innerHTML = "...." + item.eventHandler.substring(eventHandlerLength-50, eventHandlerLength); //$NON-NLS-1$
				} else {
					this._eventHandler.innerHTML = item.eventHandler;
				}
				this._summary.innerHTML = decodeURIComponent(item.summary);
				this._title.innerHTML = decodeURIComponent(item.name);
				this._eventSrcName.innerHTML = this.messages.RegListenerToolTip_1 + "..."; //$NON-NLS-1$
				this._eventTypeName.innerHTML = this.messages.RegListenerToolTip_1 + "..."; //$NON-NLS-1$			
			}
		},
		
		setEventSrcName: function(eventSrcName){
			if (eventSrcName) {
				this._eventSrcName.innerHTML = eventSrcName;
			}
		},
		
		setEventTypeName: function(eventTypeName){
			if (eventTypeName) {
				this._eventTypeName.innerHTML = eventTypeName;
			}
		},
		
		uninitialize: function(){
			delete item;
			this.inherited(arguments);
		}
		
	});
})();
