/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.RegisterListenerWizard"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("jazz.ui.Breadcrumbs"); //$NON-NLS-1$
	dojo.require("jazz.ui.Button"); //$NON-NLS-1$
	dojo.require("jazz.ui.Wizard"); //$NON-NLS-1$	
	dojo.require("jazz.ui.wizard.WizardStep"); //$NON-NLS-1$
	dojo.require("jazz.ui.wizard.WizardStepHeader"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.ProviderWizardStep"); //$NON-NLS-1$	
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.RegisterWizHeader"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.EventSourceWizardStep"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.EventTypeWizardStep"); //$NON-NLS-1$	
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.ConfigWizardStep"); //$NON-NLS-1$ 
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.CustomConfigWizardStep"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient"); //$NON-NLS-1$	
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$       
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ActionRegistry;
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var CrossAppEventClient = com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.RegisterListenerWizard", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		//  summary:
		//     RegisterListenerWizard is used for all cross application event handling actions.
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_events/templates/RegisterListenerWizard.html"), //$NON-NLS-1$  //$NON-NLS-2$		
		_providerStep: null,
		rootservices: null,
		_eventSourceStep: null,
		pageDiv: null,
		onCancel: null,
		onFinish: null,
		_selectedRootservices: null,
		_eventSelected: null,
		_registerWizHeader: null,
		
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		
		postCreate: function(){
			var segment = {
				label : this.messages.RegisterListenerWizardHTML_1,
				//href: '#action=jazz.viewPage&id=com.ibm.team.process.CrossAppEventManagement' //$NON-NLS-1$
				onClick : this.onCancel
			};
			this._breadCrumbsWidget = new jazz.ui.Breadcrumbs({
				segments: [segment]
			});
			
			this._breadcrumbs.appendChild(this._breadCrumbsWidget.domNode);	
					
			this._registerWizHeader = new com.ibm.team.process.web.ui.internal.admin.process_events.wizard.RegisterWizHeader();
			dojox.xml.parser.removeChildren(this._registerListenerWizard);
			this._providerStep = new com.ibm.team.process.web.ui.internal.admin.process_events.wizard.ProviderWizardStep({
				rootservices: this.rootservices
			});
			this._eventSourceStep = new com.ibm.team.process.web.ui.internal.admin.process_events.wizard.EventSourceWizardStep();
			this._eventTypeStep = new com.ibm.team.process.web.ui.internal.admin.process_events.wizard.EventTypeWizardStep();
			var registerListner = dojo.hitch(this, this._registerListener);
			var checkForName = dojo.hitch(this._registerWizHeader, this._registerWizHeader.checkForName);
			this._configStep = new com.ibm.team.process.web.ui.internal.admin.process_events.wizard.ConfigWizardStep({
				rootservices: this.rootservices,
				registerListner: registerListner,
				checkForName: checkForName
			});
			this._customConfigWizStep = new com.ibm.team.process.web.ui.internal.admin.process_events.wizard.CustomConfigWizardStep({
				checkForName: checkForName,
				registerListner: registerListner
			});
			this._configStep.setCustomConfigWizardStep(this._customConfigWizStep);
			this._customConfigWizStep.setConfigWizardStep(this._configStep);
			
			this.connect(this._providerStep, "onProviderSelect", function(selectedFriend){ //$NON-NLS-1$
				if (selectedFriend && this._selectedRootservices != selectedFriend.rootservices) {
					this._eventSelected = null;
					this._selectedFriend = selectedFriend;
					// To Do remove the this._selectedRootservices and replace with this._selectedFriend.rootservices
					this._selectedRootservices = selectedFriend.rootservices;
				}
				this._eventSourceStep.setSelectRootServices(selectedFriend.rootservices);
			});
			
			this.connect(this._eventSourceStep, "onEventSrcSelect", function(eventSelected){ //$NON-NLS-1$
				this._eventSelected = eventSelected;
				this._eventTypeStep.setEventSrc(eventSelected);
				
			});
			this.connect(this._eventTypeStep, "onEventTypeSelect", function(eventTypeURL){ //$NON-NLS-1$
				this._eventSelected.eventTypeURL = eventTypeURL;
				this._configStep.setEventTypeURL(this._eventSelected.eventTypeURL);
			});
			
			var onCancelFn = dojo.hitch(this, this.onCancel);
			var wizardArgs = {
				steps: [this._providerStep, this._eventSourceStep, this._eventTypeStep, this._configStep, this._customConfigWizStep],
				fullPageContainer: this._registerListenerWizard,
				customProcessCancel: onCancelFn,
				includeCancel: true,
				stepListLayout: "vertical", //$NON-NLS-1$
				hideTrim: true,
				headerNode: this._registerWizHeader.domNode
			};
			self.location.hash = "#"; //$NON-NLS-1$ 
			this._wizardFull = new jazz.ui.Wizard(wizardArgs);
			
			dojo.addClass(this._wizardFull.contentWidget.wizardHRline, "hideHRLIne"); //$NON-NLS-1$
		},
		
		_registerListener: function(eventHandler, callback, errback){
			var newItem = this._createNewItem(eventHandler);
			var regCallback = dojo.hitch(this, function(response, ioArgs){
				// Save the Last-Modified timestamp which will be used later when fetching registered listeners.
				dojo.cookie(CrossAppEventClient.COOKIE_LISTENER_REGISTRATION_LAST_MODIFIED, ioArgs.xhr.getResponseHeader("Last-Modified")); //$NON-NLS-1$
				callback(newItem);
				if (this.rootservices === this._selectedRootservices || this._selectedFriend.isInternalFriend) {
					var resourceUrl = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
					newItem.uri = resourceUrl;
					this.onFinish(newItem);
				} else {
					this.onFinish();
				}
			});
			CrossAppEventClient.registerListener(this._selectedRootservices, newItem, regCallback, errback);
		},
		
		_createNewItem: function(eventHandler){
			var newItem = {};
			newItem.name = this._registerWizHeader.getName();
			newItem.summary = this._registerWizHeader.getSummary();
			newItem.eventSource = this._eventSelected.eventSourceUrl;
			newItem.eventType = this._eventSelected.eventTypeURL;
			newItem.eventHandler = eventHandler.url;
			newItem.customConfigData = eventHandler.customConfigData;
			return newItem;
		},
		
		uninitialize: function(){
			if (this._registerWizHeader) {
				this._registerWizHeader.destroyRecursive();
				delete this._registerWizHeader;
			}
			if (this._providerStep) {
				this._providerStep.destroyRecursive();
				delete this._providerStep;
			}
			if (this._eventSourceStep) {
				this._eventSourceStep.destroyRecursive();
				delete this._eventSourceStep;
			}
			if (this._configStep) {
				this._configStep.destroyRecursive();
				delete this._configStep;
			}
			if (this._customConfigWizStep) {
				this._customConfigWizStep.destroyRecursive();
				delete this._customConfigWizStep;
			}
			delete this._wizardFull;
			dojox.xml.parser.removeChildren(this._registerListenerWizard);
			delete this._registerListenerWizard;
			delete this._eventSelected;
			delete this._selectedRootservices;
			delete this._selectedFriend;
			delete this.onCancel;
			delete this.onFinish;
			delete this.rootservices;
			if (this._breadCrumbsWidget) {
				this._breadCrumbsWidget.destroyRecursive();
				delete this._breadCrumbsWidget;
			}
			this.inherited(arguments);
		}
		
	});
	
})();
