/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventSourceSelector"); //$NON-NLS-1$
	
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventSourceSelectorWidget"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.selector", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$	
	
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var EventSourceSelectorWidget = com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventSourceSelectorWidget;
	var MessageBox = jazz.ui.MessageBox;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventSourceSelector", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
        //	Summary
        //      Instantiable alternative for embeddable EventSourceSelector gadget. 
		//      This can be used to display EventSources from local server.
		//
        //		eventSourcesURL is a mandatory parameter.
        //		
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_events/selector/templates/EventSourceSelector.html"), //$NON-NLS-1$, //$NON-NLS-2$
		widgetsInTemplate: true,
		
		constructor: function(params){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.selector", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this._eventSources = params[ProcessConstants.PREFS_EVENTSOURCES_URL];
            if (!this._eventSources) {
            	throw new Error(this.messages.EventSourceSelector_5);
            }
		},
		
		postCreate: function(){
			this._messageBox = new MessageBox();
            this._headerArea.appendChild(this._messageBox.domNode);
			this._eventSourceSelectorWidget = new EventSourceSelectorWidget({messageBox: this._messageBox}, this._eventSourceSelectorWidgetDiv);
			this._eventSourceSelectorWidget.loadEventSources(this._eventSources);
			this.connect(this._eventSourceSelectorWidget, "onSelectEventSource",  function(selectedEventSource){ //$NON-NLS-1$
				this.onSelectEventSource(dojo.toJson(selectedEventSource));
			});
		},
		
		onSelectEventSource: function(selectedEventSource){
            // callback method to which clients of this widget can connect to get the selectedEventSource details
			// selectedEventSource will have two attributes
			//   url - url of the selected eventSource
			//   eventTypes - url to fetch the eventTypes of selected eventSource
		},
		
		uninitialize: function(){
            if (this._messageBox) {
            	this._messageBox.destroyRecursive();
            	delete this._messageBox;
            }
            if (this._eventSourceSelectorWidget) {
            	this._eventSourceSelectorWidget.destroyRecursive();
            	delete this._eventSourceSelectorWidget;
            }
			delete this._eventSources;
			delete this.messages;
			this.inherited(arguments);
		}
	});

})();
