/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventSourceSelectorGadget"); //$NON-NLS-1$
	
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("jazz.client.xhr"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.internal.OpenSocialJazz"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventSourceSelectorWidget"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.selector", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$	
	
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var EventSourceSelectorWidget = com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventSourceSelectorWidget;
	var MessageBox = jazz.ui.MessageBox;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventSourceSelectorGadget", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
        //	Summary
        //		Embeddable gadget that displays Event Sources from the selected server. 
        //		This is not expected to be instantiated directly, instead it should be 
		//		embedded using OpenSocial gadget API.
        //  	
        //		eventSourcesURL is a mandatory user preference value.
        //		
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_events/selector/templates/EventSourceSelector.html"), //$NON-NLS-1$, //$NON-NLS-2$
		widgetsInTemplate: true,
		
		constructor: function(params){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.selector", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			var prefs = new gadgets.Prefs();
			this._eventSources = prefs.getString(ProcessConstants.PREFS_EVENTSOURCES_URL);
            if (!this._eventSources) {
            	throw new Error(this.messages.EventSourceSelector_5);
            }
			// Determine the absolute URL to retrieve eventTypes Gadget Specification
			var url = new dojo._Url(document.getElementsByTagName("base")[0].href, ProcessConstants.EVENTTYPES_GADGET_SPECIFICATION_URL); //$NON-NLS-1$
			this._eventTypesGadgetSpecificationUrl = url.toString();
		},
		
		postCreate: function(){
			this._messageBox = new MessageBox();
            this._headerArea.appendChild(this._messageBox.domNode);
			this._eventSourceSelectorWidget = new EventSourceSelectorWidget({messageBox: this._messageBox}, this._eventSourceSelectorWidgetDiv);
			this._eventSourceSelectorWidget.loadEventSources(this._eventSources);
			this.connect(this._eventSourceSelectorWidget, "onSelectEventSource",  function(selectedEventSource){ //$NON-NLS-1$
			    var data = {};
				data.url = selectedEventSource.url;
				// append eventTypes URL as a parameter to the eventTypesGadgetSpecification URL
                data.eventTypesGadgetSpecificationUrl = this._eventTypesGadgetSpecificationUrl + "?eventTypes=" + selectedEventSource.eventTypes; //$NON-NLS-1$
				gadgets.rpc.call("", ProcessConstants.RPCSERVICE_EVENTSOURCE_SELECTION_CHANGED, null, dojo.toJson(data)); //$NON-NLS-1$
			});
			gadgets.window.adjustHeight();
		},
		
		uninitialize: function(){
            if (this._messageBox) {
            	this._messageBox.destroyRecursive();
            	delete this._messageBox;
            }
            if (this._eventSourceSelectorWidget) {
            	this._eventSourceSelectorWidget.destroyRecursive();
            	delete this._eventSourceSelectorWidget;
            }
			delete this._eventSources;
			delete this._eventTypesGadgetSpecificationUrl;
			delete this.messages;
			this.inherited(arguments);
		}
	});

})();
