/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventTypeSelectorGadget"); //$NON-NLS-1$
	
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("jazz.client.xhr"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.internal.OpenSocialJazz"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventTypeSelectorWidget"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.selector", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$	
	
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var EventTypeSelectorWidget = com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventTypeSelectorWidget;
	var MessageBox = jazz.ui.MessageBox;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventTypeSelectorGadget", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
        //	Summary
        //		Embeddable widget that displays Event Types from the selected server. 
        //		This widget is not expected to be instantiated directly, instead it should be  
        //		embedded using OpenSocial gadget API
		
        //		eventTypesURL is a mandatory user preference value.
        //		
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_events/selector/templates/EventTypeSelector.html"), //$NON-NLS-1$, //$NON-NLS-2$
		widgetsInTemplate: true,
		
		constructor: function(params){
            this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.selector", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
            var prefs = new gadgets.Prefs();
            this._eventTypes = prefs.getString(ProcessConstants.PREFS_EVENTTYPES_URL);
            if (!this._eventTypes) {
            	throw new Error(this.messages.EventTypeSelector_5);
            }
		},
		
		postCreate: function(){	
			this._messageBox = new MessageBox();
            this._headerArea.appendChild(this._messageBox.domNode);
			this._eventTypeSelectorWidget = new EventTypeSelectorWidget({messageBox: this._messageBox}, this._eventTypeSelectorWidgetDiv);
			this._eventTypeSelectorWidget.loadEventTypes(this._eventTypes);
            this.connect(this._eventTypeSelectorWidget, "onSelectEventType", function(selectedEventType){ //$NON-NLS-1$
				gadgets.rpc.call("", ProcessConstants.RPCSERVICE_EVENTTYPE_SELECTION_CHANGED, null, selectedEventType.url); //$NON-NLS-1$
            });
			gadgets.window.adjustHeight();
		},
		
		uninitialize: function(){
            if (this._messageBox) {
            	this._messageBox.destroyRecursive();
            	delete this._messageBox;
            }
            if (this._eventTypeSelectorWidget) {
            	this._eventTypeSelectorWidget.destroyRecursive();
            	delete this._eventTypeSelectorWidget;
            }
			delete this._eventTypes;
			this.inherited(arguments);
		}
	});

})();
