/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){

	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.BaseConfigWizardStep"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$	
	dojo.require("jazz.ui.wizard.WizardStep"); //$NON-NLS-1$
	dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.BaseConfigWizardStep", [jazz.ui.wizard.WizardStep, dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		registerListner: null,
		_header: null,
		checkForName: null,
		_disableNavigation: false,


		//@Overides		
		onFinish: function(){
			// summary:
			// 		It checks whether the name is filled if yes registerListener is called				
			if (!this.checkForName()) {
				this._showMessage({
					summary: this.messages.BaseConfigWizardStep_1
				});
				return;
			}
			var listener = this.getEventHandler();
			if (listener) {
				//Disable Navigation control buttons
				this._disableNavigation = true;
				this.wizard.updateNavigationControls();
				
				var callback = dojo.hitch(this, this._onSuccess);
				var errback = dojo.hitch(this, this._onFailure);
				var customConfigData = this.getCustomConfigData();
				var eventHandler = {
					url: listener,
					customConfigData: customConfigData
				}
				this.registerListner(eventHandler, callback, errback);
			} else {
				this._showMessage({
					summary: this.messages.BaseConfigWizardStep_2
				});
			}			
		},
		
		_onSuccess: function(result){
		
		},
		
		_showMessage: function(result){
		
		},		
		
		
		
		canFlipToPreviousPage: function(){
			if (this._disableNavigation) {
				return false;
			} else {
				return true;
			}
		},
		
		canFinish: function(){
			if (this._disableNavigation) {
				return false;
			} else {
				return true;
			}
		},
		
		canCancel: function(){
			if (this._disableNavigation) {
				return false;
			} else {
				return true;
			}
		},
		
		_onFailure: function(error){
			this._showMessage({
				type: MessageBox.ERROR,
				summary: this.messages.BaseConfigWizardStep_3,
				errorObject: error
			});
			this._disableNavigation = false;
			this.wizard.updateNavigationControls();
		},

		uninitialize: function(){
			delete this._disableNavigation;
			delete this.checkForName;
			this.inherited(arguments);
		}		
	});
})();
