/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){

	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.ConfigWizardStep"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("jazz.ui.wizard.WizardStepHeader"); //$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.BaseConfigWizardStep"); //$NON-NLS-1$		
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.CustomConfigContainer"); //$NON-NLS-1$	
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.wizard", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var CrossAppEventClient = com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient;
	var MessageBox = jazz.ui.MessageBox;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.ConfigWizardStep", [com.ibm.team.process.web.ui.internal.admin.process_events.wizard.BaseConfigWizardStep, dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_events/wizard/templates/ConfigWizardStep.html"), //$NON-NLS-1$, //$NON-NLS-2$
		rootservices: null,
		registerListner: null,
		_header: null,
		checkForName: null,
		_disableNavigation: false,
		_customConfigWizStep: null,
		
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.wizard", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.stepTitle = this.messages.ConfigWizardStep_0;
		},
		
		postCreate: function(){
			this._header = new jazz.ui.wizard.WizardStepHeader({
				stepTitle: "" //$NON-NLS-1$
			});
			this._stepHeaderArea.appendChild(this._header.domNode);
			this._displayFriends();
			this.connect(this._handlerSelector, "onchange", "_displaySelectedHandlerInformation"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		setEventTypeURL: function(eventTypeURL){
			// summary:
			// 		To set the eventTypeURL of the selected eventType. 			
			if (eventTypeURL && this._eventTypeURL != eventTypeURL) {
				this._eventTypeURL = eventTypeURL;
				this._resetHandlers();
			}
		},
		
		_resetHandlers: function(){
			if(this._friendsSelect){
				this._friendsSelect.reset();
				this._friendsSelect.attr("value", this.messages.ConfigWizardStep_11); //$NON-NLS-1$
				this._handlerSelector.length =0;
				this._listener.value = ""; //$NON-NLS-1$	
			}
		},
		_displayFriends: function(){
			var callback = dojo.hitch(this, function(friends){
				this._populateFriends(friends);
			});
			var errback = dojo.hitch(this, function(error){
			});
			// To get the registered applications.
			CrossAppEventClient.getRegisteredApplications(this.rootservices, callback, errback);
		},
		
		
		_populateFriends: function(friends){
			dojox.xml.parser.removeChildren(this._friendsServerDiv);
			var message = ""; //$NON-NLS-1$
			if (!friends || friends.length == 0) {
				message = this.messages.ConfigWizardStep_13;
				this._showMessage({
					summary: message
				});
			} else {
				message = this.messages.ConfigWizardStep_12;
			}
			var friendStore = new dojo.data.ItemFileReadStore({
				data: {
					identifier: 'rootservices', //$NON-NLS-1$
					label: 'title', //$NON-NLS-1$
					items: friends
				}
			});
			this._friendsSelect = new dijit.form.ComboBox({
				autoComplete: 'false',//$NON-NLS-1$
				store: friendStore, //$NON-NLS-1$
				labelAttr: 'title', //$NON-NLS-1$
				searchAttr: 'rootservices' //$NON-NLS-1$
			});
			this._friendsSelect.attr("value", this.messages.ConfigWizardStep_11); //$NON-NLS-1$
			this.connect(this._friendsSelect, "onChange", dojo.hitch(this, function(friend){ //$NON-NLS-1$
				if (friend === this.messages.ProviderWizardStep_5) {
					return;
				}
				if (this._selectedRootservices == friend) {
					return;
				}
				this._displayEventHandlers(this._eventTypeURL, friend);
				this._selectedRootservices = friend;
				this._header.hideMessage();
			}));
			this._friendsServerDiv.appendChild(this._friendsSelect.domNode);
		},
		
		_showMessage: function(message){
			this._header.showMessage(message);
		},
		
		
		_displayEventHandlers: function(/*String*/eventTypeUrl, friend){
			// summary:
			// 		1. Gets the event type Id of provided event type resource. 
			//		2. Gets the event handlers' service provided in rootservices 
			//		document 
			//		3. Gets the event handlers associated with provided event 
			//			typeId and displays them as a list.
			this._header.hideMessage();
			var callback = dojo.hitch(this, function(eventType){
				if (eventType && eventType.typeId) {
					this._fetchEventHandlers(eventType.typeId, friend);
				} else {
					var summary = dojo.string.substitute(this.messages.ConfigWizardStep_8, [eventTypeUrl]);
					this._showMessage({
						type: MessageBox.ERROR,
						summary: summary,
						errorObject: new Error(summary)
					});
				}
			});
			
			var errback = function(err){
				var summary = dojo.string.substitute(this.messages.ConfigWizardStep_10, [eventTypeUrl]);
				this._showMessage({
					type: MessageBox.ERROR,
					summary: summary,
					errorObject: err
				});
			};
			// Get typeId of provided event type resource and get associated 
			// event handlers on callback.
			CrossAppEventClient.getEventType(eventTypeUrl, callback, errback);
		},
		
		_fetchEventHandlers: function(/*String*/eventTypeId, friend){
			//summary:
			//		Gets the event handlers' service provided in rootservices 
			//		document and then invokes it to get handlers associated with
			//		provided type id. If typeId is null, 
			//		returns all the event handlers. 
			var callback = dojo.hitch(this, function(eventHandlersServiceUrl){
				if (eventHandlersServiceUrl) {
					if (eventTypeId) {
						eventHandlersServiceUrl = eventHandlersServiceUrl + "?typeId=" + eventTypeId; //$NON-NLS-1$
						eventHandlersServiceUrl = encodeURI(eventHandlersServiceUrl);
					}
					this._populateEventHandlers(eventHandlersServiceUrl);
				} else {
					this._showMessage({
						summary: this.messages.ConfigWizardStep_1
					});
				}
			});
			
			var errback = function(err){
				var summary = dojo.string.substitute(this.messages.ConfigWizardStep_2, [err.message]);
				this._showMessage({
					type: MessageBox.ERROR,
					summary: summary,
					errorObject: err
				});
			};
			
			CrossAppEventClient.getEventHandlersServiceUrl(friend, callback, errback);
		},
		
		_populateEventHandlers: function(/*String*/eventHandlersServiceUrl){
			// summary:
			//		Loads event handlers from provided service url and displays 
			//		them as a list. 
			var callback = dojo.hitch(this, function(eventHandlers){
				this._handlerSelector.options.length = 0;
				if (eventHandlers && eventHandlers.length > 0) {
					dojo.forEach(eventHandlers, function(eventHandler){
						var option = new Option(eventHandler.name, eventHandler.url);
						this._handlerSelector.options[this._handlerSelector.options.length] = option;
					}, this);
					this._handlerSelector.selectedIndex = 0;
					this._displaySelectedHandlerInformation();
				} else {
					this._listener.value = ""; //$NON-NLS-1$
					this._showMessage({
						summary: this.messages.ConfigWizardStep_9
					});
				}
			});
			
			var errback = dojo.hitch(this, function(error){
				var summary = dojo.string.substitute(this.messages.ConfigWizardStep_3, [eventHandlersServiceUrl]);
				this._showMessage({
					type: MessageBox.ERROR,
					summary: summary,
					errorObject: error
				});
			});
			
			CrossAppEventClient.getEventHandlers(eventHandlersServiceUrl, callback, errback);
		},
		
		_displaySelectedHandlerInformation: function(){
			// summary:
			//      displays url of select event handler in registration form.
			
			var handlerUrl = this._handlerSelector.options[this._handlerSelector.selectedIndex].value;
			this._listener.value = handlerUrl;
		},
		
		setCustomConfigWizardStep: function(customConfigWizStep){
			// summary:
			//      set the custom config Container to get the configData
			this._customConfigWizStep = customConfigWizStep;
		},
		
		getCustomConfigData: function(customContainer){
			// summary:
			//      get the custom configData
			if (this._customConfigWizStep) {
				return this._customConfigWizStep.getCustomConfigData();
			}
			return null;
		},
		
		getEventHandler: function(){
			// summary:
			//      returns the eventHandler
			return this._listener.value;
		},
		
		onNext: function(){
			if (this.getEventHandler()) {
				this.wizard.processNext();
			} else {
				this._showMessage({
					summary: this.messages.ConfigWizardStep_5
				});
			}
		},
		
		
		
		uninitialize: function(){
			this._header.destroyRecursive();
			delete this._header;
			delete this._eventTypeURL;
			delete this.messages;
			delete this.rootservices;
			this.inherited(arguments);
		}
	});
})();
