/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){

	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.CustomConfigWizardStep"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("jazz.ui.wizard.WizardStepHeader"); //$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.BaseConfigWizardStep"); //$NON-NLS-1$		
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.CustomConfigContainer"); //$NON-NLS-1$	
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.wizard", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var MessageBox = jazz.ui.MessageBox;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.CustomConfigWizardStep", [com.ibm.team.process.web.ui.internal.admin.process_events.wizard.BaseConfigWizardStep, dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_events/wizard/templates/CustomConfigWizardStep.html"), //$NON-NLS-1$, //$NON-NLS-2$
		widgetsInTemplate: true,
		_header: null,
		_configWizardStep: null,
		
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.wizard", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.stepTitle = this.messages.CustomConfigWizardStep_0;
		},
		
		postCreate: function(){
			this._header = new jazz.ui.wizard.WizardStepHeader({
				stepTitle: "" //$NON-NLS-1$
			});
			this._stepHeaderArea.appendChild(this._header.domNode);
		},
		
		_showMessage: function(message){
			this._header.showMessage(message);
		},
		
		getEventHandler: function(){
			if (this._configWizardStep) {
				return this._configWizardStep.getEventHandler();
			}
			return null;
		},
		
		setConfigWizardStep: function(configWizardStep){
			this._configWizardStep = configWizardStep;
		},
		
		getCustomConfigData: function(customContainer){
			// summary:
			//      get the custom configData
			if (this._configContainer) {
				return this._configContainer.getCustomConfigData();
			}
			return null;
		},
		
		uninitialize: function(){
			this._header.destroyRecursive();
			delete this._header;
			delete this.messages;
			this.inherited(arguments);
		}
	});
})();
