/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){

	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.EventSourceWizardStep"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$	
	dojo.require("jazz.opensocial.Gadget");//$NON-NLS-1$
	dojo.require("jazz.ui.wizard.WizardStep"); //$NON-NLS-1$
	dojo.require("jazz.ui.wizard.WizardStepHeader"); //$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient"); //$NON-NLS-1$ 
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventSourceSelector"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.wizard", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var CrossAppEventClient = com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient;
	var EventSourceSelector = com.ibm.team.process.web.ui.internal.admin.process_events.selector.EventSourceSelector;
	var MessageBox = jazz.ui.MessageBox;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.EventSourceWizardStep", [jazz.ui.wizard.WizardStep, dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_events/wizard/templates/EventSourceWizardStep.html"), //$NON-NLS-1$, //$NON-NLS-2$
		widgetsInTemplate: true,
		_selectedRootservices: null,
		_eventSourcesGadget: null,
		_disableNext: true,
		_reload: false,
		
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.wizard", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.stepTitle = this.messages.EventSourceWizardStep_1;
		},
		
		postCreate: function(){
			this.header = new jazz.ui.wizard.WizardStepHeader({
				stepTitle: "" //$NON-NLS-1$
			});
			this._stepHeaderArea.appendChild(this.header.domNode);
		},
		
		setSelectRootServices: function(selectedRootservices){
			if (selectedRootservices && this._selectedRootservices !== selectedRootservices) {
				this._selectedRootservices = selectedRootservices;
				this._reload = true;
			}
		},
		
		focusStep: function(){
			if (this._reload) {
				this._reload = false;
				try {
					this._displayEventSelector();
					this._onEventSrcDeSelect();
				} catch (e) {
					this._reload = true;
				}
			}
		},
		
		//  Description:
		//    This method embeds the event source/type selector widget
		_displayEventSelector: function(){
			dojox.xml.parser.removeChildren(this._eventSourcesGadgetContainerDiv);
			if (this._eventSourcesGadget) {
				this._eventSourcesGadget.destroyRecursive();
				delete this._eventSourcesGadget;
			}
			if (this._onSelectEventSourceConnect) {
				this.disconnect(this._onSelectEventSourceConnect);
				delete this._onSelectEventSourceConnect;
			}
			// Display eventSources from local server i.e. the server hosting the EventSourceSelector UI
			if (this._selectedRootservices === ProcessConstants.ROOTSERVICESXML) {
				// directly instantiate the EventSourceSelector
				this._eventSourcesGadget = new EventSourceSelector({
					eventSourcesURL: ProcessConstants.EVENTSOURCES_URL
				});
				var callback = dojo.hitch(this, function(data){
					var dataObj = {};
					data = dojo.fromJson(data);
					if (data.url && data.eventTypes) {
						dataObj.eventSourceUrl = data.url;
						dataObj.eventTypes = data.eventTypes;
						dataObj.selectedRootServices = this._selectedRootservices;
						this.onEventSrcSelect(dataObj);
					}
				});
				this._onSelectEventSourceConnect = this.connect(this._eventSourcesGadget, "onSelectEventSource", callback); //$NON-NLS-1$
				this._eventSourcesGadgetContainerDiv.appendChild(this._eventSourcesGadget.domNode);
			} else {
				// Display eventSources from remote server or application server embedding the cross app event management page from JTS
				var callback = dojo.hitch(this, function(eventSourcesGadgetSpecificationUrl){
					if (!eventSourcesGadgetSpecificationUrl) {
						this.header.showMessage({
							type: MessageBox.INFO,
							summary:this.messages.EventSourceWizardStep_2 ,
						});
						
					}
					var dataCallback = dojo.hitch(this, function(data){
						var dataObj = {};
						data = dojo.fromJson(data);
						if (data.url && data.eventTypesGadgetSpecificationUrl) {
							dataObj.eventSourceUrl = data.url;
							dataObj.eventTypesGadgetSpecificationUrl = data.eventTypesGadgetSpecificationUrl;
							dataObj.selectedRootServices = this._selectedRootservices;
							this.onEventSrcSelect(dataObj);
						}
					});
					// Embed the EventSources gadget using OpenSocial Gadgets API
					this._eventSourcesGadget = new jazz.opensocial.Gadget({
						url: eventSourcesGadgetSpecificationUrl
					});
					this._eventSourcesGadgetContainerDiv.appendChild(this._eventSourcesGadget.domNode);
					gadgets.rpc.register(ProcessConstants.RPCSERVICE_EVENTSOURCE_SELECTION_CHANGED, dataCallback);
				});
				var errback = dojo.hitch(this, function(error){
					this.header.showMessage({
						type: MessageBox.ERROR,
						summary: error.message,
						errorObject: error
					});
				});
				CrossAppEventClient.getEventSourcesGadgetSpecUrl(this._selectedRootservices, callback, errback);
			}
		},
		
		onEventSrcSelect: function(dataObj){
			this._disableNext = false;
			this.wizard.updateNavigationControls();
		},
		
		_onEventSrcDeSelect: function(){
			this._disableNext = true;
			this.header.hideMessage();
			this.wizard.updateNavigationControls();
		},
		
		canFlipToNextPage: function(){
			if (this._disableNext) {
				return false;
			} else {
				return true;
			}
		},
		
		uninitialize: function(){
			delete this.messages;
			delete this._selectedRootservices;
			delete this._reload;
			if (this._eventSourcesGadget) {
				this._eventSourcesGadget.destroyRecursive();
				delete this._eventSourcesGadget;
			}
			this.inherited(arguments);
		}
		
	});
})();
