/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){

	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.ProviderWizardStep"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$	
	dojo.require("dijit.form.ComboBox"); //$NON-NLS-1$	
	dojo.require("jazz.ui.wizard.WizardStep"); //$NON-NLS-1$
	dojo.require("jazz.ui.wizard.WizardStepHeader"); //$NON-NLS-1$	
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient"); //$NON-NLS-1$ 
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.wizard", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var CrossAppEventClient = com.ibm.team.process.web.ui.internal.admin.process_events.CrossAppEventClient;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_events.wizard.ProviderWizardStep", [jazz.ui.wizard.WizardStep, dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_events/wizard/templates/ProviderWizardStep.html"), //$NON-NLS-1$, //$NON-NLS-2$
		rootservices: null,
		_selectedFriend: null,
		_disableNext: true,
		
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_events.wizard", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.stepTitle = this.messages.ProviderWizardStep_1;
		},
		
		postCreate: function(){
			this.header = new jazz.ui.wizard.WizardStepHeader({
				stepTitle: "" //$NON-NLS-1$
			});
			this._stepHeaderArea.appendChild(this.header.domNode);
			var callback = dojo.hitch(this, function(friends){
				this._populateFriends(friends);
			});
			var errback = dojo.hitch(this, function(error){
			});
			// To get the registered applications.
			CrossAppEventClient.getRegisteredApplications(this.rootservices, callback, errback);
			this.connect(this._friendSelector, "onchange", "onOptionSelect"); //$NON-NLS-1$ //$NON-NLS-2$
			this.inherited(arguments);
		},
		
		_populateFriends: function(friends){
			if (!friends || friends.length == 0) {
				var message = this.messages.ProviderWizardStep_3;
				this.header.showMessage({
					summary: message
				});
				dojo.addClass(this._wizardStepHeaderLabel.wizardHRline, "hideLabel"); //$NON-NLS-1$
				return;
			}
			dojo.forEach(friends, function(friend){
				var option = new Option(friend.title, friend.rootservices);
				this._friendSelector.options[this._friendSelector.options.length] = option;				
			}, this);			
		},
		
		onOptionSelect: function(){
			var rootservices = this._friendSelector.options[this._friendSelector.selectedIndex].value;
			var title = this._friendSelector.options[this._friendSelector.selectedIndex].text;
			this._selectedFriend = {title:title,rootservices:rootservices};
			this._disableNext = false;
			this.wizard.updateNavigationControls();
		},
		
		canFlipToNextPage: function(){
			if (this._disableNext) {
				return false;
			} else {
				return true;
			}
		},
		
		
		onNext: function(){
			if (this._selectedFriend) {
				this.onProviderSelect(this._selectedFriend);
				this.header.hideMessage();
				this.wizard.processNext();
			} else {
				this.header.showMessage({
					summary: this.messages.ProviderWizardStep_2
				});
			}
		},
		
		onProviderSelect: function(friend){
		
		},
		
		uninitialize: function(){
			this.header.destroyRecursive();
			delete this.header;
			dojox.xml.parser.removeChildren(this._stepHeaderArea);
			delete this._selectedFriend;
			delete this.rootservices;
			delete this._friendsSelect;
			this.inherited(arguments);
		}
		
	});
})();
