/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_templates.ImportTemplateDialog"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dojox.xml.parser"); //$NON-NLS-1$
dojo.require("dojo.io.iframe"); //$NON-NLS-1$
dojo.require("dijit.ProgressBar"); //$NON-NLS-1$
dojo.require("dijit.form.CheckBox"); //$NON-NLS-1$
dojo.require("dojox.uuid"); //$NON-NLS-1$
dojo.require("dojox.uuid.generateTimeBasedUuid"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog");//$NON-NLS-1$
dojo.require("jazz.ui.StyledTable");//$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.client.internal.userRegistry");//$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");//$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$//$NON-NLS-2$
(function(){

	var KEY_ESCAPE = 27;
	var KEY_RETURN = 13;
	var KEY_ENTER = 14;
	var KEY_SPACE = 32;
	
	var ImportTemplateDialogMessages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
	var DEFAULT_INTRO_TEXT = ImportTemplateDialogMessages.ImportTemplateDialog_1;
	var UserRegistryClient = com.ibm.team.repository.web.client.internal.userRegistry;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
	var SERVICE_URL = TeamServerClient._getServicePrefix() + "com.ibm.team.process.internal.service.web.IProcessDefinitionFileService/";//$NON-NLS-1$
	var UPLOAD_PROGRESS_SERVICE_URL = dojo.baseUrl + "../../service/com.ibm.team.process.internal.service.web.IProcessDefinitionFileService/checkUploadProgress";//$NON-NLS-1$
	var _uploadFileInput_onchange_handle;
	var _uploadFileInput;
	var _okButton_onclick_handle;
	var _newId_onchange_handle;
	var _newName_onchange_handle;
	var _jsonResponse;
	var _currentRequest;
	var _WIDTH_IN_EM = 70;
	var processImportKey;
	var _configDataTable;
	var StyledTable = jazz.ui.StyledTable;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_templates.ImportTemplateDialog", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_templates/templates/ImportTemplateDialog.html"),//$NON-NLS-1$ //$NON-NLS-2$ 
		widgetsInTemplate: true,
		constructor: function(args){
			this._owningApplicationKey = args.owningApplicationKey;
			this.width = _WIDTH_IN_EM + "em"; //$NON-NLS-1$
			this.uploadId = null;
			this.intervalId = null;
			var properties = {
				"width": this.width //$NON-NLS-1$
			};
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function(){
			this.dialog = new jazz.ui.Dialog({
				contentNode: this.contentNode,
				primaryTitle: this.messages.ImportTemplateDialog_2,
				width: this.width,
				destroyContents: true
			});
			this._topText.innerHTML = DEFAULT_INTRO_TEXT;
			
			var div = this._uploadInputDiv;
			dojox.xml.parser.removeChildren(div);
			var input1 = document.createElement("input"); //$NON-NLS-1$
			input1.type = "file"; //$NON-NLS-1$
			input1.name = "uploadFileInput";//$NON-NLS-1$
			input1.size = _WIDTH_IN_EM - 5; //size is the width of the input in characters
			this._uploadFileInput = input1;
			this._uploadFileInput_onchange_handle = dojo.connect(this._uploadFileInput, "onchange", this, "_handleDirectoryChange"); //$NON-NLS-1$ //$NON-NLS-2$
			if (!dojo.isIE) {
				// setting focus here causes IE to not show the field, so don't 
				//do it 
				this._uploadFileInput.focus();
			}
			div.appendChild(input1);
			
			this.connect(this.cancelButton, "onclick", function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				if (this.intervalId) {
					clearInterval(this.intervalId);
				}
				if (_currentRequest) {
					_currentRequest.cancel();
				}
				if (window.stop) {
					window.stop();
				}
				this.dialog.close();
			});
			this._okButton_onclick_handle = this.connect(this.okButton, "onclick", "_onOk"); //$NON-NLS-1$ //$NON-NLS-2$ 
		},
		/**
		 * enable the OK button if the file is a zip
		 * @param e is an event
		 */
		_handleDirectoryChange: function(e){
			if (e) {
				dojo.stopEvent(e);
			}
			
			this._clearStatusMessage();
			var fullPath = this._uploadFileInput.value;
			if (fullPath.length !== 0) {
				var parts = fullPath.split("\\"); //$NON-NLS-1$
				var fileName = parts[parts.length - 1];
				var extensionIndex = fileName.toLocaleLowerCase().lastIndexOf(".zip"); //$NON-NLS-1$
				if (!(extensionIndex == fileName.length - 4)) {
					this._setStatusMessage(this.messages.ImportTemplateDialog_3, true);
					return;
				} else {
					this.okButton.disabled = false;
				}
			}
		},
		_runSelect: function(e){
			dojo.stopEvent(e);
			
		},
		_runDeselect: function(e){
			dojo.stopEvent(e);
			
		},
		_onOk: function(e){
			if (e) {
				dojo.stopEvent(e);
			}
			this._setStatusMessage(this.messages.ImportTemplateDialog_4);
			this._showProgressBar(false);
			
			// create unique id for this upload
			this.uploadId = dojox.uuid.generateTimeBasedUuid();
			var queryArgs = {
				uploadId: this.uploadId,
				owningApplicationKey: this._owningApplicationKey
			};
			_currentRequest = dojo.io.iframe.send({
				form: this._uploadForm,
				content: {
					"X-Jazz-CSRF-Prevent": dojo.cookie("JSESSIONID") //$NON-NLS-1$ //$NON-NLS-2$
				},
				handleAs: "json",//$NON-NLS-1$
				url: SERVICE_URL + "?" + dojo.objectToQuery(queryArgs), //$NON-NLS-1$
				load: dojo.hitch(this, function(response, ioArgs){
					this._handleLoad(response, ioArgs);
				}),
				error: dojo.hitch(this, function(response, ioArgs){
					this._handleErrorOnUpload(response, ioArgs);
				})
			});
			
			this.okButton.disabled = true;
			this._uploadFileInput.disabled = true;
			
			this.intervalId = setInterval(dojo.hitch(this, "_pollUploadProgress"), 1000); //$NON-NLS-1$
		},
		_pollUploadProgress: function(){
			dojo.xhrGet({
				url: UPLOAD_PROGRESS_SERVICE_URL,
				handleAs: "json", //$NON-NLS-1$
				content: {
					uploadId: this.uploadId
				},
				preventCache: true,
				load: dojo.hitch(this, function(response, ioArgs){
					this._progress.update({
						maximum: response.size,
						progress: response.uploadedBytes
					});
					if (response.size == response.uploadedBytes) {
						clearInterval(this.intervalId);
					}
					return response;
				}),
				error: function(response, ioArgs){
					return response;
				}
			});
		},
		_handleLoad: function(response, ioArgs){
			clearInterval(this.intervalId);
			this._jsonResponse = response;
			switch (this._jsonResponse.status) {
				case 200:
					//success case - template overwritten
					this.onSuccess(this._jsonResponse.processId, false);
					break;
				case 201:
					//success case - template created
					this.onSuccess(this._jsonResponse.processId, true);
					break;
				case 300:
					//need user to choose configuration data
					//prompt the user to select configuration data
					this._handleNeedUserSelectConfigData();
					break;
				case 409:
					//409 indicates the id already exists.  prompt the user to
					//overwrite or enter a new id.
					this._handleDuplicateId();
					break;
				case 410:
					//zip file not on server
					this._handleFileGone();
					break;
				default:
					//any other error
					this._setStatusMessage(this._jsonResponse.message, true);
					this._progress.domNode.style.display = "none"; //$NON-NLS-1$
					this._uploadFileInput.disabled = false;
					//enable the OK button so they can fix the problem and try again
					this.okButton.disabled = false;
					break;
			}
		},
		onSuccess: function(processId, isNew){
			this.dialog.close();
		},
		_handleDuplicateId: function(){
			this._hideFileUploadSection();
			
			var iconPath = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/warning.gif"); //$NON-NLS-1$ //$NON-NLS-2$ 
			var imgHtml = "<img src=\"" + iconPath + "\"\/>"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //the last NLS should not be needed, but extra quotes throw off the builder.
			var dupHeader = this.messages.ImportTemplateDialog_11;
			var brHtml = "<br />"; //$NON-NLS-1$
			var dupMessage = dojo.string.substitute(this.messages.ImportTemplateDialog_6, [this._jsonResponse.processId]);
			this._topText.innerHTML = imgHtml + dupHeader + brHtml + dupMessage;
			
			this._showProcessIdPrompt();
			if (!this._idUpdate1.checked && !this._idUpdate2.checked) {
				this._idUpdate2.setChecked(true);
			}
			this._newId.value = this._jsonResponse.processId;
			this._newId.disabled = !this._idUpdate2.checked;
			this._newName.value = this._jsonResponse.name;
			this._newName.disabled = !this._idUpdate2.checked;
			
			this.okButton.disabled = true;
			
			this.disconnect(this._okButton_onclick_handle);
			this._okButton_onclick_handle = this.connect(this.okButton, "onclick", "_onOkDuplicateId"); //$NON-NLS-1$ //$NON-NLS-2$
			//connect to onClick (not onclick) because this is a dijit.
			this.connect(this._idUpdate1, "onClick", "_handleChooseOverwrite");//$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this._idUpdate2, "onClick", "_handleChooseChangeId"); //$NON-NLS-1$ //$NON-NLS-2$
			this._newId_onchange_handle = dojo.connect(this._newId, "onkeyup", this, "_handleIdOrNameChange");//$NON-NLS-1$ //$NON-NLS-2$
			this._newName_onchange_handle = dojo.connect(this._newName, "onkeyup", this, "_handleIdOrNameChange");//$NON-NLS-1$ //$NON-NLS-2$
		},
		_handleFileGone: function(){
			//show upload file
			this._topText.innerHTML = DEFAULT_INTRO_TEXT;
			this._hideProcessIdPrompt();
			this._showFileUploadSection();
			this._setStatusMessage(this._jsonResponse.message, true);
			this._progress.domNode.style.display = "none"; //$NON-NLS-1$
			this._uploadFileInput.disabled = false;
			this.okButton.disabled = false;
			this.disconnect(this._okButton_onclick_handle);
			this._okButton_onclick_handle = this.connect(this.okButton, "onclick", "_onOk");//$NON-NLS-1$ //$NON-NLS-2$
		},
		/* 
		 * enable the OK button if the user chooses to overwrite
		 */
		_handleChooseOverwrite: function(e){
			this.okButton.disabled = false;
			this._newId.disabled = true;
			this._newName.disabled = true;
		},
		/* 
		 * enable the OK button if the user chooses a new ID
		 */
		_handleChooseChangeId: function(e){
			this.okButton.disabled = (this._newId.value === this._jsonResponse.processId);
			this._newId.disabled = false;
			this._newName.disabled = false;
		},
		/*
		 * Post the id and overwrite value to the service to save the template
		 * when the user clicks OK after getting a duplicate ID error.
		 */
		_onOkDuplicateId: function(e){
			this._showProgressBar(true);
			
			var newId = this._newId.value;
			if (newId) {
				newId = dojo.trim(newId);
			}
			var newName = this._newName.value;
			this.processImportKey = this._jsonResponse.key ? this._jsonResponse.key : this.processImportKey;
			var overwrite = this._idUpdate1.checked;
			var queryArgs = {
				uploadKey: this.processImportKey,
				owningApplicationKey: this._owningApplicationKey
			};
			var theStatusMessage;
			if (overwrite) {
				queryArgs.overwrite = overwrite;
				theStatusMessage = this.messages.ImportTemplateDialog_7;
			} else {
				queryArgs.processId = newId;
				queryArgs.name = newName;
				theStatusMessage = this.messages.ImportTemplateDialog_8;
			}
			this._setStatusMessage(theStatusMessage, false);
			
			var self = this;
			//use iframe transport here so that both calls (initial and this one
			//can use the same response handling)
			dojo.io.iframe.send({
				form: this._overwriteOrChangeIdForm,
				content: {
					"X-Jazz-CSRF-Prevent": dojo.cookie("JSESSIONID") //$NON-NLS-1$ //$NON-NLS-2$
				},
				handleAs: "json",//$NON-NLS-1$
				url: SERVICE_URL + "?" + dojo.objectToQuery(queryArgs), //$NON-NLS-1$
				handle: function(response, ioArgs){
					self._handleLoad(response, ioArgs);
				},
				error: function(response, ioArgs){
					self._handleErrorOnUpload(response, ioArgs);
				}
			});
		},
		
		_handleErrorOnUpload: function(response, ioArgs){
			if (!response.dojoType === "cancel") { //$NON-NLS-1$
				clearInterval(this.intervalId);
				this._setStatusMessage(response, true);
			}
		},
		
		_hideFileUploadSection: function(){
			this._clearStatusMessage();
			this._uploadForm.style.display = "none"; //$NON-NLS-1$
			this._progress.domNode.style.display = "none"; //$NON-NLS-1$
		},
		
		_showFileUploadSection: function(){
			this._uploadForm.style.display = "block";//$NON-NLS-1$
		},
		
		_hideProcessIdPrompt: function(){
			this._idPrompt.style.display = "none";//$NON-NLS-1$
		},
		
		_showProcessIdPrompt: function(){
			this._idPrompt.style.display = "block";//$NON-NLS-1$
		},
		
		_handleIdOrNameChange: function(e){
			
			var newIdValue = this._newId ? dojo.string.trim(this._newId.value) : ""; //$NON-NLS-1$ 
			var newNameValue = this._newName ? dojo.string.trim(this._newName.value) : "";//$NON-NLS-1$ 
			
			if (newIdValue && newIdValue !== this._jsonResponse.processId && newNameValue) {
				this.okButton.disabled = false;
			} else {
				this.okButton.disabled = true;
			}
		},
		
		_queryError: function(err){
			this._setStatusMessage(err.message, true);
		},
		
		_clearStatusMessage: function(){
			this.status.style.visibility = "hidden";//$NON-NLS-1$
		},
		
		_setStatusMessage: function(msg, isError){
			this.status.style.visibility = "visible";//$NON-NLS-1$
			dojox.xml.parser.replaceChildren(this.status, document.createTextNode(msg));
			this.status.className = isError ? "ErrorStatus" : "NormalStatus";//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		_showProgressBar: function(indeterminate){
			this._progress.update({
				indeterminate: indeterminate
			});
			this._progress.domNode.style.display = "block";//$NON-NLS-1$
		},
		
		_handleNeedUserSelectConfigData: function(){
			this._hideFileUploadSection();
			this._hideDuplicatedIdSection();
			
			this._topText.innerHTML = this.messages.ImportTemplateDialog_12;
			
			this._showConfigDataSelectionTable();
			
			this.disconnect(this._okButton_onclick_handle);
			this._okButton_onclick_handle = this.connect(this.okButton, "onclick", "_onOkConfigDataSelection"); //$NON-NLS-1$ //$NON-NLS-2$
			this.okButton.disabled = false;
			
		},
		
		_hideDuplicatedIdSection: function(){
			this._clearStatusMessage();
			this._overwriteOrChangeIdForm.style.display = "none"; //$NON-NLS-1$
			this._progress.domNode.style.display = "none"; //$NON-NLS-1$
		},
		
		_showConfigDataSelectionTable: function(){
			this._createTable(this._jsonResponse.data);
		},

		
		_createRowFromArray: function(data, isValid){
			var tr = document.createElement("tr");//$NON-NLS-1$
			for (var i = 0; i < data.length; i++) {
				var td = document.createElement("td");//$NON-NLS-1$
				if (!isValid) {
					td.className = "invalidConfigDataRow";//$NON-NLS-1$
				}
				td.appendChild(data[i]);
				tr.appendChild(td);
			}
			return tr;
		},
		
		_createRow: function(config){
			var dataType = config._name;
			var dataTypeId = config._id;
			var dataUrl = config._instanceUrl;
			var isValid = config._isValid;
			var data = [];
			
			// Selection
			var selectionCheckbox = document.createElement("input"); //$NON-NLS-1$
			data.push(selectionCheckbox);
			selectionCheckbox.type = "checkbox"; //$NON-NLS-1$
			selectionCheckbox.checked = isValid;
			selectionCheckbox.disabled = !isValid;
			selectionCheckbox.setAttribute("dataTypeId", dataTypeId); //$NON-NLS-1$
			
			// Configuration Data Type            
			var label = document.createElement("label"); //$NON-NLS-1$
			data.push(label);
			label.innerHTML = dataType;
			
			// Configuration Data Url            
			label = document.createElement("label"); //$NON-NLS-1$
			data.push(label);
			label.innerHTML = dataUrl;
			
			// Importable            
			label = document.createElement("label"); //$NON-NLS-1$
			data.push(label);
			label.innerHTML = isValid;
			
			return this._createRowFromArray(data, isValid);
		},
		
		_createTable: function(jsonData){
			this._configDataTable = new StyledTable({
				columns: [{
					label: "",//$NON-NLS-1$
					width: "2%", //$NON-NLS-1$
					sortable: false
				}, {
					label: this.messages.ImportTemplateDialog_14,
					width: "25%", //$NON-NLS-1$
					sortable: false
				}, {
					label: this.messages.ImportTemplateDialog_15,
					width: "63%", //$NON-NLS-1$
					sortable: false
				}, {
					label: this.messages.ImportTemplateDialog_16,
					width: "10%", //$NON-NLS-1$
					sortable: false
				}],
				sortBy: 1,
				sortByAscending: false,
				topBorder: true,
				trim: jazz.ui.styledTable.TrimStyles.GOLD
			});
			
			this._configDataDiv.appendChild(this._configDataTable.domNode);
			dojo.toggleClass(this._configDataTable.domNode, "configDataTable", true);//$NON-NLS-1$

			var self = this;
			dojo.forEach(jsonData, function(item){
				var row = self._createRow(item);
				self._configDataTable.tbody.appendChild(row);
			});
			
			if (dojo.isIE) {
				this._initializeSelection();
			}
			
		},
		
		_initializeSelection: function() {
			var inputs = this._configDataTable.tbody.getElementsByTagName("input"); //$NON-NLS-1$
			for (var i = 0; i < inputs.length; i++) {
				inputs[i].checked = !inputs[i].disabled;
			}
		},
			
		_onOkConfigDataSelection: function(){
			this.okButton.disabled = true;
			this._showProgressBar(true);
			
			var queryArgs = {
				uploadKey: this._jsonResponse.key,
				owningApplicationKey: this._owningApplicationKey
			};
			var theStatusMessage = this.messages.ImportTemplateDialog_8;
			var overwrite = this._jsonResponse.overwrite;
			if (overwrite) {
				queryArgs.overwrite = overwrite;
			} else {
				var processId = this._jsonResponse.processId;
				if (processId) {
					queryArgs.processId = processId;
				}
				var name = this._jsonResponse.name;
				if (name) {
					queryArgs.name = name;
				}
			}

			var excludedList = ""; //$NON-NLS-1$
			var inputs = this._configDataTable.tbody.getElementsByTagName("input"); //$NON-NLS-1$
			for (var i = 0; i < inputs.length; i++) {
				var checked = inputs[i].checked;
				if (!checked) {
					excludedList = excludedList + inputs[i].getAttribute("dataTypeId") + ";"; //$NON-NLS-1$ //$NON-NLS-2$	
				}
			}
			queryArgs.excluded = excludedList;
			
			this._setStatusMessage(theStatusMessage, false);
			
			var self = this;
			dojo.io.iframe.send({
				form: this._overwriteOrChangeIdForm,
				content: {
					"X-Jazz-CSRF-Prevent": dojo.cookie("JSESSIONID") //$NON-NLS-1$ //$NON-NLS-2$
				},
				handleAs: "json",//$NON-NLS-1$
				url: SERVICE_URL + "?" + dojo.objectToQuery(queryArgs), //$NON-NLS-1$
				handle: function(response, ioArgs){
					self._handleLoad(response, ioArgs);
				},
				error: function(response, ioArgs){
					self._handleErrorOnUpload(response, ioArgs);
				}
			});
		},
		
		uninitialize: function(){
			if (this._uploadFileInput_onchange_handle) {
				dojo.disconnect(this._uploadFileInput_onchange_handle);
			}
			if (this._newId_onchange_handle) {
				dojo.disconnect(this._newId_onchange_handle);
			}
			if (this._newName_onchange_handle) {
				dojo.disconnect(this._newName_onchange_handle);
			}
			this.inherited(arguments);
		}
	});
	
})();
