/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_templates.ManageTemplates");//$NON-NLS-1$
	dojo.require("dojo.i18n");//$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dijit.form.SimpleTextarea"); //$NON-NLS-1$
	dojo.require("dijit.form.TextBox");//$NON-NLS-1$
	dojo.require("dijit.form.Button");//$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI");//$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.projectarea");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_templates.ImportTemplateDialog");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_templates.ExportTemplateDialog");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.StyledTableItemList"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.TRToolbar"); //$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("jazz.ui.PaginationControl"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$//$NON-NLS-2$
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var ImportTemplateDialog = com.ibm.team.process.web.ui.internal.admin.process_templates.ImportTemplateDialog;
	var ExportTemplateDialog = com.ibm.team.process.web.ui.internal.admin.process_templates.ExportTemplateDialog;
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var UIHelper = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var MessageBox = jazz.ui.MessageBox;
	var STATUS_TYPES = MessageBox.STATUS_TYPES;
	var TEMPLATES_PER_PAGE = 20;
	var currentTotalTemplates;
	var currentUpperBound;
	//constants for ids of elements and dijits
	var NAME = "name";//$NON-NLS-1$
	var PROCESS_ID = "processId";//$NON-NLS-1$
	var SUMMARY = "summary";//$NON-NLS-1$
	var TYPES = [NAME, PROCESS_ID, SUMMARY];
	var NAME_EDIT = "nameEdit";//$NON-NLS-1$
	var PROCESS_ID_EDIT = "processIdEdit";//$NON-NLS-1$
	var SUMMARY_EDIT = "summaryEdit";//$NON-NLS-1$
	var CANCEL_BUTTON = "cancel"; //$NON-NLS-1$
	var SAVE_BUTTON = "save"; //$NON-NLS-1$
	var CHANGES_PENDING = "changesPending"; //$NON-NLS-1$
	var SAVE_IN_PROGRESS = -1;
	
	var SERVICE_URI = dojo.baseUrl + "../../service/com.ibm.team.process.internal.service.web.IProcessDefinitionFileService/";//$NON-NLS-1$
	function setText(e, text){
		e.appendChild(document.createTextNode(text));
	}
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_templates.ManageTemplates", com.ibm.team.process.web.ui.internal.StyledTableItemList, { //$NON-NLS-1$
		constructor: function(args){
			this.actionToolbars = [];
			this._saveButtons = {};
			this.templateBeingEdited = null;
			this.navigationClickHandler = null;
			this._owningApplicationKey = args.owningApplicationKey;
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function(){
			this.header = new MessageBox();
			this.messageArea.appendChild(this.header.domNode);
			setText(this.heading, this.messages.ManageTemplates_1);
			setText(this.description, this.messages.ManageTemplates_2);
			dojo.addClass(this.tableContents, ProcessConstants.CSSClass.TOOLBAR_TABLE);
			dojo.addClass(this.tableContents, "templateTable", true); //$NON-NLS-1$
			var columns = [];
			columns.push({
				label: this.messages.ManageTemplates_3,
				width: "25%", //$NON-NLS-1$
				sortable: false
			});
            columns.push({
            	label: this.messages.ManageTemplates_8,
 				width: "25%", //$NON-NLS-1$
           		sortable: false
            });
            columns.push({
            	label: this.messages.ManageTemplates_4,
           		sortable: false
            });
	       	columns.push({
            	label: this.messages.ManageTemplates_26,
																   // Work around for 127064 
           		className: ProcessConstants.CSSClass.ACTION_COLUMN + " action-column-larger", //$NON-NLS-1$
            	sortable: false
            });
			this.createTable({
				columns: columns
			});
            this.importButton = this.addLink("#", this.messages.ManageTemplates_5, "com.ibm.team.process.web/ui/internal/admin/process_templates/images/import-template_co.gif", dojo.hitch(this, function(e){ //$NON-NLS-1$ //$NON-NLS-2$
            	var dialog = new ImportTemplateDialog({
            		owningApplicationKey: this._owningApplicationKey
            	});
            	this.connect(dialog, "onSuccess", "handleImportTemplateSuccess");//$NON-NLS-1$ //$NON-NLS-2$ 
            }));
            this.deployButton = this.addLink("#", this.messages.ManageTemplates_15, "com.ibm.team.process.web/ui/internal/admin/process_templates/images/deploy-process-template_co.gif", dojo.hitch(this, this.performDeployTemplates)); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		show: function(args){
			this.refresh(args);
		},
		refresh: function(args){
			this.deployButton.setDisabled(true);
			this.importButton.setDisabled(true);
			this.clearState();
			var tr = document.createElement("tr"); //$NON-NLS-1$
			var td = document.createElement("td"); //$NON-NLS-1$
			td.colSpan = 2;
			td.appendChild(document.createTextNode(this.messages.ManageTemplates_6));
			tr.appendChild(td);
			this.tbody.appendChild(tr);
			if (!args || !args.pageNum) {
				this.queryPageNumber = 0;
			} else {
				var intPageNum = parseInt(args.pageNum, 10);
				this.queryPageNumber = intPageNum;
			}
			var queryArgs = {
				pageNum: this.queryPageNumber,
				pageSize: TEMPLATES_PER_PAGE,
				owningApplicationKey: this._owningApplicationKey
			};
			var errorHandler = "handleShowTemplatesError";//$NON-NLS-1$  
			if (args && args.error) {
				errorHandler = args.error;
			}
			var srh = new ServiceResponseHandler(this, "showTemplates", errorHandler); //$NON-NLS-1$  
			ProcessClient.getProcessDefinitions(queryArgs, srh);
		},
		reload: function(args){
			if (!this._confirmLoseEdits()) {
				return;
			}
			this._destroyEditDijits(this._templateBeingEdited);
			this._templateBeingEdited = null;
			this.refresh(args);
		},
		
		clearState: function(){
			dojox.xml.parser.removeChildren(this.tbody);
			this.header.hideMessage();
			this._destroyActionToolbars();
		},
		
		showTemplates: function(data){
			dojox.xml.parser.removeChildren(this.tbody);
			dojox.xml.parser.removeChildren(this.tableControls);
			this._destroyPager();			
			
			//assume we are going to enable the deploy button
			var isDeployButtonDisabled = false;
			var self = this;
			
			if (data && data.count > 0) {
				this._pager = this._createPager(data);
				this.tableControls.appendChild(this._pager.domNode);
				
				var sortedTemplates = data.elements.sort(function(a, b){
					var translatedNameA = self.getTranslatedProcessDefinitionName(a);
					var translatedNameB = self.getTranslatedProcessDefinitionName(b);
					return translatedNameA.toLowerCase().localeCompare(translatedNameB.toLowerCase());
				});
				for (var i = 0; i < sortedTemplates.length; i++) {
					var row = this.createRowForTemplate(sortedTemplates[i]);
				}
			} else {
				var message;
				if (this.isDeployed === true) {
					message = this.messages.ManageTemplates_35;
					//don't enable the deploy button if there are no templates
					isDeployButtonDisabled = true;
				} else {
					message = this.messages.ManageTemplates_9;
				}
				
				this.header.showMessage({
					type: STATUS_TYPES.INFO,
					summary: message
				});
			}
			this.deployButton.setDisabled(isDeployButtonDisabled);
			this.importButton.setDisabled(false);
		},

		createRowForTemplate: function(datum){
			var nameNode = document.createElement("div");//$NON-NLS-1$
			var itemId = datum.itemId;
			dojo.attr(nameNode, "id", datum.itemId + NAME);//$NON-NLS-1$
			dojo.attr(nameNode, NAME, datum.name);
			var nameText = this.getTranslatedProcessDefinitionName(datum);
			var nameTextNode = document.createTextNode(nameText);
			nameNode.appendChild(nameTextNode);
			
			var idNode = document.createElement("div");//$NON-NLS-1$
			dojo.attr(idNode, "id", datum.itemId + PROCESS_ID);//$NON-NLS-1$
			dojo.attr(idNode, PROCESS_ID, datum.processId);
			var idTextNode = document.createTextNode(datum.processId);
			idNode.appendChild(idTextNode);
			
			var descNode = document.createElement("div"); //$NON-NLS-1$
			dojo.attr(descNode, "id", datum.itemId + SUMMARY);//$NON-NLS-1$
			dojo.attr(descNode, SUMMARY, datum.summary);
			//IE does not show top of cell if it has no text, so set the text to
			//a space if the summary is empty.
			var translatedSummary = this.getTranslatedProcessDefinitionSummary(datum);
			var summaryText = translatedSummary ? translatedSummary : " "; //$NON-NLS-1$
			var summaryTextNode = document.createTextNode(summaryText);
			
			descNode.appendChild(summaryTextNode);
			
			//create the row and add the process and state id's so we can save
			//edits
			var trToolbar = new com.ibm.team.process.web.ui.internal.TRToolbar();
			this.actionToolbars.push(trToolbar);
			var exportAction = {};
			exportAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/export.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			exportAction.label = dojo.string.substitute(this.messages.ManageTemplates_7, [nameText]);
			exportAction.callbackData = {
				actionHref: SERVICE_URI, 
				actionItemId: datum.itemId
			};
			var callback = function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				if (!this._isEditInProgress()) {
					var dialog = new ExportTemplateDialog({
						serviceUrl: e.currentTarget.callbackData.actionHref + this._normalizeString(this._getProcessId(datum.itemId)) + ".zip", //$NON-NLS-1$
						itemId: e.currentTarget.callbackData.actionItemId,
						applicationKey: this._owningApplicationKey
					});
				}
			};
			trToolbar.addButton(this, callback, exportAction);
			
			var deleteAction = {};
			deleteAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/delete_hov.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			deleteAction.label = dojo.string.substitute(this.messages.ManageTemplates_17, [nameText]);
			deleteAction.callbackData = {
				projectItemId: datum.itemId
			};
			callback = function(e){
				dojo.stopEvent(e);
				if (!this._isEditInProgress()) {
					this.handleDeleteTemplate(e.currentTarget.callbackData.projectItemId);
				}
			};
			trToolbar.addButton(this, callback, deleteAction);
			
			var editAction = {};
			editAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/edit.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			editAction.label = dojo.string.substitute(this.messages.ManageTemplates_36, [nameText]);
			editAction.callbackData = {
				projectItemId: datum.itemId
			};
			callback = function(e){
				dojo.stopEvent(e);
				if (!this._isEditInProgress()) {
					this._showTemplateEditor(e.currentTarget.callbackData.projectItemId);
				}
			};
			trToolbar.addButton(this, callback, editAction);
			
			var row = this.addRow(null, [nameNode, idNode, descNode, trToolbar.domNode]);
			dojo.attr(row, "processItemId", datum.itemId);//$NON-NLS-1$
			dojo.attr(row, "stateId", datum.stateId);//$NON-NLS-1$
			return row;
		},
		_isEditInProgress: function(){
			return this.templateBeingEdited && this.templateBeingEdited !== SAVE_IN_PROGRESS;
		},
		
		/*
		 * Show a new row that has editable controls.
		 */
		_showTemplateEditor: function(processItemId){
			this._disableToolbars(true);
			this._pager.disable(true);
			this.importButton.setDisabled(true);
			this.deployButton.setDisabled(true);
			
			//set the global flag to prevent editing others
			this.templateBeingEdited = processItemId;
			
			//hide the old row
			var row = this._getRowForItemId(processItemId);
			var stateId = dojo.attr(row, "stateId"); //$NON-NLS-1$
			dojo.addClass(row, "hidden");//$NON-NLS-1$
			//register a click handler in case user leaves page
			this.bodyClickHandler = PlatformUI.getWorkbench().registerBodyClickHandler(dojo.hitch(this, this._handleNavigate), /*priority*/ 10000);
			this.onBeforeUnloadHandler = PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(dojo.hitch(this, this._navigateAwayEvent), /*priority*/ 10000);
			
			//create the new row 
			var newRow = row.parentNode.insertRow(row.sectionRowIndex);
			dojo.addClass(newRow, "editing") //$NON-NLS-1$
			dojo.style(newRow, "backgroundColor", "#F2F8FC");//$NON-NLS-1$ //$NON-NLS-2$
			//make name column
			var nameColumn = newRow.insertCell(0);
			
			var nameInputDiv = document.createElement("div");//$NON-NLS-1$
			nameColumn.appendChild(nameInputDiv);
			
			var nameDivNode = dojo.byId(processItemId + NAME);
			dojo.attr(nameDivNode, CHANGES_PENDING, false);
			var name = dojo.attr(nameDivNode, NAME);
			var self = this;
			
			var nameTextBox = new dijit.form.TextBox({
				id: processItemId + NAME_EDIT,
				value: name,
				intermediateChanges: true,
				onChange: function(newText){
					if (newText != name) {
						self._enableSaveButton(processItemId);
						dojo.attr(nameDivNode, CHANGES_PENDING, true);
					} else {
						self._disableSaveButton(processItemId);
						dojo.attr(nameDivNode, CHANGES_PENDING, false);
					}
				}
			}, nameInputDiv);
			nameTextBox.startup();
			
			//make ID column
			var idColumn = newRow.insertCell(1);
			var idInputDiv = document.createElement("div");//$NON-NLS-1$
			idColumn.appendChild(idInputDiv);
			
			var idDivNode = dojo.byId(processItemId + PROCESS_ID);
			dojo.attr(idDivNode, CHANGES_PENDING, false); 
			var id = dojo.attr(idDivNode, PROCESS_ID);
			var idTextBox = new dijit.form.TextBox({
				id: processItemId + PROCESS_ID_EDIT,
				value: id,
				intermediateChanges: true,
				onChange: function(newText){
					if (newText != id) {
						self._enableSaveButton(processItemId);
						dojo.attr(idDivNode, CHANGES_PENDING, true);
					} else {
						self._disableSaveButton(processItemId);
						dojo.attr(idDivNode, CHANGES_PENDING, false);
					}
				}
			}, idInputDiv);
			idTextBox.startup();
			
			//make summary column
			var summaryDivNode = dojo.byId(processItemId + SUMMARY);
			dojo.attr(summaryDivNode, CHANGES_PENDING, false);
			var summary = dojo.attr(summaryDivNode, SUMMARY);
			
			var summaryColumn = newRow.insertCell(2);
			var summaryInputDiv = document.createElement("div");//$NON-NLS-1$
			summaryColumn.appendChild(summaryInputDiv);
			
			var summaryTextarea = new dijit.form.SimpleTextarea({
				id: processItemId + SUMMARY_EDIT,
				value: summary,
				intermediateChanges: true,
				rows: dojo.isFF ? 2 : 3,
				onChange: function(newText){
					if (summary) {
						summary = dojo.string.trim(summary);
					}
					if (newText != summary) {
						self._enableSaveButton(processItemId);
						dojo.attr(summaryDivNode, CHANGES_PENDING, true);
					} else {
						self._disableSaveButton(processItemId);
						dojo.attr(summaryDivNode, CHANGES_PENDING, false);
					}
				}
			}, summaryInputDiv);
			var summaryEditStyleNode = summaryTextarea.styleNode;
			summaryTextarea.startup();
			
			//make buttons in actions column
			var iconColumn = newRow.insertCell(3);
			
			var saveParameters = {
				itemId: processItemId,
				stateId: stateId,
				disabled: true
			};
			var saveButton = document.createElement("button"); //$NON-NLS-1$
			dojo.mixin(saveButton, saveParameters);
			saveButton.appendChild(document.createTextNode(this.messages.ManageTemplates_29));
			this.connect(saveButton, "onclick", this._handleSaveEdit); //$NON-NLS-1$
			iconColumn.appendChild(saveButton);
			this._saveButtons[processItemId] = saveButton;
			
			var cancelParameters = {
				processItemId: processItemId
			};
			var cancelButton = document.createElement("button");//$NON-NLS-1$
			cancelButton.appendChild(document.createTextNode(this.messages.ManageTemplates_28));
			dojo.mixin(cancelButton, cancelParameters);
			iconColumn.appendChild(cancelButton);
			this.connect(cancelButton, "onclick", this._handleCancelEdit); //$NON-NLS-1$
			UIHelper.resizeI18NButtons(cancelButton, [cancelButton, saveButton]);
			
		},
		/**
		 * Dispose of the edit controls and show the regular row for
		 * the template being edited.
		 * @param {Object} event
		 */
		_handleCancelEdit: function(event){
			dojo.stopEvent(event);
			this.templateBeingEdited = null;
			var dij = event.target;
			var itemId = dij.processItemId;
			var hiddenRow = this._getRowForItemId(itemId);
			if (hiddenRow) {
				dojo.removeClass(hiddenRow, "hidden");//$NON-NLS-1$
			}
			this._destroyEditRow(event, itemId);
			this.importButton.setDisabled(false);
			this.deployButton.setDisabled(false);
			this._disableToolbars(false);
			this._pager.disable(false);
		},
		
		_handleSaveEdit: function(event){
			dojo.stopEvent(event);
			
			var dij = event.target;
			
			var itemId = dij.itemId;
			var stateId = dij.stateId;
			var nameDijit = dijit.byId(itemId + NAME_EDIT);
			var newName = nameDijit.attr('value'); //$NON-NLS-1$
			var newProcessId = dijit.byId(itemId + PROCESS_ID_EDIT).attr('value'); //$NON-NLS-1$
			if (newProcessId) {
				newProcessId = dojo.trim(newProcessId);
			}
			var newSummary = dijit.byId(itemId + SUMMARY_EDIT).attr('value'); //$NON-NLS-1$
			if (this._validateSave(newName, newProcessId)) {
				this.performSaveEdit(itemId, stateId, newName, newProcessId, newSummary);
				
				var row = this._getRowForItemId(itemId);
				dojo.removeClass(row, "hidden");//$NON-NLS-1$
				dojo.addClass(row, "updating");//$NON-NLS-1$
				var nameNode = dojo.byId(itemId + NAME);
				var changesPending = dojo.attr(nameNode, CHANGES_PENDING);
				if (changesPending === true) {
					dojo.attr(nameNode, NAME, newName);
					dojox.xml.parser.removeChildren(nameNode);
					var nameTextNode = document.createTextNode(newName);
					nameNode.appendChild(nameTextNode);
				}
				var idNode = dojo.byId(itemId + PROCESS_ID);
				changesPending = dojo.attr(idNode, CHANGES_PENDING);
				if (changesPending === true) {
					dojo.attr(idNode, PROCESS_ID, newProcessId);
					dojox.xml.parser.removeChildren(idNode);
					var idTextNode = document.createTextNode(newProcessId);
					idNode.appendChild(idTextNode);
				}
				var summaryNode = dojo.byId(itemId + SUMMARY);
				changesPending = dojo.attr(summaryNode, CHANGES_PENDING);
				if (changesPending === true) {
					dojo.attr(summaryNode, SUMMARY, newSummary);
					dojox.xml.parser.removeChildren(summaryNode);
					var summaryTextNode = this._createTextNode(newSummary);
					summaryNode.appendChild(summaryTextNode);
				}
				
				this._destroyEditRow(event, itemId);
				this.importButton.setDisabled(false);
				this.deployButton.setDisabled(false);
				this._disableToolbars(false);
				this._pager.disable(false);
			}
		},
		
		_createTextNode: function(text) {
			if (dojo.isIE && text !== undefined && text.length === 0) {
				return document.createTextNode(" "); //$NON-NLS-1$
			}	
			return document.createTextNode(text);		
		},
		
		_validateSave: function(name, processId){
			if (!name || name === "") {//$NON-NLS-1$
				this.header.showMessage({
					type: STATUS_TYPES.ERROR,
					summary: this.messages.ManageTemplates_32
				});
				return false;
			}
			if (!processId || processId === "") {//$NON-NLS-1$
				this.header.showMessage({
					type: STATUS_TYPES.ERROR,
					summary: this.messages.ManageTemplates_33
				});
				return false;
			}
			return true;
		},
		_handleNavigate: function(href){
			var navigateTo = href.fragment;
			if (!navigateTo) {
				navigateTo = href.uri;
			}
			if (navigateTo.indexOf("IProcessDefinitionFileService") === -1 && navigateTo.indexOf("ProcessTemplateManagement") === -1) {//$NON-NLS-1$ //$NON-NLS-2$            
				//if user editing, prompt to save
				if (this._isEditInProgress()) {
					if (confirm(this.messages.ManageTemplates_30)) {
						//user pressed OK to laeave page
						this._unregisterClickHandlers();
						this._destroyEditDijits(this.templateBeingEdited);
						this.templateBeingEdited = null;
						return false;
					} else {
						//veto the navigation
						return true;
					}
				}
			}
			//let the navigation continue (don't veto it) if it is not to another page.
			return false;
		},
		_navigateAwayEvent: function(){
			if (this._isEditInProgress()) {
				return this.messages.ManageTemplates_31;
			}
			
			return false;
		},
		/**
		 * Remove the row from its table and destroy any edit dijits for the
		 * item with given itemId
		 * @param {Object} event
		 * @param {Object} itemId The itemId of the process template that the
		 * row was editing
		 */
		_destroyEditRow: function(event, itemId){
			this._unregisterClickHandlers();
			var editRow = this._getRow(event);
			editRow.parentNode.removeChild(editRow);
			this._destroyEditDijits(itemId);
			
		},
		_unregisterClickHandlers: function(){
			if (this.bodyClickHandler) {
				PlatformUI.getWorkbench().unregisterBodyClickHandler(this.bodyClickHandler);
			}
			if (this.onBeforeUnloadHandler) {
				PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandler);
			}
		},
		_destroyEditDijits: function(itemId){
			var nameDijit = dijit.byId(itemId + NAME_EDIT);
			if (nameDijit) {
				nameDijit.destroyRecursive();
			}
			
			var idDijit = dijit.byId(itemId + PROCESS_ID_EDIT);
			if (idDijit) {
				idDijit.destroyRecursive();
			}
			
			var summaryDijit = dijit.byId(itemId + SUMMARY_EDIT);
			if (summaryDijit) {
				summaryDijit.destroyRecursive();
			}
			
		},
		_enableSaveButton: function(itemId){
			var theButton = this._saveButtons[itemId];
			if (theButton) {
				theButton.disabled = false;
			}
		},
		_disableSaveButton: function(itemId){
			var theButton = this._saveButtons[itemId];
			if (theButton) {
				theButton.disabled = true;
			}
		},
		handleImportTemplateSuccess: function(){
			this.refresh({
				pageNum: this.queryPageNumber
			});
		},
		handleDeleteTemplate: function(processItemId){
			var processName = this._getProcessName(processItemId);
			var msg = dojo.string.substitute(this.messages.ImportTemplateDialog_9,[processName]);
			if (confirm(msg)) {
				this.header.showMessage({
					type: STATUS_TYPES.INFO,
					summary: this.messages.ImportTemplateDialog_10
				});
				var srh = new ServiceResponseHandler(this, "handleDeleteTemplateSuccess", "handleDeleteTemplateError"); //$NON-NLS-1$ //$NON-NLS-2$
				ProcessClient.deleteProcessDefinition({
					uuid: processItemId
				}, srh);
			}
		},
		
		handleDeleteTemplateSuccess: function(processDefinitionDTO){
			this.refresh({
				pageNum: this.queryPageNumber,
				error: "handleRefreshAfterDeleteError" //$NON-NLS-1$
			});
		},
		
		handleRefreshAfterDeleteError: function(error){
			//if the refresh fails because the number of templates in the repository is insufficient to warrant the
			//page, show the previous page of the query instead.
			if (this.queryPageNumber !== 0) {
				this.queryPageNumber--;
			}
			window.location.hash = "#action=" + ProcessConstants.PREFIX + "manageTemplates&pageNum=" + this.queryPageNumber; //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		handleDeleteTemplateError: function(error){
			// Error class and exception call stack add no value to user
			delete error.errorClass;
			delete error.exception;
			
			this.header.showMessage({
				type: STATUS_TYPES.ERROR,
				summary: this.messages.ManageTemplates_16,
				errorObject: error
			});
		},
		performSaveEdit: function(itemId, stateId, newName, newProcessId, newSummary){
			var msg = document.createElement("div");//$NON-NLS-1$
			msg.appendChild(document.createTextNode(dojo.string.substitute(this.messages.ManageTemplates_27, [newProcessId])));
			this.header.showMessage({
				type: STATUS_TYPES.INFO,
				summary: msg
			});
			
			this.templateBeingEdited = SAVE_IN_PROGRESS;
			
			var srh = new ServiceResponseHandler(this, "handleSaveEditSuccess", "handleSaveEditError"); //$NON-NLS-1$ //$NON-NLS-2$
			var args = {
				itemId: itemId,
				stateId: stateId,
				name: newName,
				id: newProcessId,
				summary: newSummary
			};
			ProcessClient.postProcessDefinition(args, srh);
			
		},
		/**
		 * prompts user and cleans up state and dijits if appropriate
		 */
		_confirmLoseEdits: function(){
			if (this._isEditInProgress()) {
				if (!confirm(this.messages.ManageTemplates_34)) {
					//user does not want to continue deploying
					return false;
				} else {
					//reset template edit -- edits will be overwritten when 
					//deploy runs
					this._destroyEditDijits(this.templateBeingEdited);
					this._unregisterClickHandlers();
					this.templateBeingEdited = null;
					return true;
				}
			}
			return true;
		},
		/**
		 * Deploy templates and update the table.
		 */
		performDeployTemplates: function(e){
			dojo.stopEvent(e);
			if (e.target.disabled) {
				return;
			}
			if (!this._confirmLoseEdits()) {
				return false;
			}
			//warn user that current templates may be overwritten
            if (!confirm(this.messages.ManageTemplates_37)) {
            	//user pressed CANCEL
            	return false;
            }
			this.deployButton.setDisabled(true);
			this.importButton.setDisabled(true);
			dojox.xml.parser.removeChildren(this.tbody);
			this.header.showMessage({
				type: STATUS_TYPES.INFO,
				summary: this.messages.ManageTemplates_13
			});
			var srh = new ServiceResponseHandler(this, "handleDeployTemplateSuccess", "handleDeployTemplateError"); //$NON-NLS-1$ //$NON-NLS-2$
			var queryArgs = {
				owningApplicationKey: this._owningApplicationKey
			};
			ProcessClient.deployPredefinedProcessDefinitions(queryArgs, srh);
		},
		handleSaveEditSuccess: function(response){
			this.header.hideMessage();
			this.templateBeingEdited = null;
			this.handleEditedProcess(response);
		},
		handleSaveEditError: function(error){
			this.templateBeingEdited = null;
			this.handleTemplateError(this.messages.ManageTemplates_25, error.message, false, false);
		},
		
		handleDeployTemplateSuccess: function(){
			this.isDeployed = true;
			this.refresh();
		},
		
		handleShowTemplatesError: function(error){
			var title = this.messages.ManageTemplates_18;
			this.handleTemplateError(title, error.message, true, false);
		},
		
		handleDeployTemplateError: function(error){
			var title = this.messages.ManageTemplates_14;
			this.handleTemplateError(title, error.message, true, error.errorClass.indexOf("TeamOperationCanceledException") !== -1);//$NON-NLS-1$
		},
		
		handleTemplateError: function(errorTitle, errorMessage, isBodyRemoved, shouldShowTemplates){
			if (isBodyRemoved) {
				dojox.xml.parser.removeChildren(this.tbody);
			}
			//remove the "Pending.." message
			this.header.hideMessage();
			
			//show the error
			var msg = {
				type: STATUS_TYPES.ERROR,
				summary: errorTitle
			}
			if (errorMessage) {
                msg.details = [{
                	message: errorMessage,
                	code: STATUS_TYPES.ERROR
                }];
			}
			this.header.showMessage(msg);
			this.deployButton.setDisabled(false);
			this.importButton.setDisabled(false);
			if (shouldShowTemplates) {
				this.queryPageNumber = 0;
				var queryArgs = {
					pageNum: this.queryPageNumber,
					pageSize: TEMPLATES_PER_PAGE
				};
				
				var srh = new ServiceResponseHandler(this, "showTemplates", "nullErrorHandler"); //$NON-NLS-1$  //$NON-NLS-2$
				ProcessClient.getProcessDefinitions(queryArgs, srh);
			}
		},
		
		nullErrorHandler: function(){
			//intentionally empty.  Do not overwrite an existing error message
			//with latest failure.
		},
		
		getTranslatedProcessDefinitionName: function(definition){
			var translatedName;
			
            if (djConfig.locale && definition.supportedLocales && definition.supportedLocales.length > 0) {
				// try the client locale next
				var locale = djConfig.locale;
                var localeIndex = dojo.indexOf(definition.supportedLocales, locale);
                if (localeIndex !== -1) {
                	translatedName = definition.translatedNames[localeIndex];
                }
				
                
                if (!translatedName) {
                	// if the locale included more than the language code, look for the generic
                	// language locale first
                	if (locale.length > 2) {
                		var locale = locale.substring(0, 2);
                		if (dojo.indexOf(definition.supportedLocales, locale) !== -1) {
                			translatedName = definition.translatedNames[dojo.indexOf(definition.supportedLocales, locale)];
                		}
                	}
                	
                	// try any supported locales with the same language code
                	for (var i = 0; !translatedName && i < definition.supportedLocales.length; i++) {
                		if (definition.supportedLocales[i].indexOf(locale) === 0) {
                			var supportedLocale = definition.supportedLocales[i];
                			if (dojo.indexOf(definition.supportedLocales, supportedLocale) !== -1) {
                				translatedName = definition.translatedNames[dojo.indexOf(definition.supportedLocales, supportedLocale)];
                			}
                		}
                	}
                }
            }
			
			// next try the default locale for the process definition
			if (!translatedName) {
				translatedName = definition.defaultName;
			}
			
			// finally default to the untranslated value
			if (!translatedName) {
				translatedName = definition.name;
			}
			
			return translatedName;
		},
		
		getTranslatedProcessDefinitionSummary: function(definition){
			var translatedSummary;
			
            if (djConfig.locale && definition.supportedLocales && definition.supportedLocales.length > 0) {
				// try the client locale next
				var locale = djConfig.locale;
                var localeIndex = dojo.indexOf(definition.supportedLocales, locale);
                if (localeIndex !== -1) {
                	translatedSummary = definition.translatedSummaries[localeIndex];
                }
				
                if (!translatedSummary) {
                	// if the locale included more than the language code, look for the generic
                	// language locale first
                	if (locale.length > 2) {
                		var locale = locale.substring(0, 2);
                		if (dojo.indexOf(definition.supportedLocales, locale) !== -1) {
                			translatedSummary = definition.translatedSummaries[dojo.indexOf(definition.supportedLocales, locale)];
                		}
                	}
                	
                	// try any supported locales with the same language code
                	for (var i = 0; !translatedSummary && i < definition.supportedLocales.length; i++) {
                		if (definition.supportedLocales[i].indexOf(locale) === 0) {
                			var supportedLocale = definition.supportedLocales[i];
                			if (dojo.indexOf(definition.supportedLocales, supportedLocale) !== -1) {
                				translatedSummary = definition.translatedSummaries[dojo.indexOf(definition.supportedLocales, supportedLocale)];
                			}
                		}
                	}
                }
            }
			
			// next try the default locale for the process definition
			if (!translatedSummary) {
				translatedSummary = definition.defaultSummary;
			}
			
			// finally default to the untranslated value
			if (!translatedSummary) {
				translatedSummary = definition.summary;
			}
			
			return translatedSummary;
		},
		
		/**
		 * Update the row for the given process template with the new fields
		 * values.
		 *
		 * @param processDefinitionDto is a ProcessDefinitionDTO
		 */
		handleEditedProcess: function(processDefinitionDto){
			var newItemId = processDefinitionDto.itemId;
			var newProcessState = processDefinitionDto.stateId;
			var rowToUpdate = this._getRowForItemId(newItemId);
			dojo.attr(rowToUpdate, "stateId", newProcessState);//$NON-NLS-1$
			dojo.removeClass(rowToUpdate, "updating");//$NON-NLS-1$
		},
		
		_createPager: function(data) {
			return new jazz.ui.PaginationControl({
						total: data.count,
						increment: TEMPLATES_PER_PAGE,
						startPage: this.queryPageNumber,
						_disabled: false,
						disable: function(shouldDisable) {
							if ((this._disabled && shouldDisable) //  already disabled
							|| (!shouldDisable && !this._disabled)) { // already enabled
								return;
							}
							
							if (shouldDisable) { 
								this._previousOld = { };
								this._previousOld.on = dojo.hasClass(this._previous, "on"); //$NON-NLS-1$
								if (this._previousOld.on) {
									this._previousOld.href = this._previous.href;
								}
								this._setLinkEnablement(this._previous, false);
								this._setHref(this._previous);
								
								this._nextOld = { };
								this._nextOld.on = dojo.hasClass(this._next, "on"); //$NON-NLS-1$
								if (this._nextOld.on) {
									this._nextOld.href = this._next.href;
								}
								this._setLinkEnablement(this._next, false);
								this._setHref(this._next);
							} else {
								if (this._previousOld.on) {
									this._setLinkEnablement(this._previous, true);
									this._setHref(this._previous, this._previousOld.href);
								}
								if (this._nextOld.on) {
									this._setLinkEnablement(this._next, true);
									this._setHref(this._next, this._nextOld.href);
								}
							}
							this._disabled = shouldDisable;
						},
						onNextClick: dojo.hitch(this, function(pager, start, end){ //$NON-NLS-1$
							this.queryPageNumber++;
							this.refresh({
								pageNum: this.queryPageNumber
							});
						}),
						onPreviousClick: dojo.hitch(this, function(e){ //$NON-NLS-1$
							this.queryPageNumber--;
							this.refresh({
								pageNum: this.queryPageNumber
							});
						})
					});
		},
		
		/*
		 * Find the row element that encloses the element that caused the event.
		 */
		_getRow: function(evt){
			var e = evt.target;
			while (e.parentNode) {
				if (e.tagName === "TR") { //$NON-NLS-1$
					return e;
				}
				e = e.parentNode;
			}
			return null;
		},
		/*
		 * Find the row for a given item id
		 */
		_getRowForItemId: function(itemId, table){
			var foundRows = dojo.query("tr[processItemId='" + itemId + "']");//$NON-NLS-1$ //$NON-NLS-2$
			if (foundRows.length > 0) {
				return foundRows[0];
			}
			return null;
		},

		_getProcessId: function(itemId){
			var processIdNode = dojo.byId(itemId + PROCESS_ID);
			return dojo.attr(processIdNode, PROCESS_ID);
		},
		
		_getProcessName: function(itemId) {
			var processNameNode = dojo.byId(itemId + NAME);
			var processName = ""; //$NON-NLS-1$
			if (processNameNode.firstChild) { 
				processName = dojo.string.trim(processNameNode.firstChild.nodeValue);
			} else {
				processName = dojo.attr(processNameNode, NAME); 
			}
			return processName;
		},

		_disableToolbars: function(disabled){
			for (var i = 0; i < this.actionToolbars.length; i++) {
				this.actionToolbars[i].disableToolbar(disabled);
			}
		},
		
		_destroyActionToolbars: function(){
			for (var i = 0; i < this.actionToolbars.length; i++) {
				this.actionToolbars[i].destroyRecursive();
			}
			this.actionToolbars = [];
		},
		
		_destroyPager: function() {
            if (this._pager) {
            	this._pager.destroyRecursive();
            	delete this._pager;
            }

		},
		
		_normalizeString: function(str) {
			str =  str.replace(/<|>|:|\\|\/|\"|\*|\?|\||&/g, "_"); //$NON-NLS-1$
		    str = this._normalizeSpacesAndDots(str);
			return str;
		},
		
		_normalizeSpacesAndDots: function(str) {
			
			var normalize = function(str) {
				str = str.substring(0, str.length - 1);
				str = str + "_"; //$NON-NLS-1$
				return str;
			};
			
			if (!str) {
				return str;
			}
			
			str = str.replace(/\.{2}/g, "__");//$NON-NLS-1$ //replace .. with __
			
			var c = str.charAt(str.length - 1);
			if (c != ' ' && c != '.') {  //$NON-NLS-1$ //$NON-NLS-2$ //processId doesn't end with . or ' '
				return str;
			} else if (c === ' ') { //$NON-NLS-1$ //processId ends with ' '
				str = normalize(str);
				return str;
			}
			
			var k = 0;
			for (var i = 0; i < str.length; i++) {
				if (str.charAt(i) === ' ' || str.charAt(i) === '.') {//$NON-NLS-1$ //$NON-NLS-2$
					k++;
				} else {
					break;
				}
			}
			if (k === str.length) { //processId contains only . and ' '
				str = normalize(str);
				return str;
			}
			
			k = str.lastIndexOf(' '); //$NON-NLS-1$
			if (k < 0) {
				return str;
			}
			var count = 0;
			for(var i = k; i < str.length; i++) {
				if(str.charAt(i) === '.') { //$NON-NLS-1$
					count++;
				}
			}
			if(count === (str.length - k - 1)) { //processId ends with ' '.....
				str = normalize(str);
				return str;
			}
			
			return str;
		},
		
		uninitialize: function(){
			this._destroyActionToolbars();
			this._destroyPager();
			this.header.destoyRecursive();
						
			this.inherited(arguments);
		}
	});
	
})();
