/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.admin.project_move.ErrorUtility"); //$NON-NLS-1$

/*
 * Imports 
 */

(function() {

/*
 * Class 
 */
com.ibm.team.process.web.ui.internal.admin.project_move.ErrorUtility = {
	
	/*
 	* Static Variables
 	*/	

	/*
 	 * @param Error errorObject
 	 * @param String id
 	 * 
 	 * @return void
 	 */
	logInfo: function(errorObject, id) {
		// Log info only in debug mode
		if (djConfig.isDebug) {
			console.log(this.getErrorMessage("INFO", errorObject, id)); //$NON-NLS-1$
		}
	},	
	
	/*
 	 * @param Error errorObject
 	 * @param String id
 	 * 
 	 * @return void
 	 */
	logError: function(errorObject, id) {
		console.error(this.getErrorMessage("ERROR", errorObject, id)); //$NON-NLS-1$
	},	
	
	/*
 	 * @param Error errorObject
 	 * @param String id
 	 * 
 	 * @return void
 	 */
	logWarning: function(errorObject, id) {
		console.warn(this.getErrorMessage("WARNING", errorObject, id)); //$NON-NLS-1$
	},		

	/*
 	 * @param Error errorObject
 	 * @param String id
 	 * 
 	 * @return void
 	 */
	alertError: function(errorObject, id) {
		alert(this.getErrorMessage("ERROR", errorObject, id)); //$NON-NLS-1$
	},	
	
	/*
 	 * @param Error errorObject
 	 * @param String id
 	 * 
 	 * @return void
 	 */
	alertWarning: function(errorObject, id) {
		alert(this.getErrorMessage("WARNING", errorObject, id)); //$NON-NLS-1$
	},	
	
	/*
 	 * @param String prefix
 	 * @param Error errorObject
 	 * @param String id
 	 * 
 	 * @return String
 	 */
	getErrorMessage: function(prefix, errorObject, id) {
		
		var classID = ""; //$NON-NLS-1$
		var lineNumber = ""; //$NON-NLS-1$
		var message = ""; //$NON-NLS-1$

		// Class name
		if (id) {
			classID = id + ": "; //$NON-NLS-1$
		} 

		if (errorObject) {
			// Line number
			if (errorObject.lineNumber) {
				lineNumber = "(line " + errorObject.lineNumber + "): "; //$NON-NLS-1$  //$NON-NLS-2$
			} 
			// Error message
			if (errorObject.message) {
				message = errorObject.message;
			} else {
				message = "Message unavailable"; //$NON-NLS-1$
			}
			if (errorObject.status === 403) {
				message = message + ": You do not have permission to read the associated data."; //$NON-NLS-1$
			}			
		} else {
			// Error message
			message = "Undefined exception"; //$NON-NLS-1$
		}
		
		var errorMessage = "[" + prefix + "]: " +  //$NON-NLS-1$  //$NON-NLS-2$
							classID +
							lineNumber +
							message;
							
		return errorMessage;
	}

};


})();

