/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.AbstractProcessAreaEditor"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dojo.cookie"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("dojox.collections.Dictionary"); //$NON-NLS-1$
	dojo.require("dojox.string.BidiComplex"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("jazz.ui.Breadcrumbs"); //$NON-NLS-1$
	dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
	dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("jazz.ui.StyledTable"); //$NON-NLS-1$
	dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
	dojo.require("jazz.ui.underlay"); //$NON-NLS-1$	
	dojo.require("jazz.core.RegistryFactory"); //$NON-NLS-1$
	dojo.require("jazz.app.ua.PageHoverHelp"); //$NON-NLS-1$		
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.client.session.Session"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.PermissionsScopeEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.RolesEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ErrorTab"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TeamHierarchyElementToolbar"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.TRToolbar"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper");//$NON-NLS-1$
	dojo.require("jazz.client.xhr"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var AbstractProcessAreaEditor = com.ibm.team.process.web.ui.internal.admin.projects.AbstractProcessAreaEditor;
	AbstractProcessAreaEditor.PROJECT_AREA_EDITOR = "com.ibm.team.process.editProjectArea"; //$NON-NLS-1$
	AbstractProcessAreaEditor.TEAM_AREA_EDITOR = "com.ibm.team.process.editTeamArea"; //$NON-NLS-1$
	AbstractProcessAreaEditor.MSG_COOKIE_NAME = "com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaEditor#saveMsg"; //$NON-NLS-1$
	AbstractProcessAreaEditor.NEW_MEMBERS_COOKIE_NAME = "com.ibm.team.process.web.ui.internal.admin.projects.ProcessAreaEditor#newMembers"; //$NON-NLS-1$
	AbstractProcessAreaEditor.SHOW_ARCHIVED_COOKIE_NAME = "com.ibm.team.process.web.ui.internal.admin.projects.ProcessAreaEditor#showArchived"; //$NON-NLS-1$
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var ResourceLink = jazz.ui.ResourceLink;
	var UIHelper = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;
	var USER_EDITOR = "com.ibm.team.repository.editUser"; //$NON-NLS-1$
	var ARCHIVED_USER_EDITOR = "com.ibm.team.repository.editArchivedUser"; //$NON-NLS-1$
	var KEY_RETURN = 13;
	var KEY_ENTER = 14;
	var MANAGE_ARCHIVED_LINK = "#action=com.ibm.team.process.manageArchivedProjectAreas"; //$NON-NLS-1$
	var MANAGE_ACTIVE_LINK = "#action=com.ibm.team.process.manageProjectAreas"; //$NON-NLS-1$
	var DEFAULT_DISPLAY_MAX = 5;
	var FETCH_MAX_MEMBERS = 20;
	var SHOW_TEXT_LENGTH = 1024;
	var ON_CLICK = "onclick"; //$NON-NLS-1$
	var toggleDescLinkIsClicked = false;
	var RegistryFactory = jazz.core.RegistryFactory;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.AbstractProcessAreaEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		// for project/team area editor to access
		fetchMaxMembers: FETCH_MAX_MEMBERS,
		
		widgetsInTemplate: true,
		
		constructor: function(args){
			this._owningApplicationKey = args.owningApplicationKey;
			this._isEmbedded = args.isEmbedded;
			this._appContextRoot = args.appContextRoot;
			this._appName = args.appName;
			var _queryParams = dojo.queryToObject(window.location.search.slice(1));
			this._hideTeams = args.hideTeams;
			this._widgetCache = {};
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.isNew = args.itemId === ProcessConstants.EditorMode.NEW;
			this.initTabId = args.tabId;
			this.processAuthoringPracticeId = args.practiceId;
			this.processAuthoringPracticeElementId = args.practiceElementId;
			this._resourceLinks = [];
			this._memberResourceLinks = [];
			this._adminResourceLinks = [];
			this.initialize(args);
		},
		
		postCreate: function(){
			this._messageBox = new jazz.ui.MessageBox();
			this._messageBoxDiv.appendChild(this._messageBox.domNode);
			
			this._pendingMessageBox = new jazz.ui.MessageBox();
			dojo.addClass(this._pendingMessageBox.domNode, "pendingMessage"); //$NON-NLS-1$
			this._pendingMessageBoxDiv.appendChild(this._pendingMessageBox.domNode);
			
			if (!this.isNew) {
				if (this.itemId !== undefined && this.itemId !== this.projectAreaItemId) {
					this.isTeamArea = true;
				} else {
					this.isTeamArea = false;
				}
				this._createTabs();
			}
			
			this.showingAllMembers = false;
			this.showingAllAdmins = false;
			this.connectHandles = [];
			this.addedRoles = [];
			this.removedRoles = [];
			this.definedRoles = [];
			this.originalDefinedRoles = [];
			this._actionToolbars = [];
			this._memberActionToolbars = [];
			this._adminActionToolbars = [];
			this._hierarchyToolbars = [];
			this.inputFields = [this.name, this.summary, this.description];
			this.connect(this.name, "onkeypress", function(e){ //$NON-NLS-1$
				if (e.keyCode === KEY_RETURN || e.keyCode === KEY_ENTER) {
					dojo.stopEvent(e);
					this.togglePrimaryField(ProcessConstants.EditorMode.PREVIEW);
				}
			});
			this.summary.viewElement = this.summaryView;
			this.summary.viewAllElement = this.summaryViewAll;
			this.summary.showAllLink = this.showAllSummaryLink;
			this.summary.showLessLink = this.showLessSummaryLink;
			this.summary.showingAll = false;
			this.description.viewElement = this.descriptionView;
			this.description.viewAllElement = this.descriptionViewAll;
			this.description.showAllLink = this.showAllDescriptionLink;
			this.description.showLessLink = this.showLessDescriptionLink;
			this.description.showingAll = false;
			this.editViewFields = [this.summary, this.description];
			this.connect(this.editViewTable, ON_CLICK, function(){ //$NON-NLS-1$
				this.toggleViewEditMode(ProcessConstants.EditorMode.EDIT);
			});
			
			for (var i = 0; i < this.inputFields.length; i++) {
				this.connect(this.inputFields[i], "onkeyup", "handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
				this.connect(this.inputFields[i], "onchange", "handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
			}
			
			this.customConnect();
			
			this.connect(this.memberAddButton, ON_CLICK, function(e){ //$NON-NLS-1$
				e.preventDefault();
				if (!this.allMembers) {
					this.allMembers = [];
					this.allMemberIds = [];
				}
				this.addUserDialog(this.allMemberIds, "addNewMembers"); //$NON-NLS-1$
			});
			this.connect(this.adminAddButton, ON_CLICK, function(e){
				e.preventDefault();
				if (!this.allAdmins) {
					this.allAdmins = [];
				}
				this.addUserDialog(this.allAdmins, "addNewAdmins"); //$NON-NLS-1$
			});
			
			this.connect(this.saveButton, ON_CLICK, "handleSave"); //$NON-NLS-1$
			this.connect(this.toggleDescLink, ON_CLICK, function(e){
				e.preventDefault();
				this.toggleDescLinkIsClicked = true;
				if (e.target.mode === ProcessConstants.EditorMode.PREVIEW) {
					this.toggleViewEditMode(ProcessConstants.EditorMode.EDIT);
				} else {
					this.toggleViewEditMode(ProcessConstants.EditorMode.PREVIEW);
					
				}
			});
			
			this.connect(this.previewName, "onmouseover", function(e){ //$NON-NLS-1$
				e.target.style.backgroundColor = "#FFFFCC"; //$NON-NLS-1$
			});
			this.connect(this.previewName, "onmouseout", function(e){ //$NON-NLS-1$
				e.target.style.backgroundColor = ProcessConstants.EMPTY;
			});
			this.connect(this.previewName, ON_CLICK, function(e){
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
			});
			this.connect(this.previewName, "onfocus", function(e){  //$NON-NLS-1$
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
			});
			this.connect(this.name, "onblur", function(e){ //$NON-NLS-1$
				this.togglePrimaryField(ProcessConstants.EditorMode.PREVIEW);
			});
			this.connect(this.showAllSummaryLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.summary.showingAll = true;
				this.summary.viewAllElement.style.display = ProcessConstants.INLINE;
				this.summary.showAllLink.style.display = ProcessConstants.NONE;
				this.summary.showLessLink.style.display = ProcessConstants.BLOCK;
			});
			this.connect(this.showLessSummaryLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.summary.showingAll = false;
				this.summary.viewAllElement.style.display = ProcessConstants.NONE;
				this.summary.showAllLink.style.display = ProcessConstants.BLOCK;
				this.summary.showLessLink.style.display = ProcessConstants.NONE;
			});
			this.connect(this.showAllDescriptionLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.description.showingAll = true;
				this.description.viewAllElement.style.display = ProcessConstants.INLINE;
				this.description.showAllLink.style.display = ProcessConstants.NONE;
				this.description.showLessLink.style.display = ProcessConstants.BLOCK;
			});
			this.connect(this.showLessDescriptionLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.description.showingAll = false;
				this.description.viewAllElement.style.display = ProcessConstants.NONE;
				this.description.showAllLink.style.display = ProcessConstants.BLOCK;
				this.description.showLessLink.style.display = ProcessConstants.NONE;
			});
			
			this.connect(this.showAllMembersLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.showingAllMembers = true;
				this.populateMembers(this.allMembers);
			});
			this.connect(this.showFewerMembersLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.showingAllMembers = false;
				this.populateMembers(this.allMembers);
			});
			
			this.connect(this.showAllAdminsLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.showingAllAdmins = true;
				this.populateAdmins(this.allAdmins);
			});
			this.connect(this.showFewerAdminsLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.showingAllAdmins = false;
				this.populateAdmins(this.allAdmins);
			});
			
			this._teamHierarchyToolbar = new jazz.ui.SimpleToolbar();
			var filterAction = {};
			filterAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/teamarea_archived_obj.gif"); //$NON-NLS-1$  //$NON-NLS-2$
			filterAction.label = this.messages.AbstractProcessAreaEditor_ShowArchived;
			filterAction.buttonType = jazz.ui.SimpleToolbar.ButtonTypes.TWO_STATE;
			this._showArchivedButton = this._teamHierarchyToolbar.addButton(this, this._displayArchivedChildren, filterAction);
			this.checkForShowArchived();
			var createTeamAction = {};
			createTeamAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/create_ta_co.gif"); //$NON-NLS-1$  //$NON-NLS-2$
			createTeamAction.label = this.messages.ProjectAreaEditorHTML_3;
			this._createChildButton = this._teamHierarchyToolbar.addButton(this, this._createTeamArea, createTeamAction);
			this._teamHierarchyToolbar.disableButton(this._createChildButton);
			this.teamAreaHierarchyToolbarDiv.appendChild(this._teamHierarchyToolbar.domNode);

			this.refresh(false);
		},
		
		customConnect: function(){
			// Derived can override and add custom connects here
		
		},
		
		// Switch to the tab specified in the args used to create this
		// editor. Derived should call this only after having fetched
		// all of their data
		navigateToInitTab : function() {
			//switch tab if tabId is setting
			if (this.initTabId) {
				this._switchTab(this.initTabId);
				this.initTabId = null;
			}
		},		
		
		_createTabs: function(){
			this._saveParticipants = new dojox.collections.Dictionary();
			this._tabs = [];
			
			this.createTab(this.messages.ProjectAreaEditor_OverviewTabLabel, ProcessConstants.TabEnum.OVERVIEW, function(){
				/* No call back needed for overview tab 
				 * Just return an empty object to represent the tab
				 */
				return {};
			}, undefined, undefined, this.getTabUAKey(ProcessConstants.TabEnum.OVERVIEW));
			dojo.removeClass(this._tabs[ProcessConstants.TabEnum.OVERVIEW].helpWidget.domNode, "helpHidden"); //$NON-NLS-1$
			this.createTab(this.messages.ProjectAreaEditor_RolesTabLabel, ProcessConstants.TabEnum.ROLES, this._createRoles, undefined, undefined, this.getTabUAKey(ProcessConstants.TabEnum.ROLES));
			this.createTab(this.messages.ProjectAreaEditor_PermissionTabLabel, ProcessConstants.TabEnum.PERMISSIONS, this._createPermissions, undefined, undefined, this.getTabUAKey(ProcessConstants.TabEnum.PERMISSIONS));
			
			this.createCustomTabs();
			
			dojo.toggleClass(this.tabSection.childNodes[0], "selected", true); //$NON-NLS-1$
			this.selectedTab = ProcessConstants.TabEnum.OVERVIEW;
		},
		
		createCustomTabs: function(){
			// Derived can override and add custom widgets here
			// using the createTab() function
		
		},
		
		createTab: function(text, tabId, createCallBack, idOfTabToInsertBefore, extensionPointWidget, uaKey){
			if (!this._tabs[tabId]) {
				var link = document.createElement("a"); //$NON-NLS-1$
				link.className = "tab"; //$NON-NLS-1$
				link.href = "#"; //$NON-NLS-1$
				link.tabId = tabId;
				link.createTab = createCallBack;
				link.extensionPointWidget = extensionPointWidget;
				link.tabTitle = text;
				link.title = text;
				dijit.setWaiRole(link, "tab"); //$NON-NLS-1$
				var topWrapper = document.createElement("div"); //$NON-NLS-1$
				topWrapper.className = "topWrapper"; //$NON-NLS-1$
				var topBorder = document.createElement("div"); //$NON-NLS-1$
				topBorder.className = "topBorder"; //$NON-NLS-1$
				topWrapper.appendChild(topBorder);
				var corners = document.createElement("div"); //$NON-NLS-1$
				corners.className = "corners"; //$NON-NLS-1$
				topWrapper.appendChild(corners);
				link.appendChild(topWrapper);
				var innerWrapper = document.createElement("div"); //$NON-NLS-1$
				innerWrapper.className = "innerWrapper"; //$NON-NLS-1$
				var title = document.createElement("div"); //$NON-NLS-1$
				title.className = "title"; //$NON-NLS-1$
				title.appendChild(document.createTextNode(text));
				title.tabId = tabId;
				title.title = text;
				dijit.setWaiRole(title, "tab"); //$NON-NLS-1$
				innerWrapper.appendChild(title);
				link.appendChild(innerWrapper);
				if (uaKey) {
					var helpHooks = document.createElement("div"); //$NON-NLS-1$
					var helpWidget = new jazz.app.ua.PageHoverHelp({
						uaKey: uaKey
					});
					helpWidget.domNode.tabId = tabId;
					helpHooks.appendChild(helpWidget.domNode);
					dojo.addClass(helpHooks, "helpInline"); //$NON-NLS-1$
					dojo.addClass(helpWidget.domNode, "helpHidden"); //$NON-NLS-1$
					title.appendChild(helpHooks);
					link.helpWidget = helpWidget;
				}

				if (idOfTabToInsertBefore) {
					this.tabSection.insertBefore(link, this._tabs[idOfTabToInsertBefore]);
				} else {
					this.tabSection.appendChild(link);
				}
				
				this.connect(link, ON_CLICK, "_onTabClick"); //$NON-NLS-1$
				this._tabs[tabId] = link;
			} else {
				// Tab with a duplicate ID is found...don't create it
				console.error(dojo.string.substitute(this.messages.AbstractProcessAreaEditor_ErrorDuplicateTabId, [tabId]));
			}
		},
		
		_createPermissions: function(){
		
			var editor = new com.ibm.team.process.web.ui.internal.admin.projects.PermissionsScopeEditor({
				editor: this,
				owningApplicationKey: this._owningApplicationKey
			});
			this.permissionEditor = editor;
			this.twoColumnMainColumn.appendChild(editor.domNode);
			return editor;
		},
		
		_getProcessAreaStore: function(){
			// Must be overridden by the project and team are editors
			// To supply the correct type of store for permisions/timelines
		},
		
		_handleCreateStoreError: function(error, permissionsScopeContext){
			switch (permissionsScopeContext) {
				case ProcessConstants.PermissionsScopeContext.DEV_LINES:
					this.handleServerResponseError(error, this.messages.AbstractProcessAreaEditor_ErrorFetchingDevelopmentLines);
					break;
				case ProcessConstants.PermissionsScopeContext.ITERATION_TYPES:
					this.handleServerResponseError(error, this.messages.AbstractProcessAreaEditor_ErrorFetchingIterationTypes);
					break;
				case ProcessConstants.PermissionsScopeContext.ITERATIONS:
					this.handleServerResponseError(error, this.messages.AbstractProcessAreaEditor_ErrorFetchingIterations);
					break;
			}
			
		},
		
		_createRoles: function(){
		
			var editor = new com.ibm.team.process.web.ui.internal.admin.projects.RolesEditor({
				editor: this
			});
			this.rolesEditor = editor;
			this.twoColumnMainColumn.appendChild(editor.domNode);
			return editor;
		},
		
		_switchTab: function(targetTabId){
			if (this.selectedTab !== targetTabId) {
				var oldTab = this._tabs[this.selectedTab].mainPage;
				if (oldTab && dojo.isFunction(oldTab.deactivateTab)) {
					if (!oldTab.deactivateTab.call(oldTab)) {
						return;
					}
				}
			}
			
			var selectedTab;
			for (var i = 0; i < this.tabSection.childNodes.length; i++) {
				var tabId = this.tabSection.childNodes[i].tabId;
				var helpWidget = this._tabs[tabId].helpWidget;
				if (tabId == targetTabId) {
					dojo.toggleClass(this.tabSection.childNodes[i], "selected", true); //$NON-NLS-1$
					if (helpWidget) {
						dojo.toggleClass(helpWidget.domNode, "helpHidden", false); //$NON-NLS-1$
					}
					this.tabSection.childNodes[i].removeAttribute('href'); //$NON-NLS-1$ 
					selectedTab = tabId;
				} else {
					dojo.toggleClass(this.tabSection.childNodes[i], "selected", false); //$NON-NLS-1$
					if (helpWidget) {
						dojo.toggleClass(helpWidget.domNode, "helpHidden", true); //$NON-NLS-1$
					}
					this.tabSection.childNodes[i].href = "#"; //$NON-NLS-1$
				}
			}

			if (this.selectedTab === selectedTab) {
				return; //tab already selected
			}
			
			// cache the current tab
			if (!this._widgetCache[this.selectedTab]) {
				this._cacheCurrentChildren(this.selectedTab);
			}
			dojox.xml.parser.removeChildren(this.twoColumnMainColumn);
			this.selectedTab = selectedTab;
			
			// Only show the team area hierarchy on the overview tab
			if (this.selectedTab === ProcessConstants.TabEnum.OVERVIEW && !this._hideTeams) {
				this.teamAreaHierarchy.style.display = "block"; //$NON-NLS-1$
			} else {
				this.teamAreaHierarchy.style.display = "none"; //$NON-NLS-1$
			}
			
			if (!this._widgetCache[selectedTab]) {
				var tabLink = this._tabs[selectedTab];
				//first time going to the tab so invoke it's creation
				if (tabLink.extensionPointWidget) {
					try {
						// If tab loaded from registry...load and create the widget
						tabLink.mainPage = this._createExtensionTab(tabLink);
					} catch (error) {
						// Create an error tab
						var tabContainer = this._createTabContainer();
						tabLink.mainPage = new com.ibm.team.process.web.ui.internal.admin.projects.ErrorTab({
							itemUUID: this.projectAreaItemId,
							tabContainer: tabContainer,
							tabID: tabLink.tabId,
							tabTitle: tabLink.tabTitle,
							tabWidget: tabLink.extensionPointWidget,
							tabError: error.message
						});
						
						this.twoColumnMainColumn.appendChild(tabLink.mainPage.domNode);
						
					}
				} else {
					// Invoke the call back creation method 
					tabLink.mainPage = tabLink.createTab.call(this);
				}
			} else {
				var theTab = this._tabs[selectedTab].mainPage;
				if (theTab && dojo.isFunction(theTab.activateTab)) {
					theTab.activateTab.call(theTab);
				}
				
			}
			
			//replaceChild
			if (this._widgetCache[selectedTab]) {
				this._switchCachedTab(selectedTab);
			}
			this.showBreadcrumbs();
		},
		
		_onTabClick: function(event){
			dojo.stopEvent(event);
			this._switchTab(event.currentTarget.tabId);
		},
		
		_createExtensionTab: function(tabLink){
			// Load widget JS, HTML & CSS		
			jazz.core.loader.load_sync(tabLink.extensionPointWidget);
			// Instantiate widget
			var widgetConstructor = eval(tabLink.extensionPointWidget);
			var tabContainer = this._createTabContainer();
			var subNode = document.createElement(ProcessConstants.DIV);
			this.twoColumnMainColumn.appendChild(subNode);
			var tabContentWidget = new widgetConstructor({
				itemUUID: this.projectAreaItemId,
				editor: this,
				tabContainer: tabContainer,
				tabID: tabLink.tabId,
				tabTitle: tabLink.tabTitle
			}, subNode);
			return tabContentWidget;
		},
		
		_createTabContainer: function(){
			return {
				setDirty: dojo.hitch(this, this.setDirty),
				changesPending: dojo.hitch(this, this.changesPending),
				displaySuccessMessage: dojo.hitch(this, this._displayLongSuccessMessage),
				displayErrorMessage: dojo.hitch(this, this._displayLongErrorMessage),
				displayWarningMessage: dojo.hitch(this, this._displayLongWarningMessage),
				displayPendingMessage: dojo.hitch(this, this._displayPendingMessage),
				clearMessage: dojo.hitch(this, this._clearMessage)
			};
		},
		
		_switchCachedTab: function(selectedTab){
			dojo.forEach(this._widgetCache[selectedTab], function(child){
				this.twoColumnMainColumn.appendChild(child);
			}, this);
		},
		
		_cacheCurrentChildren: function(selectedTab){
			var children = [];
			for (var i = 0; i < this.twoColumnMainColumn.childNodes.length; i++) {
				children[i] = this.twoColumnMainColumn.childNodes[i];
			}
			this._widgetCache[selectedTab] = children;
		},
		
		addUserDialog: function(filterUsers, callbackFunction){
			var userFilter = [];
			for (var i = 0; i < filterUsers.length; i++) {
				if (!filterUsers[i].itemId) {
					userFilter.push({
						'itemId': filterUsers[i] //$NON-NLS-1$
					});
				} else {
					userFilter.push({
						'itemId': filterUsers[i].itemId //$NON-NLS-1$
					});
				}
			}
			var userPicker = new com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog({
				destroyContents: true,
				'disableUsers': userFilter //$NON-NLS-1$
			});
			this.connect(userPicker, "onAdd", callbackFunction); //$NON-NLS-1$
		},
		
		refresh: function(refreshClicked){
			if (!this.navigateAwayHandle) {
				this.navigateAwayHandle = PlatformUI.getWorkbench().registerBodyClickHandler(dojo.hitch(this, this._handleNavigate), /*priority*/ 10000);
				this.onBeforeUnloadHandle = PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(dojo.hitch(this, this.navigateAwayEvent), /*priority*/ 10000);
			}
			
			this.clearState(refreshClicked);
			this.deferredSaveCount = 0;
			if (this.isNew) {
				this.toggleViewEditMode(ProcessConstants.EditorMode.EDIT);
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
				this.populateMembers([]);
				this.populateAdmins([]);
				setTimeout(dojo.hitch(this.name, function(){
					try {
						this.select();
					} catch (error) {
						// If the text can't be selected...ignore the error
					}
				}), 250);
			} else {
				this._destroyStyledTable(this.membersDiv);
				this._destroyStyledTable(this.adminsDiv);
			}
			
			this.customRefresh(refreshClicked);
			this.checkForSuccessMsg();
		},
		
		_handleNavigate: function(urlObj){
			if (urlObj && urlObj.fragment === "") { //$NON-NLS-1$		
				return false;
			}	
			try {
				if (this.changesPending()) {
					if (!confirm(this.messages.ProjectAreaEditor_2)) {
						return true; //veto the navigate
					}
				}
			} catch (error) {
				// Work around for workitem 56269 as documented 
				// in workitem 161749.  Need to let the handlers 
				// get unregistered in the event of an exception
				// or they stick around forever preventing other
				// handlers from getting called.
			}
			//move away from the editor
			this._unregisterHandlers();
			return false;
		},
		
		navigateAwayEvent: function(){
			return this.changesPending() ? this.messages.ProjectAreaEditor_3 : false;
		},
		
		_unregisterHandlers: function(){
			PlatformUI.getWorkbench().unregisterBodyClickHandler(this.navigateAwayHandle);
			this.navigateAwayHandle = null;
			PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandle);
			this.onBeforeUnloadHandle = null;
		},
		
		checkForSuccessMsg: function(){
			var msgCookie = dojo.cookie(AbstractProcessAreaEditor.MSG_COOKIE_NAME);
			if (msgCookie) {
				this._displayLongSuccessMessage(msgCookie);
				var now = new Date();
				now.setTime(now.getTime() - 1);
				dojo.cookie(AbstractProcessAreaEditor.MSG_COOKIE_NAME, ProcessConstants.EMPTY, {
					expires: now
				});
			}
		},
		
		checkForTeamInvitation: function(){
			var inviteCookie = dojo.cookie(AbstractProcessAreaEditor.NEW_MEMBERS_COOKIE_NAME);
			if (inviteCookie) {
				var newMemberArray = this._getNewMembers(dojo.fromJson(inviteCookie), false);
				if (newMemberArray.length > 0 && !this._isEmbedded) {//cookie and more than yourself & not an embedded editor
					this.chooseTeamInvitees(newMemberArray);
				}
				var now = new Date();
				now.setTime(now.getTime() - 1);
				dojo.cookie(AbstractProcessAreaEditor.NEW_MEMBERS_COOKIE_NAME, ProcessConstants.EMPTY, {
					expires: now
				});
			}
		},
		
		checkForNewMembersWithoutRoles: function(){
			var newMemberCookie = dojo.cookie(AbstractProcessAreaEditor.NEW_MEMBERS_COOKIE_NAME);
			if (!newMemberCookie) {
				return;
			}
			var newMemberArray = this._getNewMembers(dojo.fromJson(newMemberCookie), true);
			var newMemberWithoutRoles = [];
			var trace = ""; //$NON-NLS-1$
			dojo.forEach(newMemberArray, function(member){
				if (member.processRoles.length == 1) { //only the default role
					trace += "\n\t" + member.name; //$NON-NLS-1$
				}
			});
			
			if (trace.length > 0) {
				var error = {};
				error.errorData = {};
				error.errorData.identifier = "com.ibm.team.process.newMembersWithoutRole"; //$NON-NLS-1$
				error.errorData.internalReportInfos = [];
				error.errorData.internalReportInfos[0] = {};
				error.errorData.internalReportInfos[0].identifier = "com.ibm.team.process.internal.newMembersWithoutRoles"; //$NON-NLS-1$
				error.errorData.internalReportInfos[0].data = this.messages.AbstractProcessAreaEditor_NewMembersWithoutRoles + trace;
				var errorHeader = this.messages.AbstractProcessAreaEditor_NewMembersWithoutRolesWarningHeader;
				this._handleWarning(error, ProcessConstants.ERROR_PRIORITY_WARNING_LOW, errorHeader);
			}
		},
		
		checkForShowArchived: function(){
			var showArchived = dojo.cookie(AbstractProcessAreaEditor.SHOW_ARCHIVED_COOKIE_NAME);
			if (showArchived === "true") { //$NON-NLS-1$
				this._teamHierarchyToolbar.setPressed(this._showArchivedButton, true);
				var now = new Date();
				now.setTime(now.getTime() - 1);
				dojo.cookie(AbstractProcessAreaEditor.SHOW_ARCHIVED_COOKIE_NAME, ProcessConstants.EMPTY, {
					expires: now
				});
			}
		},
		
		clearState: function(refreshClicked){
			delete this.errObj;
			this.setDirty(false);
			this.pendingMemberChanges = {};
			this.pendingAdminChanges = {};
			this.cancelPreviousMembersRequest();
			this.allMembers = [];
			this.allMemberIds = [];
			delete this.loadingAllMembers;
			this.addedRoles = [];
			this.removedRoles = [];
			this.definedRoles = [];
			this.originalDefinedRoles = [];
			this.allAdmins = [];
			this._clearMessage();
			this.name.value = ProcessConstants.EMPTY;
			this.summary.value = ProcessConstants.EMPTY;
			this.description.value = ProcessConstants.EMPTY;
			this._destroyStyledTable(this.membersDiv);
			this._destroyStyledTable(this.adminsDiv);
			for (var i = 0; i < this.inputFields.length; i++) {
				this.inputFields[i].changePending = false;
			}
			
			if (refreshClicked) {
				this._destroySaveParticipants();
				this._saveParticipants = new dojox.collections.Dictionary();
			}
			if (this.sharedStore) {
				delete this.sharedStore;
			}
			this._destroyActionToolbars();
			this._destroyHierarchyToolbars();
			this._destroyResourceLinks();
			
		},
		
		_clearMessage: function(){
			this._pendingMessageBox.hideMessage();
			this._messageBox.hideMessage();
		},
		
		handleFetchError: function(error){
			error.priority = ProcessConstants.ERROR_PRIORITY_HIGH;
			if (error.status == ProcessConstants.SC_FORBIDDEN) {
				// Hide everything in the editor
				this.primaryFieldContainer.style.display = ProcessConstants.NONE;
				this.tabSection.style.display = ProcessConstants.NONE;
				this.contentWrapper.style.display = ProcessConstants.NONE;
				// Eliminate the stock message from core.
				error.message = ""; //$NON-NLS-1$ 
			}
			var message = this.getFetchErrorMessage(error);
			this.handleServerResponseError(error, message, [ProcessConstants.PERMISSION_DENIED_EXCEPTION, ProcessConstants.LICENSE_NOT_GRANTED_EXCEPTION]);
		},
		
		handleServerResponseSuccess: function(response){
			this.deferredSaveCount--;
			if (this.deferredSaveCount <= 0) {
				if (!this.errObj) { //no more outstanding saves and not already showing an error
					this.refresh(false);
					this._displayLongSuccessMessage(this.getServerResponseSuccessMessage());
				} else { //all the deferred saves are complete. Report the previously hit error
					if (this.errObj.priority > ProcessConstants.ERROR_PRIORITY_WARNING) {
						this._displayLongErrorMessage(this.errObj);
					} else {
						var errorObject = this.errObj;
						if (this.isNeedRefreshWithWarning()) {
							this.refresh(false);
						}
						this._displayLongWarningMessage(errorObject);
					}
					
				}
			}
			return response;
		},
		
		getServerResponseSuccessMessage: function(){
			if (this.isTeamArea) {
				return this.messages.TeamAreaEditor_30;
			} else {
				return this.messages.ProjectAreaEditor_30;
			}
		},
		
		handleServerResponseError: function(error, optionalHeaderMessage, optionalExceptionClassesToIgnore){
			this.deferredSaveCount--;
			
			// If the error doesn't have a priority...give it a really low one. 
			if (!error.priority) {
				error.priority = ProcessConstants.ERROR_PRIORITY_LOW;
			}
			
			if (!this.errObj || error.priority > this.errObj.priority) {
				this.errObj = dojo.mixin({}, error);
				if (optionalHeaderMessage) {
					this.errObj.headerMessage = optionalHeaderMessage;
				}
				if (optionalExceptionClassesToIgnore) {
					this.errObj.exceptionClassesToIgnore = optionalExceptionClassesToIgnore;
				}
			}
			
			if (this.deferredSaveCount <= 0) { //no more outstanding saves and not already showing an error
				this._displayLongErrorMessage(this.errObj);
			}
		},
		
		handleServerResponseWarning: function(error, optionalHeaderMessage){
			this.deferredSaveCount--;
			this._handleWarning(error, ProcessConstants.ERROR_PRIORITY_WARNING, optionalHeaderMessage);
		},
		
		_handleWarning: function(error, priority, optionalHeaderMessage){
			if (this.errObj && this.errObj.priority >= priority) {
				return;
			}
			
			this.errObj = dojo.mixin({}, error);
			this.errObj.priority = priority;
			this.errObj.headerMessage = optionalHeaderMessage;
			var errorObject = this.errObj;
			if (this.deferredSaveCount <= 0) { //no more outstanding saves and not already showing an error
				if (this.isNeedRefreshWithWarning()) {
					this.refresh(false);
				}
				this._displayLongWarningMessage(errorObject);
			}
		},
		
		togglePrimaryField: function(mode){
			if (mode === ProcessConstants.EditorMode.PREVIEW) {
				this.name.style.display = ProcessConstants.NONE;
				dojox.xml.parser.removeChildren(this.previewName);
				this.previewName.appendChild(document.createTextNode(this.name.value || this.getPrimaryFieldLabel()));
				this.previewName.style.display = ProcessConstants.EMPTY;
			} else if (mode === ProcessConstants.EditorMode.EDIT) {
				this.previewName.style.display = ProcessConstants.NONE;
				this.name.style.display = ProcessConstants.EMPTY;
				this.name.focus();
				this.name.select();
			}
		},
		
		toggleViewEditMode: function(mode){
			this.toggleDescLink.mode = mode;
			if (mode === ProcessConstants.EditorMode.PREVIEW) {
				dojo.forEach(this.editViewFields, function(field){
					field.style.display = ProcessConstants.NONE;
					dojox.xml.parser.removeChildren(field.viewElement);
					var previewString = field.value.substring(0, SHOW_TEXT_LENGTH);
					var hiddenString = field.value.substring(SHOW_TEXT_LENGTH);
					if (field.value.length > SHOW_TEXT_LENGTH) {
						var spaceIndex = hiddenString.indexOf(" "); //$NON-NLS-1$
						var newlineIndex = hiddenString.indexOf("\n"); //$NON-NLS-1$
						// if there is no good point to break the string in hiddenString, just show the whole thing
						if (spaceIndex === -1 && newlineIndex === -1) {
							previewString += hiddenString;
							hiddenString = ProcessConstants.EMPTY;
						} else if (newlineIndex === -1 || (spaceIndex !== -1 && spaceIndex < newlineIndex)) {
							previewString += hiddenString.substring(0, spaceIndex);
							hiddenString = hiddenString.substring(spaceIndex);
						} else if (spaceIndex === -1 || (newlineIndex !== -1 && newlineIndex < spaceIndex)) {
							previewString += hiddenString.substring(0, newlineIndex);
							hiddenString = hiddenString.substring(newlineIndex);
						}
					}
					var strings = previewString.split(/\n/);
					for (var i = 0; i < strings.length; i++) {
						if (i > 0) {
							field.viewElement.appendChild(document.createElement(ProcessConstants.BR));
						}
						if (strings[i].length > 0) {
							field.viewElement.appendChild(document.createTextNode(strings[i]));
						}
					}
					field.viewElement.style.display = ProcessConstants.EMPTY;
					dojox.xml.parser.removeChildren(field.viewAllElement);
					if (hiddenString) { //a non empty string
						strings = hiddenString.split(/\n/);
						for (i = 0; i < strings.length; i++) {
							if (i > 0) {
								field.viewAllElement.appendChild(document.createElement(ProcessConstants.BR));
							}
							if (strings[i].length > 0) {
								field.viewAllElement.appendChild(document.createTextNode(strings[i]));
							}
						}
						if (field.showingAll) {
							field.viewAllElement.style.display = ProcessConstants.INLINE;
							field.showLessLink.style.display = ProcessConstants.BLOCK;
							field.showAllLink.style.display = ProcessConstants.NONE;
						} else {
							field.viewAllElement.style.display = ProcessConstants.NONE;
							field.showLessLink.style.display = ProcessConstants.NONE;
							field.showAllLink.style.display = ProcessConstants.BLOCK;
						}
					}
				});
				dojox.xml.parser.removeChildren(this.toggleDescLink);
				this.toggleDescLink.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_8));
			} else if (mode === ProcessConstants.EditorMode.EDIT) {
				dojox.xml.parser.removeChildren(this.toggleDescLink);
				this.toggleDescLink.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_9));
				dojo.forEach(this.editViewFields, function(field){
					field.viewElement.style.display = ProcessConstants.NONE;
					field.viewAllElement.style.display = ProcessConstants.NONE;
					field.style.display = ProcessConstants.EMPTY;
					field.showAllLink.style.display = ProcessConstants.NONE;
					field.showLessLink.style.display = ProcessConstants.NONE;
				});
			}
		},
		
		populateProcessAreaData: function(data){
			this.stateId = data.stateId;
			this._isArchived = data.archived;
			this._setProcessAreaIcon(this._isArchived);
			this.name.value = data.name;
			this.name.savedValue = data.name;
			this.togglePrimaryField(ProcessConstants.EditorMode.PREVIEW);
			this.summary.value = data.summary;
			this.summary.savedValue = data.summary;
			this.description.value = data.description;
			this.description.savedValue = data.description;
			if (!this.toggleDescLinkIsClicked) {
				if (data.description) {
					this.toggleViewEditMode(ProcessConstants.EditorMode.PREVIEW);
				} else {
					this.toggleViewEditMode(ProcessConstants.EditorMode.EDIT);
				}
			}
			this.processAuthoringlicenseInfo = data.licenseInformation;
			
			if (data.processProviderDTO) {
				this.allProcessRoles = data.processProviderDTO.roles;
			} else if (data.processDTO) {
				this.allProcessRoles = data.processDTO.roles;
			} else {
				this.allProcessRoles = [];
			}
			
			this.definedRoles = [];
			dojo.forEach(this.allProcessRoles, function(role){
				if (role.defined === true) {
					this.definedRoles.push(role);
					// Make a copy of all the defined role ids so they can be deleted.
					this.originalDefinedRoles.push({
						id: role.id
					});
				}
			}, this);
			
			if (this.rolesEditor) {
				this.rolesEditor.refresh();
			}
			
			this.allMembers = data.members;
			this.allAdmins = data.admins;
			this.allMemberIds = data.memberIds;
			this.populateMembers(this.allMembers);
			this.populateAdmins(this.allAdmins);
			if (data.memberIds && data.memberIds.length > FETCH_MAX_MEMBERS) {
				this.fetchAllMembers(data);
			} else {
				this.checkForNewMembersWithoutRoles();
				this.checkForTeamInvitation();
			}
		},
		
		fetchAllMembers: function(data) {
			// kick off the call to get all members
			this.indicateLoadingMembers();
			var srh = new ServiceResponseHandler(this, "handleGetAllMembers", "handleGetAllMembersError"); //$NON-NLS-1$ //$NON-NLS-2$
			this.previousMembersRequest = ProcessClient.getMembersPaged({
				processAreaItemId: this.isTeamArea ? this.itemId : this.projectAreaItemId,
				requestToken: data.resultToken
			}, srh);	
		},
		
		indicateLoadingMembers: function(){
			this.loadingAllMembers = true;
			this.showAllMembersLink.style.display = ProcessConstants.NONE;
			this.loadingMembersDiv.style.display = ProcessConstants.BLOCK;
		},
		
		indicateDoneLoadingMembers: function(){
			delete this.loadingAllMembers;
			this.showAllMembersLink.style.display = ProcessConstants.BLOCK;
			this.loadingMembersDiv.style.display = ProcessConstants.NONE;
		},
		
		cancelPreviousMembersRequest: function(){
			if (this.previousMembersRequest) {
				// set failOk so that cancelled error does not show up in
				// browser console (aborted GET will still show up)
				this.previousMembersRequest._deferred.ioArgs.args.failOk = true;
				this.previousMembersRequest.abort();
				delete this.previousMembersRequest;
			}
		},

		showBreadcrumbs: function(){
			if (this._breadCrumbsWidget) {
				this._breadCrumbsWidget.destroyRecursive();
				delete this._breadCrumbsWidget;
			}
			dojox.xml.parser.removeChildren(this.breadcrumbs);
			
			//Check if the action is taking place on an Archived process Area.
			var currAction = document.location.hash;
			this._isArchived = ((currAction.indexOf(AbstractProcessAreaEditor.PROJECT_AREA_EDITOR, 0) === -1) &&
			(currAction.indexOf(AbstractProcessAreaEditor.TEAM_AREA_EDITOR, 0) === -1));
			var breadcrumbSegments = [];
			var projectManagementSegment = {};
			projectManagementSegment.href = this._isArchived ? MANAGE_ARCHIVED_LINK : MANAGE_ACTIVE_LINK;
			projectManagementSegment.label = this._isArchived ? this.messages.ProjectAreaEditor_10 : this.messages.ProjectAreaEditor_11;
			
			breadcrumbSegments.push(projectManagementSegment);
			this.customAddBreadcrumbSegments(breadcrumbSegments);
			this._breadCrumbsWidget = new jazz.ui.Breadcrumbs({
				segments: breadcrumbSegments
			});
			
			this.breadcrumbs.appendChild(this._breadCrumbsWidget.domNode);
			
			
		},
		
		getAllProcessRoles: function(){
			var allRoles = [];
			// Add in the defined roles
			dojo.forEach(this.definedRoles, function(role){
				allRoles.push(role);
			});
			
			// Now add in the inherited roles
			dojo.forEach(this.allProcessRoles, function(role){
				if (role.id === ProcessConstants.DEFAULT_ROLE_ID) {
					// Default role is always first.
					allRoles.unshift(role);
				} else if (role.defined === false) {
					// Only add in inherited roles
					allRoles.push(role);
				}
			});
			
			return allRoles;
		},
		
		customAddBreadcrumbSegments: function(breadcrumbSegments){
			// Derived can override and add custom bread crumb segments
		
		},
		
		_teamArchiveHandler: function(event) {
			dojo.stopEvent(event);
			if (confirm(dojo.string.substitute(this.messages.AbstractProcessAreaEditor_ConfirmArchiveTeam, [event.currentTarget.callbackData.name]))) {
				this._disableToolbars(true);
				this._displayPendingMessage(this.messages.AbstractProcessAreaEditor_ArchiveTeamAreaInProgress);
				var srh = new ServiceResponseHandler(this, "_teamArchiveSuccessCallback", "_teamArchiveErrorCallback"); //$NON-NLS-1$ //$NON-NLS-2$
				ProcessClient.postArchiveProcessItem({
					uuid: event.currentTarget.callbackData.itemId,
					itemType: ProcessConstants.ITEM_TYPE.TEAM_AREA
				}, srh);
			}
			
		},
		
		_teamArchiveSuccessCallback: function(){
			UIHelper.runSafe(dojo.hitch(this, function(){
				this._refreshProcessAreaHierarchy();
				this._disableToolbars(false);
				this._displayLongSuccessMessage(this.messages.AbstractProcessAreaEditor_ArchiveTeamAreaSuccess);
			}));
		},
		
		_teamArchiveErrorCallback: function(err){
			this._disableToolbars(false);
			var summary = dojo.string.substitute(this.messages.AbstractProcessAreaEditor_ArchiveTeamAreaError, [err.message]);
			this._displayLongErrorMessage(summary);
		},
		
		_teamUnarchiveHandler: function(event) {
			dojo.stopEvent(event);
			if (confirm(dojo.string.substitute(this.messages.AbstractProcessAreaEditor_6, [event.currentTarget.callbackData.name]))) {
				this._disableToolbars(true);
				this._displayPendingMessage(this.messages.AbstractProcessAreaEditor_3);
				var srh = new ServiceResponseHandler(this, "_teamUnarchiveSuccessCallback", "_teamUnarchiveErrorCallback"); //$NON-NLS-1$ //$NON-NLS-2$
				ProcessClient.postUnarchiveProcessArea({
					uuid: event.currentTarget.callbackData.itemId,
					itemType: ProcessConstants.ITEM_TYPE.TEAM_AREA
				}, srh);
			}
		},

		_teamUnarchiveSuccessCallback: function() {
			UIHelper.runSafe(dojo.hitch(this, function(){
				this._refreshProcessAreaHierarchy();
				this._disableToolbars(false);
				this._displayLongSuccessMessage(this.messages.AbstractProcessAreaEditor_4);
			}));
		},

		_teamUnarchiveErrorCallback: function(err) {
			this._disableToolbars(false);
			var summary = dojo.string.substitute(this.messages.AbstractProcessAreaEditor_5, [err.message]);
			this._displayLongErrorMessage(summary);
		},
		
		populateTeamAreaHierarchy: function(data){
			this.updateProcessHierarchyButtons(data.archived);
			dojox.xml.parser.removeChildren(this.teamAreaHierarchyContent);
                var processAreaData = {
					processAreaName: data.name,
					processAreaItemId: this.projectAreaItemId,
					archived: data.archived,
					isProjectArea: true
				};
			var div = this._createTeamHierarchyElement(processAreaData, false, false);
			div.archived = data.archived;
			this.teamAreaHierarchyContent.appendChild(div);
			if (data.children) {
				this.displayProcessChildren(data.children, 1, div);
			}
		},
		
		updateProcessHierarchyButtons: function(archived) {
			if (!archived) {
				this._teamHierarchyToolbar.enableButton(this._createChildButton);
			} else {
				this._teamHierarchyToolbar.setPressed(this._showArchivedButton, true);
			}
		},
		
		displayProcessChildren: function(children, indent, parentProcessArea){
			children = children.sort(function(a, b){
				return ProcessClient.stringCompare(a.name, b.name);
			});
			for (var i = 0; i < children.length; i++) {
                var processAreaData = {
					processAreaName: children[i].name,
					processAreaItemId: children[i].itemId,
					parentProcessArea: parentProcessArea,
					archived: children[i].archived,
					isProjectArea: false
				};
				var div = this._createTeamHierarchyElement(processAreaData, !parentProcessArea.archived, true);
				div.style.paddingLeft = (indent * 15) + "px"; //$NON-NLS-1$
				div.archived = children[i].archived;
				this.teamAreaHierarchyContent.appendChild(div);
				if (children[i].children) {
					this.displayProcessChildren(children[i].children, indent + 1, div);
				}
			}
			this._displayArchivedChildren();
		},
		
		_displayArchivedChildren: function() {
			var showArchived = this._teamHierarchyToolbar.isPressed(this._showArchivedButton);
			var hierarchyElements = this.teamAreaHierarchyContent.childNodes;
			for(var i=0; i < hierarchyElements.length; i++) {
				
				if (hierarchyElements[i].archived === true && !showArchived) {
					dojo.addClass(hierarchyElements[i], "hideArchived"); //$NON-NLS-1$
				} else {
					dojo.removeClass(hierarchyElements[i], "hideArchived"); //$NON-NLS-1$
				}
			}
		},
		
		_createTeamHierarchyElement: function(processAreaData, canToggleArchive, canLink) {
			var div = document.createElement(ProcessConstants.DIV);
			dojo.addClass(div, "hierarchyElement"); //$NON-NLS-1$
			div._parentProcessArea = processAreaData.parentProcessArea;
			
			var img = document.createElement("img"); //$NON-NLS-1$
			dojo.addClass(img, "hierarchyElementIcon"); //$NON-NLS-1$
			if (processAreaData.isProjectArea === true) {
				if (processAreaData.archived === true) {
					img.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/projectarea_archived_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
				} else {
					img.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/projectarea_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
				}
			} else {
				if (processAreaData.archived === true) {
					img.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/teamarea_archived_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
				} else {
					img.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/teamarea_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
				}
			}
			div.appendChild(img);
						
			if (canLink) {
				var link = document.createElement("a"); //$NON-NLS-1$
				var openEditorUri = "#action="; //$NON-NLS-1$
				if (processAreaData.processAreaItemId === this.projectAreaItemId) {
					link.href = this._getServerUrl() + net.jazz.ajax._contextRoot + "/process/project-areas/" + this.projectAreaItemId;//$NON-NLS-1$
					openEditorUri += AbstractProcessAreaEditor.PROJECT_AREA_EDITOR + "&itemId=" +this.projectAreaItemId; //$NON-NLS-1$ //$NON-NLS-2$
				} else {
					link.href = this._getServerUrl() + net.jazz.ajax._contextRoot + "/process/project-areas/" + this.projectAreaItemId + "/team-areas/" + processAreaData.processAreaItemId; //$NON-NLS-1$ //$NON-NLS-2$
					openEditorUri += AbstractProcessAreaEditor.TEAM_AREA_EDITOR + "&itemId=" + processAreaData.processAreaItemId + "&projectAreaItemId=" + this.projectAreaItemId; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				}  
				link.appendChild(document.createTextNode(processAreaData.processAreaName));
				var rl = new ResourceLink({
					'presentationUri': openEditorUri,//$NON-NLS-1$
					'lazyFetch': true //$NON-NLS-1$
				}, link);
				this._resourceLinks.push(rl);
				this.connectHandles.push(dojo.connect(link, "onfocus", div, function(e){ //$NON-NLS-1$
					dojo.toggleClass(this, "selected", true); //$NON-NLS-1$
				}));
				this.connectHandles.push(dojo.connect(link, "onblur", div, function(e){ //$NON-NLS-1$
					dojo.toggleClass(this, "selected", false); //$NON-NLS-1$
				}));
				this.connectHandles.push(dojo.connect(link, "onclick", this, function(e){ //$NON-NLS-1$
					dojo.cookie(AbstractProcessAreaEditor.SHOW_ARCHIVED_COOKIE_NAME, this._teamHierarchyToolbar.isPressed(this._showArchivedButton));
				}));
				dojo.addClass(rl.domNode, "processAreaLink");  //$NON-NLS-1$
				div.appendChild(rl.domNode);
			} else {
				var span = dojo.create("span", { }, div); //$NON-NLS-1$
				dojo.addClass(span, "j-label"); //$NON-NLS-1$
				dojo.addClass(span, "processAreaLink"); //$NON-NLS-1$
				span.appendChild(document.createTextNode(processAreaData.processAreaName));
			}
			
			var toolbar = new com.ibm.team.process.web.ui.internal.admin.projects.TeamHierarchyElementToolbar();
			this.connectHandles.push(dojo.connect(div, "onmouseover", div, function(e){ //$NON-NLS-1$
				dojo.addClass(this, "selected");  //$NON-NLS-1$
			}));
			this.connectHandles.push(dojo.connect(div, "onmouseout", div, function(e){ //$NON-NLS-1$
				dojo.removeClass(this, "selected");  //$NON-NLS-1$
			}));
			div.appendChild(toolbar.domNode);
			this._hierarchyToolbars.push(toolbar);
			
			var archiveAction = {};
			archiveAction.callbackData = {
				itemId: processAreaData.processAreaItemId,
				name: processAreaData.processAreaName
			};
			if (!processAreaData.archived) {
				archiveAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/archive_hov.gif"); //$NON-NLS-1$  //$NON-NLS-2$
				if (processAreaData.isProjectArea === true) {
					archiveAction.label = this.messages.AbstractProcessAreaEditor_ArchiveProjectArea;
				} else {
					archiveAction.label = this.messages.AbstractProcessAreaEditor_ArchiveTeamArea;
				}
				var archiveButton = toolbar.addButton(this, this._teamArchiveHandler, archiveAction);
			} else {
				archiveAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/unarchive_hov.gif"); //$NON-NLS-1$  //$NON-NLS-2$
				if (processAreaData.isProjectArea === true) {
					archiveAction.label = this.messages.AbstractProcessAreaEditor_1;
				} else {
					archiveAction.label = this.messages.AbstractProcessAreaEditor_2;
				}
				var archiveButton = toolbar.addButton(this, this._teamUnarchiveHandler, archiveAction);
			}
			div._toolbar = toolbar;
			div._archiveAction = archiveButton;
			
			if (!canToggleArchive) {
				div._toolbar.disableButton(div._archiveAction);
			}
			
			return div;			
		},
		
		handleTeamAreaHierarchyFetchError: function(error){
			this.handleServerResponseError(error, this.messages.ProjectAreaEditor_12);
		},
				
		handleGetAllMembers: function(data){
			UIHelper.runSafe(dojo.hitch(this, function(){
				delete this.previousMembersRequest;
				var fetchedMembers = data && data.members.count > 0 ? data.members.elements : [];
				this._mergeInFetchedMembers(fetchedMembers);
				this.indicateDoneLoadingMembers();
				this.populateMembers(this.allMembers);
				this.checkForNewMembersWithoutRoles();
				this.checkForTeamInvitation();
			}));
		},
		
		_mergeInFetchedMembers: function(fetchedMembers){
			// splice off added members (to keep them at the end of the list)
			for (var i = this.allMembers.length-1; i >= 0; i--) {
				var added = this.pendingMemberChanges.add && dojo.some(this.pendingMemberChanges.add, function(itemId) {
					return this.allMembers[i].itemId === itemId;
				}, this);
				if (!added) {
					break;
				}
			}
			var addedMembers = this.allMembers.splice(i+1, this.allMembers.length-1-i);
			
			// filter removed and already fetched members from incoming list
			fetchedMembers = dojo.filter(fetchedMembers, function(member) {
            	var removed = this.pendingMemberChanges.remove && dojo.some(this.pendingMemberChanges.remove, function(itemId) {
					return member.itemId === itemId;
				}, this);
            	var alreadyFetched = dojo.some(this.allMembers, function(other){
            		return member.itemId === other.itemId;
            	}, this);
            	return !removed && !alreadyFetched;
        	}, this);
        	
        	// add newly fetched members
        	this.allMembers = this.allMembers.concat(fetchedMembers);
        	
        	// add added members back in
        	this.allMembers = this.allMembers.concat(addedMembers);
		},
		
		handleGetAllMembersError: function(error){
			delete this.previousMembersRequest;
			this.handleServerResponseError(error, dojo.string.substitute(this.messages.AbstractProcessAreaEditor_7, [this.name.value]));
		},
		
		populateMembers: function(members){
			this._destroyMemberResourceLinks();
			this._destroyMemberActionToolbars();
			if (this._isEmbedded) {
				this.populateUsers(members, this.membersDiv, !this.isNew, this.showingAllMembers, this._memberResourceLinks, this._memberActionToolbars, "memberRemoveHandler", "processRoleHandler"); //$NON-NLS-1$ //$NON-NLS-2$ 
			} else {
				this.populateUsers(members, this.membersDiv, !this.isNew, this.showingAllMembers, this._memberResourceLinks, this._memberActionToolbars, "memberRemoveHandler", "processRoleHandler", "teamInviteHandler"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			}
			if (!this.loadingAllMembers && members && members.length > DEFAULT_DISPLAY_MAX) {
				if (this.showingAllMembers) {
					this.showFewerMembersLink.style.display = ProcessConstants.BLOCK;
					this.showAllMembersLink.style.display = ProcessConstants.NONE;
				} else {
					this.showFewerMembersLink.style.display = ProcessConstants.NONE;
					this.showAllMembersLink.style.display = ProcessConstants.BLOCK;
				}
			} else {
				this.showFewerMembersLink.style.display = ProcessConstants.NONE;
				this.showAllMembersLink.style.display = ProcessConstants.NONE;
			}
		},
		
		populateAdmins: function(admins){
			this._destroyAdminResourceLinks();
			this._destroyAdminActionToolbars();
			this.populateUsers(admins, this.adminsDiv, false, this.showingAllAdmins, this._adminResourceLinks, this._adminActionToolbars, "adminRemoveHandler"); //$NON-NLS-1$
			if (admins && admins.length > DEFAULT_DISPLAY_MAX) {
				if (this.showingAllAdmins) {
					this.showFewerAdminsLink.style.display = ProcessConstants.BLOCK;
					this.showAllAdminsLink.style.display = ProcessConstants.NONE;
				} else {
					this.showFewerAdminsLink.style.display = ProcessConstants.NONE;
					this.showAllAdminsLink.style.display = ProcessConstants.BLOCK;
				}
			} else {
				this.showFewerAdminsLink.style.display = ProcessConstants.NONE;
				this.showAllAdminsLink.style.display = ProcessConstants.NONE;
			}
		},
		
		populateUsers: function(users, tableDiv, isNotNew, showAll, resourceLinks, actionToolbars, removeHandler, processRoleHandler, teamInviteHandler){
			this._destroyStyledTable(tableDiv);
			
			var columns = [];
			columns.push({
				label: this.messages.ProjectAreaEditor_18,
				className: "memberName", //$NON-NLS-1$
				sortable: false
			});
			if (isNotNew) {
				columns.push({
					label: this.messages.ProjectAreaEditor_19,
					className: "memberRoles", //$NON-NLS-1$
					sortable: false
				});
			} else {
				columns.push({
					label: this.messages.ProjectAreaEditor_20,
					className: "memberMail", //$NON-NLS-1$
					sortable: false
				});
			}
			columns.push({
				label: this.messages.AbstractProcessAreaEditor_UserTableActionsHeader,
				// Work around for 127064	
				className: ProcessConstants.CSSClass.ACTION_COLUMN + " action-column-3-actions", //$NON-NLS-1$
				sortable: false
			});
			tableDiv.styledTable = new jazz.ui.StyledTable({
				columns: columns,
				showHover: true
			});
			tableDiv.appendChild(tableDiv.styledTable.domNode);
			if (users && users.length > 0) {
				var usersToShow = !showAll && users.length > DEFAULT_DISPLAY_MAX ? DEFAULT_DISPLAY_MAX : users.length;
				for (var i = 0; i < usersToShow; i++) {
					tr = document.createElement("tr"); //$NON-NLS-1$
					tr.userObj = users[i];
					var td = document.createElement("td"); //$NON-NLS-1$
					td.className = "memberName"; //$NON-NLS-1$
					var link = document.createElement("a"); //$NON-NLS-1$
					var presentationUri;
					if (users[i].archived) {
						presentationUri = "#action=" + ARCHIVED_USER_EDITOR + "&itemId=" + users[i].itemId; //$NON-NLS-1$ //$NON-NLS-2$
					} else {
						presentationUri = "#action=" + USER_EDITOR + "&itemId=" + users[i].itemId; //$NON-NLS-1$ //$NON-NLS-2$
					}
					var encodedUserId = encodeURIComponent(users[i].userId);
					link.href = this._getServerUrl() + net.jazz.ajax._contextRoot + "/users/" + encodedUserId; //$NON-NLS-1$ 
					var rl = new ResourceLink({
						'presentationUri': presentationUri, //$NON-NLS-1$
						'lazyFetch': true //$NON-NLS-1$
					}, link);
					resourceLinks.push(rl);
					link.appendChild(document.createTextNode(users[i].name));
					td.appendChild(link);
					
					this.connectHandles.push(dojo.connect(link, "onfocus", tr, function(e){ //$NON-NLS-1$
						dojo.toggleClass(this, ProcessConstants.CSSClass.TABLE_ROW_SELECTED, true);
					}));
					this.connectHandles.push(dojo.connect(link, "onblur", tr, function(e){ //$NON-NLS-1$
						dojo.toggleClass(this, ProcessConstants.CSSClass.TABLE_ROW_SELECTED, false);
					}));
					
					tr.appendChild(td);
					if (isNotNew) {
						td = document.createElement("td"); //$NON-NLS-1$
						td.className = "memberRoles"; //$NON-NLS-1$
						var roleStr = ProcessConstants.EMPTY;
						if (users[i].processRoles) {
							users[i].savedProcessRoles = users[i].processRoles;
							var roleIds = [];
							for (var j = 0; j < users[i].processRoles.length; j++) {
								// hide the default role from the display
								if (users[i].processRoles[j].id != "default") { //$NON-NLS-1$
									roleIds.push(users[i].processRoles[j].label);
								}
							}
							roleStr = roleIds.join(", "); //$NON-NLS-1$
						}
						if (dojo.isIE && roleStr === ProcessConstants.EMPTY) {
							roleStr = " "; //$NON-NLS-1$
						}
						td.appendChild(document.createTextNode(roleStr));
						tr.roleDisplay = td;
					} else {
						td = document.createElement("td"); //$NON-NLS-1$
						td.className = "memberMail"; //$NON-NLS-1$
						if (users[i].emailAddress) {
							link = document.createElement("a"); //$NON-NLS-1$
							//Do not format the email address code, just the display String
							link.href = "mailto:" + users[i].emailAddress; //$NON-NLS-1$
							var emailAddress = dojox.string.BidiComplex.createDisplayString(users[i].emailAddress, "EMAIL"); //$NON-NLS-1$
							link.appendChild(document.createTextNode(emailAddress));
							this.connectHandles.push(dojo.connect(link, "onfocus", tr, function(e){ //$NON-NLS-1$
								dojo.toggleClass(this, ProcessConstants.CSSClass.TABLE_ROW_SELECTED, true);
							}));
							this.connectHandles.push(dojo.connect(link, "onblur", tr, function(e){ //$NON-NLS-1$
								dojo.toggleClass(this, ProcessConstants.CSSClass.TABLE_ROW_SELECTED, false);
							}));
							
							td.appendChild(link);
						} else if (dojo.isIE) {
							td.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
						}
						tr.mailDisplay = td;
					}
					tr.appendChild(td);
					td = document.createElement("td"); //$NON-NLS-1$
					var trToolbar = new com.ibm.team.process.web.ui.internal.TRToolbar();
					td.appendChild(trToolbar.domNode);
					actionToolbars.push(trToolbar);
					
					if (isNotNew) {
						var processRolesAction = {};
						processRolesAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/process-roles.gif"); //$NON-NLS-1$  //$NON-NLS-2$
						processRolesAction.label = this.messages.ProjectAreaEditor_21;
						trToolbar.addButton(this, processRoleHandler, processRolesAction);
					}
					if (isNotNew && teamInviteHandler) {
						var teamInviteAction = {};
						teamInviteAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/team-invite.gif"); //$NON-NLS-1$  //$NON-NLS-2$
						teamInviteAction.label = this.messages.ProjectAreaEditor_40;
						trToolbar.addButton(this, teamInviteHandler, teamInviteAction);
					}
					this.addRemoveIcon(trToolbar, removeHandler);
					tr.appendChild(td);
					tableDiv.styledTable.tbody.appendChild(tr);
				}
			}
		},
		
		addRemoveIcon: function(trToolbar, removeHandler){
			var removeAction = {};
			removeAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/remove.gif"); //$NON-NLS-1$  //$NON-NLS-2$
			removeAction.label = this.messages.ProjectAreaEditor_22;
			trToolbar.addButton(this, removeHandler, removeAction);
		},
		
		memberRemoveHandler: function(e){
			dojo.stopEvent(e);
			if (!this.pendingMemberChanges.remove) {
				this.pendingMemberChanges.remove = [];
			}
			var rowNode = e.target;
			while (rowNode.tagName !== "TR") { //$NON-NLS-1$
				rowNode = rowNode.parentNode;
			}
			var selectedUser = rowNode.userObj;
			var itemId = selectedUser.itemId;
			
			this.pendingMemberChanges.remove.push(itemId);
			for (var j = 0; j < this.allMembers.length; j++) {
				if (itemId === this.allMembers[j].itemId) {
					this.allMembers.splice(j, 1);
					break;
				}
			}
			for (var j = 0; j < this.allMemberIds.length; j++) {
				if (itemId === this.allMemberIds[j]) {
					this.allMemberIds.splice(j, 1);
					break;
				}
			}
			if (this.pendingMemberChanges.add) {
				for (j = 0; j < this.pendingMemberChanges.add.length; j++) {
					if (this.pendingMemberChanges.add[j] == itemId) {
						this.pendingMemberChanges.add.splice(j, 1);
						this.pendingMemberChanges.remove.splice(this.pendingMemberChanges.remove.length - 1, 1);
						break;
					}
				}
			}
			this.setDirty(this.changesPending());
			this.populateMembers(this.allMembers);
		},
		
		processRoleHandler: function(e){
			dojo.stopEvent(e);
			var rowNode = e.target;
			while (rowNode.tagName !== "TR") { //$NON-NLS-1$
				rowNode = rowNode.parentNode;
			}
			var selectedUser = rowNode.userObj;
			this.processRoleRow = rowNode;
			
			var roleObj = {};
			roleObj.allRoles = this.allProcessRoles;
			roleObj.member = selectedUser;
			var processRoleDialog = new com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog(roleObj);
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: this.messages.ProjectAreaEditor_23,
				contentNode: processRoleDialog.domNode,
				width: "52em", //$NON-NLS-1$
				destroyContents: true,
				execute: function(selectedRoles){
					var roleIds = [];
					for (var i = 0; i < selectedRoles.length; i++) {
						// hide the default role from the display
						if (selectedRoles[i].id != "default") { //$NON-NLS-1$
							roleIds.push(selectedRoles[i].label);
						}
					}
					var roleString = roleIds.join(", "); //$NON-NLS-1$
					var selectedRow = this.targetObj.processRoleRow;
					dojox.xml.parser.removeChildren(selectedRow.roleDisplay);
					selectedRow.roleDisplay.appendChild(document.createTextNode(roleString));
					selectedRow.userObj.processRoles = selectedRoles;
					var roleChanged = false;
					if (selectedRoles.length == selectedRow.userObj.savedProcessRoles.length) {
						for (var j = 0; j < selectedRoles.length; j++) {
							if (selectedRoles[j].id != selectedRow.userObj.savedProcessRoles[j].id) {
								roleChanged = true;
								break;
							}
						}
					} else {
						roleChanged = true;
					}
					if (roleChanged) {
						var roleArray = [];
						for (j = 0; j < selectedRow.userObj.processRoles.length; j++) {
							roleArray.push(selectedRow.userObj.processRoles[j].id);
						}
						if (!this.targetObj.pendingMemberChanges.roles) {
							this.targetObj.pendingMemberChanges.roles = {};
						}
						this.targetObj.pendingMemberChanges.roles[selectedRow.userObj.itemId] = roleArray;
					} else {
						if (this.targetObj.pendingMemberChanges.roles) {
							delete this.targetObj.pendingMemberChanges.roles[selectedRow.userObj.itemId];
							var roleChanges = false;
							for (j in this.targetObj.pendingMemberChanges.roles) {
								roleChanges = true;
								break;
							}
							if (!roleChanges) {
								delete this.targetObj.pendingMemberChanges.roles;
							}
						}
					}
					if (this.targetObj.changesPending()) {
						this.targetObj.setDirty(true);
					} else {
						this.targetObj.setDirty(false);
					}
				}
			});
			
			processRoleDialog.startup();
			dialogWidget.targetObj = this;
			dialogWidget.processRoleDialogObj = processRoleDialog;
			this.connectHandles.push(dojo.connect(processRoleDialog.cancelButton, ON_CLICK, dialogWidget, function(e){
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(processRoleDialog.finishButton, ON_CLICK, dialogWidget, function(e){
				this.execute(this.processRoleDialogObj.getChosenRoles());
				this.close();
			}));
		},
		
		teamInviteHandler: function(e){
			dojo.stopEvent(e);
			var rowNode = e.target;
			while (rowNode.tagName !== "TR") { //$NON-NLS-1$
				rowNode = rowNode.parentNode;
			}
			var selectedUser = rowNode.userObj;
			this.customizeAndSendTeamInvitation([rowNode.userObj.itemId], rowNode.userObj, false);
		},
		
		createInvitationPropertiesString: function(user, repoLink){
			return dojo.string.substitute("teamRepository=${0}\nuserId=${1}\nuserName=${2}\nprojectAreaName=${3}", [repoLink, user.userId, user.name, this.name.value]); //$NON-NLS-1$
		},
		
		getInvitationLink: function(host){
			return dojo.string.substitute("${0}/web/projects/${1}", [host, this.name.value]); //$NON-NLS-1$
		},
		
		handleLoadInvitationExtensionResponse: function(response){
			response = dojo.fromJson(response);
			var invitees = this.cachedInvitees;
			var singleUser = this.cachedSingleUser;
			var emailObj = {};
			if (response.emailSubject) {
				emailObj.subject = response.emailSubject;
				emailObj.isNonRTC = true;
			} else {
				emailObj.subject = dojo.string.substitute(this.messages.ProjectAreaEditor_39, [this.name.value]);
			}
			
			var host = document.location.protocol + "//" + document.location.host + net.jazz.ajax._contextRoot; //$NON-NLS-1$
			var link = this.getInvitationLink(host);
			link = encodeURI(link);
			if (response.emailBody) {
				emailObj.message = response.emailBody;
				emailObj.isNonRTC = true;
			} else {
				emailObj.message = dojo.string.substitute(this.messages.ProjectAreaEditor_38, [this.name.value, link]);
			}
			if (response.invalidEmailSubject || response.invalidEmailBody) {
				emailObj.invalidEmailSubjectOrBody = true;
			}
			if (invitees.length == 1) {
				emailObj.description = dojo.string.substitute(this.messages.ProjectAreaEditor_36, [singleUser.name]);
				emailObj.singleUserObj = singleUser;
				emailObj.properties = this.createInvitationPropertiesString(singleUser, host); //$NON-NLS-1$
			} else {
				emailObj.description = this.messages.ProjectAreaEditor_37;
			}
			
			var invitationDialog = new com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog(emailObj);
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: this.messages.ProjectAreaEditor_51,
				contentNode: invitationDialog.domNode,
				width: dojo.isIE ? "48em" : "46em", //$NON-NLS-1$ //$NON-NLS-2$
				destroyContents: true,
				execute: function(dialogObj){
					var params = {
						subject: dialogObj.getEmailSubject(),
						message: dialogObj.getEmailBody(),
						cc: dialogObj.getCopySelf() ? getAuthenticatedContributor().emailAddress : ProcessConstants.EMPTY
					};
					
					params.jsonInvitees = dojo.toJson(invitees);
					this.targetObj.customTeamInvitationParams(params);
					var srh = new ServiceResponseHandler(this.targetObj, "handleInvitationResponse", "handleInvitationError"); //$NON-NLS-1$ //$NON-NLS-2$
					if (invitees.length == 1) {
						this.targetObj.messageToDisplay = this.targetObj.messages.ProjectAreaEditor_44;
					} else {
						this.targetObj.messageToDisplay = this.targetObj.messages.ProjectAreaEditor_43;
					}
					ProcessClient.generateTeamInvitations(params, srh);
					this.targetObj._displayPendingMessage(this.targetObj.messages.ProjectAreaEditor_41);
				}
			});
			dialogWidget.targetObj = this;
			dialogWidget.invitationDialogObj = invitationDialog;
			invitationDialog.startup();
			invitationDialog.emailSubject.focus();
			this.connectHandles.push(dojo.connect(invitationDialog.cancelButton, ON_CLICK, dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(invitationDialog.finishButton, ON_CLICK, dialogWidget, function(e){ //$NON-NLS-1$
				this.execute(this.invitationDialogObj);
				this.close();
			}));
		},
		
		handleLoadInvitationExtensionError: function(error){
			this.handleServerResponseError(error, this.messages.ProjectAreaEditor_52, [ProcessConstants.TEAM_OPERATION_CANCELED_EXCEPTION]);
		},
		
		customizeAndSendTeamInvitation: function(invitees, singleUser){
			this.cachedInvitees = invitees;
			this.cachedSingleUser = singleUser;
			var srh = new ServiceResponseHandler(this, "handleLoadInvitationExtensionResponse", "handleLoadInvitationExtensionError"); //$NON-NLS-1$ //$NON-NLS-2$
			var parms = {};
			var repositoryUrl = document.location.protocol + "//" + document.location.host + net.jazz.ajax._contextRoot; //$NON-NLS-1$
			parms.repositoryUrl = repositoryUrl;
			if (this.isTeamArea) {
				parms.processAreaId = this.itemId;
			} else {
				parms.processAreaId = this.projectAreaItemId;
			}
			ProcessClient.generateTeamInvitation(parms, srh);
		},
		
		customTeamInvitationParams: function(params){
			params.projectAreaUuid = this.projectAreaItemId;
		},
		
		_getNewMembers: function(newMemberIds, includeCurrentUser){
			if (!includeCurrentUser) {
				var currentUser = getAuthenticatedContributor();
			}
			
			var newMemberArray = [];
			dojo.forEach(newMemberIds, function(itemId){
				dojo.forEach(this.allMembers, function(member){
					if (member.itemId === itemId && (includeCurrentUser || (member.itemId !== currentUser.itemId))) {
						newMemberArray.push(member);
					}
				});
			}, this);
			return newMemberArray;
		},
		
		chooseTeamInvitees: function(newMemberArray){
			var mixinObj = {};
			mixinObj.newMembers = newMemberArray;
			
			var self = this;
			var teamInvitationDialog = new com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog(mixinObj);
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: this.messages.ProjectAreaEditor_42,
				contentNode: teamInvitationDialog.domNode,
				width: dojo.isIE ? "38em" : "36em", //$NON-NLS-1$ //$NON-NLS-2$
				destroyContents: true,
				execute: function(){
					var invitees = this.teamInvitationDialogObj.getChosenMembers();
					if (invitees.length > 0) {
						self.customizeAndSendTeamInvitation(invitees, this.teamInvitationDialogObj.singleUser, true);
					}
				}
			});
			dialogWidget.targetObj = this;
			dialogWidget.teamInvitationDialogObj = teamInvitationDialog;
			teamInvitationDialog.startup();
			teamInvitationDialog.okButton.focus();
			this.connectHandles.push(dojo.connect(teamInvitationDialog.cancelButton, ON_CLICK, dialogWidget, function(e){
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(teamInvitationDialog.okButton, ON_CLICK, dialogWidget, function(e){
				this.execute();
				this.close();
			}));
		},
		
		handleInvitationResponse: function(response){
			this._displayLongSuccessMessage(this.messageToDisplay);
		},
		
		handleInvitationError: function(error){
			this.handleServerResponseError(error, this.messages.ProjectAreaEditor_45, [ProcessConstants.TEAM_OPERATION_CANCELED_EXCEPTION, ProcessConstants.MAIL_SERVICE_NOT_CONFIGURED_EXCEPTION]);
		},
		
		adminRemoveHandler: function(e){
			dojo.stopEvent(e);
			if (!this.pendingAdminChanges.remove) {
				this.pendingAdminChanges.remove = [];
			}
			var rowNode = e.target;
			while (rowNode.tagName !== "TR") { //$NON-NLS-1$
				rowNode = rowNode.parentNode;
			}
			var selectedUser = rowNode.userObj;
			var itemId = selectedUser.itemId;
			
			this.pendingAdminChanges.remove.push(itemId);
			for (var j = 0; j < this.allAdmins.length; j++) {
				if (itemId === this.allAdmins[j].itemId) {
					this.allAdmins.splice(j, 1);
					break;
				}
			}
			if (this.pendingAdminChanges.add) {
				for (j = 0; j < this.pendingAdminChanges.add.length; j++) {
					if (this.pendingAdminChanges.add[j] == itemId) {
						this.pendingAdminChanges.add.splice(j, 1);
						this.pendingAdminChanges.remove.splice(this.pendingAdminChanges.remove.length - 1, 1);
						break;
					}
				}
			}
			this.setDirty(this.changesPending());
			this.populateAdmins(this.allAdmins);
		},
		
		addNewMembers: function(newMembers){
			if (newMembers) {
				if (newMembers.length > 0) {
					if (!this.pendingMemberChanges.add) {
						this.pendingMemberChanges.add = [];
					}
				}
				
				var defaultRole = this.getDefaultRole();
				for (var i = 0; i < newMembers.length; i++) {
					var member = newMembers[i];
					member.itemId = member.itemId;
					member.processRoles = [{
						id: ProcessConstants.DEFAULT_ROLE_ID,
						label: defaultRole.label,
						description: defaultRole.description
					}];
					member.savedProcessRoles = [{
						id: ProcessConstants.DEFAULT_ROLE_ID,
						label: defaultRole.label,
						description: defaultRole.description
					}];
					this.allMembers.push(member);
					this.allMemberIds.push(member.itemId);
					this.pendingMemberChanges.add.push(member.itemId);
					if (this.pendingMemberChanges.remove) {
						for (var j = 0; j < this.pendingMemberChanges.remove.length; j++) {
							if (this.pendingMemberChanges.remove[j] == member.itemId) {
								this.pendingMemberChanges.remove.splice(j, 1);
								this.pendingMemberChanges.add.splice(this.pendingMemberChanges.add.length - 1, 1);
								break;
							}
						}
					}
				}
			}
			this.setDirty(this.changesPending());
			this.populateMembers(this.allMembers);
		},
		
		getDefaultRole: function(){
			if (this.allProcessRoles) {
				for (var i = 0; i < this.allProcessRoles.length; i++) {
					if (this.allProcessRoles[i].id === ProcessConstants.DEFAULT_ROLE_ID) { //$NON-NLS-1$
						return this.allProcessRoles[i];
					}
				}
			}
			// new process area case...no roles yet
			return {
				id: ProcessConstants.DEFAULT_ROLE_ID
			};
		},
		
		addNewAdmins: function(newAdmins){
			if (newAdmins) {
				if (newAdmins.length > 0) {
					this.setDirty(true);
					if (!this.pendingAdminChanges.add) {
						this.pendingAdminChanges.add = [];
					}
				}
				var defaultRole = this.getDefaultRole();
				for (var i = 0; i < newAdmins.length; i++) {
					var admin = newAdmins[i];
					admin.itemId = admin.itemId;
					admin.processRoles = [{
						id: ProcessConstants.DEFAULT_ROLE_ID,
						label: defaultRole.label,
						description: defaultRole.description
					}];
					admin.savedProcessRoles = [{
						id: ProcessConstants.DEFAULT_ROLE_ID,
						label: defaultRole.label,
						description: defaultRole.description
					}];
					this.allAdmins.push(admin);
					this.pendingAdminChanges.add.push(admin.itemId);
					if (this.pendingAdminChanges.remove) {
						for (var j = 0; j < this.pendingAdminChanges.remove.length; j++) {
							if (this.pendingAdminChanges.remove[j] == admin.itemId) {
								this.pendingAdminChanges.remove.splice(j, 1);
								this.pendingAdminChanges.add.splice(this.pendingAdminChanges.add.length - 1, 1);
								break;
							}
						}
					}
				}
			}
			this.setDirty(this.changesPending());
			this.populateAdmins(this.allAdmins);
		},
		
		handleChange: function(e){
			this.handleCustomChange(e);
			
			if (e.target.value != e.target.savedValue) {
				e.target.changePending = true;
				this.setDirty(true);
			} else {
				e.target.changePending = false;
				if (!this.changesPending()) {
					this.setDirty(false);
				}
			}
		},
		
		setDirty: function(isDirty){
			this.enableSaveButton(isDirty);
			if (isDirty || this.isNew) {
				this.modifiedFlag.style.display = ProcessConstants.INLINE;
				if (this._canSave()) {
					this._messageBox.hideMessage();
				}
			} else {
				this.modifiedFlag.style.display = ProcessConstants.NONE;
			}
		},
		
		enableSaveButton: function(isDirty){
			if (isDirty && this.name.value && (!this.isNew || this.processSelector.selectedIndex > -1) && this._canSave()) {
				this.saveButton.disabled = false;
			} else {
				this.saveButton.disabled = true;
			}
			
		},
		
		_canSave: function(){
			// Check if the tabs loaded by extension point have any
			// changes pending
			if (this._tabs) {
				for (tabId in this._tabs) {
					var tab = this._tabs[tabId];
					if (this.isActivatedExtensionTab(tab) && !tab.mainPage.canSave()) {
						return false;
					}
				}
			}
			
			// TODO need generic ability to call on each tab
			if (this.rolesEditor) {
				if (!this.rolesEditor.canSave()) {
					return false;
				}
			}
			if (!this.customCanSave()) {
				return false;
			}
			return true;
		},
		
		customCanSave: function(){
			// Derived can override to check custom fields here
			return true;
		},
		
		isActivatedExtensionTab: function(tab){
			return tab.extensionPointWidget && tab.mainPage;
		},
		
		changesPending: function(){
			if (this._processAreaChangesPending()) {
				return true;
			}
			
			// Check if the tabs loaded by extension point have any
			// changes pending
			if (this._tabs) {
				for (tabId in this._tabs) {
					var tab = this._tabs[tabId];
					if (this.isActivatedExtensionTab(tab) && tab.mainPage.changesPending()) {
						return true;
					}
				}
			}
			return false;
		},
		
		_processAreaChangesPending: function() {
			for (var i = 0; i < this.inputFields.length; i++) {
				if (this.inputFields[i].changePending) {
					return true;
				}
			}

			if (this.pendingMemberChanges.add && this.pendingMemberChanges.add.length > 0 || this.pendingMemberChanges.remove && this.pendingMemberChanges.remove.length > 0) {
				return true;
			}
			
			if (this.pendingMemberChanges.roles) {
				return true;
			}
			
			if (this.pendingAdminChanges.add && this.pendingAdminChanges.add.length > 0 || this.pendingAdminChanges.remove && this.pendingAdminChanges.remove.length > 0) {
				return true;
			}
			
			if (!this.isNew && this._saveParticipants) {
				var iter = this._saveParticipants.getIterator();
				while (!iter.atEnd()) {
					if (iter.get().value.changesPending()) {
						return true;
					}
				}
			}
			
			if (this.customChangesPending()) {
				return true;
			}
			
			return false;
			
		},
		
		customChangesPending: function(){
			// Derived can override and add custom changes pending here
		},
		
		handleSave: function(e){
		
			if (e) {
				dojo.stopEvent(e);
			}
			this.deferredSaveCount = this.getDeferredSaveCount();
			delete this.errObj;
			this.saveButton.disabled = true;
			
			var saveObj = this.configureSaveObject();
			
			var msg = this.validateRequired(saveObj);
			if (msg) { //nonempty message
				this._displayLongErrorMessage(msg);
			} else if (this._processAreaChangesPending()) {
				var srh = new ServiceResponseHandler(this, "handleSaveResponse", "handleSaveError"); //$NON-NLS-1$ //$NON-NLS-2$
				this.doSave(saveObj, srh);
			} else {
				this.deferredSaveCount--; // We won't be saving the process area
				this._displayPendingMessage(this.messages.ProjectAreaEditor_25);
				
				this._saveExtensionTabs();
			}
		},
		
		doSave: function(saveObj, serviceResponseHandler){
			ProcessClient.postProjectArea(saveObj, serviceResponseHandler);
			if (this.isNew) {
				this._displayPendingMessage(this.messages.ProjectAreaEditor_24);
			} else {
				this._displayPendingMessage(this.messages.ProjectAreaEditor_25);
			}
		},
		
		configureSaveObject: function(){
			var saveObj = {
				itemId: this.projectAreaItemId
			};
			if (!this.isNew) {
				saveObj.stateId = this.stateId;
			}
			saveObj.owningApplicationKey = this._owningApplicationKey;
			for (var i = 0; i < this.inputFields.length; i++) {
				if (this.inputFields[i].changePending) {
					saveObj[this.inputFields[i].name] = dojo.string.trim(this.inputFields[i].value);
				}
			}
			saveObj.jsonMembers = dojo.toJson(this.pendingMemberChanges);
			saveObj.jsonAdmins = dojo.toJson(this.pendingAdminChanges);
			if (this.isNew) {
				if (this.processSelector) {
					saveObj.processUuid = this.processSelector.value;
					saveObj.processLocale = this.processSelector.options[this.processSelector.selectedIndex].locale;
				}
			}
			if (saveObj.processLocale === null || saveObj.processLocale === undefined) {
				saveObj.processLocale = this.processLocale ? this.processLocale : ProcessConstants.EMPTY;
			}
						
			this.generateChangeParameters(saveObj);
			this.generateRoleChanges(saveObj);
			this.customSave(saveObj);
			return saveObj;
		},
		
		customSave: function(saveObj){
			// Derived can override and add custom save here
		},
		
		customValidateRequired: function(saveObj){
			// Derived can override and add custom validation here
		},
		
		generateRoleChanges: function(saveObj){
			if (this.rolesEditor && this.rolesEditor.changesPending()) {
				var jsonRoles = {};
				jsonRoles.add = this.definedRoles;
				jsonRoles.remove = this.originalDefinedRoles;
			}
			if (jsonRoles) {
				saveObj.jsonRoles = dojo.toJson(jsonRoles);
			}
		},
		
		validateRequired: function(saveData){
			if (saveData.name == ProcessConstants.EMPTY || (this.isNew && !saveData.name)) {
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
				return this.messages.ProjectAreaEditor_26;
			}
			
			if (saveData.name && saveData.name.indexOf('/') >= 0) { //$NON-NLS-1$
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
				if (this.isTeamArea) {
					return this.messages.TeamAreaEditor_35;
				} else {
					return this.messages.ProjectAreaEditor_55;
				}
			}
			
			if (this.isNew && !saveData.processUuid && !saveData.internalProcessProviderUUID) {
				if (this.processList.options.length === 0) {
					return this.messages.ProjectAreaEditor_27;
				} else {
					this.processList.focus();
					return this.messages.ProjectAreaEditor_28;
				}
			}
			
			// TODO need generic mechanism that is called on each tab
			if (this.rolesEditor) {
				var msg = this.rolesEditor.validateRequired();
				if (msg) {
					return msg;
				}
			}
			return this.customValidateRequired(saveData);
		},
		
		generateChangeParameters: function(saveObj){
			if (!this.isNew) {
				var iter = this._saveParticipants.getIterator();
				while (!iter.atEnd()) {
					iter.get().value.aboutToBeSaved(saveObj);
				}
			}
		},
		
		addSaveParticipant: function(participant, participantId){
			if (!this._saveParticipants.contains(participantId)) {
				this._saveParticipants.add(participantId, participant);
				return true;
			}
			var message = dojo.string.substitute(this.messages.AbstractProjectAreaEditor_DuplicateSaveParticipant, [participantId]);
			this._displayLongErrorMessage(message);
			throw new Error(message);
		},
		
		removeSaveParticipant: function(participantId){
			if (this._saveParticipants.contains(participantId)) {
				this._saveParticipants.remove(participantId);
				return true;
			}
			return false;
		},
		
		handleSaveResponse: function(response){			
			this._saveExtensionTabs();
			
			if (this.pendingMemberChanges.add && this.pendingMemberChanges.add.length > 0) {
				dojo.cookie(AbstractProcessAreaEditor.NEW_MEMBERS_COOKIE_NAME, dojo.toJson(this.pendingMemberChanges.add));
			}
			
			if (this.isNew && response) {
				dojo.publish(ProcessConstants.ProjectSelectorContext.ADD, [this.name.value]);
				dojo.cookie(AbstractProcessAreaEditor.MSG_COOKIE_NAME, this.messages.ProjectAreaEditor_29);
				this._unregisterHandlers();
				document.location.href = "#action=" + AbstractProcessAreaEditor.PROJECT_AREA_EDITOR + "&itemId=" + response; //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				if (this.name.changePending && !this._isArchived) {
					dojo.publish(ProcessConstants.ProjectSelectorContext.DELETE, [this.name.savedValue]);
					dojo.publish(ProcessConstants.ProjectSelectorContext.ADD, [this.name.value]);
				}
				this.handleServerResponseSuccess(response);
				var iter = this._saveParticipants.getIterator();
				while (!iter.atEnd()) {
					iter.get().value.saved(response);
				}
			}
		},
		
		handleSaveError: function(error){
			this.saveButton.disabled = false;
			this.deferredSaveCount = 0; // Save of process area did not complete successfully so there will be no deferred saves
			this.handleServerResponseError(error, this.getSaveErrorMessage(), [ProcessConstants.PROCESS_DATA_VALIDATION_EXCEPTION, ProcessConstants.STALE_DATA_EXCEPTION, ProcessConstants.PERMISSION_DENIED_EXCEPTION, ProcessConstants.TEAM_OPERATION_CANCELED_EXCEPTION, ProcessConstants.LICENSE_NOT_GRANTED_EXCEPTION]);
		},
		
		getSaveErrorMessage: function(err){
			return this.messages.ProjectAreaEditor_31;
		},
		
		onRefresh: function(e){
			dojo.stopEvent(e);
			if (this.changesPending() && !confirm(this.messages.ProjectAreaEditor_32)) {
				return;
			}
			this.refresh(true);
		},
		
		startLoading: function(msg) {
			// Need to trap the focus because disabling
			// the controls can cause some of them to lose
			// focus once re-enabled when loading is done on IE
			if (dojo.isIE && !this._lastFocus) {
				this._lastFocus = dijit.getFocus();
			}
			this._displayPendingMessage(msg);
			jazz.ui.underlay.show({
				appendTo: this.domNode,
				zIndex: 999,
				animate: false,
				stopEvents: true 
			})
		},
		
		stopLoading: function() {
			this._pendingMessageBox.hideMessage();
			jazz.ui.underlay.hide();
			if (dojo.isIE && this._lastFocus) {
				dijit.focus(this._lastFocus);
				this._lastFocus = undefined;
			}
		},
		
		_displayPendingMessage: function(msg){
			this._messageBox.hideMessage();
			var messageBoxArgs = {
				type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
				summary: msg
			};
			this._pendingMessageBox.showMessage(messageBoxArgs);
		},
		
		_displayLongSuccessMessage: function(msg){
			var messageBoxArgs = {
				type: jazz.ui.MessageBox.STATUS_TYPES.OK,
				summary: msg,
				closable: true
			};
			this._displayLongMessage(messageBoxArgs);
		},
		
		_displayLongInfoMessage: function(msg){
			var messageBoxArgs = {
				type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
				summary: msg,
				closable: true
			};
			this._displayLongMessage(messageBoxArgs);
		},
		
		_displayLongWarningMessage: function(msg){
			var messageBoxArgs = this._convertMsgToMsgBoxArgs(msg);
			messageBoxArgs.type = jazz.ui.MessageBox.STATUS_TYPES.WARNING;
			this._displayLongMessage(messageBoxArgs);
		},
		
		_displayLongErrorMessage: function(msg){
			var messageBoxArgs = this._convertMsgToMsgBoxArgs(msg);
			messageBoxArgs.type = jazz.ui.MessageBox.STATUS_TYPES.ERROR;
			this._displayLongMessage(messageBoxArgs);
		},
		
		_displayLongMessage: function(messageBoxArgs){
			this._pendingMessageBox.hideMessage();
			this._messageBox.showMessage(messageBoxArgs);
		},
		
		_convertMsgToMsgBoxArgs: function(msg){
			var messageBoxArgs = {};
			if (dojo.isString(msg)) {
				messageBoxArgs.summary = msg;
			} else {
				messageBoxArgs.summary = msg.headerMessage;
				messageBoxArgs.errorObject = msg;
				if (this._isErrorDataOfInterest(msg.errorData)) {
					msg.exception = msg.errorData.internalReportInfos[0].data.split("\n"); //$NON-NLS-1$
				} else if (this._shouldIgnoreException(msg)) {
					delete msg.errorClass;
					delete msg.exception;
				}
			}
			return messageBoxArgs;
		},
		
		_shouldIgnoreException: function(errObj){
			if (errObj.exceptionClassesToIgnore) {
				for (var i = 0; i < errObj.exceptionClassesToIgnore.length; i++) {
					if (errObj.exceptionClassesToIgnore[i] === errObj.errorClass) {
						return true;
					}
				}
			}
			return false;
		},
		
		_isErrorDataOfInterest: function(errorData){
			return errorData !== undefined &&
			(errorData.identifier === "com.ibm.team.process.server.initializeProjectArea" || errorData.identifier === "com.ibm.team.process.projectLinks" || errorData.identifier === "com.ibm.team.process.newMembersWithoutRole") && //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			errorData.internalReportInfos !== undefined &&
			errorData.internalReportInfos.length > 0 &&
			(errorData.internalReportInfos[0].identifier === "com.ibm.team.process.internal.operationException" || errorData.internalReportInfos[0].identifier === "com.ibm.team.process.internal.linksException" || errorData.internalReportInfos[0].identifier === "com.ibm.team.process.internal.newMembersWithoutRoles") && //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			errorData.internalReportInfos[0].data !== undefined;
		},
		
		_destroyResourceLinks: function(){
			for (var i = 0; i < this._resourceLinks.length; i++) {
				this._resourceLinks[i].destroyRecursive();
			}
			this._resourceLinks = [];
			this._destroyMemberResourceLinks();
			this._destroyAdminResourceLinks();
		},
		
		_disableToolbars: function(disabled){
			for (var i = 0; i < this._actionToolbars.length; i++) {
				this._actionToolbars[i].disableToolbar(disabled);
			}
			for (var i = 0; i < this._hierarchyToolbars.length; i++) {
				this._hierarchyToolbars[i].disableToolbar(disabled);
			}
			for (var i = 0; i < this._memberActionToolbars.length; i++) {
				this._memberActionToolbars[i].disableToolbar(disabled);
			}
			for (var i = 0; i < this._adminActionToolbars.length; i++) {
				this._adminActionToolbars[i].disableToolbar(disabled);
			}
		},
		
		_destroyActionToolbars: function(){
			for (var i = 0; i < this._actionToolbars.length; i++) {
				this._actionToolbars[i].destroyRecursive();
			}
			this._actionToolbars = [];
			this._destroyMemberActionToolbars();
			this._destroyAdminActionToolbars();
		},
		
		_destroyHierarchyToolbars: function(){
			for (var i = 0; i < this._hierarchyToolbars.length; i++) {
				this._hierarchyToolbars[i].destroyRecursive();
			}
			this._hierarchyToolbars = [];
		},

		_destroySaveParticipants: function(){
			if (this._saveParticipants) {
				var keys = this._saveParticipants.getKeyList();
				for (var i = 0; i < keys.length; i++) {
					this._saveParticipants.remove(keys[i]);
				}
				delete this._saveParticipants;
			}
			
		},
		
		_destroyStyledTable: function(tableDiv){
			if (tableDiv.styledTable) {
				tableDiv.styledTable.destroyRecursive();
				// IE 7 doesn't like delete here for some reason so just undefine it
				tableDiv.styledTable = undefined;
			}
			dojox.xml.parser.removeChildren(tableDiv);
		},
		
		_destroyMemberResourceLinks: function(){
			for (var i = 0; i < this._memberResourceLinks.length; i++) {
				this._memberResourceLinks[i].destroyRecursive();
			}
			this._memberResourceLinks = [];
		},
		
		_destroyAdminResourceLinks: function(){
			for (var i = 0; i < this._adminResourceLinks.length; i++) {
				this._adminResourceLinks[i].destroyRecursive();
			}
			this._adminResourceLinks = [];
		},
		
		_destroyMemberActionToolbars: function(){
			for (var i = 0; i < this._memberActionToolbars.length; i++) {
				this._memberActionToolbars[i].destroyRecursive();
			}
			this._memberActionToolbars = [];
		},
		
		_destroyAdminActionToolbars: function(){
			for (var i = 0; i < this._adminActionToolbars.length; i++) {
				this._adminActionToolbars[i].destroyRecursive();
			}
			this._adminActionToolbars = [];
		},
		
		_getServerUrl: function(){
			var location = document.location.href;
			var separator = "/"; //$NON-NLS-1$
			var path = location.split(separator); //$NON-NLS-1$
			var serverAddress;
			if (path.length > 0) {
				serverAddress = path.shift() + separator + separator;
				path.shift(); //empty from the double //
				serverAddress = serverAddress + path.shift();
			}
			return serverAddress;
		},
		
		uninitialize: function(){
			this._destroyActionToolbars();
			this._destroyHierarchyToolbars();
			dojo.forEach(this.connectHandles, function(handle){
				dojo.disconnect(handle);
			});
			
			if (this.rolesEditor) {
				this.rolesEditor.destroyRecursive();
				delete this.rolesEditor;
				
			}
			
			if (this.permissionEditor) {
				this.permissionEditor.destroyRecursive();
				delete this.permissionEditor;
			}
			
			this._destroySaveParticipants();
			
			if (this._widgetCache) {
				for (var tabId in this._widgetCache) {
					this._widgetCache[tabId] = null;
				}
				delete this._widgetCache;
			}
			
			if (this._tabs) {
				for (tabId in this._tabs) {
					var tab = this._tabs[tabId];
					if (this.isActivatedExtensionTab(tab)) {
						tab.mainPage.destroyRecursive();
					}
					if (tab.helpWidget) {
						tab.helpWidget.destroyRecursive();
					}
					this._tabs[tabId] = null;
				}
				delete this._tabs;
			}
			
			if (this._breadCrumbsWidget) {
				this._breadCrumbsWidget.destroyRecursive();
			}
			
			this._destroyStyledTable(this.membersDiv);
			this._destroyStyledTable(this.adminsDiv);
			this._destroyResourceLinks();
			
			this._messageBox.destroyRecursive();
			this._pendingMessageBox.destroyRecursive();
			
			this.cancelPreviousMembersRequest();
			this.inherited(arguments);
		},
		
		handleCustomChange: function(e){
			// Derived can override and add custom event handling here
		},
		
		_loadRegistryTabs: function(){
			// Get extension registry
			var registry = RegistryFactory.getRegistry();
			if (!registry) {
				return;
			}
			// Get extension points
			var extensionsPoints = registry.getExtensionPoint(ProcessConstants.ProjectAreaExtensionPage.EXTENSION_POINT_PROFILE_PAGES);
			if (!extensionsPoints) {
				return;
			}
			// Get extensions
			var extensions = extensionsPoints.getExtensions();
			if ((extensions instanceof Array === false) ||
			(extensions.length === 0)) {
				return;
			}
			// Get elements
			for (var index = 0; index < extensions.length; index++) {
				var elements = extensions[index].getConfigurationElements();
				if ((elements instanceof Array === false) ||
				(elements.length === 0)) {
					continue;
				}
				this._processTabElements(elements);
			}
		},
		
		/*
		 * @param Array elements
		 *
		 * @return void
		 */
		_processTabElements: function(elements){
		
			for (var index = 0; index < elements.length; index++) {
				var element = elements[index];
				if (element.getName() !== ProcessConstants.ProjectAreaExtensionPage.ELEMENT_PAGE) {
					continue;
				}
				// Get id
				var id = element.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_ID);
				if (!id) {
					continue;
				}
				// Get title
				var title = element.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_TITLE);
				if (!title) {
					continue;
				}
				// Get widget
				var widget = element.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_WIDGET);
				if (!widget) {
					continue;
				}
				
				// Get widget
				var createForTeamAreaEditor = element.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_TEAM_AREA_EDITOR);
				if (!this._createForCurrentEditor(createForTeamAreaEditor)) {
					continue;
				}

				// Get ua key
				var uaKey = this.getRegistryTabUAKey(element)
				
				this.createTab(title, id, undefined, undefined, widget, uaKey);
			}
		},
		
		_createForCurrentEditor: function(createForTeamAreaEditor){
			return true;
		},
		
		_saveExtensionTabs: function(){
			if (!this.isNew && this._tabs) {
				for (tabId in this._tabs) {
					var tab = this._tabs[tabId];
					if (this.isActivatedExtensionTab(tab)) {
						if (tab.mainPage.changesPending()) {
							tab.mainPage.doSave(dojo.hitch(this, this._saveExtensionPageCallback));
						}
					}
				}
			}
		},
		
		/*
		 * @param Error errorObject
		 *
		 * @return void
		 */
		_saveExtensionPageCallback: function(errorObject){
		
			if (!this.domNode) {
				// Edge case
				// Notification too late, the editor has already been destroyed
				return;
			}
			
			if (errorObject) {
				// Save operation failed for the tab
				this.handleServerResponseError(errorObject);
				this.saveButton.disabled = false;
			} else {
				// Save operation passed for the tab
				this.handleServerResponseSuccess();
			}
		},
		
		getTabUAKey: function(tabKey) {
			return undefined;
		},
		
		getRegistryTabUAKey: function(extensionElement) {
			return undefined;
		},
		
		isNeedRefreshWithWarning: function() {
			return false;
		}
	});
	
})();
