/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.ConfigurationDataClient");//$NON-NLS-1$
	dojo.require("dojo.i18n");//$NON-NLS-1$
	dojo.require("dojox.xml.DomParser"); //$NON-NLS-1$
	dojo.require("jazz.client.xhr"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var rootserviceURL = null;
	var CONFIGURATIONPOINT = "processConfigurationData"; //$NON-NLS-1$
	var CONFIGURATIONPOINT_CATEGORY = "processConfigurationDataCategories"; //$NON-NLS-1$
	var RESOURCE = "resource"; //$NON-NLS-1$

	com.ibm.team.process.web.ui.internal.admin.projects.ConfigurationDataClient.getConfigurationPointCategories = function(/* String */ owningApplicationKey, /* function */ successCallback, /* function */ errorCallback){
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		var fetchConfigurationPointCategoriesServiceURL = function(rootservicesXMLResponse){
			var rootservicesDocument = dojox.xml.DomParser.parse(rootservicesXMLResponse);
			var configurationPointCategoryNode = rootservicesDocument.getElementsByTagNameNS(CONFIGURATIONPOINT_CATEGORY, ProcessConstants.NAMESPACE_JP);
			var configurationPointCategoryServiceURL = configurationPointCategoryNode[0].getAttributeNS(RESOURCE, ProcessConstants.NAMESPACE_RDF);
			configurationPointCategoryServiceURL = configurationPointCategoryServiceURL + "?" + ProcessConstants.PARAM_OWNING_APP_KEY + "=" + owningApplicationKey; //$NON-NLS-1$ //$NON-NLS-2$
			var fetchConfigurationPointCategoriesXml = function(configurationPointsXMLResponse){
				if (successCallback) {
					successCallback(configurationPointsXMLResponse);
				}
			};
			_invokeService(configurationPointCategoryServiceURL, fetchConfigurationPointCategoriesXml, errorHandler);
		};
		_invokeService(ProcessConstants.ROOTSERVICESXML, fetchConfigurationPointCategoriesServiceURL, errorHandler);
	};
	
	com.ibm.team.process.web.ui.internal.admin.projects.ConfigurationDataClient.getConfigurationPoints = function(/* String */ owningApplicationKey, /* function */ successCallback, /* function */ errorCallback){
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		var fetchConfigurationPointServiceURL = function(rootservicesXMLResponse){
			var rootservicesDocument = dojox.xml.DomParser.parse(rootservicesXMLResponse);
			var configurationPointNode = rootservicesDocument.getElementsByTagNameNS(CONFIGURATIONPOINT, ProcessConstants.NAMESPACE_JP);
			var configurationPointServiceURL = configurationPointNode[0].getAttributeNS(RESOURCE, ProcessConstants.NAMESPACE_RDF);
			configurationPointServiceURL = configurationPointServiceURL + "?" + ProcessConstants.PARAM_OWNING_APP_KEY + "=" + owningApplicationKey; //$NON-NLS-1$ //$NON-NLS-2$
			var fetchConfigurationPointsXml = function(configurationPointsXMLResponse){
				if (successCallback) {
					successCallback(configurationPointsXMLResponse);
				}
			};
			_invokeService(configurationPointServiceURL, fetchConfigurationPointsXml, errorHandler);
		};
		_invokeService(ProcessConstants.ROOTSERVICESXML, fetchConfigurationPointServiceURL, errorHandler);
		
	};
	
	com.ibm.team.process.web.ui.internal.admin.projects.ConfigurationDataClient.getConfigurationPointInstances = function(successCallback, errorCallback,processElementId){
		var errorHandler = function(/* Error */error){
			if (errorCallback) {
				errorCallback(error);
			}
		};
		var fetchConfigurationPointInstanceServiceURL = function(rootservicesXMLResponse){
			var rootservicesDocument = dojox.xml.DomParser.parse(rootservicesXMLResponse);
			var configurationPointNode = rootservicesDocument.getElementsByTagNameNS(CONFIGURATIONPOINT, ProcessConstants.NAMESPACE_JP);
			var configurationPointServiceURL = configurationPointNode[0].getAttributeNS(RESOURCE, ProcessConstants.NAMESPACE_RDF);
			var fetchConfigurationPointInstancesXml = function(configurationPointInstancesXMLResponse){
				if (successCallback) {
					successCallback(configurationPointInstancesXMLResponse);
				}
			};
			_invokeService(configurationPointServiceURL + "/instances?context=" + processElementId, fetchConfigurationPointInstancesXml, errorHandler); //$NON-NLS-1$
		};
		_invokeService(ProcessConstants.ROOTSERVICESXML, fetchConfigurationPointInstanceServiceURL, errorHandler);
		
	};
	
	
	_invokeService = function(url, successCallback, errorCallback){
		var args = {
			url: url,
			headers: {
				"accept": "text/xml" //$NON-NLS-1$ //$NON-NLS-2$
			}
		};
		var deferred = jazz.client.xhrGet(args);
		
		deferred.addCallback(successCallback);
		deferred.addErrback(errorCallback);
	};
	
})();
