/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
 (function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.ConfigurationDataTree"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProcessTree"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants; 	
	var ContextCSSClass = {
		CONFIGURATIONDATA: 'configDataIcon', //$NON-NLS-1$
		CONFIGURATIONDATA_CATEGORY: 'configurationDataTypeCategoryIcon', //$NON-NLS-1$
		CONFIGURATIONDATA_TYPE: 'configurationDataTypeIcon' //$NON-NLS-1$	
	};
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.ConfigurationDataTree", [com.ibm.team.process.web.ui.internal.admin.projects.ProcessTree], { //$NON-NLS-1$
    	constructor: function(args){
    		this.showRoot = false;
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		getIconClass: function(item) {
			if(!item || !this.model.store.isItem(item)) {
				return;
			}
			if(!this.model.store.hasAttribute(item,"type")) {//$NON-NLS-1$
				return;
			}
			var itemType = this.model.store.getValue(item,"type"); //$NON-NLS-1$
			
			if(itemType === ProcessConstants.ConfigurationData.ROOT) {
				return ContextCSSClass.CONFIGURATIONDATA;
			} else 	if(itemType === ProcessConstants.ConfigurationData.CATEGORY) {
				return ContextCSSClass.CONFIGURATIONDATA_CATEGORY;
			} else if(itemType === ProcessConstants.ConfigurationData.CONFIGURATION_DATA_TYPE) {
				return ContextCSSClass.CONFIGURATIONDATA_TYPE;
			}
		},
		
		uninitialize: function() {
			if(this.model) {
				delete this.model;
			}
			this.inherited(arguments);
		}
		
    	
    });
    
    
 })();