/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.DeferredModel"); //$NON-NLS-1$
	dojo.require("dijit.Tree"); //$NON-NLS-1$
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.DeferredModel", dijit.tree.ForestStoreModel, { //$NON-NLS-1$
		getChildren: function(parentItem, successCallback, errorCallback){
			if (parentItem === this.root) {
				this.inherited(arguments);
			} else {
				var store = this.store;
				
				var childItems = [];
				for (var i = 0; i < this.childrenAttrs.length; i++) {
					var vals = store.getValues(parentItem, this.childrenAttrs[i]);
					childItems = childItems.concat(vals);
				}
				
				var _waitCount = 0;
				dojo.forEach(childItems, function(item){
					if (!store.isItemLoaded(item)) {
						_waitCount++;
					}
				});
				
				if (_waitCount === 0) {
					successCallback(childItems);
				} else {
					var self = this;
					var onItem = function onItem(item){
						if (--_waitCount === 0) {
							// we will have added/updated children based on the
							// resolution of the service provider catalog so
							// update the collection of children to reflect the
							// curent fetched set within the store
							childItems = [];
							for (i = 0; i < self.childrenAttrs.length; i++) {
								vals = store.getValues(parentItem, self.childrenAttrs[i]);
								childItems = childItems.concat(vals);
							}
							// all nodes have been loaded, send them to the tree
							successCallback(childItems);
						}
					};
					dojo.forEach(childItems, function(item){
						if (!store.isItemLoaded(item)) {
							store.loadItem({
								item: item,
								onItem: onItem,
								onError: errorCallback
							});
						}
					});
				}
			}
		}
	});
})();
