/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.ManageProjectAreas"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.projectarea"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.StyledTableItemList"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.TRToolbar"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper"); //$NON-NLS-1$
	dojo.require("jazz.ui.ResourceLink");//$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("jazz.ui.SearchBox"); //$NON-NLS-1$
	dojo.require("jazz.ui.PaginationControl"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var ResourceLink = jazz.ui.ResourceLink;
	var MessageBox = jazz.ui.MessageBox;
	var STATUS_TYPES = MessageBox.STATUS_TYPES;
	var PAGE_SIZE = 25;
	var UIHelper = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;
	
	function setText(e, text){
		e.appendChild(document.createTextNode(text));
	}
	
	var PROJECT_ACTION = "com.ibm.team.process.editProjectArea"; //$NON-NLS-1$
	var PROJECT_ACTION_PREFIX = PROJECT_ACTION + "&itemId="; //$NON-NLS-1$
	var CONTRIBUTORS_IN_PROJECT_ACTION = "#action=com.ibm.team.process.usersInProjectArea&projectAreaItemId="; //$NON-NLS-1$
	var HIDDEN_CLASS_NAME = "hiddenLpaArea"; //$NON-NLS-1$
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.ManageProjectAreas", com.ibm.team.process.web.ui.internal.StyledTableItemList, { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/templates/ManageProjectAreas.html"), //$NON-NLS-1$ //$NON-NLS-2$
		constructor: function(args){
			this._owningApplicationKey = args.owningApplicationKey;
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this._collapsedIconSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/grey-twistie-closed.png").toString(); //$NON-NLS-1$ //$NON-NLS-2$
			this._expandedIconSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/grey-twistie-open.png").toString(); //$NON-NLS-1$ //$NON-NLS-2$
			this._resourceLinks = [];
		},
		
		postCreate: function(){
			this.header = new MessageBox();
			this.messageArea.appendChild(this.header.domNode);
			this._actionToolbars = [];
			var hash = window.location.hash.toLowerCase();
			var index = hash.indexOf("find251users=true"); //$NON-NLS-1$
			if (index > -1) {
				this.findUsers = true;
			}
			setText(this.heading, this.messages.ManageProjectAreas_1);
			
			dojo.addClass(this.tableContents, ProcessConstants.CSSClass.TOOLBAR_TABLE);
			var columns = [];
			columns.push({
				label: this.messages.ManageProjectAreas_3,
				width: "30%", //$NON-NLS-1$
				sortable: false
			});
			columns.push({
				label: this.messages.ManageProjectAreas_4,
				sortable: false
			});
			columns.push({
				label: this.messages.ManageProjectAreas_ActionsColumnHeader,
				className: ProcessConstants.CSSClass.ACTION_COLUMN,
				sortable: false
			});
			
			this.createTable({
				columns: columns
			});
			this._createNewLink = this.addLink("#action=" + PROJECT_ACTION_PREFIX + "new", this.messages.ManageProjectAreas_5, "com.ibm.team.process.web/ui/internal/admin/projects/images/new-project_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			this._createSearchBox();
			this._createPager();
			this.connect(this.lpaDescriptionCollapseButton, "onclick", this._onLpaDescripctionCollapseButtonClick); //$NON-NLS-1$
			this.connect(this.lpaHeaderText, "onclick", this._onLpaDescripctionCollapseButtonClick); //$NON-NLS-1$
			this.connect(this.lpaHeaderText, "onmouseover", function(e) { //$NON-NLS-1$
				dojo.toggleClass(e.target, "hover", true); //$NON-NLS-1$
			}); 
			this.connect(this.lpaHeaderText, "onmouseout", function(e) {  //$NON-NLS-1$
				dojo.toggleClass(e.target, "hover", false); //$NON-NLS-1$
			});
			
			var srh = new ServiceResponseHandler(this, "_handleLpaResponse", "_nullErrorHandler"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.getLPACreateProjectAreaUrl(srh);

			this.refresh();
		},
		
		refresh: function(){
			this._pageNum = 0;
			this._indicateLoading();
			var srh = new ServiceResponseHandler(this, "showProjects", "handleError"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.getProjectAreasPaged(srh, {
				hideArchivedProjects: true,
				owningApplicationKey: this._owningApplicationKey,
				pageNum: 0,
				pageSize: PAGE_SIZE
			});
		},
		
		_indicateLoading: function(){
			this._createNewLink.setDisabled(true);
			this._pager.setEnabled(false);
			this.clearState();
			var tr = document.createElement("tr"); //$NON-NLS-1$
			var td = document.createElement("td"); //$NON-NLS-1$
			td.colSpan = 2;
			td.appendChild(document.createTextNode(this.messages.ManageProjectAreas_6));
			tr.appendChild(td);
			this.tbody.appendChild(tr);
			
		},
		
		clearState: function(){
			dojox.xml.parser.removeChildren(this.tbody);
			this.header.hideMessage();
			this._destroyActionToolbars();
			this._destroyResourceLinks();
			this._searchBox.clear();
		},
		
		_getProjectsUsingSearchFilter: function(searchFilter){
			this._indicateLoading();
			var params = {
				hideArchivedProjects: true,
				owningApplicationKey: this._owningApplicationKey,
				pageNum: this._pageNum,
				pageSize: PAGE_SIZE
			}
			if (searchFilter) {
				searchFilter = searchFilter.replace(/\*/g, "%"); //$NON-NLS-1$
				params.nameFilter = searchFilter;
			}
			var srh = new ServiceResponseHandler(this, "showProjects", "handleError"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.getProjectAreasPaged(srh, params);
		},
		
		showProjects: function(data){
			UIHelper.runSafe(dojo.hitch(this, function(){
				dojox.xml.parser.removeChildren(this.tbody);
				if (data && data.count > 0) {
					var sortedData = data.elements;
					for (var i = 0; i < sortedData.length; i++) {
						var actionHref = PROJECT_ACTION_PREFIX + sortedData[i].itemId;
						var descNode = this._createDescriptionNode(sortedData[i].summary, sortedData[i].description);
						var trToolbar = new com.ibm.team.process.web.ui.internal.TRToolbar();
						this._actionToolbars.push(trToolbar);
						
						var initializeAction = {};
						initializeAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/projectarea_initialization.gif"); //$NON-NLS-1$ //$NON-NLS-2$
						initializeAction.label = this.messages.ManageProjectAreas_18;
						initializeAction.callbackData = {
							itemId: sortedData[i].itemId
						};
						var callback = function(e){ //$NON-NLS-1$
							dojo.stopEvent(e);
							this._initializeProjectArea(e.currentTarget.callbackData.itemId);
						};
						var initializationButton = trToolbar.addButton(this, callback, initializeAction);
						if (sortedData[i].initialized) {
							trToolbar.disableButton(initializationButton);
						}
						
						
						var archiveAction = {};
						archiveAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/archive_hov.gif"); //$NON-NLS-1$ //$NON-NLS-2$
						archiveAction.label = this.messages.ManageProjectAreas_7;
						archiveAction.callbackData = {
							itemId: sortedData[i].itemId,
							name: sortedData[i].name
						};
						callback = function(e){ //$NON-NLS-1$
							dojo.stopEvent(e);
							if (confirm(dojo.string.substitute(this.messages.ManageProjectAreas_8, [e.currentTarget.callbackData.name]))) {
								this.archiveProject(e.currentTarget.callbackData);
							}
						};
						trToolbar.addButton(this, callback, archiveAction);
						var row = this.addRow(actionHref, [sortedData[i].name, descNode, trToolbar.domNode]);
						
						var query = "a[href*='" + PROJECT_ACTION + "']";//$NON-NLS-1$ //$NON-NLS-2$
						var link = dojo.query(query, row)[0];
						var presentationUri = link.href;
						link.href = this.getProjectAreaUrl(sortedData[i].itemId);
						this._resourceLinks.push(new ResourceLink({
							'presentationUri': presentationUri, //$NON-NLS-1$
							'lazyFetch': true //$NON-NLS-1$ 
						}, link));
						
						if (this.findUsers) {
							this._addFindUsersButton(trToolbar, sortedData[i], "users-in-project", this.messages.ManageProjectAreas_13, false); //$NON-NLS-1$
							this._addFindUsersButton(trToolbar, sortedData[i], "users-not-in-project", this.messages.ManageProjectAreas_14, true); //$NON-NLS-1$
						}
					}
					this._pager.setStartPage(this._pageNum);
					this._pager.setTotal(data.count);
				} else {
					if (!this._projectAreaArchiving) {
						this.header.showMessage({
							type: STATUS_TYPES.INFO,
							summary: this.messages.ManageProjectAreas_9
						});
					}
					this._pager.setStartPage(0);
					this._pager.setTotal(0);
				}
				if (this._projectAreaArchiving) {
					delete this._projectAreaArchiving;
				}
				this._createNewLink.setDisabled(false);
				this._pager.setEnabled(true);
			}));
			
		},
		
		handleError: function(errorObj){
			this.inherited(arguments);
			this._createNewLink.setDisabled(false);
			this._pager.setEnabled(true);
		},
		
		
		getProjectAreaUrl: function(projectAreaItemId){
			var location = document.location.href;
			var path = location.split("/"); //$NON-NLS-1$
			var serverAddress;
			if (path.length > 0) {
				serverAddress = path.shift() + "//";//$NON-NLS-1$
				path.shift(); //empty from the double //
				serverAddress = serverAddress + path.shift();
			}
			return serverAddress + net.jazz.ajax._contextRoot + "/process/project-areas/" + projectAreaItemId; //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		_createDescriptionNode: function(summary, description){
			if (dojo.isIE && summary !== undefined && summary.length === 0 &&
			description !== undefined &&
			description.length === 0) {
				// IE needs a space or it won't paint the TD
				summary = " "; //$NON-NLS-1$
			}
			var descNode = document.createElement("div"); //$NON-NLS-1$
			descNode.appendChild(document.createTextNode(summary));
			if (description) {
				if (summary) {
					descNode.appendChild(document.createElement("br")); //$NON-NLS-1$
					descNode.appendChild(document.createElement("br")); //$NON-NLS-1$
				}
				descNode.appendChild(document.createTextNode(description));
			}
			return descNode;
		},
		
		_addFindUsersButton: function(toolbar, projectArea, imageName, label, notInProject){
		
			var action = {};
			var imagePath = "ui/internal/admin/projects/images/" + imageName + ".gif"; //$NON-NLS-1$ //$NON-NLS-2$
			action.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", imagePath); //$NON-NLS-1$ 
			action.label = label;
			action.callbackData = {
				actionHref: CONTRIBUTORS_IN_PROJECT_ACTION + projectArea.itemId + "&projectAreaName=" + projectArea.name + "&notInProject=" + notInProject //$NON-NLS-1$ //$NON-NLS-2$
			};
			var callback = function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				window.location.hash = e.currentTarget.callbackData.actionHref;
			};
			toolbar.addButton(this, callback, action);
		},
		
		archiveProject: function(projectArea){
			if (!this._projectAreaArchiving) {
				this._projectAreaArchiving = projectArea;
				this._disableToolbars(true);
				var srh = new ServiceResponseHandler(this, "archiveCallback", "archiveErrorCallback"); //$NON-NLS-1$ //$NON-NLS-2$
				this.header.showMessage({
					type: STATUS_TYPES.INFO,
					summary: this.messages.ManageProjectAreas_10
				});
				
				ProcessClient.postArchiveProcessItem({
					uuid: projectArea.itemId,
					itemType: ProcessConstants.ITEM_TYPE.PROJECT_AREA
				}, srh);
			}
		},
		
		archiveCallback: function(){
			dojo.publish(ProcessConstants.ProjectSelectorContext.DELETE, [this._projectAreaArchiving.name]);
			UIHelper.runSafe(dojo.hitch(this, function(){
				this.refresh();
				this.header.showMessage({
					summary: this.messages.ManageProjectAreas_11,
					type: STATUS_TYPES.OK,
					closable: true
				});
			}));
		},
		
		archiveErrorCallback: function(err){
			delete this._projectAreaArchiving;
			this._disableToolbars(false);
			var summary = dojo.string.substitute(this.messages.ManageProjectAreas_12, [err.message]);
			this.header.showMessage({
				summary: summary,
				errorObject: err
			});
		},
		
		_initializeProjectArea: function(itemId){
			this._disableToolbars(true);
			var srh = new ServiceResponseHandler(this, "_handleInitializeProjectAreaSuccess", "_handleInitializeProjectAreaError"); //$NON-NLS-1$ //$NON-NLS-2$
			this.header.showMessage({
				type: STATUS_TYPES.INFO,
				summary: this.messages.ManageProjectAreas_15
			});
			
			ProcessClient.postInitializeProjectArea({
				uuid: itemId
			}, srh);
		},
		
		_handleInitializeProjectAreaSuccess: function(){
			this.refresh();
			this.header.showMessage({
				summary: this.messages.ManageProjectAreas_16,
				type: STATUS_TYPES.OK,
				closable: true
			});
		},
		
		_handleInitializeProjectAreaError: function(err){
			this._disableToolbars(false);
			var summary = dojo.string.substitute(this.messages.ManageProjectAreas_17, [err.message]);
			this.header.showMessage({
				summary: summary,
				errorObject: err
			});
		},
		
		_createPager: function(){
			this._pager = new jazz.ui.PaginationControl({
				total: 0,
				increment: PAGE_SIZE,
				onNextClick: dojo.hitch(this, function(pager, start, end){ //$NON-NLS-1$
					this._pageNum++;
					this._getProjectsUsingSearchFilter(this._searchBox.getCurrentQuery());
				}),
				onPreviousClick: dojo.hitch(this, function(e){ //$NON-NLS-1$
					this._pageNum--;
					this._getProjectsUsingSearchFilter(this._searchBox.getCurrentQuery());
				}),
				setStartPage: function(startPage){
					this.startPage = startPage;
				}
			});
			
			this.tableControls.appendChild(this._pager.domNode);
		},
		
		_createSearchBox: function(){
		
			this._searchBox = new jazz.ui.SearchBox({
				scopes: [{
					id: "projectAreas", //$NON-NLS-1$
					label: this.messages.ManageProjectAreas_1,
					icon: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/projectAreaIcon.png") //$NON-NLS-1$ //$NON-NLS-2$
				}],
				onExecute: dojo.hitch(this, function(searchFilter){
					this._pageNum = 0;
					this._getProjectsUsingSearchFilter(searchFilter)
				}),
				clear: function(){
					this._setScope({
						scope: this.scopes[0],
						focusText: false
					});
				},
				onUpdate: dojo.hitch(this, function(){
					this._pageNum = 0;
				}),
				getCurrentQuery: function(){
					return this._currentQuery;
				}
			});
			this.tableControls.appendChild(this._searchBox.domNode);
			
		},
		
		_disableToolbars: function(disabled){
			for (var i = 0; i < this._actionToolbars.length; i++) {
				this._actionToolbars[i].disableToolbar(disabled);
			}
		},
		
		_handleLpaResponse: function(lpaUrl) {
			UIHelper.runSafe(dojo.hitch(this, function() {
				this._populateDescription(lpaUrl);
				this._populateLpaLink(lpaUrl);
			}));
		},
		
		_populateDescription: function(lpaUrl){
            setText(this.description, this.messages.ManageProjectAreas_2);
            
            if (lpaUrl) {
            	dojo.removeClass(this.extraDescriptionArea, HIDDEN_CLASS_NAME);
            	this.lpaExplanation.innerHTML = dojo.string.substitute(this.messages.ManageProjectAreas_LPAExplanation, [lpaUrl, ProcessConstants.PROJECT_AREA_HELP_URL, ProcessConstants.LPA_HELP_URL]);
            }
		},
		
		//create a new link for the lifecycle project creation and
		//place it after the create new project link 
		_populateLpaLink: function(lpaUrl){
			if (lpaUrl) {
				var lpaLink = this.addLink(lpaUrl, this.messages.ManageProjectAreas_CreateLifecycleProject, "com.ibm.team.process.web/ui/internal/admin/projects/images/create-lpa_obj.png") //$NON-NLS-1$
                var launchImg = dojo.create("img", {  //$NON-NLS-1$
                	src: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/launch_obj.gif").toString()  //$NON-NLS-1$ //$NON-NLS-2$
                }, lpaLink.focusNode);
				dojo.addClass(launchImg, "trailingImage");  //$NON-NLS-1$
			}
		},
		
		_createSeparator: function() {
				var separator = document.createElement("span"); //$NON-NLS-1$
				dojo.addClass(separator, "verticalBar"); //$NON-NLS-1$
				// IE 7 won't show the separator if it's empty
				separator.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
				return separator;
		},
		
		//error handler that just writes error to console
		_nullErrorHandler: function(err){
			console.warn("[ManageProjectAreas] ", dojo.toJson(err));//$NON-NLS-1$
		},
		
		//shows the lpaExplanation; this method should only be called
		//after populateDescription has been called.
		_onLpaDescripctionCollapseButtonClick: function(e){
			dojo.stopEvent(e);
			if (dojo.hasClass(this.lpaExplanationDiv, HIDDEN_CLASS_NAME)) { 
				this.lpaCollapseImage.src = this._expandedIconSrc;
			} else {
				this.lpaCollapseImage.src = this._collapsedIconSrc;
			}
			dojo.toggleClass(this.lpaExplanationDiv, HIDDEN_CLASS_NAME); 
		},
		
		_destroyActionToolbars: function(){
			for (var i = 0; i < this._actionToolbars.length; i++) {
				this._actionToolbars[i].destroyRecursive();
			}
			this._actionToolbars = [];
		},
		
		_destroyResourceLinks: function(){
			for (var i = 0; i < this._resourceLinks.length; i++) {
				this._resourceLinks[i].destroyRecursive();
			}
			this._resourceLinks = [];
		},
		
		uninitialize: function(){
			this._destroyActionToolbars();
			this._destroyResourceLinks();
			this.header.destroyRecursive();
			this._searchBox.destroyRecursive();
			this._pager.destroyRecursive();
			
			this.inherited(arguments);
			
		}
	});
	
})();
