/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.ProcessTree"); //$NON-NLS-1$
	dojo.require("dijit.Tree"); //$NON-NLS-1$
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.ProcessTree", [dijit.Tree], { //$NON-NLS-1$
	
		disabled : false,
		
		// summary:
		//		Tree widget for Process component
		// description:
		//		Provides methods for inheriting classes to add follow-up actions 
		//		to various functions in dijit's Tree widget. 
		
		postCreate: function(){
			this.inherited(arguments);
			this.connect(this, "focusNode", "focusChanged"); //$NON-NLS-1$  //$NON-NLS-2$
			this.connect(this, "_onEnterKey", "enterKeyChanged"); //$NON-NLS-1$  //$NON-NLS-2$
			this.connect(this, "_onClick", "onClicked"); //$NON-NLS-1$  //$NON-NLS-2$
		},
		
		///////////////////////////////////////////////////////
		// Overridable function to add follow-up actions to dijit.Tree functions  
		focusChanged: function(/* _tree.Node */node){
			// Should be overriden to add follow-up action to Tree's 'focusNode' 
			// action
		},
		
		enterKeyChanged: function(/*Object*/message, /*Event*/ evt){
			// Should be overriden to add follow-up action to Tree's 
			// '_onEnterKey' action 
		},
		
		onClicked: function(/*TreeNode*/nodeWidget, /*Event*/ e){
			// Should be overriden to add follow-up action to Tree's '_onClick'
			// action
		},	
		
		setDisabled: function(/*Boolean*/disabled) {
			this.disabled = disabled;
		},
		
		// Workitem 110559...need to override the tree.js private method so 
		// that disable support can be added
		_onKeyPress: function(/*Event*/ e){
			if (!this.disabled) {
				this.inherited(arguments);
			} else {
				dojo.stopEvent(e)
			}
		}
			
	});
	
})();
