/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.TeamHierarchyElementToolbar"); //$NON-NLS-1$
dojo.require("jazz.ui.SimpleToolbar"); //$NON-NLS-1$
(function(){

	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.TeamHierarchyElementToolbar", jazz.ui.SimpleToolbar, { //$NON-NLS-1$
		addButton: function(context, callback, args){
			var button = this.inherited(arguments);
			button.domNode.callbackData = args.callbackData;
			
			this.connect(button.domNode, "onfocus", function(e){ //$NON-NLS-1$
				var element = e.target;
				while (element && !dojo.hasClass(element, "hierarchyElement")) { //$NON-NLS-1$ //$NON-NLS-2$
					element = element.parentNode;
				}
				if (element) {
					dojo.toggleClass(element, "selected", true); //$NON-NLS-1$
				}
			});
			this.connect(button.domNode, "onblur", function(e){ //$NON-NLS-1$
				var element = e.target;
				while (element && !dojo.hasClass(element, "hierarchyElement")) { //$NON-NLS-1$ //$NON-NLS-2$
					element = element.parentNode;
				}
				if (element) {
					dojo.toggleClass(element, "selected", false); //$NON-NLS-1$
				}
			});
			
			return button;
		},
		
		/**
		 * Disables all buttons on the toolbar 
		 * 
		 * @param {boolean} disabled - true if the toolbar should be disabled
		 */
		disableToolbar: function(disabled) {
			if (disabled === true) {
				dojo.toggleClass(this.domNode, "toolbar-disabled", true); //$NON-NLS-1$
			} else {
				dojo.toggleClass(this.domNode, "toolbar-disabled", false); //$NON-NLS-1$
			}
		}
	});
})();
