/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.ConfigHelper");
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    dojo.require("com.ibm.team.repository.web.client.internal.ServerStatusClient");
    
    var SRH = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var ServerStatusClient = com.ibm.team.repository.web.client.internal.ServerStatusClient;
    
    dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.ConfigHelper", null, {		
        implClass: null,
        constructor: function(args){
		  this.implClass = args.implClass;
		  this.handleServiceError = args.handleServiceError;
		  this.parent = args.parent;
          this._loadProps();
        },
        
        
        _loadProps: function(){
            if (this.implClass) {
                var srh = new SRH(this, "_handleServiceProps", "_handleServiceError");
                ServerStatusClient.getServiceConfiguration(srh, this.implClass);
            }
        },
        
        _handleServiceError: function(errObj){
            if (this.handleServiceError && this.parent) 
                this.parent[this.handleServiceError](errObj);
        },
        
        _handleServiceProps: function(serviceInfo){
            this.serviceInfo = serviceInfo;
        },
		
		getPropertyValue : function(propName){
		  if (this.serviceInfo) {
		  	for (var i = 0; i < this.serviceInfo.properties.length; i++) {
		  		if (this.serviceInfo.properties[i].name == propName) {
		  			return this.serviceInfo.properties[i].overrideValue;
		  		}
		  	}
		  }
		  return null;
		}
        
        
    });
    
})();
