/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.ExtensionsHelper");
dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.LicenseTokenServiceConfigExtension");
var Extension = com.ibm.team.repository.web.ui.internal.admin.server.LicenseTokenServiceConfigExtension;
var RegistryFactory = jazz.core.RegistryFactory;

com.ibm.team.repository.web.ui.internal.admin.server.ExtensionsHelper = {

    // Internal
    loadExtensions: function(extPoint, elemName){
        var extensions = null;
        if (extPoint) {
            var registry = RegistryFactory.getRegistry();
            var matchingElements = [];
            if (registry) {
                var extensionsPoints = registry.getExtensionPoint(extPoint);
                if (extensionsPoints) {
                    var extensions = extensionsPoints.getExtensions();
                    if ((extensions instanceof Array)) {
                        for (var index = 0; index < extensions.length; index++) {
                            var elements = extensions[index].getConfigurationElements();
                            if ((elements instanceof Array === false) ||
                            (elements.length === 0)) {
                                continue;
                            }
                            for (var i = 0; i < elements.length; i++) {
                                var element = elements[i];
                                if (element.getName() !== elemName) {
                                    continue;
                                }
                                matchingElements.push(elements[i])
                            }
                        }
                        
                        
                        
                    }
                }
            }
            
        }
        return matchingElements;
    },
    
	getLicenseTokenProviders : function(){
		if (!this.tokenProviders) {
			this.tokenProviders = [];
			var elements = this.loadExtensions("com.ibm.team.repository.web.licenseTokenServiceConfig", "licenseTokenServiceConfig");
			for (var i = 0; i < elements.length;i++)
			{
				this.tokenProviders.push(new Extension({
					element: elements[i]
				},null));
			}
		}
		return this.tokenProviders;
		
	}   
}

