/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.PropertiesWizard");
dojo.require("com.ibm.team.repository.web.ui.wizard.WizardConfigurationStep");
dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "ConfigurePageMessages");
dojo.require("dojo.i18n");


var PropertiesConfigStep = com.ibm.team.repository.web.ui.internal.admin.server.PropertiesConfigStep;
var WizardConfigurationStep = com.ibm.team.repository.web.ui.wizard.WizardConfigurationStep;
(function(){
    dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.PropertiesWizard", null, {
        implClass: "",
        serviceName: "",
		configSaveCallback: null,
        propConfigStep: null,
        constructor: function(args){
            this.messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "ConfigurePageMessages");
            this.implClass = args.implClass;
            this.serviceName = args.serviceName;
			this.propConfigStep = args.propConfigStep;
			this.configSaveCallback = args.configSaveCallback;
            this.showWizard();
        },
        
        
        showWizard: function(){
            if (!this.propConfigStep && this.implClass) {
                var self = this;
                var propConfigArgs = {
                    stepTitle: dojo.string.substitute(this.messages.editPropertiesHeader, [this.serviceName]),
                    parentPointer: this,
                    description: "",
                    implementationClassName: this.implClass,
                    showTestButton: false,
                    enableNext: true,
                    innerArgs: {
                        headingLabel: "",
                        heading: ""
                    },
                    extraServiceConfigArgs: {
                        forceSimple: true
                    },
                    canFinish: function(){
                        return this._config._changed;
                    },
                    
                    _showConnectionStatus: function(type, summary, details){
                        // Do nothing
                    },
                    
                    cancelRequested: function(){
                        var verifyCancel = self.propConfigStep._config._changed ? confirm(self.messages.dirtyCancelWarn) : true;
                        if (verifyCancel) {
                            self.wizard.close();
                        }
                    }
                }
                this.propConfigStep = new WizardConfigurationStep(propConfigArgs);
            }
            
            if (this.propConfigStep) {
                var self = this;
                var wizardArgs = {
                    steps: [this.propConfigStep],
                    width: "870px",
                    primaryTitle: this.messages.editPropertiesTitle,
                    showStepSummary: false,
                    processFinish: function(){                      
						this._steps[0].invokeSave(self, "onSaveSuccess", "onSaveFailure");					
                    },
                    processCancel: function(){
                        self.propConfigStep.cancelRequested();
                    },
					configSaveCallback: this.configSaveCallback
                };
                this.wizard = new jazz.ui.Wizard(wizardArgs);
            }
        },
        
		onSaveSuccess : function(){
			if (this.configSaveCallback)
			  this.configSaveCallback();
			this.wizard.close();
		},
		
		onSaveFailure : function(){
			
		},
		
		close: function(){
			this.wizard.close();
		}
        
    });
})()
