/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.ServerPropertyServiceRow");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "ServerPropertyMessages");

(function() {

dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.ServerPropertyServiceRow", [dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/admin/server/templates/ServerPropertyServiceRow.html"),
	
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "ServerPropertyMessages");
	},
	
	postCreate: function() {
		com.ibm.team.repository.web.ui.internal.admin.server.ServerPropertyServiceRow.superclass.postCreate.apply(this);
		if (this._enableToggle) {
			this.domNode.title = this.messages.clickToEdit;
		}
		if (this.rowClass) {
			for (var i=0; i < this.rowClass.length; i++) {
				dojo.toggleClass(this._propertiesRow, this.rowClass[i], true);
			}
		}
		if (this._descriptionMode == "table") {
			this._descriptionHeader.style.display = "";
			this._longPropertiesValueHeader.colSpan = 3;
		}
		else {
			this._longPropertiesValueHeader.colSpan = 2;
		}
	}

});

})();