/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.schema.AdminHome");

dojo.require("jazz.ensemble.internal.util.XmlBindingFactory");
dojo.require("jazz.ensemble.internal.util.Xml");

(function() {
	
var XmlBindingFactory = jazz.ensemble.internal.util.XmlBindingFactory;
var namespace = jazz.ensemble.internal.util.Xml.namespace;

com.ibm.team.repository.web.ui.internal.admin.server.schema.AdminHome = {
	
	discovery: [{
		property:       "AdminHome",
		type:     		XmlBindingFactory.OBJECT,
		nodeType: 		XmlBindingFactory.CHILD_ELEMENT,
		elemName: 		"AdminHome",
		elemNS:   		namespace.jfs,
		multiValued: 	true,
		schema:
			[ {
				property: 		"service",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
				elemNS:			namespace.jd,
				elemName:		"service",
				attrNS: 		namespace.rdf,
				attrName: 		"resource"
			},{
				property: 		"contextRoot",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_TEXT,
				elemNS:			namespace.jd,
				elemName:		"contextRoot"
			},{	
			    property: 		"publisher",
				type: 			XmlBindingFactory.STRING,
				nodeType: 		XmlBindingFactory.CHILD_ELEMENT_TEXT,
				elemNS:			namespace.dublin,
				elemName:		"publisher"
			},{
				property:		"applicationAbout",
				type:			XmlBindingFactory.STRING,
				nodeType:		XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
				elemNS:			namespace.oslc,
				elemName:		"publisher",
				attrNS:			namespace.rdf,
				attrName:		"resource"
			}		
			]
		}],

	adminHomeService: [{
		property:   "AdminHomeEntries",
		type:       XmlBindingFactory.OBJECT,
		nodeType:   XmlBindingFactory.CHILD_ELEMENT,
		multiValued:false,
		elemNS:     namespace.jfs,
		elemName:   "AdminHomeEntries",
		schema: [{
			property:   "entries",
			type:       XmlBindingFactory.OBJECT,
			nodeType:   XmlBindingFactory.CHILD_ELEMENT,
			multiValued:true,
			elemNS:     namespace.jfs,
			elemName:   "entry",
			schema: [{
				property:  "title",
				type:      XmlBindingFactory.STRING,
				nodeType:  XmlBindingFactory.CHILD_ELEMENT_TEXT,
				elemNS:    namespace.dublin,
				elemName:  "title"
				},{	
				property:  "description",
				type:      XmlBindingFactory.STRING,
				nodeType:  XmlBindingFactory.CHILD_ELEMENT_TEXT,
				elemNS:    namespace.dublin,
				elemName:  "description"
				},{				
				property:   "href",
				type:       XmlBindingFactory.STRING,
				nodeType:   XmlBindingFactory.CHILD_ELEMENT_ATTRIBUTE,
				elemNS:     namespace.jfs,
				elemName:   "href",
				attrNS:     namespace.rdf,
				attrName:   "resource"
			}]
		}]
	}]
}

})();
