/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.users.GroupEditorContainer");

/*
 * Imports 
 */
dojo.require("dojo.i18n"); 

dojo.require("com.ibm.team.repository.web.ui.internal.admin.users.GroupEditor");


(function() {

/*
 * Aliases 
 */
var GroupEditor = com.ibm.team.repository.web.ui.internal.admin.users.GroupEditor;
var Breadcrumbs = jazz.ui.Breadcrumbs;

/*
 * Class 
 */
dojo.declare("com.ibm.team.repository.web.ui.internal.admin.users.GroupEditorContainer",
	[dijit._Widget, dijit._Templated], {

	// Properties //----------------------------------------------------------->

	editor: null,
	itemId: null,
	
	/*
	 * Templates
	 */	
	templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/admin/users/templates/GroupEditorContainer.html"),
	
	/*
	 * Static Variable Container
	 */
	_static: function() {}, 
		
	
	// Public Methods //------------------------------------------------------->

	/*
 	 * @param Object args
 	 * 
 	 * @return void
 	 */
	constructor: function(args) {
	},
	
	/*
 	 * @param void
 	 * 
 	 * @return void
 	 * @overrides super
 	 */	
	postCreate: function() {
		this.inherited(arguments);
		
		this._initializeStaticVariables();
		this._initializeEditor();
	},

	/*
 	 * @param void
 	 * 
 	 * @return void
 	 * @overrides super
 	 */		
	destroy: function() {
		
		if (this.editor) {
			this.editor.destroy();
			delete this.editor;
		}

		if (this.itemId) {
			delete this.itemId;
		}
		
		this.inherited(arguments);
	},

	// Private Methods //------------------------------------------------------>
	
	/*
 	 * @param void
 	 * 
 	 * @return void
 	 */		
	_initializeStaticVariables: function() {

		if (this._static._instanceCount) {
			this._static._instanceCount++;
			return;
		}

		this._static._instanceCount = 1;

	},	
	
	/*
 	 * @param void
 	 * 
 	 * @return void
 	 */		
	_initializeEditor: function() {
		this.editor = new GroupEditor({
			itemId: this.itemId,
			container: this
		});
		this._editorContentSite.appendChild(this.editor.domNode);
	}	
	
});

})();
