/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function() {
	
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.users.UserHelper");

// UserHelper provides non-UI support for shared methods throughout the User pages
dojo.declare("com.ibm.team.repository.web.ui.internal.admin.users.UserHelper", dijit._Widget, {
	
	constructor: function(args) {
		this.messages = args.messages;
	},
	
	postCreate: function() {
		//silence...for now
	},
	
	createPagerDiv: function () {
		pagerDiv = dojo.create("div", { className: "pager"});
		var prevSpan = dojo.create("span", {}, pagerDiv);
		var prevLink = dojo.create("a", { innerHTML: this.messages.previous }, prevSpan);
		var disabledPrev = dojo.create("span", { innerHTML: this.messages.previous, className: "disabledText" }, prevSpan);
		pagerDiv.prevSpan = prevSpan;
		pagerDiv.prevLink = prevLink;
		pagerDiv.appendChild(document.createTextNode(" | "));
		var rangeSpan = dojo.create("span", { className: "bold" }, pagerDiv);
		pagerDiv.rangeSpan = rangeSpan;
		pagerDiv.appendChild(document.createTextNode(" " + this.messages.of + " "));
		var totalSpan = dojo.create("span", { className: "bold" }, pagerDiv);
		pagerDiv.totalSpan = totalSpan;
		pagerDiv.appendChild(document.createTextNode(" | "));
		var nextSpan = dojo.create("span", {}, pagerDiv);
		var nextLink = dojo.create("a", { innerHTML: this.messages.next }, nextSpan);
		var disabledNext = dojo.create("span", { innerHTML: this.messages.next, className: "disabledText" }, nextSpan);
		pagerDiv.nextSpan = nextSpan;
		pagerDiv.nextLink = nextLink;
		this.connect(prevLink,"onclick",function (e) {
			dojo.stopEvent(e);
			document.location.href = e.target.href;
		});
		this.connect(nextLink,"onclick",function (e) {
			dojo.stopEvent(e);
			document.location.href = e.target.href;
		});	
		return pagerDiv;
	},
	
		
	buildTableControls: function(container) {
		var table = dojo.create("table", { className: "tableControls"}, container);
		var tbody = dojo.create("tbody", {}, table);
		var row = dojo.create("tr", {}, tbody);
		var controls = new Array();
		controls["col1"] = dojo.create("td", { style: { textAlign: "left", width: "33%" }}, row);
		controls["col2"] = dojo.create("td", { style: { textAlign: "center", width: "33%" }}, row);
		controls["col3"] = dojo.create("td", { style: { textAlign: "right", width: "33%" }}, row);
		return controls;
	},
	
	buildFilterBox: function(container, placeholderText, titleText, action) {
		var searchText = dojo.create("input", { type: "text", title: titleText }, container);
		if('placeholder' in searchText) {
			searchText.placeholder = placeholderText;
		} else {
			//Browser doesn't support HTML5 placeholder
			dojo.addClass(searchText, "faded");
			searchText.value = placeholderText;
			this.connect(searchText,"onfocus",function (e) {
				searchText.value = "";
				dojo.removeClass(searchText, "faded");
			});
			this.connect(searchText,"onblur",function (e) {
				if(searchText.value == "") {
					dojo.addClass(searchText, "faded");
					searchText.value = placeholderText;
				} 
			});
		}
		this.connect(searchText,"onkeypress",function (e) {
			if (e.keyCode == 13) {
				document.location.href = "#" + action + "&searchTerm=" + encodeURIComponent(searchText.value);
			}
		});
		//Returns a handle to the search node
		return searchText;
	}
	


});


})();