/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.common.StyledTable"); //$NON-NLS-1$
dojo.require("jazz.ui.StyledTable"); //$NON-NLS-1$
(function(){
    function getRow(evt){
        var e = evt.target;
        while (e.parentNode) {
            if (e.tagName === "TR") {
                return e;
            }
            e = e.parentNode;
        }
        return null;
    }
    dojo.declare("com.ibm.team.repository.web.ui.internal.common.StyledTable", jazz.ui.StyledTable, { //$NON-NLS-1$
    	/*
    	 * Extends the base StyledTable class and adds support for selecting rows 
    	 */
		hightlight : false,
				
        postCreate: function(){
            this.inherited(arguments);
			dojo.addClass(this.domNode , "com-ibm-team-repository-styled-table");
			if (this.highlight)
				dojo.addClass(this.tbody , "highlight");
     		this.connect(this.tbody, "onmouseover", "_handleMouseOver");
			this.connect(this.tbody, "onmouseout", "_handleMouseOut");       
        },
		
		_handleMouseOver: function(e){
            //ensure that no other rows are "selected" because of keyboard focus
            var rows = this.tbody.rows;
            var i;
            for (i = 0; i < rows.length; i++) {
                dojo.toggleClass(rows.item(i), "selected", false);
            }
            
            //highlight the current row
            var row = getRow(e);
            if (row && (!row.collapsable || e.target.tagName === "A")) {
                dojo.toggleClass(row, "selected", true);
            }
        },
        
        _handleMouseOut: function(e){
            var row = getRow(e);
            if (row && (!row.collapsable || e.target.tagName === "A")) {
                dojo.toggleClass(row, "selected", false);
            }
        }
        
    });
})();
