/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.common.TimestampWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.DateTextBox");
dojo.require("dojo.i18n");
dojo.require("com.ibm.team.repository.web.ui.internal.admin.util");

(function(){
	var util = com.ibm.team.repository.web.ui.internal.admin.util;
    var CALENDAR_IMG_SRC = dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/images/calendar.gif");
    
    dojo.declare("com.ibm.team.repository.web.ui.internal.common.TimestampWidget", [dijit._Widget, dijit._Templated], {
    
        templateString: '<div class="TimestampWidget">' +
        '<span style="display: inline" dojoAttachPoint="_dateTextSPAN" class="TimestampInput"><span dojoAttachPoint="_dateBoxSPAN"></span><img dojoAttachPoint="_calandarImage" class="CalendarImage" dojoAttachEvent="onclick: _handleCalendarClick"/></span>' +
        '</div>',
        		 		
        postCreate: function(){
            this.createDateLabel("");
            this.createDateTextBox();
            this._isChanged = false;
            this._calandarImage.src = CALENDAR_IMG_SRC;
        },
		
        destroy: function(){
			if(this.dateWidget) this.dateWidget.destroy();
			this.inherited(arguments); 
        },
		
        _handleCalendarClick: function(e){
            this.dateWidget.focus();
        },
		
        createDateLabel: function(value){
            value = value || "";
            
            var dateSpan = document.createElement("span");
            dateSpan.appendChild(document.createTextNode(value));
        },
		
        createDateTextBox: function(){
            dojo.addClass(this.domNode, "DateTextContainer");
            var value = "";
            var constraints = {};
            if (dojo.i18n.normalizeLocale() == "en-us") {
                constraints = {
                    datePattern: "MMM d, yyyy"
                };
            }
            this.dateWidget = /* createWidget */ new dijit.form.DateTextBox({
                isDate: true,							
                containerToggle: "fade",
                constraints: constraints
            }, this._dateBoxSPAN);
            
            this.dateWidget.__jazzWidget = this;
            var self = this;
            this.connect(this.dateWidget, "onChange", function(e){
                self._handleDateChange();
                
            });
            
            // Date widget dynamically replaced its class so need to set element style.
            this.dateWidget.domNode.style.margin = "0";
            this.dateWidget.domNode.style.fontFamily = "inherit";
        },
        
        getBirtValue: function(){
			return util.getBirtDateValue(this.getDateValue());
        },
        
        getDateValue: function(){
			var date = this.dateWidget.attr('value');
			// If the date is null , check to see if we have set the dateIsNull attribute.  Attribute added to ensure
			// backwards compatibility wrt expected behavior.
			if (!date && this.useCurrentDateIfDateIsNull)
			  date = new Date();
			return date;     
        },
        
        _handleDateChange: function(){
            this._isChanged = true;
            if (this.onChangeFunction && this.parent) {
                //var value = this.dateWidget.getValue()
                this.parent[this.onChangeFunction](this.getDateValue());
            }
            this.createDateLabel(this.dateWidget.attr('displayedValue'));
        },
		
		uninitialize: function () {
			this.inherited(arguments);
	    }
        
    });
    
})();
