/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	// Shared
	'close': "Close",
	'del': "Delete",
	'delConfirmPrivate': "Are you sure you want to delete ${0}?",
	'loading': "Loading...",
	'addViewletText': "Add Widget",
	'refresh': "Refresh",
	'ok': "OK",
	'save': "Save",
	'cancel': "Cancel",
	'allHeading': "All Dashboards",
	'allProjectDash': "All ${0} Dashboards",
	'allPersonalDashboards': 'All Personal Dashboards',
	'clickToEdit': "Click to Edit",
	'featureNotSupported': "Your browser does not support this feature.",
	
	// Client
	'noAccessWeb': "Your account does not belong to the groups that are authorized to access the Web UI.  Please contact your server administrator.",
	
	// Dashboard Page
	'dashboardUpdateTitle': "Dashboard Update",
	'dashboardUpdateText': "This tool will perform a bulk update of all dashboards in order to update them to the latest format. This is a one-time operation and must be performed by an adminstrator. Depending on the number of dashboards on the server, this may take a while to complete. Please ensure that your database is backed up before proceeding.",
	'dashboardUpdateText2': "Click Update to start updating the dashboards.",
	'dashboardUpdateButton': "Update",
	'dashboardUpdateProgress': "Updating dashboards... please wait",
	'dashboardUpdateSuccess': "Update completed successfully!",
	'dashboardUpdateError': "An error occured during the update. Please check the Jazz Team Server log for details, and try again after resolving the issue.",
	'dashboardTitleWithTab': "${0} > ${1}",
	'projectDashboardTitle': "Project Dashboard: ${0}",
	'personalDashboardTitle': "Personal Dashboard: ${0}",
	'allPersonalTitle': "All Personal Dashboards",
	'allTeamAreasTitle': "All Dashboards > All Team Areas",
	'dashboardsGenericTitle': "Dashboards",
	'connectionFailure': "The server may be offline or your internet connection may be down. Please check your connection and try again.",
	'errorNoPermission': "You do not have permission to view this dashboard.",
	'errorNotFound': "The requested dashboard could not be found.",
	'errorTitleNotFound': "Not Found",
	'errorRetrieving': "An error occurred while retrieving the dashboard:",
	'errorConflict': "The dashboard could not be saved because it was independently modified by another user. Please <0>refresh</0> to discard your changes and view the latest content.",
	'errorConflictSelf': "The dashboard could not be saved because it was independently modified in another browser window. Please <0>refresh</0> to discard your changes and view the latest content.",
	'errorConcurrentModification': "The dashboard has been concurrently modified and an updated version is available. <0>Refresh</0> to discard your changes and load the latest content.",
	'errorConcurrentModificationNonDirty': "The dashboard has been updated; <0>refresh</0> to view the latest content.",
	'errorSave': "There was a problem saving the dashboard: ${0}",
	'saveFailure': "The dashboard could not be saved because it has been independently modified in another browser. Please refresh to see the latest content.",
	'deleteNoLongerExists': "The dashboard no longer exists on the server.",
	'tryAgain': "Try Again",
	'movedTitle': "Dashboard Moved",
	'movedMsg': "The requested dashboard has been moved to the Jazz Team Server. Please update your links and bookmarks to the URL below.<br/>You will automatically be redirected in 10 seconds.<br/><br/>${0}",
	
	// Dashboard Container
	'navigateAwayPrefixGeneric': "Are you sure you want to navigate away? \n\n",
	'navigateAwayPrefixDashboards': "Are you sure you want to navigate away from this Dashboard? \n\n",
	'navigateAwaySuffixDashboards': "\n\nPress OK to continue, or Cancel to stay on the current page.",
	'navigateAwaySuffixUnsaved': "\n\nPress OK to continue, or Cancel to view the unsaved dashboard.",
	'navigateAwaySuffixSaveInProgress': "\n\nPress OK to continue, or Cancel to view the dashboard that is being saved.",
	'unsavedChangesGeneric': "You have an unsaved Dashboard. ", //preserve space after the period
	'unsavedChangesDashboards': "You have unsaved changes. ", //preserve space after the period
	'editingContentsGeneric': "You are currently editing one or more widgets on a Dashboard. ", //preserve space after the period
	'editingContentsDashboards': "You are currently editing one or more widgets on this Dashboard. ", //preserve space after the period
	'willDiscard': "If you continue your changes will be discarded.",
	'mayDiscard': "If you continue your changes may be discarded.", 
	'navigateAwaySaveInProgressGeneric': "A Dashboard is currently being saved. ", //preserve space after the period
	'navigateAwaySaveInProgressDashboards': "It is currently being saved. ", //preserve space after the period
	'viewletDefinitionsError': "Unable to retrieve widget definitions. ", //preserve space after the period
	'viewletErrors': "One or more of the widgets could not be loaded.",
	'restoreError': "An error occurred while restoring the dashboard:\n\n${0}",
	'saveInProgress': "Saving Dashboard...",
	'saveComplete': "Dashboard successfully saved",
	
	// Dashboard Item
	'itemSaveStaleSpecific': "The dashboard could not be saved because it has been modified by ${0}. Please refresh to see the latest content.",
	'itemSaveStaleGeneral': "The dashboard could not be saved because it independently modified in another browser. Please refresh to see the latest content.",
	'itemSaveLocked': "The dashboard could not be saved because it is being edited by ${0}. Please refresh to see the latest content.",
	
	// Viewlet Page
	'addViewletRemoteError': "Add Widget remote error: ",
	'viewletNotFetched': "The widget definition could not be fetched: ",
	'noViewlets': "There are no widgets in this tab.",
	'noViewletsAdd': "To add some, click on the <0>${0}</0> link located at the top right of the dashboard.",
	
	// Draggable Tabs
	'newTab': "New tab",
	'rename': "Rename",
	'copyTab': "Copy Tab",
	'deleteText': "Delete",
	'layout': "Layout",   // The layout of the dashboard (number of columns)
	'oneColumn': "1 Column",
	'twoColumns': "2 Columns",
	'threeColumns': "3 Columns",
	'deletingTabConfirm': "Are you sure you want to delete ${0}?",
	'deleteLastTab': "The last tab cannot be deleted.",
	'duplicateTab': "Duplicate Tab",
	'menu': "Menu",
	'tabButtonName': "${0} menu", // ${0} = Name of tab; e.g. "General menu"
	
	// ViewletAdapter
	'viewletLogin': "You must log into ${0} to view this content.",
	'viewletLogin2': "Log In",
	'viewletNotLoggedIn': "(not logged in)",
	'viewletDefNotFound': "Viewlet definition not found: ${0}",
	'disconnected': "Disconnected from ${0} (${1})",
	'connected': "Connected to ${0} (${1})",
	'remoteServer': "remote server",
	'remoteConnectionError': "There was a problem connecting to the remote server.",
	'stopEditingConfirm': "\"${0}\" is currently being edited.  If you continue, your changes to this widget will be lost. \n\nAre you sure you want to continue?",
	'filter': "Filter",

	// All Dashboards
	'allTeams': "All Team Areas",
	'allTeamsNoneMatch': "No matches for the current filter.",
	'allDashboardsPrev': "Previous",
	'allDashboardsNext': "Next",
	'allDashboardsOf': "of",
	'allPersonalNone': "No personal dashboards found. <0>Create one</0>",
	'allPersonalSearching': "Searching dashboards",
	'allPersonalColumnTitle': "Title",
	'allPersonalColumnAuthor': "Author",
	
	// Meta Nav
	'connectionError':"Connection error: The server is offline or your internet connection is down. Your most recent action may not have been saved.",
	'communicationError': "An error occurred while communicating with the server.",
	'archivedContributor': "Note: The user associated with this dashboard is archived and no longer in use.",
	'archivedTeam': "Note: The team associated with this dashboard is archived and no longer in use.",
	'archivedProject': "Note: The project associated with this dashboard is archived and no longer in use.",
	'reload': "Reload",
	'autoSave': "Auto-save",
	'restoreDefault': "Restore Default",
	'confirm': "You will lose your changes.  Are you sure? \n(Click Okay to discard changes or Cancel to resume editing)",  //  "\n" is required
	'dashboardModified': "This dashboard has been modified",
	'addNewTab': "Add New Tab",
	'sharing': "Sharing Options",
	'default': "Set as default dashboard",
	'defaultDisabled': "This is your default dashboard",
	'defaultConfirm': "Setting this as your default dashboard will cause the home button to bring you to this dashboard. You can change it later by setting another dashboard as your default.\n\nDo you wish to make this your default dashboard?",
	'paste': "Paste",
	'alertShareDirty': "You have unsaved changes. You need to save the dashboard before you can edit sharing options.",
	'confirmShare': "Are you sure you want to share your dashboard? This will allow all users to view it, and it will be listed in the All Personal Dashboards page.",
	'confirmUnshare': "You sure you want to stop sharing your dashboard? Other users will no longer be able to view it.",
	'clipboardEmpty': "You have nothing in the clipboard.",
	'restoreDashboard': "Are you sure you want to restore this dashboard to its template?\nWARNING: This will ERASE the current dashboard content.",
	'firebugWarning': "Firebug is known to make Dashboards slow. Disable it to improve performance.",
	
	// MigrationStatusPage
	'migrationTitleNotStarted': "Migration Required",
	'migrationTitleInProgress': "Migration In Progress...",
	'migrationTitleSuccess': "Migration Successful",
	'migrationTitleError': "Migration Error",
	'migrationTitlePopupBlocker': "Pop-up Blocked",
	'migrationRequiredMsg': "Before continuing, existing dashboards must first be migrated to the Jazz Team Server. This is a one-time operation and must be done by an administrator.",
	'migrationRequiredMsgAdmin1': "<b>Note</b>: If there are any dashboards containing remote viewlets added from other servers, please ensure that those servers are online before starting the migration. Information required for migration will be accessed from those servers but those servers will not be modified. If some of the servers are not available, the migration will complete with errors, but you will be given an opportunity to retry the migration for the remaining dashboards that did not migrate successfully.",
	'migrationRequiredMsgAdmin2': "Click the button below to start the migration.",
	'migrationRequiredMsgNonAdmin': "You do not have administrator privileges. Please contact an administrator to visit this dashboard (or any dashboard) URL, in order to start the migration.",
	'migrationButton': "Migrate",
	'migrationProgress': "Progress:",
	'migrationProgressInit': "Initializing...",
	'migrationProgress2': "${0} of ${1} dashboards migrated",
	'migrationProgressMsg': "Dashboards are currently being migrated to the Jazz Team Server. Please wait until the migration completes.",
	'migrationSuccessMsg': "The migration completed successfully.",
	'migrationSuccessMsg2': "${0} dashboards were migrated in ${1} seconds.",
	'migrationShowDashboard': "Show Dashboard",
	'migrationError': "There was a problem loading the dashboard migration status or performing the requested operation on the server. Please contact your administrator to resolve the problem and <0>try again</0>.",
	'migrationErrorDetails': "Details:",
	'migrationErrorStatus': "Status Code: ${0}",
	'migrationErrorMore': "(More... see error log)",
	'migrationErrorsMsg': "There was a problem migrating some of the dashboards to the Jazz Team Server.",
	'migrationErrorsMsg3Admin': "You must successfully complete the migration before using dashboards. Please ensure that all the necessary servers are online. Once the problem is resolved, click below to migrate the remaining dashboards. Please consult the error log for additional error details.",
	'migrationErrorsMsg3NonAdmin': "Dashboards must be migrated by an administrator before they can be used. You do not currently have administrator privileges; please contact your administrator to resolve the problem and complete the migration.",
	'migrationTryAgain': "Retry Migration",
	'migrationOverride': "Retry And Ignore Errors",
	'migrateOverrideWarn': "WARNING: By ignoring errors, some of the widgets and/or dashboards will be skipped and will be LOST. You will need to recreate those widgets/dashboards in order to use them. It is HIGHLY recommended that you try to resolve the error(s) and complete the migration.\n\nAre you sure you want to ignore errors?",

	// Error Page
	'dashboardErrorMessage': "An internal system error occurred while retrieving the dashboard.",
	'dashboardErrorTitle': "Error",
	
	// Viewlet Settings
	'settingsLoadingOpts': "Loading Options...",
	'settingsAppearance': "Appearance",
	'settingsTitle': "Title",
	'settingsTitleDesc': "The text that appears in the heading area of the widget.",
	'settingsTitleDesc2': "Only editable when not using a computed title.",
	'settingsTitleComp': "Use computed title",
	'settingsTitleCompDesc': "Indicates whether the widget should automatically determine its title.",
	'settingsTrim': "Trim",
	'settingsTrimDesc': "Trim colour selection affects widget borders and background.",
	'settingsBackgr': "Show Background Color",
	'settingsBackgrDesc': "Indicates whether trim color should fill the background of the widget.",
	'settingsPrefs': "Preferences",
	'settingsPrefsEdit': "Select...",
	'settingsScopeAll': "Scope",
	'settingsScopeUser': "User",
	'settingsScopeTeam': "Team",
	'settingsScopeProject': "Project",
	'settingsScopeProcess': "Project/Team",
	'settingsScopeSub': "Include sub-teams",
	'settingsScopeSubDesc': "Indicates whether the widget should include sub-teams of the selected team or project.",
	'settingsScopeNone': "None",
	'settingsScopeLabelUser': "${0} (User)",
	'settingsScopeLabelTeam': "${0} (Team)",
	'settingsScopeLabelProject': "${0} (Project)",
	
	// ErrorReport
	'errorReport': "An error occurred while loading the widget.",
	'errorReportShowDetails': "Show details",
	'errorReportHideDetails': "Hide details",
	
	// PagedTableViewlet
	'pagedTableNoResults': "No results available.",
	'pagedTableFetchNotOverriden': "fetch has not been overriden.",
	'pagedTablePermissionDenied': "You do not have permission to view this data.",
	
	// Component Menu
	'myDashboards': 'My Dashboards',
	'personalDashboards': 'Personal Dashboards',
	'publicDashboards': "Public Dashboards",
	'projectDashboards': 'Current Project and Team Dashboards',
	'currentPersonal': 'Current Personal Dashboards',
	'sharedDashboards': 'Shared Dashboards',
	'recentDashboards': "Recently Viewed",
	'unsavedDashboards': "Unsaved",
	'createDashboard': "Create Dashboard",
	'createPersonalDashboard': "Create dashboard",
	'noDashboards': "None",
	'createPermissionDenied': "You do not have permission to create a dashboard. Please contact your administrator to be granted the proper permissions.",
	
	// All Personal Dashboards
	'createPersonalDashboardMessage': "Creating dashboard...",
	'createPersonalDashboardError': "Error creating dashboard.",
	'createPersonalDashboardSuccessful': 'Dashboard successfully created',
	
	// IFrame Container
	'iframeTitle': "Remote viewlet content area",
	
	// Search Provider
	'searchScopeAll': "All Dashboards",
	'searchScopeAllTeams': "All Team Dashboards",
	'searchTooltip': "Search dashboards",
	'searchNoResultsLabel': "No dashboards found for ${0}.",
	'searchError': "Error: ${0}",
	'searchErrorContact': "Error contacting server",
	'searchUsers': "Shared (${0})"
})
