/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.util.FilterPanel");

dojo.require("jazz.ensemble.internal.settings.SlideoutPanel");
dojo.require("jazz.ui.FilterBox");

dojo.require("dojo.i18n"); 
dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

(function() {

var SlideoutPanel = jazz.ensemble.internal.settings.SlideoutPanel;

var messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

dojo.declare("com.ibm.team.dashboard.web.ui.internal.util.FilterPanel", SlideoutPanel, {
	
	animate: false,
	
	postCreate: function() {
		this.inherited(arguments);
		var div = dojo.create("div", {className: "com-ibm-team-dashboard-web-ui-internal-util-FilterPanel"}, this.contentNode);
		var buttonWrapper = dojo.create("div", {className: "close-button-wrapper"}, div);
		var closeButton = dojo.create("a",{href: "#", title: messages.close}, buttonWrapper);
		this.connect(closeButton,"onclick",function(e) {
			e.preventDefault();
			this.close();
		});
		this.filterBox = new jazz.ui.FilterBox({
			dwellTime: 300
		});
		div.appendChild(this.filterBox.domNode);
	},
	
	open: function() {
		this.inherited(arguments);
		this.filterBox.focus();
	},
	
	close: function() {
		this.inherited(arguments);
		this.filterBox.clear();
		this.filterBox.blur();
	},
	
	uninitialize: function() {
		this.filterBox.destroy();
	}
});

})();
