/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.util.ScopeSelectionDialog");

dojo.require("jazz.ui.Dialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.process.web.ui.internal.ProcessAreaSelectionDialog");
dojo.require("com.ibm.team.dashboard.web.ui.internal.util.TeamContributorSelectionDialog");

dojo.provide("com.ibm.team.dashboard.web.ui.DashboardConstants");

(function() {

var DashboardConstants = com.ibm.team.dashboard.web.ui.DashboardConstants;

dojo.declare("com.ibm.team.dashboard.web.ui.internal.util.ScopeSelectionDialog", null, {
	constructor: function(args) {
		this.contentWidget = new com.ibm.team.dashboard.web.ui.internal.util.ScopeSelectionDialogContent(args);
		var widgetParams = {
			primaryTitle: "Select Scope",
			contentNode: this.contentWidget.domNode
		};
		this.dialog = new jazz.ui.Dialog(widgetParams);
		this.contentWidget.dialog = this.dialog;
		this.contentWidget.init();
	}
});

dojo.declare("com.ibm.team.dashboard.web.ui.internal.util.ScopeSelectionDialogContent", [dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "ui/internal/templates/ScopeSelectionDialog.html"),
	
	init: function() {
		if (this.scope == DashboardConstants.SCOPE_CONTRIBUTOR) {
			this._user.checked = true;
			this._showUserWidget();
		}
		else {
			this._process.checked = true;
			this._showProcessWidget();
		}
		this.connect(this._process,"onclick",this._showProcessWidget);
		this.connect(this._user,"onclick",this._showUserWidget);
	},
	
	_showUserWidget: function() {
		if (!this._userContentWidget) {
			this._userContentWidget = new com.ibm.team.dashboard.web.ui.internal.util.TeamContributorSelectionDialogContent({
				self: this,
				isMultiselect: false,
				useOkCancel: true, /* Not Add/Close */
				onOK: function(selectedContribs){
					this.self.onOk({
						user: selectedContribs
					});
				}
			});
			this._userContentWidget.dialog = this.dialog;
			this._content.appendChild(this._userContentWidget.domNode);
		}
		dojo.removeClass(this._userContentWidget.domNode, "hidden");
		if (this._processContentWidget)
			dojo.addClass(this._processContentWidget.domNode, "hidden");
	},
	
	_showProcessWidget: function() {
		if (!this._processContentWidget) {
			this._processContentWidget = new com.ibm.team.process.web.ui.internal.ProcessAreaSelectionDialogContent({
				self: this,
				projects: true,
				teams: true,
				onOk: function(area){
					this.self.onOk({
						process: area
					});
					this.onCancel();
				},
				onCancel: function(){
					this.self.dialog.close();
				},
				selection: this.scope == DashboardConstants.SCOPE_PROJECT_AREA || this.scope == DashboardConstants.SCOPE_TEAM_AREA ?
					this.selection : null
			});
			this._processContentWidget.dialog = this.dialog;
			this._content.appendChild(this._processContentWidget.domNode);
			this._processContentWidget.init();
		}
		dojo.removeClass(this._processContentWidget.domNode, "hidden");
		if (this._userContentWidget)
			dojo.addClass(this._userContentWidget.domNode, "hidden");
	}
	
});

})();
