/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.viewlets.web.ui.internal.utils.OrderableList");

dojo.require("jazz.ui.dnd.DraggableContainer");
dojo.require("jazz.ui.dnd.DraggableManager");

(function() {
	var draggableManager = jazz.ui.dnd.draggableManager();
	
	dojo.declare("com.ibm.team.dashboard.viewlets.web.ui.internal.utils.OrderableList", jazz.ui.dnd.DraggableContainer, {
		constructor: function(node, params) {
			this.avatarClass = "orderableListAvatar";
			this.category = params.category;
			this.bookmarks = params.bookmarks;
			this.nodes = params.nodes;
			dojo.addClass(this.node,"orderableList");
		},
		move: function(fromIndex, toContainer, toIndex) {
			var overWidget = draggableManager.overContainer.overWidget;
			if (overWidget) {
				var diff = this.getPlaceholder().index - overWidget.index;	
				for (var i = 0; i < this.nodes.length; i++) {
					if (this.nodes[i] == overWidget.domNode) {
						var destIndex = i;
					} else if (this.nodes[i] == draggableManager.fromContainer.widgets[fromIndex].domNode) {
						var initIndex = i;
					}
					if (destIndex && initIndex) {
						break;
					}
				}
				destIndex=destIndex+diff;
				if (draggableManager.overContainer != draggableManager.fromContainer && destIndex > initIndex) {
					destIndex--;
				}
			} else {
				diff = 0;
				for (var i = 0; i < this.nodes.length; i++) {
					if (this.nodes[i] == draggableManager.fromContainer.widgets[fromIndex].domNode) {
						var initIndex = i;
						break;
					}
				}
				var destIndex = 0;
			}
			this.bookmarks[initIndex].category = draggableManager.overContainer.category;
			if (!draggableManager.overContainer.category) {
				dojo.removeClass(this.nodes[initIndex], "singleIndent");
			} else {
				dojo.addClass(this.nodes[initIndex], "singleIndent");
			}
			this.bookmarks.splice(destIndex,0,this.bookmarks.splice(initIndex,1)[0]);
			this.nodes.splice(destIndex,0,this.nodes.splice(initIndex,1)[0]);
			
			this.updateIndices();
			if (draggableManager.fromContainer != draggableManager.overContainer) {
				this.updateIndices(draggableManager.fromContainer);
			}
			for (var x = 0; x < this.bookmarks.length; x++) {
				this.bookmarks[x].id = x;
			}
			this.inherited(arguments);
		},
		onDndStart: function(widget) {
			var modifieds = dojo.query(".modified",this.node.parentNode);
			for (var i = 0; i < modifieds.length; i++) {
				dojo.removeClass(modifieds[i],"modified");
			}
			dojo.addClass(widget.domNode, "modified");
			
			this.inherited(arguments);
		}
	});
})();