/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.viewlets.web.ui.internal.utils.URLUtility");

(function() {

/*
 * Class 
 */
com.ibm.team.dashboard.viewlets.web.ui.internal.utils.URLUtility = {
	
	/*
	 * Returns the context root path of the repository, e.g. "/jazz".
	 */
	getContextRoot: function() {
		if (!this._contextRoot) {
			// use internal JAF constant (see work item 48210)
			this._contextRoot = net.jazz.ajax._contextRoot;
		}
		return this._contextRoot;
	},
	
	/*
	 * Returns an href that can be used for a link to the contributor with
	 * the given item id.
	 */
	/* string */ getContributorHref: function(/* string */ itemId, /* string */ webRoot) {
		return (webRoot || this.getContextRoot()) + "/admin#action=com.ibm.team.repository.viewUserProfile&itemId=" + itemId;
	}
};


})();

