/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010,2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 * For each numbered message, an explanation and useraction messages should be provided.  These are
 * extracted during the build and published in an infocenter.  Specify these using the same property
 * name, but with a .explanation or .useraction suffix. e.g.:
 *    "AuthenticationUtil_Invalid_User_Pass": "CRRRS4550E Either the username or password is not valid.",
 *    "AuthenticationUtil_Invalid_User_Pass.explanation": "Note that both username and password are case sensitive.",
 *    "AuthenticationUtil_Invalid_User_Pass.useraction": "Try logging in again using a valid username and password."
 *******************************************************************************/
 //NLS_CHARSET=UTF-8
({
	"stepTitle": "Finalize Application",
	"description": "In order to finish the configuration of this application, there are a few operations that need to be completed. This step will provide feedback regarding the status of these operations. Once this step is complete, the application setup will be complete. You may click \"Next\" to continue.",
	"step1Label": "Step 1:",
	"step1Title": "Initiate Finalization Process",
	"step1ButtonLabel": "Finalize Application Setup",
	"step1Instructions": "The finalization process is composed of three parts: applying an internal license, configuring storage on the Jazz Team Server and building indexed data. To begin, click the button below.",
	"step2Label": "Step 2:",
	"step2Title": "Rebuild Indexed Data Only (Optional)",
	"step2ButtonLabel": "Rebuild Index",
	"step2Instructions": "The Jazz Team Server maintains an index of the data. To begin rebuilding the index, click the button below.",
	"step3Label": "Step 3:",
	"step3Title": "View Progress",
	
	"operation1title": "Apply Internal License",
	"operation1desc": "The application uses a preauthorized user to communicate with the Jazz Team Server.  This user must have an internal license for the application to operate.",
	"operation2title": "Configure Storage on the Jazz Team Server",
	"operation2desc": "The application stores user data on the Jazz Team Server. In order to store data, the application must configure storage on the Jazz Team Server.  This operation also creates the data necessary for the application to function.",
	"operation3title": "Rebuild Indexed Data",
	"operation3desc": "This operation will rebuild an index of the data on the Jazz Team Server. Depending on the amount of data stored on the Jazz Team Server, the index rebuild can take several minutes. While the index rebuild is active, using the application can result in unexpected behavior and is not recommended.",
	
	"operationError1": "CRRRS3005E An error occurred while trying to assign the Internal License. Please see the error message at the top of this page for more information.",
	"operationError1.explanation": "The step of assigning the RM Interal License failed. On the top of the page you can click on the \"See Details\" text to see detailed information on the error that occurred.",
	"operationError1.useraction": "With the provided information, try to resolve the problem. If you cannot resolve the problem, provide the the detailed error information to the IBM Support team.",	

	"operationError2": "CRRRS3009E An error occurred while trying to configure storage on the Jazz Team Server. Please see the error message at the top of this page for more information.",
	"operationError2.explanation": "The step of configuring the application storage on the Jazz Team Server failed. On the top of the page you can click on the \"See Details\" text to see detailed information on the error that occurred.",
	"operationError2.useraction": "With the provided information, try to resolve the problem. If you cannot resolve the problem, provide the the detailed error information to the IBM Support team.",	

	"operationError3": "CRRRS3010E An error occurred while trying to rebuild an index of the data on the Jazz Team Server. Please see the error message at the top of this page for more information.",
	"operationError3.explanation": "The step of rebuilding an index of the data on the Jazz Team Server failed. On the top of the page you can click on the \"See Details\" text to see detailed information on the error that occurred.",
	"operationError3.useraction": "With the provided information, try to resolve the problem. If you cannot resolve the problem, provide the the detailed error information to the IBM Support team.",	

	"testingConfiguration" : "Testing configuration settings. This can take a few seconds...",	
	"configurationOK" : "Testing configuration settings succeeded. Click \"Finalize Application Setup\" to continue.",	
	"noFinalizeNeeded" : "The finalization has already been completed for this application. You can optionally click \"Finalize Application Setup\" to reconfigure storage, \"Rebuild Index\", or click \"Next\" to continue.",
	"noFinalizeNeededStandalone" : "The finalization has already been completed for this application. You can optionally click \"Finalize Application Setup\" to reconfigure storage, \"Rebuild Index\", or click \"Finish\" to continue.",
	"finalizeProgress" : "Finalization is in progress. This can take a few minutes...",	
	"rebuildProgress" : "Rebuilding index is in progress. This can take a few minutes...",	
	"allComplete": "The finalization process is complete. Click \"Next\" to continue.",
	"allCompleteStandalone": "The finalization process is complete. Click \"Finish\" to continue.",

	"noVersionMatch" : "CRRRS3011W The finalization of this application has already been completed, but the application version does not match. Try configuring this application again by clicking \"Finalize Application Setup\".",
	"noVersionMatch.explanation": "During configuration testing, the application resulted to be configured, but the returned version number of the configuration does not match the expected value of 3.",
	"noVersionMatch.useraction": "The version number of the configuration should always match the expected value of 3. Try to finalize this application. If finalization fails, contact your IBM Support team.",	
	
	"authorizationError": "CRRRS3006E The user ID you are currently using is not authorized to finalize this application. Another possibility is that you are not authorized to configure already existing RM storage areas on the Jazz Team Server.  The OAuth consumer key for this application should be unique and match the existing storage areas.",
	"authorizationError.explanation": "To perform finalization of this application, the logged on user needs sufficient authorization to perform finalization. The currently logged on user does not have sufficient authorization. Another possibility is that already existing Storage Areas on the Jazz Team Server have a Consumer Key from  either (1) a previous registration, or (2) from another installation of this application using the same Jazz Team Server. In case of (1), when re-registering this application, a new Consumer Key was generated, which is out of synch with the Consumer Key for existing Storage Areas. In case of (2), only one RM application can have storage areas on a Jazz Team Server at a time. Both cases result in an authorization error accessing these existing Storage Areas.",
	"authorizationError.useraction": "Assign the Rational Requirements Composer Analyst Client Access License (CAL) to the user ID you are using for setting up this application. In case the Consumer Key for the Storage Areas on the Jazz Team Server is out of synch with the Consumer Key for this registered application, you need to update the Consumer Key for the Storage Areas on the Jazz Team Server to match the Consumer Key of the registered application on the Jazz Team Server administration pages. You can update the Consumer Key for the Storage Areas using recovery commands (repotools-jts). The setup where two RM applications use one single Jazz Team Server for storage is not supported.",

	"authenticationError": "CRRRS3007E The user ID you are currently using is not authenticated with this application.",
	"authenticationError.explanation": "When reaching this page the user lost its authentication tokens.",
	"authenticationError.useraction": "Close the browser, and run the Setup Wizard again.",

	"unexpectedError": "CRRRS3008E Unexpected error occurred, see the log file for a possible cause. The response code for the error is '${0}'",
	"unexpectedError.explanation": "An unexpected response code was received from the Requirements Server service, while checking if this application needs finalization.",
	"unexpectedError.useraction": "Check this application server log file for an error message that indicates the cause of the problem."

})	
