/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {

dojo.provide("com.ibm.rdm.fronting.server.web.reqpromigration.util.domutils");

com.ibm.rdm.fronting.server.web.reqpromigration.util.domutils = {

	RDF_NAMESPACE: "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
	RDF_QUALIFIER: "rdf",
	
	RM_NAMESPACE: "http://www.ibm.com/xmlns/rdm/rdf/",
	RM_QUALIFIER: "rm",
	
	DC_NAMESPACE: "http://purl.org/dc/terms/",
	DC_QUALIFIER: "dc",
	
	JD_NAMESPACE: "http://jazz.net/xmlns/prod/jazz/discovery/1.0/",
	JD_QUALIFIER: "jd",
	
	JAZZ_NAMESPACE: "http://jazz.net/xmlns/foundation/1.0/",
	JAZZ_QUALIFIER: "jazz",
	
	OSLC_RM_NAMESPACE: "http://open-services.net/xmlns/rm/1.0/",
	OSLC_RM_QUALIFIER: "oslc_rm",
	
	getElementsByTagNameNS: function(domNode, unqualifiedTagName, namespace, qualifier) {
        // summary:
        //     E.g. assuming you've got a domNode like this ...
        //       <entry>
        //         ...
        //         <rdf:Description
        //             xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
        //             xmlns:dcterms="http://purl.org/dc/terms/"
        //             rdf:about="/jazz/resources/rdm/resources/res.media_1">
        //         ...
        //         </rdf:Description>
        //         ...
        //       </entry>
        //     You can use:
        //         com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(
        //             atomEntryNode, "Description",
        //             "http://www.w3.org/1999/02/22-rdf-syntax-ns#", "rdf");
        //     to get the appropriate "rdf:Description" node.
        //     
        //     If no qualifier is speficied, xmlns attribute is used to determine the namespace of the tags
        //     E.g. to get <resourceUri xmlns="http://com.ibm.rdm.commenting#">/jazz/example</resourceUri>:
        //         com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(
        //             atomEntryNode, "resourceUri",
        //             "http://com.ibm.rdm.commenting#");
        //
        
        if (!qualifier) {
        	var nodes = domNode.getElementsByTagName(unqualifiedTagName);
        	var nodeArray = new Array();
        	for (var i=0; i<nodes.length; i++) {
        		var n = nodes.item(i);
        		var xmlns = n.getAttribute("xmlns");
        		if (xmlns==namespace)
        			nodeArray.push(n);
        	}
        	/*
        	var NodeList = function (array Array of Node) {
        	   this.nodes = array;
        	   this.length = array.length;
        	}
            // Make sure it is a NodeList with item() method
        	NodeList.prototype.item = function(i) {
                return this.nodes[i];
            }
        	return new NodeList(nodeArray);
        	*/
        	nodeArray.item = function(i) {
        		return nodeArray[i];
        	}
        	return nodeArray;
        }
        
        return (
            dojo.isIE ?
            domNode.getElementsByTagName(qualifier + ":" + unqualifiedTagName) :
            domNode.getElementsByTagNameNS(namespace, unqualifiedTagName));
    },
    
    getAttributeNS: function(domNode, unqualifiedAttributeName, namespace, qualifier) {
        // summary:
        //     E.g. assuming you've got a domNode like this ...
        //         <rdf:Description
        //             xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
        //             xmlns:dcterms="http://purl.org/dc/terms/"
        //             rdf:about="/jazz/resources/rdm/resources/res.media_1">
        //         ...
        //         </rdf:Description>
        //     You can use:
        //         com.ibm.rdm.web.util.domutils.getAttributeNS(
        //             descriptionNode, "about",
        //             "http://www.w3.org/1999/02/22-rdf-syntax-ns#", "rdf");
        //     to get at the "rdf:about" attribute value:
        //             "/jazz/resources/rdm/resources/res.media_1"
        if (!domNode)
        	return "";
        return (
            dojo.isIE ?
            domNode.getAttribute(qualifier + ":" + unqualifiedAttributeName) :
            domNode.getAttributeNS(namespace, unqualifiedAttributeName));
    }
};
})();