/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rdm.fronting.server.web.reqpromigration.util.rrsutils");

dojo.require("com.ibm.rdm.fronting.server.web.reqpromigration.util.domutils");

var domutils = com.ibm.rdm.fronting.server.web.reqpromigration.util.domutils;

com.ibm.rdm.fronting.server.web.reqpromigration.util.rrsutils = {
	
	getRRSUrl: function(location) {
		var curPage = new dojo._Url(location);
		var rrsUrl = curPage.toString();
		return rrsUrl.substring(0, rrsUrl.indexOf("/migration/reqpro"));
    },
    
    getRootServiceUrl: function(rrsUrl, unqualifiedTagName, namespace, qualifier) {	
    	var ret = null;
		var result = jazz.client.xhrGet({
			url: rrsUrl + "/rootservices",
			sync: true,
			handleAs: "xml",
			headers: {
		    	"Accept": "application/rdf+xml"
		    },
			load: function(data, ioargs){
				//parse response				
				var artifactNodes = domutils.getElementsByTagNameNS(
						 data, 
						 unqualifiedTagName,
						 namespace, 
						 qualifier);
		 
				var node = artifactNodes[0];
			
				var text = (node.firstChild ? node.firstChild.nodeValue : "");

				if (text != null && text.length > 0) {
					ret = text;
				} else {
					var attr = domutils.getAttributeNS(
	                	node, 
	                	"resource",
	                 	domutils.RDF_NAMESPACE, 
						domutils.RDF_QUALIFIER);
					ret = attr;
				}
			},
			error: function(error){
				console.log(error);
			}	        
		});
		
		return ret;
	},
	
	/*
	 * Verify that the host part of a url is valid
	 */
	validateURLHostField: function(inputValue) {
		var isValid = true;
		var isEmpty = inputValue === "";
		if (isEmpty) {
			isValid = false;
		} 
		
		if (isValid) {
			//validate host name
			var host = new dojo._Url(inputValue).host;
			if (!host) {
				isValid = false;
			}
		}
		return isValid;
	}
};
