/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ui.wizard.WizardStepHeader");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.ui.wizard.WizardStep");
dojo.require("jazz.ui.MessageBox");
dojo.require("dojo.i18n");
dojo.requireLocalization("jazz.ui", "WizardMessages");
	
(function() {

var messages;

dojo.declare("jazz.ui.wizard.WizardStepHeader", [jazz.ui.wizard.WizardStep, dijit._Widget, dijit._Templated], {
	
	reset: null, // provide a reset function in the step constructor to display the reset icon
	helpContent: null, // provide a string to display in the help hover to display the help icon
	
	templatePath: dojo.moduleUrl("jazz.ui", "templates/WizardStepHeader.html"),
	
	constructor: function() {
		this.messages = messages = dojo.i18n.getLocalization("jazz.ui", "WizardMessages");
		this.stepTitle = this.stepTitle ? this.stepTitle : "";
	},

	postCreate: function() {
		if (this.reset && dojo.isFunction(this.reset)){
			this.connect(this.resetArea, "onclick", "reset");
			dojo.removeClass(this.resetArea, "noDisplay");
		}
		this.msgBox = new jazz.ui.MessageBox();
		this.messageBox.appendChild(this.msgBox.domNode);
	},

	showMessage: function(message) {
		this.msgBox.showMessage(message);
	},

	hideMessage: function() {
		this.msgBox.hideMessage();
	},
	
	uninitialize: function() {
		this.msgBox.destroyRecursive();
		this.inherited(arguments);
	}
});

})();